# <a href="https://awesome-go.com/"><img align="right" src="https://github.com/avelino/awesome-go/raw/main/tmpl/assets/logo.png" alt="awesome-go" title="awesome-go" /></a> Awesome Go

[Awesome]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.4.1/docs/awesome.svg "star > 2000"
[Green]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Green.svg "最近一周有更新"
[Yellow]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Yellow.svg "最近一年没有更新"
[CN]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Cn.svg "包含中文文档"
[Archived]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.2.1/docs/archived.svg "项目已归档"
[GoDoc]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/DOC.svg "godoc文档地址"

**此项目是 [awesome-go](https://awesome-go.com/) 中文版，最后一次同步时间 : 2022-01-17 07:15:47(每隔1天同步一次)**

[![chinese](https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/english.svg)](README_EN.md) [![Build Status](https://travis-ci.org/avelino/awesome-go.svg?branch=master)](https://travis-ci.org/avelino/awesome-go) [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome) [![Slack Widget](https://img.shields.io/badge/join-us%20on%20slack-gray.svg?longCache=true&logo=slack&colorB=red)](http://gophers.slack.com/messages/awesome) [![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)

[![patreon avelino](https://c5.patreon.com/external/logo/become_a_patron_button@2x.png)](https://www.patreon.com/avelinosource) 为Awesome Go打赏~

精选了一系列很棒的Go框架、库和软件。灵感来自于[awesome-python](https://github.com/vinta/awesome-python)。

**小图标说明** :


小图标 | 说明  
:-:|-
![awesome][Awesome] | star > 2000
![最近一个周有更新][Green] | 最近一周有更新。可以基本判断当前库处于积极维护状态。
![最近一年未更新][Yellow] | 最近一年没有更新。反应了此库的维护积极性不高，使用时需谨慎。
![归档项目][Archived] | 此项目已归档，不再更新，使用时需谨慎。
![此项目有中文文档][CN] | 此项目有中文文档。
![godoc文档][GoDoc] | godoc文档地址。

### 说明

[中文](README.md)  | [English](README_EN.md) 
 

<a href="https://www.producthunt.com/posts/awesome-go?utm_source=badge-featured&utm_medium=badge&utm_souce=badge-awesome-go" target="_blank"><img src="https://api.producthunt.com/widgets/embed-image/v1/featured.svg?post_id=291535&theme=light" alt="awesome-go - Curated list awesome Go frameworks, libraries and software | Product Hunt" style="width: 250px; height: 54px;" width="250" height="54" /></a>

你可以快速浏览贡献者名单[contribution guidelines](https://github.com/avelino/awesome-go/blob/master/CONTRIBUTING.md). 感谢所有为此项目付出的同学[contributors](https://github.com/avelino/awesome-go/graphs/contributors); 你真棒!
### 赞助
如果您在看到一个包或项目不再维护或不适合，请往awesome-go提交[Pull Request](https://github.com/avelino/awesome-go/pulls)，本项目每隔一天与英文文档同步。感谢!
[![Doppler](https://github.com/avelino/awesome-go/raw/main/tmpl/assets/sponsors/doppler.png)](https://www.doppler.com/?utm_campaign=github_repo&utm_medium=referral&utm_content=awesomego&utm_source=github)

[![Digital Ocean](https://avelino.run/sponsors/do_logo_horizontal_blue-210.png)](https://m.do.co/c/bd3b723c0a36?utm_medium=opensource&utm_source=awesome-go)

**Awesome Go has no monthly fee**_, but we have employees who **work hard** to keep it running, with money raised we can repay the effort of each person involved! You can see how we calculate our billing and distribution as it is open to the entire community._

> A curated list of awesome Go frameworks, libraries and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python).


### 贡献

Please take a quick gander at the [contribution guidelines](https://github.com/avelino/awesome-go/blob/master/CONTRIBUTING.md) first. Thanks to all [contributors](https://github.com/avelino/awesome-go/graphs/contributors); you rock!

#### *如果您在这里看到一个包或项目不再维护或不适合，请提交一个pull request来改进此文件。谢谢你！!*

### 内容

- [Awesome Go](#awesome-go)
    - [音频和音乐](#音频和音乐)
    - [身份验证和OAuth](#身份验证和oauth)
    - [区块链](#区块链)
    - [Bot建设](#bot建设)
    - [构建自动化](#构建自动化)
    - [命令行](#命令行)
    - [配置](#配置)
    - [持续集成](#持续集成)
    - [CSS预处理器](#css预处理器)
    - [数据结构](#数据结构)
    - [数据库](#数据库)
    - [数据库驱动程序](#数据库驱动程序)
    - [日期和时间](#日期和时间)
    - [分布式系统](#分布式系统)
    - [动态域名](#动态域名)
    - [电子邮件](#电子邮件)
    - [可嵌入的脚本语言](#可嵌入的脚本语言)
    - [错误处理](#错误处理)
    - [文件处理](#文件处理)
    - [金融](#金融)
    - [表单](#表单)
    - [方法](#方法)
    - [游戏开发](#游戏开发)
    - [代码生成与泛型](#代码生成与泛型)
    - [地理](#地理)
    - [Go 编译器](#go-编译器)
    - [Goroutines](#goroutines)
    - [GUI](#gui)
    - [硬件](#硬件)
    - [图片](#图片)
    - [物联网](#物联网)
    - [作业调度器](#作业调度器)
    - [JSON](#json)
    - [日志记录](#日志记录)
    - [机器学习](#机器学习)
    - [消息](#消息)
    - [微软办公软件](#微软办公软件)
        - [Microsoft Excel](#microsoft-excel)
    - [杂项](#杂项)
        - [依赖注入](#依赖注入)
        - [项目布局](#项目布局)
        - [字符串](#字符串)
        - [未分类的](#未分类的)
    - [自然语言处理](#自然语言处理)
    - [网络](#网络)
        - [HTTP客户端](#http客户端)
    - [OpenGL](#opengl)
    - [ORM](#orm)
    - [包管理](#包管理)
    - [性能](#性能)
    - [查询语言](#查询语言)
    - [嵌入的资源](#嵌入的资源)
    - [科学与数据分析](#科学与数据分析)
    - [安全](#安全)
    - [序列化](#序列化)
    - [服务器应用程序](#服务器应用程序)
    - [流处理](#流处理)
    - [模板引擎](#模板引擎)
    - [测试](#测试)
    - [文本处理](#文本处理)
    - [Third-party APIs](#third-party-apis)
    - [公用事业公司](#公用事业公司)
    - [UUID](#uuid)
    - [验证](#验证)
    - [版本控制](#版本控制)
    - [视频](#视频)
    - [Web框架](#web框架)
        - [中间件](#中间件)
            - [仿真中间件](#仿真中间件)
            - [用于创建HTTP中间件的库](#用于创建http中间件的库)
        - [路由器](#路由器)
    - [WebAssembly](#webassembly)
    - [Windows](#windows)
    - [XML](#xml)
    - [零信任](#零信任)

- [工具](#工具)
    - [代码分析](#代码分析)
    - [编辑器插件](#编辑器插件)
    - [Go 生成工具](#go-生成工具)
    - [Go 工具](#go-工具)
    - [软件包](#软件包)
        - [DevOps 工具](#devops-工具)
        - [其他软件](#其他软件)

- [资源](#资源)
    - [基准](#基准)
    - [会议](#会议)
    - [E-Books](#e-books)
    - [Gophers](#gophers)
    - [聚会](#聚会)
    - [风格指南](#风格指南)
    - [Twitter](#twitter)
    - [网站](#网站)
        - [教程](#教程)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#contents) 吧~)*

## 音频和音乐

*用于操作音频的库。 (翻译出错了? 试试 [英文版](README_EN.md#audio-and-music) 吧~)*

* [Oto](https://github.com/hajimehoshi/oto) **star:941** 多平台的 low-level 声音播放库。   [![godoc][GoDoc]](https://godoc.org/github.com/hajimehoshi/oto)
* [PortAudio](https://github.com/gordonklaus/portaudio) **star:489** 基于 Go 的PortAudio audio I/O库。   [![最近一年没有更新][Yellow]](https://github.com/gordonklaus/portaudio)   [![godoc][GoDoc]](https://godoc.org/github.com/gordonklaus/portaudio)
* [music-theory](https://github.com/go-music-theory/music-theory) **star:376** 基于 Go 的音乐理论模型。   [![最近一年没有更新][Yellow]](https://github.com/go-music-theory/music-theory)   [![godoc][GoDoc]](https://godoc.org/github.com/go-music-theory/music-theory)
* [portmidi](https://github.com/rakyll/portmidi) **star:262** PortMidi的 Go 语言实现接口.   [![最近一年没有更新][Yellow]](https://github.com/rakyll/portmidi)   [![godoc][GoDoc]](https://godoc.org/github.com/rakyll/portmidi)
* [id3v2](https://github.com/bogem/id3v2) **star:228** ID3解码和编码库为Go。   [![最近一周有更新][Green]](https://github.com/bogem/id3v2)   [![godoc][GoDoc]](https://godoc.org/github.com/bogem/id3v2)
* [GoAudio](https://github.com/DylanMeeus/GoAudio) **star:196** 本地Go音频处理库。   [![godoc][GoDoc]](https://godoc.org/github.com/DylanMeeus/GoAudio)
* [flac](https://github.com/mewkiz/flac) **star:189** 原生 Go FLAC编码器/解码器，支持FLAC流。   [![godoc][GoDoc]](https://godoc.org/github.com/mewkiz/flac)
* [malgo](https://github.com/gen2brain/malgo) **star:161** 迷你音频库。
* [mix](https://github.com/go-mix/mix) **star:146** 基于序列的 Go 原生音乐混音器。   [![最近一年没有更新][Yellow]](https://github.com/go-mix/mix)   [![godoc][GoDoc]](https://godoc.org/github.com/go-mix/mix)
* [gaad](https://github.com/Comcast/gaad) **star:93** 原生 Go AAC位流解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/Comcast/gaad)
* [minimp3](https://github.com/tosone/minimp3) **star:68** 轻量级MP3解码器库。
* [vorbis](https://github.com/mccoyst/vorbis) **star:29** “原生” Go Vorbis解码器(使用CGO，但没有依赖关系)。   [![最近一年没有更新][Yellow]](https://github.com/mccoyst/vorbis)   [![godoc][GoDoc]](https://godoc.org/github.com/mccoyst/vorbis)
* [gosamplerate](https://github.com/dh1tw/gosamplerate) **star:15** libsamplerate 的 Go 语言实现接口。   [![最近一年没有更新][Yellow]](https://github.com/dh1tw/gosamplerate)   [![godoc][GoDoc]](https://godoc.org/github.com/dh1tw/gosamplerate)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#audio-and-music) 吧~)*

## 身份验证和OAuth

*用于实现验证方案的库。 (翻译出错了? 试试 [英文版](README_EN.md#authentication-and-oauth) 吧~)*

* [casbin](https://github.com/casbin/casbin) **star:11089** 支持ACL、RBAC、ABAC等访问控制模型的授权库。   [![star > 2000][Awesome]](https://github.com/casbin/casbin)   [![godoc][GoDoc]](https://godoc.org/github.com/casbin/casbin)
* [oauth2](https://github.com/golang/oauth2) **star:3974** goauth2的继任者。通用OAuth 2.0包，附带JWT、谷歌api、计算引擎和应用程序引擎支持。   [![star > 2000][Awesome]](https://github.com/golang/oauth2)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/oauth2)
* [goth](https://github.com/markbates/goth) **star:3475** 提供了 OAuth 和 OAuth2 的简单清晰易用的方法。可开箱即用处理多个提供程序。   [![star > 2000][Awesome]](https://github.com/markbates/goth)   [![最近一周有更新][Green]](https://github.com/markbates/goth)   [![godoc][GoDoc]](https://godoc.org/github.com/markbates/goth)
* [authboss](https://github.com/volatiletech/authboss) **star:2972** web模块化认证系统。它试图删除尽可能多的模板文件和硬编码，以便每次新建一个新的web项目时，您都可以插入、配置并开始构建您的应用程序，而不必每次都构建一个身份验证系统。   [![star > 2000][Awesome]](https://github.com/volatiletech/authboss)   [![godoc][GoDoc]](https://godoc.org/github.com/volatiletech/authboss)
* [go-jose](https://github.com/square/go-jose) **star:1862** 相当完整地实现了JOSE工作组的JSON Web令牌、JSON Web签名和JSON Web加密规范。
* [go-oauth2-server](https://github.com/RichardKnop/go-oauth2-server) **star:1852** 用 Golang 编写的独立且符合规范的OAuth2服务器。   [![最近一年没有更新][Yellow]](https://github.com/RichardKnop/go-oauth2-server)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/go-oauth2-server)
* [loginsrv](https://github.com/tarent/loginsrv) **star:1840** JWT登录微服务带有可插拔的后端服务，如OAuth2 (Github)、htpasswd、osiam。   [![godoc][GoDoc]](https://godoc.org/github.com/tarent/loginsrv)
* [osin](https://github.com/openshift/osin) **star:1710** OAuth2服务器库。   [![godoc][GoDoc]](https://godoc.org/github.com/openshift/osin)
* [gologin](https://github.com/dghubble/gologin) **star:1469** 用于使用OAuth1和OAuth2身份验证提供者登录的可链处理程序。   [![最近一周有更新][Green]](https://github.com/dghubble/gologin)   [![godoc][GoDoc]](https://godoc.org/github.com/dghubble/gologin)
* [gorbac](https://github.com/mikespook/gorbac) **star:1241** 轻量级的基于角色的访问控制(RBAC)实现。   [![godoc][GoDoc]](https://godoc.org/github.com/mikespook/gorbac)
* [scs](https://github.com/alexedwards/scs) **star:1015** HTTP服务器的会话管理器。   [![最近一周有更新][Green]](https://github.com/alexedwards/scs)   [![godoc][GoDoc]](https://godoc.org/github.com/alexedwards/scs)
* [paseto](https://github.com/o1egl/paseto) **star:568** 平台无关的安全令牌(PASETO)。   [![godoc][GoDoc]](https://godoc.org/github.com/o1egl/paseto)
* [permissions2](https://github.com/xyproto/permissions2) **star:443** 用于跟踪用户、登录状态和权限的库。依赖于cookie安全和bcrypt。   [![godoc][GoDoc]](https://godoc.org/github.com/xyproto/permissions2)
* [go-guardian](https://github.com/shaj13/go-guardian) **star:334** Go-Guardian是一个golang库，它提供了一种简单、干净和习惯的方式来创建强大的现代API和web身份验证，支持LDAP、Basic、承载令牌和基于证书的身份验证。   [![godoc][GoDoc]](https://godoc.org/github.com/shaj13/go-guardian)
* [jwt](https://github.com/cristalhq/jwt) **star:312** 安全、简单、快速的JSON Web令牌。   [![godoc][GoDoc]](https://godoc.org/github.com/cristalhq/jwt)
* [jwt](https://github.com/pascaldekloe/jwt) **star:277** 轻量级JSON Web令牌库。   [![godoc][GoDoc]](https://godoc.org/github.com/pascaldekloe/jwt)
* [jeff](https://github.com/abraithwaite/jeff) **star:234** 简单、灵活、安全和惯用的web会话管理，具有可配置化的后端。   [![godoc][GoDoc]](https://godoc.org/github.com/abraithwaite/jeff)
* [jwt-auth](https://github.com/adam-hanna/jwt-auth) **star:211** JWT中间件，可用于Golang http服务器，提供了许多配置选项。   [![godoc][GoDoc]](https://godoc.org/github.com/adam-hanna/jwt-auth)
* [otpgen](https://github.com/grijul/otpgen) **star:113** 库生成TOTP/HOTP代码。   [![godoc][GoDoc]](https://godoc.org/github.com/grijul/otpgen)
* [sessionup](https://github.com/swithek/sessionup) **star:113** 简单但有效的HTTP会话管理和标识包。   [![godoc][GoDoc]](https://godoc.org/github.com/swithek/sessionup)
* [session](https://github.com/icza/session) **star:105** web服务器会话管理(包括支持谷歌应用程序引擎 - GAE)。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/session)
* [jwt](https://github.com/robbert229/jwt) **star:96** 简单易用的JSON Web令牌实现(JWT)。   [![最近一年没有更新][Yellow]](https://github.com/robbert229/jwt)   [![godoc][GoDoc]](https://godoc.org/github.com/robbert229/jwt)
* [sjwt](https://github.com/brianvoe/sjwt) **star:95** 简单的jwt生成器和解析器。   [![最近一年没有更新][Yellow]](https://github.com/brianvoe/sjwt)   [![godoc][GoDoc]](https://godoc.org/github.com/brianvoe/sjwt)
* [rbac](https://github.com/zpatrick/rbac) **star:88** 最小的RBAC包。   [![最近一年没有更新][Yellow]](https://github.com/zpatrick/rbac)   [![godoc][GoDoc]](https://godoc.org/github.com/zpatrick/rbac)
* [sessions](https://github.com/adam-hanna/sessions) **star:61** 非常简单，高性能，可深度定制的会话服务，主要用于的 go http 服务器。   [![最近一年没有更新][Yellow]](https://github.com/adam-hanna/sessions)   [![godoc][GoDoc]](https://godoc.org/github.com/adam-hanna/sessions)
* [securecookie](https://github.com/chmike/securecookie) **star:54** 高效安全的cookie编码/解码。   [![godoc][GoDoc]](https://godoc.org/github.com/chmike/securecookie)
* [go-email-normalizer](https://github.com/dimuska139/go-email-normalizer) **star:36** Golang库，用于提供电子邮件地址的规范表示。   [![godoc][GoDoc]](https://godoc.org/github.com/dimuska139/go-email-normalizer)
* [otpgo](https://github.com/jltorresm/otpgo) **star:26** 基于时间的一次性密码(TOTP)和基于hmac的一次性密码(HOTP)库用于Go。   [![godoc][GoDoc]](https://godoc.org/github.com/jltorresm/otpgo)
* [branca](https://github.com/essentialkaos/branca) **star:25** branca token[规范实现](https://github.com/tuupola/branca-spec)用于Golang 1.15+。   [![godoc][GoDoc]](https://godoc.org/github.com/essentialkaos/branca)
* [scope](https://github.com/SonicRoshan/scope) **star:17** 在Go中轻松管理OAuth2范围。   [![godoc][GoDoc]](https://godoc.org/github.com/SonicRoshan/scope)
* [sessiongate-go](https://github.com/f0rmiga/sessiongate-go) **star:9** 使用SessionGate Redis模块进行会话管理。   [![最近一年没有更新][Yellow]](https://github.com/f0rmiga/sessiongate-go)   [![godoc][GoDoc]](https://godoc.org/github.com/f0rmiga/sessiongate-go)
* [cookiestxt](https://github.com/mengzhuo/cookiestxt) **star:8** 提供cookie .txt文件格式的解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/mengzhuo/cookiestxt)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#authentication-and-oauth) 吧~)*

## 区块链

*构建区块链的工具。 (翻译出错了? 试试 [英文版](README_EN.md#blockchain) 吧~)*

* [go-ethereum](https://github.com/ethereum/go-ethereum) **star:34839** 以太坊协议的官方Go实现。   [![star > 2000][Awesome]](https://github.com/ethereum/go-ethereum)   [![最近一周有更新][Green]](https://github.com/ethereum/go-ethereum)   [![godoc][GoDoc]](https://godoc.org/github.com/ethereum/go-ethereum)
* [tendermint](https://github.com/tendermint/tendermint) **star:4582** 一个高性能中间件，可将任何语言的状态机转换为 Byzantine Fault 状态机。使用 Tendermint 一致性及区块链协议。   [![star > 2000][Awesome]](https://github.com/tendermint/tendermint)   [![最近一周有更新][Green]](https://github.com/tendermint/tendermint)   [![godoc][GoDoc]](https://godoc.org/github.com/tendermint/tendermint)
* [cosmos-sdk](https://github.com/cosmos/cosmos-sdk) **star:3277** 在宇宙生态系统中构建公共区块链框架。   [![star > 2000][Awesome]](https://github.com/cosmos/cosmos-sdk)   [![最近一周有更新][Green]](https://github.com/cosmos/cosmos-sdk)   [![godoc][GoDoc]](https://godoc.org/github.com/cosmos/cosmos-sdk)
* [gossamer](https://github.com/ChainSafe/gossamer) **star:298** Polkadot主机的Go实现。   [![最近一周有更新][Green]](https://github.com/ChainSafe/gossamer)   [![godoc][GoDoc]](https://godoc.org/github.com/ChainSafe/gossamer)
* [solana-go](https://github.com/gagliardetto/solana-go) **star:181** 去库与Solana JSON RPC和WebSocket接口接口。   [![最近一周有更新][Green]](https://github.com/gagliardetto/solana-go)   [![godoc][GoDoc]](https://godoc.org/github.com/gagliardetto/solana-go)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#blockchain) 吧~)*

## Bot建设

*用于构建和使用机器人的库。 (翻译出错了? 试试 [英文版](README_EN.md#bot-building) 吧~)*

* [telegram-bot-api](https://github.com/Syfaro/telegram-bot-api) **star:3332** 简单轻量级的Telegram bot客户端。   [![star > 2000][Awesome]](https://github.com/Syfaro/telegram-bot-api)   [![最近一周有更新][Green]](https://github.com/Syfaro/telegram-bot-api)   [![godoc][GoDoc]](https://godoc.org/github.com/Syfaro/telegram-bot-api)
* [olivia](https://github.com/olivia-ai/olivia) **star:3176** 用人工神经网络建造的聊天机器人。   [![star > 2000][Awesome]](https://github.com/olivia-ai/olivia)   [![godoc][GoDoc]](https://godoc.org/github.com/olivia-ai/olivia)
* [telebot](https://github.com/tucnak/telebot) **star:2262** 用Go编写的Telegram bot框架。   [![star > 2000][Awesome]](https://github.com/tucnak/telebot)   [![最近一周有更新][Green]](https://github.com/tucnak/telebot)   [![godoc][GoDoc]](https://godoc.org/github.com/tucnak/telebot)
* [Kelp](https://github.com/stellar/kelp) **star:834** 官方交易和做市机器人为[Stellar](https://www.stellar.org/) DEX。开箱即用的作品，用 Golang 编写，兼容集中交易和定制交易策略。   [![godoc][GoDoc]](https://godoc.org/github.com/stellar/kelp)
* [go-chat-bot](https://github.com/go-chat-bot/bot) **star:714** 用 Go 编写的IRC, Slack和电报机器人。   [![最近一年没有更新][Yellow]](https://github.com/go-chat-bot/bot)   [![godoc][GoDoc]](https://godoc.org/github.com/go-chat-bot/bot)
* [go-joe](https://joe-bot.net)  一个通用的机器人库的灵感来自于Hubot。
* [Golang CryptoTrading Bot](https://github.com/saniales/golang-crypto-trading-bot) **star:674** 基于控制台的，用于加密货币交易所的的交易机器人。   [![godoc][GoDoc]](https://godoc.org/github.com/saniales/golang-crypto-trading-bot)
* [slacker](https://github.com/shomali11/slacker) **star:573** 可简单创建Slack机器人的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/slacker)
* [tbot](https://github.com/yanzay/tbot) **star:322** 带有类似于net/http API的Telegram bot服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/yanzay/tbot)
* [go-twitch-irc](https://github.com/gempir/go-twitch-irc) **star:215** 为twitch写机器人的库。电视聊天   [![最近一周有更新][Green]](https://github.com/gempir/go-twitch-irc)   [![godoc][GoDoc]](https://godoc.org/github.com/gempir/go-twitch-irc)
* [go-sarah](https://github.com/oklahomer/go-sarah) **star:213** 此框架提供了聊天机器人相关的服务，包括LINE、Slack、Gitter等。   [![最近一周有更新][Green]](https://github.com/oklahomer/go-sarah)   [![godoc][GoDoc]](https://godoc.org/github.com/oklahomer/go-sarah)
* [Tenyks](https://github.com/kyleterry/tenyks) **star:171** 面向服务的IRC bot，使用Redis和JSON进行消息传递。   [![最近一年没有更新][Yellow]](https://github.com/kyleterry/tenyks)   [![godoc][GoDoc]](https://godoc.org/github.com/kyleterry/tenyks)
* [hanu](https://github.com/sbstjn/hanu) **star:134** 用于编写Slack机器人的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/sbstjn/hanu)
* [go-tgbot](https://github.com/olebedev/go-tgbot) **star:111** 由swagger文件、基于会话的路由器和中间件生成的纯Golang Telegram Bot API包装器。   [![最近一年没有更新][Yellow]](https://github.com/olebedev/go-tgbot)   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/go-tgbot)
* [slack-bot](https://github.com/innogames/slack-bot) **star:75** 为懒惰的开发者准备好使用Slack Bot:自定义命令，Jenkins, Jira, Bitbucket, Github…   [![最近一周有更新][Green]](https://github.com/innogames/slack-bot)   [![godoc][GoDoc]](https://godoc.org/github.com/innogames/slack-bot)
* [margelet](https://github.com/zhulik/margelet) **star:66** 构建电报机器人的框架。   [![最近一年没有更新][Yellow]](https://github.com/zhulik/margelet)   [![godoc][GoDoc]](https://godoc.org/github.com/zhulik/margelet)
* [ephemeral-roles](https://github.com/ewohltman/ephemeral-roles) **star:52** 用于管理基于语音通道成员存在的临时角色的不和机器人。   [![godoc][GoDoc]](https://godoc.org/github.com/ewohltman/ephemeral-roles)
* [echotron](https://github.com/NicoNex/echotron) **star:49** 用纯Go编写的Telegram Bots并发库。   [![godoc][GoDoc]](https://godoc.org/github.com/NicoNex/echotron)
* [slackscot](https://github.com/alexandre-normand/slackscot) **star:49** 另一个构建Slack机器人的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/alexandre-normand/slackscot)
* [govkbot](https://github.com/nikepan/govkbot) **star:37** 简单的Go [VK](https://vk.com) bot库。   [![godoc][GoDoc]](https://godoc.org/github.com/nikepan/govkbot)
* [larry](https://github.com/ezeoleaf/larry) **star:31** 拉里🐦是一个很简单的推特机器人生成器,tweet随机从Github库建在走。   [![最近一周有更新][Green]](https://github.com/ezeoleaf/larry)   [![godoc][GoDoc]](https://godoc.org/github.com/ezeoleaf/larry)
* [micha](https://github.com/onrik/micha) **star:17** 基于 GO 实现的Telegram 机器人API库。   [![godoc][GoDoc]](https://godoc.org/github.com/onrik/micha)
* [telego](https://github.com/mymmrac/telego) **star:8** goang的Telegram Bot API库，完全一对一的API实现。   [![最近一周有更新][Green]](https://github.com/mymmrac/telego)   [![godoc][GoDoc]](https://godoc.org/github.com/mymmrac/telego)
* [teleterm](https://github.com/alfiankan/teleterm) **star:4** Telegram Bot执行终端命令。   [![godoc][GoDoc]](https://godoc.org/github.com/alfiankan/teleterm)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#bot-building) 吧~)*

## 构建自动化

*帮助构建自动化的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#build-automation) 吧~)*

* [Task](https://github.com/go-task/task) **star:4477** 简单的“Go”的选择。   [![star > 2000][Awesome]](https://github.com/go-task/task)   [![最近一周有更新][Green]](https://github.com/go-task/task)   [![godoc][GoDoc]](https://godoc.org/github.com/go-task/task)
* [realize](https://github.com/tockins/realize) **star:4189** Go 语言构建系统，可以监控文件变化并重新加载。运行，构建，监控文件并支持自定义路径。   [![star > 2000][Awesome]](https://github.com/tockins/realize)   [![godoc][GoDoc]](https://godoc.org/github.com/tockins/realize)
* [mage](https://github.com/magefile/mage) **star:2806** 法师是一个使用Go制作/耙子类的构建工具。   [![star > 2000][Awesome]](https://github.com/magefile/mage)   [![最近一周有更新][Green]](https://github.com/magefile/mage)   [![godoc][GoDoc]](https://godoc.org/github.com/magefile/mage)
* [mmake](https://github.com/tj/mmake) **star:1595** 现代 Make 工具   [![最近一年没有更新][Yellow]](https://github.com/tj/mmake)   [![godoc][GoDoc]](https://godoc.org/github.com/tj/mmake)
* [goyek](https://github.com/goyek/goyek) **star:273** 在Go中创建构建管道。   [![godoc][GoDoc]](https://godoc.org/github.com/goyek/goyek)
* [taskctl](https://github.com/taskctl/taskctl) **star:151** 并发任务跑。   [![godoc][GoDoc]](https://godoc.org/github.com/taskctl/taskctl)
* [1build](https://github.com/gopinath-langote/1build) **star:123** 命令行工具，以无摩擦地管理项目特定的命令。   [![godoc][GoDoc]](https://godoc.org/github.com/gopinath-langote/1build)
* [gaper](https://github.com/maxcnunes/gaper) **star:50** 当Go项目崩溃或一些人看到文件更改时，构建并重新启动该项目。   [![godoc][GoDoc]](https://godoc.org/github.com/maxcnunes/gaper)
* [gilbert](https://go-gilbert.github.io)  一个为 Go 项目而生的构建系统和任务运行器。
* [anko](https://github.com/GuilhermeCaruso/anko) **star:20** 适用于多种编程语言的简单应用程序监视程序。   [![godoc][GoDoc]](https://godoc.org/github.com/GuilhermeCaruso/anko)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#build-automation) 吧~)*

## 命令行

### 标准CLI

*用于构建标准或基本命令行应用程序的库。 (翻译出错了? 试试 [英文版](README_EN.md#standard-cli) 吧~)*

* [cobra](https://github.com/spf13/cobra) **star:24807** 现代Go CLI命令行交互工具。   [![star > 2000][Awesome]](https://github.com/spf13/cobra)   [![最近一周有更新][Green]](https://github.com/spf13/cobra)   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/cobra)
* [urfave/cli](https://github.com/urfave/cli) **star:17148** 可让你简单、快速和愉快的构建命令行应用(之前是codegangsta/cli)。   [![star > 2000][Awesome]](https://github.com/urfave/cli)   [![最近一周有更新][Green]](https://github.com/urfave/cli)   [![godoc][GoDoc]](https://godoc.org/github.com/urfave/cli)
* [elvish](https://github.com/elves/elvish) **star:4620** 一种表达性编程语言和通用的交互外壳。   [![star > 2000][Awesome]](https://github.com/elves/elvish)   [![最近一周有更新][Green]](https://github.com/elves/elvish)   [![godoc][GoDoc]](https://godoc.org/github.com/elves/elvish)
* [kingpin](https://github.com/alecthomas/kingpin) **star:3190** 支持子命令的命令行和标志解析器(被' kong '取代;见下文)。   [![star > 2000][Awesome]](https://github.com/alecthomas/kingpin)   [![godoc][GoDoc]](https://godoc.org/github.com/alecthomas/kingpin)
* [Dnote](https://github.com/dnote/dnote) **star:2199** 一个简单的命令行笔记本与多设备同步。   [![star > 2000][Awesome]](https://github.com/dnote/dnote)   [![最近一周有更新][Green]](https://github.com/dnote/dnote)   [![godoc][GoDoc]](https://godoc.org/github.com/dnote/dnote)
* [go-flags](https://github.com/jessevdk/go-flags) **star:2121**  Go 命令行选项解析器。   [![star > 2000][Awesome]](https://github.com/jessevdk/go-flags)   [![godoc][GoDoc]](https://godoc.org/github.com/jessevdk/go-flags)
* [pflag](https://github.com/spf13/pflag) **star:1666** 基于POSIX/GNU-style --flags实现的包，主要用于替换Go的falg包。   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/pflag)
* [mitchellh/cli](https://github.com/mitchellh/cli) **star:1450** 用于实现命令行接口的Go库。   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/cli)
* [go-arg](https://github.com/alexflint/go-arg) **star:1337** 基于结构的参数解析。   [![godoc][GoDoc]](https://godoc.org/github.com/alexflint/go-arg)
* [liner](https://github.com/peterh/liner) **star:863** 类似readline-like的命令行接口库。   [![最近一周有更新][Green]](https://github.com/peterh/liner)   [![godoc][GoDoc]](https://godoc.org/github.com/peterh/liner)
* [ops](https://github.com/nanovms/ops) **star:822** Unikernel 构建器/协调器。   [![最近一周有更新][Green]](https://github.com/nanovms/ops)   [![godoc][GoDoc]](https://godoc.org/github.com/nanovms/ops)
* [complete](https://github.com/posener/complete) **star:806** 使用 Go 语言编写的 bash 命令补全工具以及 Go 命令补全工具.   [![godoc][GoDoc]](https://godoc.org/github.com/posener/complete)
* [mow.cli](https://github.com/jawher/mow.cli) **star:775** 用于构建具有复杂标志和参数解析和验证的CLI应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/jawher/mow.cli)
* [flaggy](https://github.com/integrii/flaggy) **star:774** 一个健壮的、易用的标志包，具有出色的子命令支持。   [![godoc][GoDoc]](https://godoc.org/github.com/integrii/flaggy)
* [cli](https://github.com/mkideal/cli) **star:639** 基于golang结构标签，功能丰富易于使用的命令行包。   [![godoc][GoDoc]](https://godoc.org/github.com/mkideal/cli)
* [argparse](https://github.com/akamensky/argparse) **star:392** 命令行参数分析器，灵感来自Python的argparse模块。   [![godoc][GoDoc]](https://godoc.org/github.com/akamensky/argparse)
* [climax](https://github.com/tucnak/climax) **star:192** Alternative CLI with "human face", in spirit of Go command.   [![最近一年没有更新][Yellow]](https://github.com/tucnak/climax)   [![godoc][GoDoc]](https://godoc.org/github.com/tucnak/climax)
* [wmenu](https://github.com/dixonwille/wmenu) **star:150** 为cli程序提供了简单上手的菜单，可提示用户作出选择。   [![godoc][GoDoc]](https://godoc.org/github.com/dixonwille/wmenu)
* [commandeer](https://github.com/jaffee/commandeer) **star:147** 开发友好的CLI应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/jaffee/commandeer)
* [sflags](https://github.com/octago/sflags) **star:130** 基于结构的flag生成器，用于flag、urfave/cli、pflag、cobra、kingpin和其他库。   [![godoc][GoDoc]](https://godoc.org/github.com/octago/sflags)
* [flag](https://github.com/cosiner/flag) **star:117** 简单但功能强大的命令行选项解析库，用于支持Go子命令。   [![最近一年没有更新][Yellow]](https://github.com/cosiner/flag)   [![godoc][GoDoc]](https://godoc.org/github.com/cosiner/flag)
* [job](https://github.com/liujianping/job) **star:111** 工作，把你的短期指令当作长期任务。   [![最近一年没有更新][Yellow]](https://github.com/liujianping/job)
* [ukautz/clif](https://github.com/ukautz/clif) **star:111** 简小的命令行接口框架。   [![最近一年没有更新][Yellow]](https://github.com/ukautz/clif)   [![godoc][GoDoc]](https://godoc.org/github.com/ukautz/clif)
* [cli](https://github.com/teris-io/cli) **star:99** 为 Go 构建命令接口提供简单而完整的API。   [![godoc][GoDoc]](https://godoc.org/github.com/teris-io/cli)
* [cmdr](https://github.com/hedzr/cmdr) **star:92** 一个POSIX/GNU风格的、类似getopt的命令行UI Go库。   [![最近一周有更新][Green]](https://github.com/hedzr/cmdr)   [![godoc][GoDoc]](https://godoc.org/github.com/hedzr/cmdr)
* [env](https://github.com/codingconcepts/env) **star:89** 基于标记的结构化的环境配置。   [![最近一年没有更新][Yellow]](https://github.com/codingconcepts/env)   [![godoc][GoDoc]](https://godoc.org/github.com/codingconcepts/env)
* [clîr](https://github.com/leaanthony/clir) **star:81** 一个简单而清晰的CLI库。依赖免费的。   [![godoc][GoDoc]](https://godoc.org/github.com/leaanthony/clir)
* [gocmd](https://github.com/devfacet/gocmd) **star:56** 用于构建命令行应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/devfacet/gocmd)
* [hiboot cli](https://github.com/hidevopsio/hiboot/tree/master/pkg/app/cli)  具有自动配置和依赖注入的cli应用程序框架。
* [wlog](https://github.com/dixonwille/wlog) **star:53** 支持跨平台和并发的简单日志记录接口。   [![godoc][GoDoc]](https://godoc.org/github.com/dixonwille/wlog)
* [strumt](https://github.com/antham/strumt) **star:44** 用于创建提示链。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/strumt)
* [go-getoptions](https://github.com/DavidGamba/go-getoptions) **star:39**  Go 选择解析器，借鉴于Perl灵活性的GetOpt::Long。   [![最近一周有更新][Green]](https://github.com/DavidGamba/go-getoptions)   [![godoc][GoDoc]](https://godoc.org/github.com/DavidGamba/go-getoptions)
* [flagvar](https://github.com/sgreben/flagvar) **star:37** 符合 Go 标准的“flag”标志参数类型包。   [![最近一年没有更新][Yellow]](https://github.com/sgreben/flagvar)   [![godoc][GoDoc]](https://godoc.org/github.com/sgreben/flagvar)
* [cmd](https://github.com/posener/cmd) **star:33** 扩展标准的' flag '包以支持子命令和更多惯用方式。   [![最近一年没有更新][Yellow]](https://github.com/posener/cmd)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/cmd)
* [acmd](https://github.com/cristalhq/acmd) **star:32** 简单，有用和固执己见的CLI包。   [![godoc][GoDoc]](https://godoc.org/github.com/cristalhq/acmd)
* [argv](https://github.com/cosiner/argv) **star:32** 基于Base 语法，用于分隔命令行字符串并将其作为参数的 Go 语言库，   [![最近一年没有更新][Yellow]](https://github.com/cosiner/argv)   [![godoc][GoDoc]](https://godoc.org/github.com/cosiner/argv)
* [go-commander](https://github.com/yitsushi/go-commander) **star:24** 用于简化CLI工作流的 Go 库。   [![最近一年没有更新][Yellow]](https://github.com/yitsushi/go-commander)   [![godoc][GoDoc]](https://godoc.org/github.com/yitsushi/go-commander)
* [command-chain](https://github.com/rainu/go-command-chain) **star:19** 一个用于配置和运行命令链的go库——比如unix shell中的管道。   [![godoc][GoDoc]](https://godoc.org/github.com/rainu/go-command-chain)
* [sand](https://github.com/Zaba505/sand) **star:15** 用于创建解释器等的简单API。   [![最近一年没有更新][Yellow]](https://github.com/Zaba505/sand)   [![godoc][GoDoc]](https://godoc.org/github.com/Zaba505/sand)
* [ts](https://github.com/liujianping/ts) **star:13** 时间戳转换和比较工具。   [![最近一年没有更新][Yellow]](https://github.com/liujianping/ts)   [![godoc][GoDoc]](https://godoc.org/github.com/liujianping/ts)
* [go-andotp](https://github.com/grijul/go-andotp) **star:10** 一个CLI程序加密/解密[andOTP](https://github.com/andOTP/andOTP)文件。也可以用作图书馆。   [![godoc][GoDoc]](https://godoc.org/github.com/grijul/go-andotp)
* [subcmd](https://github.com/bobg/subcmd) **star:1** 解析和运行子命令的另一种方法。与标准的“旗帜”包一起工作。   [![godoc][GoDoc]](https://godoc.org/github.com/bobg/subcmd)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#standard-cli) 吧~)*

### 高级控制台用户界面

*用于构建控制台应用程序和控制台用户界面的库。 (翻译出错了? 试试 [英文版](README_EN.md#advanced-console-uis) 吧~)*

* [termui](https://github.com/gizak/termui) **star:11510** 此库是基于**termbox-go**实现的，借鉴于[blessed-contrib](https://github.com/yaronn/blessed-contrib)。   [![star > 2000][Awesome]](https://github.com/gizak/termui)   [![godoc][GoDoc]](https://godoc.org/github.com/gizak/termui)
* [gocui](https://github.com/jroimartin/gocui) **star:7828** 旨在创建控制台用户界面的极简Go库。   [![star > 2000][Awesome]](https://github.com/jroimartin/gocui)   [![godoc][GoDoc]](https://godoc.org/github.com/jroimartin/gocui)
* [gommon/color](https://github.com/labstack/gommon/tree/master/color)  更换终端文本样式。
* [go-prompt](https://github.com/c-bata/go-prompt) **star:4293** 构建一个强大的交互式提示，借鉴于[python-prompt-toolkit](https://github.com/jonathanslenders/python-prompt-toolkit)   [![star > 2000][Awesome]](https://github.com/c-bata/go-prompt)   [![godoc][GoDoc]](https://godoc.org/github.com/c-bata/go-prompt)
* [termbox-go](https://github.com/nsf/termbox-go) **star:4212** 基于文本的跨平台接口库。   [![star > 2000][Awesome]](https://github.com/nsf/termbox-go)   [![godoc][GoDoc]](https://godoc.org/github.com/nsf/termbox-go)
* [pterm](https://github.com/pterm/pterm) **star:2353** 一个在每个平台上使用许多可组合组件美化控制台输出的库。   [![star > 2000][Awesome]](https://github.com/pterm/pterm)   [![最近一周有更新][Green]](https://github.com/pterm/pterm)   [![godoc][GoDoc]](https://godoc.org/github.com/pterm/pterm)
* [progressbar](https://github.com/schollz/progressbar) **star:2260** 基本线程安全的进度条，在每个操作系统工作。   [![star > 2000][Awesome]](https://github.com/schollz/progressbar)   [![godoc][GoDoc]](https://godoc.org/github.com/schollz/progressbar)
* [uiprogress](https://github.com/gosuri/uiprogress) **star:1876** 在终端呈现进度条，可灵活配置的。   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/uiprogress)
* [termdash](https://github.com/mum4k/termdash) **star:1872** 此库是基于**termbox-go**实现的，借鉴于[termui](https://github.com/gizak/termui)。   [![最近一周有更新][Green]](https://github.com/mum4k/termdash)   [![godoc][GoDoc]](https://godoc.org/github.com/mum4k/termdash)
* [asciigraph](https://github.com/guptarohit/asciigraph) **star:1825** 在命令行中构建轻量级ASCII线图╭┈╯，应用程序中没有其他依赖项。   [![godoc][GoDoc]](https://godoc.org/github.com/guptarohit/asciigraph)
* [spinner](https://github.com/briandowns/spinner) **star:1672**  一个 Go 语言软件包，提供多种选项，方便在终端中创建加载动画。   [![godoc][GoDoc]](https://godoc.org/github.com/briandowns/spinner)
* [mpb](https://github.com/vbauerster/mpb) **star:1534** 可在终端显示多进度条。   [![最近一周有更新][Green]](https://github.com/vbauerster/mpb)   [![godoc][GoDoc]](https://godoc.org/github.com/vbauerster/mpb)
* [uilive](https://github.com/gosuri/uilive) **star:1407** 用于实时更新终端输出的库。   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/uilive)
* [aurora](https://github.com/logrusorgru/aurora) **star:1159** 支持fmt.Printf/Sprintf的ANSI终端颜色。   [![godoc][GoDoc]](https://godoc.org/github.com/logrusorgru/aurora)
* [gookit/color](https://github.com/gookit/color) **star:1003** 终端显色工具库，支持16种颜色，256种颜色，RGB显色输出，兼容Windows。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/color)   [![包含中文文档][CN]](https://github.com/gookit/color)
* [termenv](https://github.com/muesli/termenv) **star:875** 先进的ANSI风格和颜色支持您的终端应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/termenv)
* [uitable](https://github.com/gosuri/uitable) **star:626** 改善终端应用程序中表格数据的可读性。   [![最近一年没有更新][Yellow]](https://github.com/gosuri/uitable)   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/uitable)
* [go-isatty](https://github.com/mattn/go-isatty) **star:585** Go 实现的 isatty。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-isatty)
* [go-colorable](https://github.com/mattn/go-colorable) **star:583** 适用于windows的颜色编写器。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-colorable)
* [chalk](https://github.com/ttacon/chalk) **star:388** 美化终端/控制台输出。   [![最近一年没有更新][Yellow]](https://github.com/ttacon/chalk)   [![godoc][GoDoc]](https://godoc.org/github.com/ttacon/chalk)
* [simpletable](https://github.com/alexeyco/simpletable) **star:341** 可在终端显示简易表格。   [![godoc][GoDoc]](https://godoc.org/github.com/alexeyco/simpletable)
* [yacspin](https://github.com/theckman/yacspin) **star:306** 用于与终端旋转器一起工作。   [![godoc][GoDoc]](https://godoc.org/github.com/theckman/yacspin)
* [tabby](https://github.com/cheynewallace/tabby) **star:305** 一个可在终端生成一个极简Golang表格轻量级库   [![最近一年没有更新][Yellow]](https://github.com/cheynewallace/tabby)   [![godoc][GoDoc]](https://godoc.org/github.com/cheynewallace/tabby)
* [go-colortext](https://github.com/daviddengcn/go-colortext) **star:209** 在终端中使用彩色文字。   [![最近一年没有更新][Yellow]](https://github.com/daviddengcn/go-colortext)   [![godoc][GoDoc]](https://godoc.org/github.com/daviddengcn/go-colortext)
* [box-cli-maker](https://github.com/Delta456/box-cli-maker) **star:170** 为你的CLI制作高度定制的盒子。   [![最近一周有更新][Green]](https://github.com/Delta456/box-cli-maker)   [![godoc][GoDoc]](https://godoc.org/github.com/Delta456/box-cli-maker)
* [cfmt](https://github.com/mingrammer/cfmt) **star:81** 提供上下文的fmt，灵感来自于bootstrap color classes。   [![最近一年没有更新][Yellow]](https://github.com/mingrammer/cfmt)   [![godoc][GoDoc]](https://godoc.org/github.com/mingrammer/cfmt)
* [tabular](https://github.com/InVisionApp/tabular) **star:58** 不需要向API传递大量参数就可从命令行实用程序中打印ASCII表。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/tabular)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/tabular)
* [ctc](https://github.com/wzshiming/ctc) **star:37** 不需要Print方法的非侵入性跨平台终端颜色库。   [![最近一年没有更新][Yellow]](https://github.com/wzshiming/ctc)   [![godoc][GoDoc]](https://godoc.org/github.com/wzshiming/ctc)   [![包含中文文档][CN]](https://github.com/wzshiming/ctc)
* [cfmt](https://github.com/i582/cfmt) **star:33** 简单和方便格式化格式化输出完全兼容fmt库。   [![godoc][GoDoc]](https://godoc.org/github.com/i582/cfmt)
* [colourize](https://github.com/TreyBastian/colourize) **star:25** 在终端提供ANSI彩色文本。   [![最近一年没有更新][Yellow]](https://github.com/TreyBastian/colourize)   [![godoc][GoDoc]](https://godoc.org/github.com/TreyBastian/colourize)
* [marker](https://github.com/cyucelen/marker) **star:25** 最简单的方法来匹配和标记字符串的彩色终端输出。   [![最近一周有更新][Green]](https://github.com/cyucelen/marker)   [![godoc][GoDoc]](https://godoc.org/github.com/cyucelen/marker)
* [table](https://github.com/tomlazar/table) **star:14** 为基于终端颜色的表的小库。   [![godoc][GoDoc]](https://godoc.org/github.com/tomlazar/table)
* [go-ataman](https://github.com/workanator/go-ataman) **star:11** 在终端提供ANSI彩色文本模板。   [![最近一年没有更新][Yellow]](https://github.com/workanator/go-ataman)   [![godoc][GoDoc]](https://godoc.org/github.com/workanator/go-ataman)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#advanced-console-uis) 吧~)*

## 配置

*配置解析的库。 (翻译出错了? 试试 [英文版](README_EN.md#configuration) 吧~)*

* [viper](https://github.com/spf13/viper) **star:17951** 配置管理。   [![star > 2000][Awesome]](https://github.com/spf13/viper)   [![最近一周有更新][Green]](https://github.com/spf13/viper)   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/viper)
* [godotenv](https://github.com/joho/godotenv) **star:4469** Ruby 的 dotenv 库的 Go移植版(从.env文件加载环境变量)。   [![star > 2000][Awesome]](https://github.com/joho/godotenv)   [![最近一周有更新][Green]](https://github.com/joho/godotenv)   [![godoc][GoDoc]](https://godoc.org/github.com/joho/godotenv)
* [kelseyhightower/envconfig](https://github.com/kelseyhightower/envconfig) **star:3933** 管理来自环境变量的配置数据。   [![star > 2000][Awesome]](https://github.com/kelseyhightower/envconfig)   [![godoc][GoDoc]](https://godoc.org/github.com/kelseyhightower/envconfig)
* [ini](https://github.com/go-ini/ini) **star:2817**  读和写INI文件。   [![star > 2000][Awesome]](https://github.com/go-ini/ini)   [![最近一周有更新][Green]](https://github.com/go-ini/ini)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ini/ini)
* [env](https://github.com/caarlos0/env) **star:2219** 解析环境变量并赋值到struct中(默认值)。   [![star > 2000][Awesome]](https://github.com/caarlos0/env)   [![最近一周有更新][Green]](https://github.com/caarlos0/env)   [![godoc][GoDoc]](https://godoc.org/github.com/caarlos0/env)
* [kong](https://github.com/alecthomas/kong) **star:772** 命令行解析器，支持任意复杂的命令行结构和其他配置源，如YAML、JSON、TOML等(' kingpin '的后继)。   [![godoc][GoDoc]](https://godoc.org/github.com/alecthomas/kong)
* [koanf](https://github.com/knadh/koanf) **star:706** 轻量级可扩展库，用于读取Go应用程序中的配置。内置支持JSON, TOML, YAML, env，命令行。   [![最近一周有更新][Green]](https://github.com/knadh/koanf)   [![godoc][GoDoc]](https://godoc.org/github.com/knadh/koanf)
* [konfig](https://github.com/lalamove/konfig) **star:618** 可组合、可观察和高性能的分布式配置管理。   [![最近一年没有更新][Yellow]](https://github.com/lalamove/konfig)   [![godoc][GoDoc]](https://godoc.org/github.com/lalamove/konfig)
* [cleanenv](https://github.com/ilyakaznacheev/cleanenv) **star:445** 简约的配置阅读器(来自文件、环境，以及你想要的任何地方)。   [![godoc][GoDoc]](https://godoc.org/github.com/ilyakaznacheev/cleanenv)
* [confita](https://github.com/heetch/confita) **star:420** 从多个后端级联加载配置到struct中。   [![godoc][GoDoc]](https://godoc.org/github.com/heetch/confita)
* [aconfig](https://github.com/cristalhq/aconfig) **star:330** 简单，有用和固执的配置加载程序。   [![godoc][GoDoc]](https://godoc.org/github.com/cristalhq/aconfig)
* [gookit/config](https://github.com/gookit/config) **star:321** 程序配置管理(load,get,set)。支持JSON, YAML, TOML, INI, HCL。支持多文件加载，数据覆盖合并。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/config)   [![包含中文文档][CN]](https://github.com/gookit/config)
* [config](https://github.com/JeremyLoy/config) **star:287** 云本地应用程序配置。将ENV绑定到结构体仅需两行代码。   [![godoc][GoDoc]](https://godoc.org/github.com/JeremyLoy/config)
* [store](https://github.com/tucnak/store) **star:259** 轻量级配置管理器。   [![最近一年没有更新][Yellow]](https://github.com/tucnak/store)   [![godoc][GoDoc]](https://godoc.org/github.com/tucnak/store)
* [hjson](https://github.com/hjson/hjson-go) **star:252** 更加人性化的JSON配置。轻松的语法，更少的错误，更多的注释。   [![最近一周有更新][Green]](https://github.com/hjson/hjson-go)   [![godoc][GoDoc]](https://godoc.org/github.com/hjson/hjson-go)
* [config](https://github.com/olebedev/config) **star:241** 带有环境变量和标记解析的JSON或YAML配置包装器。   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/config)
* [config](https://github.com/golobby/config) **star:238** 一个轻量级但功能强大的配置包，用于Go项目。   [![godoc][GoDoc]](https://godoc.org/github.com/golobby/config)
* [envconfig](https://github.com/vrischmann/envconfig) **star:220** 从环境变量中读取配置。   [![godoc][GoDoc]](https://godoc.org/github.com/vrischmann/envconfig)
* [joshbetz/config](https://github.com/joshbetz/config) **star:209** 一个可解析环境变量、JSON文件小巧的配置库，在SIGHUP时会自动重新加载。   [![godoc][GoDoc]](https://godoc.org/github.com/joshbetz/config)
* [fig](https://github.com/kkyr/fig) **star:189** 用于从文件和环境变量(带有验证和默认值)中读取配置的微型库。   [![godoc][GoDoc]](https://godoc.org/github.com/kkyr/fig)
* [xdg](https://github.com/adrg/xdg) **star:161** Go实现[XDG基本目录规范](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html)和[XDG用户目录](https://wiki.archlinux.org/index.php/XDG_user_directories)。   [![godoc][GoDoc]](https://godoc.org/github.com/adrg/xdg)
* [gcfg](https://github.com/go-gcfg/gcfg) **star:156** 将ini的配置文件读入 Go structs中;支持用户定义的类型和子选项。   [![godoc][GoDoc]](https://godoc.org/github.com/go-gcfg/gcfg)
* [goConfig](https://github.com/crgimenes/goConfig) **star:149** 将结构体解析为输入，并用来自命令行、环境变量和配置文件的参数填充该结构体的字段。   [![godoc][GoDoc]](https://godoc.org/github.com/crgimenes/goConfig)
* [envh](https://github.com/antham/envh) **star:95** 协助管理环境变量的Helpers。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/envh)
* [envcfg](https://github.com/tomazk/envcfg) **star:94** 对环境变量进行解析，并赋值到struct。   [![最近一年没有更新][Yellow]](https://github.com/tomazk/envcfg)   [![godoc][GoDoc]](https://godoc.org/github.com/tomazk/envcfg)
* [harvester](https://github.com/beatlabs/harvester) **star:94** 一个易于使用的静态和动态配置包   [![godoc][GoDoc]](https://godoc.org/github.com/beatlabs/harvester)
* [onion](https://github.com/goraz/onion) **star:93** 基于层配置的Go，支持JSON, TOML, YAML，属性，etcd, env，和加密使用PGP。   [![godoc][GoDoc]](https://godoc.org/github.com/goraz/onion)
* [configuro](https://github.com/sherifabdlnaby/configuro) **star:80** 固执己见的配置加载和验证框架从环境和文件集中到12因素兼容的应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/sherifabdlnaby/configuro)
* [xdg](https://github.com/OpenPeeDeeP/xdg) **star:65** 遵循[XDG标准](https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html)的跨平台包。   [![最近一年没有更新][Yellow]](https://github.com/OpenPeeDeeP/xdg)   [![godoc][GoDoc]](https://godoc.org/github.com/OpenPeeDeeP/xdg)
* [gofigure](https://github.com/ian-kent/gofigure) **star:60** 让程序配置变得简单。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/gofigure)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/gofigure)
* [gone/jconf](https://github.com/One-com/gone/tree/master/jconf)  模块化的JSON配置。保持配置结构及其配置的代码，并将解析委托给子模块，而不牺牲配置的完整序列化。
* [configure](https://github.com/paked/configure) **star:54** 通过多个源提供配置，包括JSON、flags和环境变量。   [![最近一年没有更新][Yellow]](https://github.com/paked/configure)   [![godoc][GoDoc]](https://godoc.org/github.com/paked/configure)
* [configuration](https://github.com/BoRuDar/configuration) **star:43** 库，用于从环境变量、文件、标记和“默认”标记初始化配置结构。   [![godoc][GoDoc]](https://godoc.org/github.com/BoRuDar/configuration)
* [go-aws-ssm](https://github.com/PaddleHQ/go-aws-ssm) **star:43** 从AWS系统管理器-参数存储中获取参数的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/PaddleHQ/go-aws-ssm)
* [uConfig](https://github.com/omeid/uconfig) **star:40** 轻量级、零依赖和可扩展的配置管理。   [![godoc][GoDoc]](https://godoc.org/github.com/omeid/uconfig)
* [hocon](https://github.com/gurkankaymak/hocon) **star:37** 使用HOCON(一种人类友好的JSON超集)格式的配置库，支持环境变量、引用其他值、注释和多个文件等特性。   [![godoc][GoDoc]](https://godoc.org/github.com/gurkankaymak/hocon)
* [go-up](https://github.com/ufoscout/go-up) **star:35** 一个简单的配置库，具有递归占位符解析功能。   [![最近一年没有更新][Yellow]](https://github.com/ufoscout/go-up)   [![godoc][GoDoc]](https://godoc.org/github.com/ufoscout/go-up)
* [ingo](https://github.com/schachmat/ingo) **star:34** flag保存在类ini的配置文件中。   [![最近一年没有更新][Yellow]](https://github.com/schachmat/ingo)   [![godoc][GoDoc]](https://godoc.org/github.com/schachmat/ingo)
* [mini](https://github.com/sasbury/mini) **star:28** 用于解析ini类型的配置文件。   [![最近一年没有更新][Yellow]](https://github.com/sasbury/mini)   [![godoc][GoDoc]](https://godoc.org/github.com/sasbury/mini)
* [genv](https://github.com/sakirsensoy/genv) **star:25** 使用dotenv支持轻松读取环境变量。   [![最近一年没有更新][Yellow]](https://github.com/sakirsensoy/genv)   [![godoc][GoDoc]](https://godoc.org/github.com/sakirsensoy/genv)
* [conflate](https://github.com/the4thamigo-uk/conflate) **star:21** 合并来自任意url的多个JSON/YAML/TOML文件、针对JSON模式的验证以及模式中定义的默认值的应用程序。   [![最近一年没有更新][Yellow]](https://github.com/the4thamigo-uk/conflate)   [![godoc][GoDoc]](https://godoc.org/github.com/the4thamigo-uk/conflate)
* [go-ssm-config](https://github.com/ianlopshire/go-ssm-config) **star:10** 从AWS SSM(参数存储)加载配置参数的Go实用程序。   [![最近一年没有更新][Yellow]](https://github.com/ianlopshire/go-ssm-config)   [![godoc][GoDoc]](https://godoc.org/github.com/ianlopshire/go-ssm-config)
* [envconf](https://github.com/ian-kent/envconf) **star:9** 从环境配置中读取配置。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/envconf)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/envconf)
* [ini](https://github.com/wlevene/ini) **star:8** INI Parser & Write Library, Unmarshal to Struct,Marshal to Json,Write File,watch File。   [![godoc][GoDoc]](https://godoc.org/github.com/wlevene/ini)
* [nasermirzaei89/env](https://github.com/nasermirzaei89/env) **star:7** 读取环境变量的简单有用的包。   [![godoc][GoDoc]](https://godoc.org/github.com/nasermirzaei89/env)
* [go-ini](https://github.com/subpop/go-ini) **star:6** 一个对ini文件进行封送和解送的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/subpop/go-ini)
* [swap](https://github.com/oblq/swap) **star:4** 根据构建环境递归实例化/配置结构。(YAML, TOML, JSON和env)。   [![godoc][GoDoc]](https://godoc.org/github.com/oblq/swap)
* [typenv](https://github.com/diegomarangoni/typenv) **star:4** 简约，零依赖，类型化环境变量库。   [![最近一年没有更新][Yellow]](https://github.com/diegomarangoni/typenv)   [![godoc][GoDoc]](https://godoc.org/github.com/diegomarangoni/typenv)
* [gonfig](https://github.com/milad-abbasi/gonfig) **star:2** 基于标记的配置解析器，它将来自不同提供程序的值加载到类型安全结构中。   [![godoc][GoDoc]](https://godoc.org/github.com/milad-abbasi/gonfig)
* [go-conf](https://github.com/ThomasObenaus/go-conf) **star:1** 用于基于注释结构的应用程序配置的简单库。它支持从环境变量、配置文件和命令行参数读取配置。   [![godoc][GoDoc]](https://godoc.org/github.com/ThomasObenaus/go-conf)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#configuration) 吧~)*

## 持续集成

*用于帮助进行持续集成的工具。 (翻译出错了? 试试 [英文版](README_EN.md#continuous-integration) 吧~)*

* [drone](https://github.com/drone/drone) **star:24404** Drone 是一个基于 Docker 的持续集成平台，用 Go 编写。   [![star > 2000][Awesome]](https://github.com/drone/drone)   [![最近一周有更新][Green]](https://github.com/drone/drone)   [![godoc][GoDoc]](https://godoc.org/github.com/drone/drone)
* [CDS](https://github.com/ovh/cds) **star:3708** 企业级CI/CD和DevOps自动化开源平台。   [![star > 2000][Awesome]](https://github.com/ovh/cds)   [![最近一周有更新][Green]](https://github.com/ovh/cds)   [![godoc][GoDoc]](https://godoc.org/github.com/ovh/cds)
* [goveralls](https://github.com/mattn/goveralls) **star:708** Coveralls.io 是一个用 Go 编写，可持续对代码覆盖率进行检测的系统。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/goveralls)
* [gotestfmt](https://github.com/haveyoudebuggedit/gotestfmt) **star:188** 为人类测试输出。   [![最近一周有更新][Green]](https://github.com/haveyoudebuggedit/gotestfmt)   [![godoc][GoDoc]](https://godoc.org/github.com/haveyoudebuggedit/gotestfmt)
* [overalls](https://github.com/go-playground/overalls) **star:108** 针对多package 的 Go 语言项目，可为类似 goveralls 这样的工具生成覆盖率报告。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/overalls)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/overalls)
* [duci](https://github.com/duck8823/duci) **star:70** 一个简单的 ci 服务。   [![最近一周有更新][Green]](https://github.com/duck8823/duci)   [![godoc][GoDoc]](https://godoc.org/github.com/duck8823/duci)
* [gomason](https://github.com/nikogura/gomason) **star:51** 在一个干净的工作区中对你的 Go 二进制文件进行测试、构建、签名和发布。   [![godoc][GoDoc]](https://godoc.org/github.com/nikogura/gomason)
* [roveralls](https://github.com/LawrenceWoodman/roveralls) **star:15** 递归覆盖测试工具。   [![最近一年没有更新][Yellow]](https://github.com/LawrenceWoodman/roveralls)   [![godoc][GoDoc]](https://godoc.org/github.com/LawrenceWoodman/roveralls)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#continuous-integration) 吧~)*

## CSS预处理器

*用于预处理CSS文件的库。 (翻译出错了? 试试 [英文版](README_EN.md#css-preprocessors) 吧~)*

* [gcss](https://github.com/yosssi/gcss) **star:444** 纯Go编写的 CSS 预处理器。   [![最近一年没有更新][Yellow]](https://github.com/yosssi/gcss)   [![godoc][GoDoc]](https://godoc.org/github.com/yosssi/gcss)
* [go-libsass](https://github.com/wellington/go-libsass) **star:183**  采用 Go封装，100% 与 Sass 兼容的 libsass 项目。   [![最近一年没有更新][Yellow]](https://github.com/wellington/go-libsass)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#css-preprocessors) 吧~)*

## 数据结构

*用 Go 实现的通用的数据结构和算法。 (翻译出错了? 试试 [英文版](README_EN.md#data-structures) 吧~)*

* [gods](https://github.com/emirpasic/gods) **star:10958** 数据结构。容器、集合、列表、堆栈、地图、BidiMaps、树、HashSet等。   [![star > 2000][Awesome]](https://github.com/emirpasic/gods)   [![godoc][GoDoc]](https://godoc.org/github.com/emirpasic/gods)
* [go-datastructures](https://github.com/Workiva/go-datastructures) **star:6330** 可靠的、高性能的和线程安全的数据结构的集合。   [![star > 2000][Awesome]](https://github.com/Workiva/go-datastructures)   [![godoc][GoDoc]](https://godoc.org/github.com/Workiva/go-datastructures)
* [golang-set](https://github.com/deckarep/golang-set) **star:2212** 线程安全和非线程安全的高性能集。   [![star > 2000][Awesome]](https://github.com/deckarep/golang-set)   [![godoc][GoDoc]](https://godoc.org/github.com/deckarep/golang-set)
* [gota](https://github.com/kniren/gota) **star:1938** 实现了数据帧，序列以及数据噪音。   [![godoc][GoDoc]](https://godoc.org/github.com/kniren/gota)
* [roaring](https://github.com/RoaringBitmap/roaring) **star:1460** 实现了压缩 bitsets 的Go包。   [![最近一周有更新][Green]](https://github.com/RoaringBitmap/roaring)   [![godoc][GoDoc]](https://godoc.org/github.com/RoaringBitmap/roaring)
* [willf/bloom](https://github.com/willf/bloom) **star:1411** 实现Bloom过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/willf/bloom)
* [boomfilters](https://github.com/tylertreat/BoomFilters) **star:1402** 用于处理连续的概率数据结构。   [![godoc][GoDoc]](https://godoc.org/github.com/tylertreat/BoomFilters)
* [gocache](https://github.com/eko/gocache) **star:1043** 一个完整的Go缓存库，具有多个存储(内存，memcache, redis，…)，可链，可加载，指标缓存和更多。   [![最近一周有更新][Green]](https://github.com/eko/gocache)   [![godoc][GoDoc]](https://godoc.org/github.com/eko/gocache)
* [cuckoofilter](https://github.com/seiflotfy/cuckoofilter) **star:860** 布谷鸟过滤器:一个用Go实现，可替代计数 bloom 过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/seiflotfy/cuckoofilter)
* [bitset](https://github.com/willf/bitset) **star:818** 实现了 bitsets 的 Go 包。   [![最近一周有更新][Green]](https://github.com/willf/bitset)   [![godoc][GoDoc]](https://godoc.org/github.com/willf/bitset)
* [hyperloglog](https://github.com/axiomhq/hyperloglog) **star:763** HyperLogLog implementation with Sparse, LogLog-Beta bias correction and TailCut space reduction.   [![godoc][GoDoc]](https://godoc.org/github.com/axiomhq/hyperloglog)
* [algorithms](https://github.com/shady831213/algorithms) **star:602** 算法和数据结构。来源于CLRS。   [![godoc][GoDoc]](https://godoc.org/github.com/shady831213/algorithms)
* [trie](https://github.com/derekparker/trie) **star:566** 在Go中实现Trie。   [![最近一年没有更新][Yellow]](https://github.com/derekparker/trie)   [![godoc][GoDoc]](https://godoc.org/github.com/derekparker/trie)
* [gostl](https://github.com/liyue201/gostl) **star:362** 用于go的数据结构和算法库，旨在提供类似c++ STL的函数。   [![godoc][GoDoc]](https://godoc.org/github.com/liyue201/gostl)
* [go-geoindex](https://github.com/hailocab/go-geoindex) **star:333** 基于内存的地理索引。   [![最近一年没有更新][Yellow]](https://github.com/hailocab/go-geoindex)   [![godoc][GoDoc]](https://godoc.org/github.com/hailocab/go-geoindex)
* [ttlcache](https://github.com/ReneKroon/ttlcache) **star:333** 内存中的string-interface{}缓存各种基于时间的过期选项和回调。   [![最近一周有更新][Green]](https://github.com/ReneKroon/ttlcache)   [![godoc][GoDoc]](https://godoc.org/github.com/ReneKroon/ttlcache)
* [merkletree](https://github.com/cbergoon/merkletree) **star:301** 实现了merkle树，提供了对数据结构内容的有效和安全的验证。   [![最近一年没有更新][Yellow]](https://github.com/cbergoon/merkletree)   [![godoc][GoDoc]](https://godoc.org/github.com/cbergoon/merkletree)
* [go-edlib](https://github.com/hbollon/go-edlib) **star:300** Go字符串比较和编辑距离算法库(Levenshtein, LCS, Hamming, Damerau Levenshtein, Jaro-Winkler等)兼容Unicode。   [![最近一周有更新][Green]](https://github.com/hbollon/go-edlib)   [![godoc][GoDoc]](https://godoc.org/github.com/hbollon/go-edlib)
* [deque](https://github.com/gammazero/deque) **star:274** 快速环缓冲区deque(双端队列)。   [![godoc][GoDoc]](https://godoc.org/github.com/gammazero/deque)
* [hilbert](https://github.com/google/hilbert) **star:240** 用于映射空间填充曲线（例如 Hilbert 曲线和 Peano 曲线）和数值。   [![最近一年没有更新][Yellow]](https://github.com/google/hilbert)   [![godoc][GoDoc]](https://godoc.org/github.com/google/hilbert)
* [goskiplist](https://github.com/ryszard/goskiplist) **star:230** 基于 Go 的跳表实现。   [![最近一年没有更新][Yellow]](https://github.com/ryszard/goskiplist)   [![godoc][GoDoc]](https://godoc.org/github.com/ryszard/goskiplist)
* [go-adaptive-radix-tree](https://github.com/plar/go-adaptive-radix-tree) **star:220** 自适应基数树。   [![最近一年没有更新][Yellow]](https://github.com/plar/go-adaptive-radix-tree)   [![godoc][GoDoc]](https://godoc.org/github.com/plar/go-adaptive-radix-tree)
* [cuckoo-filter](https://github.com/linvon/cuckoo-filter) **star:193** 布谷鸟滤波器:一种综合布谷鸟滤波器，与其他实现相比，具有可配置性和空间优化性，原论文中提到的所有特性均可获得。   [![godoc][GoDoc]](https://godoc.org/github.com/linvon/cuckoo-filter)   [![包含中文文档][CN]](https://github.com/linvon/cuckoo-filter)
* [skiplist](https://github.com/MauriceGit/skiplist) **star:183** 高性能的 Go 跳表实现。   [![godoc][GoDoc]](https://godoc.org/github.com/MauriceGit/skiplist)
* [binpacker](https://github.com/zhuangsirui/binpacker) **star:179** 帮助用户构建自定义二进制流的二进制封装器和解包器   [![godoc][GoDoc]](https://godoc.org/github.com/zhuangsirui/binpacker)
* [levenshtein](https://github.com/agnivade/levenshtein) **star:171** 实现在Go中计算levenshtein距离。   [![godoc][GoDoc]](https://godoc.org/github.com/agnivade/levenshtein)
* [goconcurrentqueue](https://github.com/enriquebris/goconcurrentqueue) **star:155** 并行FIFO队列。   [![最近一年没有更新][Yellow]](https://github.com/enriquebris/goconcurrentqueue)   [![godoc][GoDoc]](https://godoc.org/github.com/enriquebris/goconcurrentqueue)
* [bloom](https://github.com/zhenjl/bloom) **star:145** 在Go中实现了Bloom过滤器。   [![最近一年没有更新][Yellow]](https://github.com/zhenjl/bloom)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenjl/bloom)
* [iter](https://github.com/disksing/iter) **star:141** Go实现的c++ STL迭代器和算法。   [![最近一年没有更新][Yellow]](https://github.com/disksing/iter)   [![godoc][GoDoc]](https://godoc.org/github.com/disksing/iter)   [![包含中文文档][CN]](https://github.com/disksing/iter)
* [ring](https://github.com/TheTannerRyan/ring) **star:122** 高性能、线程安全的bloom过滤器。   [![最近一年没有更新][Yellow]](https://github.com/TheTannerRyan/ring)   [![godoc][GoDoc]](https://godoc.org/github.com/TheTannerRyan/ring)
* [go-rquad](https://github.com/aurelien-rainone/go-rquad) **star:119** 区域四叉树具有高效的点定位和邻域查找功能。   [![最近一年没有更新][Yellow]](https://github.com/aurelien-rainone/go-rquad)   [![godoc][GoDoc]](https://godoc.org/github.com/aurelien-rainone/go-rquad)
* [bitmap](https://github.com/kelindar/bitmap) **star:114** 高密度，零分配，在Go中启用simd位图/bitset。   [![godoc][GoDoc]](https://godoc.org/github.com/kelindar/bitmap)
* [encoding](https://github.com/zhenjl/encoding) **star:110** 整形压缩库。   [![最近一年没有更新][Yellow]](https://github.com/zhenjl/encoding)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenjl/encoding)
* [bit](https://github.com/yourbasic/bit) **star:109** Go 语言集合数据结构。提供了额外的位操作功能。   [![最近一年没有更新][Yellow]](https://github.com/yourbasic/bit)   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/bit)
* [remember-go](https://github.com/rocketlaunchr/remember-go) **star:107** 用于缓存慢速数据库查询的通用接口(支持redis、memcached、ristretto或in-memory)。   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/remember-go)
* [conjungo](https://github.com/InVisionApp/conjungo) **star:99** 一个小型、强大和灵活的合并库。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/conjungo)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/conjungo)
* [skiplist](https://github.com/gansidui/skiplist) **star:76** 在Go中实现了跳表。   [![最近一年没有更新][Yellow]](https://github.com/gansidui/skiplist)   [![godoc][GoDoc]](https://godoc.org/github.com/gansidui/skiplist)
* [go-mcache](https://github.com/OrlovEvgeny/go-mcache) **star:74** 基于内存的实现了高性能的key:value存储库。指针缓存。   [![最近一年没有更新][Yellow]](https://github.com/OrlovEvgeny/go-mcache)   [![godoc][GoDoc]](https://godoc.org/github.com/OrlovEvgeny/go-mcache)
* [bloom](https://github.com/yourbasic/bloom) **star:65** Golang Bloom过滤器的实现。   [![最近一年没有更新][Yellow]](https://github.com/yourbasic/bloom)   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/bloom)
* [levenshtein](https://github.com/agext/levenshtein) **star:60** Levenshtein distance and similarity metrics with customizable edit costs and Winkler-like bonus for common prefix.   [![最近一年没有更新][Yellow]](https://github.com/agext/levenshtein)   [![godoc][GoDoc]](https://godoc.org/github.com/agext/levenshtein)
* [count-min-log](https://github.com/seiflotfy/count-min-log) **star:54** Go实现Count-Min-log sketch的功能 : 使用近似计数器进行近似计数(类似Count-Min sketch，但使用更少内存)。   [![最近一年没有更新][Yellow]](https://github.com/seiflotfy/count-min-log)   [![godoc][GoDoc]](https://godoc.org/github.com/seiflotfy/count-min-log)
* [crunch](https://github.com/superwhiskers/crunch) **star:47** 打包实现缓冲区，以便轻松处理各种数据类型。   [![godoc][GoDoc]](https://godoc.org/github.com/superwhiskers/crunch)
* [nan](https://github.com/kak-tus/nan) **star:46** 一个库中的可零分配空结构，具有方便的转换函数、编组器和解组器。   [![godoc][GoDoc]](https://godoc.org/github.com/kak-tus/nan)
* [goset](https://github.com/zoumo/goset) **star:43** 一个有用的Go集合实现。   [![最近一年没有更新][Yellow]](https://github.com/zoumo/goset)   [![godoc][GoDoc]](https://godoc.org/github.com/zoumo/goset)
* [hide](https://github.com/emvi/hide) **star:42** ID type with marshalling to/from hash to prevent sending IDs to clients.   [![godoc][GoDoc]](https://godoc.org/github.com/emvi/hide)
* [pipeline](https://github.com/hyfather/pipeline) **star:38** 实现了 fan-in 和 fan-out 的管道功能。   [![godoc][GoDoc]](https://godoc.org/github.com/hyfather/pipeline)
* [deque](https://github.com/edwingeng/deque) **star:37** 高度优化的双端队列。   [![godoc][GoDoc]](https://godoc.org/github.com/edwingeng/deque)
* [concurrent-writer](https://github.com/free/concurrent-writer) **star:36** 具备高并发能力，可替换 bufio.Writer。   [![最近一年没有更新][Yellow]](https://github.com/free/concurrent-writer)   [![godoc][GoDoc]](https://godoc.org/github.com/free/concurrent-writer)
* [timedmap](https://github.com/zekroTJA/timedmap) **star:36** 实现了有生命周期的键值对Map。   [![godoc][GoDoc]](https://godoc.org/github.com/zekroTJA/timedmap)
* [typ](https://github.com/gurukami/typ) **star:29** 从复杂结构中获取值，支持空类型、安全的类型转换。   [![godoc][GoDoc]](https://godoc.org/github.com/gurukami/typ)
* [null](https://github.com/emvi/null) **star:24** 对空的 Go 数据类型也可以进行JSON进行解析/反解析。   [![godoc][GoDoc]](https://godoc.org/github.com/emvi/null)
* [dict](https://github.com/srfrog/dict) **star:22** 实现类似 python dict的功能(dict)。   [![最近一年没有更新][Yellow]](https://github.com/srfrog/dict)   [![godoc][GoDoc]](https://godoc.org/github.com/srfrog/dict)
* [cmap](https://github.com/lrita/cmap) **star:21** 一个线程安全的go map   [![最近一年没有更新][Yellow]](https://github.com/lrita/cmap)   [![godoc][GoDoc]](https://godoc.org/github.com/lrita/cmap)
* [go-ef](https://github.com/amallia/go-ef) **star:18** 实现了 Elias-Fano 编码。   [![最近一年没有更新][Yellow]](https://github.com/amallia/go-ef)   [![godoc][GoDoc]](https://godoc.org/github.com/amallia/go-ef)
* [ptrie](https://github.com/viant/ptrie) **star:17** 前缀树的一种实现。   [![最近一年没有更新][Yellow]](https://github.com/viant/ptrie)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/ptrie)
* [set](https://github.com/StudioSol/set) **star:17** 使用LinkedHashMap在Go中实现简单的set数据结构。   [![godoc][GoDoc]](https://godoc.org/github.com/StudioSol/set)
* [mspm](https://github.com/BlackRabbitt/mspm) **star:16** 用于信息检索的多字符串模式匹配算法。   [![最近一年没有更新][Yellow]](https://github.com/BlackRabbitt/mspm)   [![godoc][GoDoc]](https://godoc.org/github.com/BlackRabbitt/mspm)
* [fsm](https://github.com/cocoonspace/fsm) **star:13** 有限状态机包。   [![godoc][GoDoc]](https://godoc.org/github.com/cocoonspace/fsm)
* [parapipe](https://github.com/nazar256/parapipe) **star:13** FIFO管道，并行执行在每个阶段，同时保持消息和结果的顺序。   [![godoc][GoDoc]](https://godoc.org/github.com/nazar256/parapipe)
* [ordered-concurrently](https://github.com/tejzpr/ordered-concurrently) **star:12** Go模块，处理并发工作，并在通道中返回输入顺序的输出。   [![godoc][GoDoc]](https://godoc.org/github.com/tejzpr/ordered-concurrently)
* [treap](https://github.com/perdata/treap) **star:12** 使用树堆进行持久、快速有序的映射。   [![最近一年没有更新][Yellow]](https://github.com/perdata/treap)   [![godoc][GoDoc]](https://godoc.org/github.com/perdata/treap)
* [gofal](https://github.com/xxjwxc/gofal) **star:9** 基于 Go 实现的分数计算。包含分子、分母运算    [![最近一年没有更新][Yellow]](https://github.com/xxjwxc/gofal)   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/gofal)   [![包含中文文档][CN]](https://github.com/xxjwxc/gofal)
* [bloomfilter](https://github.com/OldPanda/bloomfilter) **star:8** 另一个在Go中的Bloomfilter实现，与Java的番石榴库兼容。   [![godoc][GoDoc]](https://godoc.org/github.com/OldPanda/bloomfilter)
* [gdcache](https://github.com/ulovecode/gdcache) **star:6** 一个由golang实现的纯非侵入式缓存库，您可以使用它来实现您自己的分布式缓存。   [![godoc][GoDoc]](https://godoc.org/github.com/ulovecode/gdcache)   [![包含中文文档][CN]](https://github.com/ulovecode/gdcache)
* [goterator](https://github.com/yaa110/goterator) **star:6** 迭代器实现，提供映射和减少功能。   [![最近一年没有更新][Yellow]](https://github.com/yaa110/goterator)   [![godoc][GoDoc]](https://godoc.org/github.com/yaa110/goterator)
* [hashsplit](http://github.com/bobg/hashsplit)  将字节流分割成块，并将块排列成树，边界由内容而不是位置决定。
* [parsefields](https://github.com/MonaxGT/parsefields) **star:6** 用于解析类似json的日志的工具，用于收集惟一的字段和事件。   [![最近一年没有更新][Yellow]](https://github.com/MonaxGT/parsefields)   [![godoc][GoDoc]](https://godoc.org/github.com/MonaxGT/parsefields)
* [dsu](https://github.com/ihebu/dsu) **star:5** 在Go中实现离散集数据结构。   [![godoc][GoDoc]](https://godoc.org/github.com/ihebu/dsu)
* [slices](https://github.com/srfrog/slices) **star:5** 对片进行操作的函数;类似于“包字符串”，但适用于使用片。   [![最近一年没有更新][Yellow]](https://github.com/srfrog/slices)   [![godoc][GoDoc]](https://godoc.org/github.com/srfrog/slices)
* [merkle](https://github.com/bobg/merkle) **star:1** 默克尔根哈希的空间高效计算和包含证明。   [![godoc][GoDoc]](https://godoc.org/github.com/bobg/merkle)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#data-structures) 吧~)*

## 数据库

*数据库。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [prometheus](https://github.com/prometheus/prometheus) **star:40484** 用于监控系统和时序的数据库。   [![star > 2000][Awesome]](https://github.com/prometheus/prometheus)   [![最近一周有更新][Green]](https://github.com/prometheus/prometheus)   [![godoc][GoDoc]](https://godoc.org/github.com/prometheus/prometheus)
* [tidb](https://github.com/pingcap/tidb) **star:30151** TiDB是一个分布式SQL数据库。灵感来自谷歌F1的设计。   [![star > 2000][Awesome]](https://github.com/pingcap/tidb)   [![最近一周有更新][Green]](https://github.com/pingcap/tidb)   [![godoc][GoDoc]](https://godoc.org/github.com/pingcap/tidb)   [![包含中文文档][CN]](https://github.com/pingcap/tidb)
* [cockroach](https://github.com/cockroachdb/cockroach) **star:23129** 可伸缩、区域备份、事务性数据存储。   [![star > 2000][Awesome]](https://github.com/cockroachdb/cockroach)   [![最近一周有更新][Green]](https://github.com/cockroachdb/cockroach)   [![godoc][GoDoc]](https://godoc.org/github.com/cockroachdb/cockroach)
* [influxdb](https://github.com/influxdb/influxdb) **star:22719** 可伸缩的数据存储，用于指标衡量、事件和实时分析。   [![star > 2000][Awesome]](https://github.com/influxdb/influxdb)   [![最近一周有更新][Green]](https://github.com/influxdb/influxdb)   [![godoc][GoDoc]](https://godoc.org/github.com/influxdb/influxdb)
* [dgraph](https://github.com/dgraph-io/dgraph) **star:17256** 可伸缩、分布式、低延迟、高吞吐量的图形数据库。   [![star > 2000][Awesome]](https://github.com/dgraph-io/dgraph)   [![最近一周有更新][Green]](https://github.com/dgraph-io/dgraph)   [![godoc][GoDoc]](https://godoc.org/github.com/dgraph-io/dgraph)
* [groupcache](https://github.com/golang/groupcache) **star:11068** Groupcache是一个缓存和缓存填充库，在许多情况下，它是memcached的替代品。   [![star > 2000][Awesome]](https://github.com/golang/groupcache)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/groupcache)
* [badger](https://github.com/dgraph-io/badger) **star:10259** 快速 K/V 存储。   [![star > 2000][Awesome]](https://github.com/dgraph-io/badger)   [![godoc][GoDoc]](https://godoc.org/github.com/dgraph-io/badger)
* [rqlite](https://github.com/rqlite/rqlite) **star:9303** 基于SQLite的轻量级分布式关系数据库。   [![star > 2000][Awesome]](https://github.com/rqlite/rqlite)   [![最近一周有更新][Green]](https://github.com/rqlite/rqlite)   [![godoc][GoDoc]](https://godoc.org/github.com/rqlite/rqlite)
* [Milvus](https://github.com/milvus-io/milvus) **star:9223** Milvus是一个矢量数据库，用于嵌入管理、分析和搜索。   [![star > 2000][Awesome]](https://github.com/milvus-io/milvus)   [![最近一周有更新][Green]](https://github.com/milvus-io/milvus)   [![godoc][GoDoc]](https://godoc.org/github.com/milvus-io/milvus)
* [immudb](https://github.com/codenotary/immudb) **star:6851** immudb是一个轻量级、高速、不可变的数据库，用于用Go编写的系统和应用程序。   [![star > 2000][Awesome]](https://github.com/codenotary/immudb)   [![最近一周有更新][Green]](https://github.com/codenotary/immudb)   [![godoc][GoDoc]](https://godoc.org/github.com/codenotary/immudb)
* [go-cache](https://github.com/pmylund/go-cache) **star:5766** 基于内存的 K/V 存储/缓存 : (类似于Memcached)，适用于单机应用程序。   [![star > 2000][Awesome]](https://github.com/pmylund/go-cache)   [![godoc][GoDoc]](https://godoc.org/github.com/pmylund/go-cache)
* [VictoriaMetrics](https://github.com/VictoriaMetrics/VictoriaMetrics) **star:5687** 开源，快速，可伸缩的时间序列数据库。支持PromQL。   [![star > 2000][Awesome]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![最近一周有更新][Green]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![godoc][GoDoc]](https://godoc.org/github.com/VictoriaMetrics/VictoriaMetrics)
* [BigCache](https://github.com/allegro/bigcache) **star:5381** 高效的键/值缓存为千兆字节的数据。   [![star > 2000][Awesome]](https://github.com/allegro/bigcache)   [![godoc][GoDoc]](https://godoc.org/github.com/allegro/bigcache)
* [Bitcask](https://git.mills.io/prologic/bitcask)  Bitcask是一个可嵌入的、持久的、快速的键值(KV)数据库，使用纯Go编写，具有可预测的读写性能、低延迟和高吞吐量，这得益于Bitcask的磁盘布局(LSM+WAL)。
* [bbolt](https://github.com/etcd-io/bbolt) **star:5109** 一个用于Go的嵌入式键/值数据库。   [![star > 2000][Awesome]](https://github.com/etcd-io/bbolt)   [![最近一周有更新][Green]](https://github.com/etcd-io/bbolt)   [![godoc][GoDoc]](https://godoc.org/github.com/etcd-io/bbolt)
* [goleveldb](https://github.com/syndtr/goleveldb) **star:4851** 在Go中实现[LevelDB](https://github.com/google/leveldb) key/value数据库。   [![star > 2000][Awesome]](https://github.com/syndtr/goleveldb)   [![godoc][GoDoc]](https://godoc.org/github.com/syndtr/goleveldb)
* [dtm](https://github.com/yedf/dtm) **star:4607** 分布式事务管理器。支持XA, TCC, SAGA，可靠消息。   [![star > 2000][Awesome]](https://github.com/yedf/dtm)   [![最近一周有更新][Green]](https://github.com/yedf/dtm)   [![godoc][GoDoc]](https://godoc.org/github.com/yedf/dtm)   [![包含中文文档][CN]](https://github.com/yedf/dtm)
* [ledisdb](https://github.com/siddontang/ledisdb) **star:3795** Ledisdb是一种高性能的NoSQL，类似于基于LevelDB的Redis。   [![star > 2000][Awesome]](https://github.com/siddontang/ledisdb)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/ledisdb)
* [buntdb](https://github.com/tidwall/buntdb) **star:3620** 基于内存的K/V，快速，可嵌入的数据库，可自定义索引和空间支持。   [![star > 2000][Awesome]](https://github.com/tidwall/buntdb)   [![godoc][GoDoc]](https://godoc.org/github.com/tidwall/buntdb)
* [tiedot](https://github.com/HouzuoGuo/tiedot) **star:2649** 属于你的NoSQL数据库。   [![star > 2000][Awesome]](https://github.com/HouzuoGuo/tiedot)   [![godoc][GoDoc]](https://godoc.org/github.com/HouzuoGuo/tiedot)
* [rosedb](https://github.com/roseduan/rosedb) **star:2213** 基于LSM+WAL的嵌入式k-v数据库，支持string、list、hash、set、zset。   [![star > 2000][Awesome]](https://github.com/roseduan/rosedb)   [![最近一周有更新][Green]](https://github.com/roseduan/rosedb)   [![godoc][GoDoc]](https://godoc.org/github.com/roseduan/rosedb)   [![包含中文文档][CN]](https://github.com/roseduan/rosedb)
* [nutsdb](https://github.com/xujiajun/nutsdb) **star:1849** Nutsdb是一个用纯Go编写的简单、快速、可嵌入、持久的键/值存储。它支持完全序列化的事务和许多数据结构，如列表、集合、排序集。   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/nutsdb)   [![包含中文文档][CN]](https://github.com/xujiajun/nutsdb)
* [GCache](https://github.com/bluele/gcache) **star:1805** 支持过期缓存、LFU、LRU和ARC的缓存库。   [![godoc][GoDoc]](https://godoc.org/github.com/bluele/gcache)
* [cache2go](https://github.com/muesli/cache2go) **star:1668** 基于内存的 K/V 缓存，支持超时的自动失效。   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/cache2go)
* [godis](https://github.com/hdt3213/godis) **star:1638** 一个Golang实现了高性能Redis服务器和集群。   [![godoc][GoDoc]](https://godoc.org/github.com/hdt3213/godis)   [![包含中文文档][CN]](https://github.com/hdt3213/godis)
* [fastcache](https://github.com/VictoriaMetrics/fastcache) **star:1320** 基于内存的快速线程安全的缓存，可缓存大量的条目。最大限度地减少GC开销。   [![godoc][GoDoc]](https://godoc.org/github.com/VictoriaMetrics/fastcache)
* [CovenantSQL](https://github.com/CovenantSQL/CovenantSQL) **star:1267** 区块链领域的一个SQL数据库。   [![godoc][GoDoc]](https://godoc.org/github.com/CovenantSQL/CovenantSQL)
* [diskv](https://github.com/peterbourgon/diskv) **star:1124** 支持磁盘备份的可持久化 K/V 存储。   [![godoc][GoDoc]](https://godoc.org/github.com/peterbourgon/diskv)
* [Databunker](https://github.com/paranoidguy/databunker) **star:943** 个人身份信息(PII)存储服务符合GDPR和CCPA。   [![最近一周有更新][Green]](https://github.com/paranoidguy/databunker)   [![godoc][GoDoc]](https://godoc.org/github.com/paranoidguy/databunker)
* [eliasdb](https://github.com/krotik/eliasdb) **star:867** 无其他依赖项，支持REST API，短语搜索和sql类似的查询语言的事务图数据库。   [![godoc][GoDoc]](https://godoc.org/github.com/krotik/eliasdb)
* [column](https://github.com/kelindar/column) **star:857** 高性能、柱状、可嵌入的内存存储，具有位图索引和事务。   [![最近一周有更新][Green]](https://github.com/kelindar/column)   [![godoc][GoDoc]](https://godoc.org/github.com/kelindar/column)
* [pogreb](https://github.com/akrylysov/pogreb) **star:856** 针对大量读取工作负载的嵌入式键值存储。   [![godoc][GoDoc]](https://godoc.org/github.com/akrylysov/pogreb)
* [moss](https://github.com/couchbase/moss) **star:853** Moss是一个用100% Go编写的简单LSM键值存储引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/moss)
* [levigo](https://github.com/jmhodges/levigo) **star:402** 实现了对LevelDB封装。   [![godoc][GoDoc]](https://godoc.org/github.com/jmhodges/levigo)
* [pudge](https://github.com/recoilme/pudge) **star:306** 使用Go的标准库编写的快速和简单的键/值存储。   [![godoc][GoDoc]](https://godoc.org/github.com/recoilme/pudge)
* [Vasto](https://github.com/chrislusf/vasto) **star:233** 分布式高性能键值存储。可做磁盘备份。最终一致。高可用。能够在不中断服务的情况下增长或收缩。   [![最近一年没有更新][Yellow]](https://github.com/chrislusf/vasto)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/vasto)
* [Kivik](https://github.com/go-kivik/kivik) **star:219** Kivik为CouchDB、PouchDB和类似的数据库提供了一个通用的Go和GopherJS客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/go-kivik/kivik)
* [piladb](https://github.com/fern4lvarez/piladb) **star:193** 基于堆栈数据结构的轻量级RESTful数据库引擎。   [![最近一年没有更新][Yellow]](https://github.com/fern4lvarez/piladb)   [![godoc][GoDoc]](https://godoc.org/github.com/fern4lvarez/piladb)
* [Scribble](https://github.com/nanobox-io/golang-scribble) **star:143** 小型平面文件JSON存储。   [![最近一年没有更新][Yellow]](https://github.com/nanobox-io/golang-scribble)   [![godoc][GoDoc]](https://godoc.org/github.com/nanobox-io/golang-scribble)
* [cache](https://github.com/akyoto/cache) **star:100** 基于内存的 K/V 存储:带生命周期的值存储，0个依赖项，<100 LoC, 100%覆盖率。   [![最近一年没有更新][Yellow]](https://github.com/akyoto/cache)   [![godoc][GoDoc]](https://godoc.org/github.com/akyoto/cache)
* [slowpoke](https://github.com/recoilme/slowpoke) **star:98** 具有持久性的键值存储。   [![最近一年没有更新][Yellow]](https://github.com/recoilme/slowpoke)   [![godoc][GoDoc]](https://godoc.org/github.com/recoilme/slowpoke)   [![归档项目][Archived]](https://github.com/recoilme/slowpoke)
* [unitdb](https://github.com/unit-io/unitdb) **star:82** 快速timeseries数据库物联网，实时消息传递应用程序。使用pubsub通过tcp或websocket访问unitdb，使用github.com/unit-io/unitd应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/unit-io/unitdb)
* [bcache](https://github.com/iwanbk/bcache) **star:76** 基于内存的最终一致的分布式缓存。   [![最近一年没有更新][Yellow]](https://github.com/iwanbk/bcache)   [![godoc][GoDoc]](https://godoc.org/github.com/iwanbk/bcache)
* [couchcache](https://github.com/codingsince1985/couchcache) **star:53** 由 Couchbase服务 支持的RESTful缓存微服务。   [![godoc][GoDoc]](https://godoc.org/github.com/codingsince1985/couchcache)
* [hare](https://github.com/jameycribbs/hare) **star:48** 一个简单的数据库管理系统，将每个表存储为一行分隔的JSON文本文件。   [![godoc][GoDoc]](https://godoc.org/github.com/jameycribbs/hare)
* [clusteredBigCache](https://github.com/oaStuff/clusteredBigCache) **star:39** BigCache 支持集群和独立且生命周期存储项。   [![最近一年没有更新][Yellow]](https://github.com/oaStuff/clusteredBigCache)   [![godoc][GoDoc]](https://godoc.org/github.com/oaStuff/clusteredBigCache)
* [Coffer](https://github.com/claygod/coffer) **star:27** 支持事务的简单ACID键值数据库。   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/coffer)
* [tempdb](https://github.com/rafaeljesus/tempdb) **star:15** 用于临时数据存放的 K/V 存储。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/tempdb)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/tempdb)
* [ttlcache](https://github.com/cheshir/ttlcache) **star:4** 内存键值存储与TTL为每个记录。   [![godoc][GoDoc]](https://godoc.org/github.com/cheshir/ttlcache)

*数据库迁移。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [migrate](https://github.com/golang-migrate/migrate) **star:7884** 基于CLI的数据库迁移库。   [![star > 2000][Awesome]](https://github.com/golang-migrate/migrate)   [![最近一周有更新][Green]](https://github.com/golang-migrate/migrate)   [![godoc][GoDoc]](https://godoc.org/github.com/golang-migrate/migrate)
* [sql-migrate](https://github.com/rubenv/sql-migrate) **star:2356** 数据库迁移工具。允许使用go-bindata将迁移嵌入到应用程序中。   [![star > 2000][Awesome]](https://github.com/rubenv/sql-migrate)   [![godoc][GoDoc]](https://godoc.org/github.com/rubenv/sql-migrate)
* [goose](https://github.com/pressly/goose) **star:2167** 数据库迁移工具。您可以通过创建增量SQL或Go脚本来管理数据库的升级。   [![star > 2000][Awesome]](https://github.com/pressly/goose)   [![最近一周有更新][Green]](https://github.com/pressly/goose)   [![godoc][GoDoc]](https://godoc.org/github.com/pressly/goose)
* [skeema](https://github.com/skeema/skeema) **star:974** 用于MySQL的纯sql模式管理系统，支持分片和外部在线模式更改工具。   [![godoc][GoDoc]](https://godoc.org/github.com/skeema/skeema)
* [soda](https://github.com/gobuffalo/pop/tree/master/soda)  数据库迁移、创建、ORM等。用于MySQL、PostgreSQL和SQLite。
* [goavro](https://github.com/linkedin/goavro) **star:771** 一个对Avro数据进行编码和解码的Go包。   [![最近一周有更新][Green]](https://github.com/linkedin/goavro)   [![godoc][GoDoc]](https://godoc.org/github.com/linkedin/goavro)
* [gormigrate](https://github.com/go-gormigrate/gormigrate) **star:716** 面向Gorm ORM的数据库 schema 迁移辅助程序。   [![最近一周有更新][Green]](https://github.com/go-gormigrate/gormigrate)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gormigrate/gormigrate)
* [darwin](https://github.com/GuiaBolso/darwin) **star:125** 用于数据库 schema 升级的库。   [![godoc][GoDoc]](https://godoc.org/github.com/GuiaBolso/darwin)
* [migrator](https://github.com/lopezator/migrator) **star:117** 非常简单的 Go 数据库迁移库。   [![最近一年没有更新][Yellow]](https://github.com/lopezator/migrator)   [![godoc][GoDoc]](https://godoc.org/github.com/lopezator/migrator)
* [go-pg-migrations](https://github.com/robinjoseph08/go-pg-migrations) **star:81** 用Go -pg/pg编写的迁移包。   [![godoc][GoDoc]](https://godoc.org/github.com/robinjoseph08/go-pg-migrations)
* [avro](https://github.com/khezen/avro) **star:28** 发现SQL schemas并将其转换为AVRO schemas。   [![最近一周有更新][Green]](https://github.com/khezen/avro)   [![godoc][GoDoc]](https://godoc.org/github.com/khezen/avro)
* [sqlize](https://github.com/sunary/sqlize) **star:27** 数据库迁移生成器。允许生成sql迁移从模型和现有的sql不同。   [![最近一周有更新][Green]](https://github.com/sunary/sqlize)   [![godoc][GoDoc]](https://godoc.org/github.com/sunary/sqlize)
* [go-fixtures](https://github.com/RichardKnop/go-fixtures) **star:26** 类似 Django fixture，用于 Go 建立内置数据库/sql库。   [![最近一年没有更新][Yellow]](https://github.com/RichardKnop/go-fixtures)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/go-fixtures)
* [pravasan](https://github.com/pravasan/pravasan) **star:26** 简易的迁移工具-目前只支持MySQL，但计划很快支持Postgres, SQLite, MongoDB等。   [![最近一年没有更新][Yellow]](https://github.com/pravasan/pravasan)
* [migrator](https://github.com/larapulse/migrator) **star:13** MySQL数据库迁移器设计用于运行到您的特性的迁移，并管理数据库模式更新与直观的go代码。   [![godoc][GoDoc]](https://godoc.org/github.com/larapulse/migrator)
* [schema](https://github.com/adlio/schema) **star:9** 库，用于将数据库/sql兼容数据库的模式迁移嵌入到Go二进制文件中。   [![godoc][GoDoc]](https://godoc.org/github.com/adlio/schema)
* [go-pg-migrate](https://github.com/lawzava/go-pg-migrate) **star:6** 用于go-pg迁移管理的cli友好包。   [![godoc][GoDoc]](https://godoc.org/github.com/lawzava/go-pg-migrate)

*数据库工具。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [vitess](https://github.com/youtube/vitess) **star:13187** vitess提供了可以为大规模web服务扩展MySQL数据库提供便利的服务和工具。   [![star > 2000][Awesome]](https://github.com/youtube/vitess)   [![最近一周有更新][Green]](https://github.com/youtube/vitess)   [![godoc][GoDoc]](https://godoc.org/github.com/youtube/vitess)
* [pgweb](https://github.com/sosedoff/pgweb) **star:7145** 基于web的PostgreSQL数据库浏览器。   [![star > 2000][Awesome]](https://github.com/sosedoff/pgweb)   [![godoc][GoDoc]](https://godoc.org/github.com/sosedoff/pgweb)
* [kingshard](https://github.com/flike/kingshard) **star:5917** kingshard 是基于 Golang 的MySQL高性能代理。   [![star > 2000][Awesome]](https://github.com/flike/kingshard)   [![godoc][GoDoc]](https://godoc.org/github.com/flike/kingshard)   [![包含中文文档][CN]](https://github.com/flike/kingshard)
* [orchestrator](https://github.com/github/orchestrator) **star:4372** MySQL复制拓扑管理器和可视化工具。   [![star > 2000][Awesome]](https://github.com/github/orchestrator)   [![godoc][GoDoc]](https://godoc.org/github.com/github/orchestrator)
* [go-mysql-elasticsearch](https://github.com/siddontang/go-mysql-elasticsearch) **star:3706** 自动将MySQL数据同步到Elasticsearch中。   [![star > 2000][Awesome]](https://github.com/siddontang/go-mysql-elasticsearch)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/go-mysql-elasticsearch)
* [go-mysql](https://github.com/siddontang/go-mysql) **star:3412**  Go 工具集，用于处理MySQL协议和复制。   [![star > 2000][Awesome]](https://github.com/siddontang/go-mysql)   [![最近一周有更新][Green]](https://github.com/siddontang/go-mysql)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/go-mysql)
* [pREST](https://github.com/prest/prest) **star:3067** 简化和加速开发,⚡即时、实时、高性能在任何Postgres应用,现有的或新的。   [![star > 2000][Awesome]](https://github.com/prest/prest)   [![最近一周有更新][Green]](https://github.com/prest/prest)   [![godoc][GoDoc]](https://godoc.org/github.com/prest/prest)
* [chproxy](https://github.com/Vertamedia/chproxy) **star:795** ClickHouse数据库的HTTP代理。   [![最近一周有更新][Green]](https://github.com/Vertamedia/chproxy)   [![godoc][GoDoc]](https://godoc.org/github.com/Vertamedia/chproxy)
* [pg_timetable](https://github.com/cybertec-postgresql/pg_timetable) **star:600** 高级调度为PostgreSQL。   [![最近一周有更新][Green]](https://github.com/cybertec-postgresql/pg_timetable)   [![godoc][GoDoc]](https://godoc.org/github.com/cybertec-postgresql/pg_timetable)
* [clickhouse-bulk](https://github.com/nikepan/clickhouse-bulk) **star:335** 收集小的 insterts 并向 ClickHouse 服务器发送大请求。   [![godoc][GoDoc]](https://godoc.org/github.com/nikepan/clickhouse-bulk)
* [myreplication](https://github.com/2tvenom/myreplication) **star:176** MySql二进制日志复制监听器。支持基于语句和行的复制。   [![最近一年没有更新][Yellow]](https://github.com/2tvenom/myreplication)   [![godoc][GoDoc]](https://godoc.org/github.com/2tvenom/myreplication)
* [octillery](https://github.com/knocknote/octillery) **star:150** 用于数据库分表(支持每个ORM或原生SQL)。   [![godoc][GoDoc]](https://godoc.org/github.com/knocknote/octillery)
* [dbbench](https://github.com/sj14/dbbench) **star:62** 数据库基准测试工具，支持多个数据库和脚本。   [![最近一周有更新][Green]](https://github.com/sj14/dbbench)   [![godoc][GoDoc]](https://godoc.org/github.com/sj14/dbbench)
* [datagen](https://github.com/codingconcepts/datagen) **star:45** 一个快速的数据生成器，支持多表感知和多行DML。   [![最近一年没有更新][Yellow]](https://github.com/codingconcepts/datagen)   [![godoc][GoDoc]](https://godoc.org/github.com/codingconcepts/datagen)
* [prep](https://github.com/hexdigest/prep) **star:30** 在不更改代码的情况下使用准备好的SQL语句。   [![最近一年没有更新][Yellow]](https://github.com/hexdigest/prep)   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/prep)
* [rwdb](https://github.com/andizzle/rwdb) **star:13** rwdb为多个数据库服务器的设置提供读取副本功能。   [![最近一年没有更新][Yellow]](https://github.com/andizzle/rwdb)   [![godoc][GoDoc]](https://godoc.org/github.com/andizzle/rwdb)

*SQL查询生成器，用于构建和使用SQL的库。 (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

* [Squirrel](https://github.com/Masterminds/squirrel) **star:4449** 帮助您构建SQL查询的Go库。   [![star > 2000][Awesome]](https://github.com/Masterminds/squirrel)   [![godoc][GoDoc]](https://godoc.org/github.com/Masterminds/squirrel)
* [xo](https://github.com/knq/xo) **star:2985** 基于现有的schema定义和自定义查询生成 Go 代码，基于支持PostgreSQL、MySQL、SQLite、Oracle和Microsoft SQL Server。   [![star > 2000][Awesome]](https://github.com/knq/xo)   [![godoc][GoDoc]](https://godoc.org/github.com/knq/xo)
* [goqu](https://github.com/doug-martin/goqu) **star:1366** 常用的SQL生成器和查询库。   [![godoc][GoDoc]](https://godoc.org/github.com/doug-martin/goqu)
* [gendry](https://github.com/didi/gendry) **star:1333** 非入侵的SQL构建器和强大的数据绑定器。   [![godoc][GoDoc]](https://godoc.org/github.com/didi/gendry)   [![包含中文文档][CN]](https://github.com/didi/gendry)
* [Dotsql](https://github.com/gchaincl/dotsql) **star:611** Go library帮助您将sql文件保存在一个地方，并轻松地使用它们。   [![godoc][GoDoc]](https://godoc.org/github.com/gchaincl/dotsql)
* [jet](https://github.com/go-jet/jet) **star:600** 用于在Go中编写类型安全的SQL查询的框架，能够轻松地将数据库查询结果转换为所需的任意对象结构。   [![最近一周有更新][Green]](https://github.com/go-jet/jet)   [![godoc][GoDoc]](https://godoc.org/github.com/go-jet/jet)
* [ozzo-dbx](https://github.com/go-ozzo/ozzo-dbx) **star:548** Powerful data retrieval methods as well as DB-agnostic query building capabilities.   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-dbx)
* [dbq](https://github.com/rocketlaunchr/dbq) **star:325** Zero boilerplate database operations for Go   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/dbq)
* [sqrl](https://github.com/elgris/sqrl) **star:237** SQL查询生成器，从Squirrel fork而来，并再此基础上对性能做了优化。   [![godoc][GoDoc]](https://godoc.org/github.com/elgris/sqrl)
* [Squalus](https://gitlab.com/qosenergy/squalus)  Go SQL中间层，能使得执行查询更加容易。
* [sqlingo](https://github.com/lqs/sqlingo) **star:205** 在Go中构建SQL的轻量级DSL。   [![godoc][GoDoc]](https://godoc.org/github.com/lqs/sqlingo)
* [sq](https://github.com/bokwoon95/go-structured-query) **star:145** 用于Go的类型安全的SQL生成器和结构映射器。   [![godoc][GoDoc]](https://godoc.org/github.com/bokwoon95/go-structured-query)
* [igor](https://github.com/galeone/igor) **star:84** PostgreSQL的抽象层，支持高级功能和类似gorm的语法。   [![最近一年没有更新][Yellow]](https://github.com/galeone/igor)   [![godoc][GoDoc]](https://godoc.org/github.com/galeone/igor)
* [godbal](https://github.com/xujiajun/godbal) **star:52** 数据库抽象层(dbal)。支持SQL builder，轻松获取结果。   [![最近一年没有更新][Yellow]](https://github.com/xujiajun/godbal)   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/godbal)
* [buildsqlx](https://github.com/arthurkushman/buildsqlx) **star:44** 去数据库查询生成器库的PostgreSQL。   [![godoc][GoDoc]](https://godoc.org/github.com/arthurkushman/buildsqlx)
* [sqlf](https://github.com/leporo/sqlf) **star:38** 快速SQL查询生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/leporo/sqlf)
* [bqb](https://github.com/nullism/bqb) **star:26** 轻量级和易于学习的查询构建器。   [![godoc][GoDoc]](https://godoc.org/github.com/nullism/bqb)
* [qry](https://github.com/HnH/qry) **star:19** 该工具使用原始SQL查询从文件生成常量。   [![godoc][GoDoc]](https://godoc.org/github.com/HnH/qry)
* [gosql](https://github.com/twharmon/gosql) **star:17** 支持更好的空值的SQL查询生成器。   [![最近一年没有更新][Yellow]](https://github.com/twharmon/gosql)   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/gosql)
* [hasql](https://golang.yandex/hasql)  用于访问多主机SQL数据库安装的库。
* [mpath](https://github.com/spacetab-io/mpath-go) **star:10** MPTT(修改前序树遍历)包的SQL记录-物化路径实现。   [![最近一年没有更新][Yellow]](https://github.com/spacetab-io/mpath-go)   [![godoc][GoDoc]](https://godoc.org/github.com/spacetab-io/mpath-go)
* [ormlite](https://github.com/pupizoid/ormlite) **star:1** 包含一些类似orm的特性和sqlite数据库的辅助程序的轻量级包   [![最近一年没有更新][Yellow]](https://github.com/pupizoid/ormlite)   [![godoc][GoDoc]](https://godoc.org/github.com/pupizoid/ormlite)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#database) 吧~)*

## 数据库驱动程序

*用于连接和操作数据库的库。 (翻译出错了? 试试 [英文版](README_EN.md#database-drivers) 吧~)*

* Relational Databases
    * [go-sql-driver/mysql](https://github.com/go-sql-driver/mysql) **star:11815** MySQL驱动程序。   [![star > 2000][Awesome]](https://github.com/go-sql-driver/mysql)   [![最近一周有更新][Green]](https://github.com/go-sql-driver/mysql)   [![godoc][GoDoc]](https://godoc.org/github.com/go-sql-driver/mysql)
    * [pq](https://github.com/lib/pq) **star:7015** 纯 Go 的Postgres驱动。   [![star > 2000][Awesome]](https://github.com/lib/pq)   [![最近一周有更新][Green]](https://github.com/lib/pq)   [![godoc][GoDoc]](https://godoc.org/github.com/lib/pq)
    * [go-sqlite3](https://github.com/mattn/go-sqlite3) **star:5382** SQLite3驱动程序。   [![star > 2000][Awesome]](https://github.com/mattn/go-sqlite3)   [![最近一周有更新][Green]](https://github.com/mattn/go-sqlite3)
    * [pgx](https://github.com/jackc/pgx) **star:4926** PostgreSQL驱动，支持比现有database/sql更多的特性。   [![star > 2000][Awesome]](https://github.com/jackc/pgx)   [![最近一周有更新][Green]](https://github.com/jackc/pgx)   [![godoc][GoDoc]](https://godoc.org/github.com/jackc/pgx)
    * [go-mssqldb](https://github.com/denisenkom/go-mssqldb) **star:1497** 微软MSSQL驱动程序。   [![最近一周有更新][Green]](https://github.com/denisenkom/go-mssqldb)   [![godoc][GoDoc]](https://godoc.org/github.com/denisenkom/go-mssqldb)
    * [go-oci8](https://github.com/mattn/go-oci8) **star:575** Oracle 驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-oci8)
    * [sqlhooks](https://github.com/qustavo/sqlhooks) **star:503** 将钩子附加到任何数据库/sql驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/qustavo/sqlhooks)
    * [godror](https://github.com/godror/godror) **star:319** 基于 ODPI-C 的 Oracle 驱动程序
    * [firebirdsql](https://github.com/nakagami/firebirdsql) **star:164** Firebird RDBMS SQL驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/nakagami/firebirdsql)
    * [go-adodb](https://github.com/mattn/go-adodb) **star:124** Microsoft ActiveX对象数据库驱动程序。   [![最近一年没有更新][Yellow]](https://github.com/mattn/go-adodb)   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-adodb)
    * [gofreetds](https://github.com/minus5/gofreetds) **star:105** 微软该司机。去包装[FreeTDS](https://www.freetds.org)。   [![最近一年没有更新][Yellow]](https://github.com/minus5/gofreetds)   [![godoc][GoDoc]](https://godoc.org/github.com/minus5/gofreetds)
    * [Sqinn-Go](https://github.com/cvilsmeier/sqinn-go) **star:94** SQLite with pure Go.   [![godoc][GoDoc]](https://godoc.org/github.com/cvilsmeier/sqinn-go)
    * [avatica](https://github.com/apache/calcite-avatica-go) **star:86** Apache Avatica/Phoenix SQL驱动程序。   [![最近一年没有更新][Yellow]](https://github.com/apache/calcite-avatica-go)   [![godoc][GoDoc]](https://godoc.org/github.com/apache/calcite-avatica-go)
    * [bgc](https://github.com/viant/bgc) **star:15** BigQuery 的数据存储连接。   [![最近一年没有更新][Yellow]](https://github.com/viant/bgc)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/bgc)
    * [pig](https://github.com/alexeyco/pig) **star:6** 简单的[pgx](https://github.com/jackc/pgx)包装器执行和[扫描](https://github.com/georgysavva/scany)查询结果很容易。   [![godoc][GoDoc]](https://godoc.org/github.com/alexeyco/pig)

* NoSQL Databases
    * [redis](https://github.com/go-redis/redis) **star:13313** 基于 Go 的 Redis 客户端。   [![star > 2000][Awesome]](https://github.com/go-redis/redis)   [![最近一周有更新][Green]](https://github.com/go-redis/redis)   [![godoc][GoDoc]](https://godoc.org/github.com/go-redis/redis)
    * [redigo](https://github.com/gomodule/redigo) **star:8830** Redigo 是基于 Go 的Redis 客户端。   [![star > 2000][Awesome]](https://github.com/gomodule/redigo)   [![godoc][GoDoc]](https://godoc.org/github.com/gomodule/redigo)
    * [mongo-go-driver](https://github.com/mongodb/mongo-go-driver) **star:6379** 官方的 MongoDB 驱动。   [![star > 2000][Awesome]](https://github.com/mongodb/mongo-go-driver)   [![最近一周有更新][Green]](https://github.com/mongodb/mongo-go-driver)   [![godoc][GoDoc]](https://godoc.org/github.com/mongodb/mongo-go-driver)
    * [mgo](https://github.com/globalsign/mgo) **star:1931** (已停止维护) MongoDB驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/globalsign/mgo)
    * [gorethink](https://github.com/dancannon/gorethink) **star:1587** RethinkDB 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/dancannon/gorethink)
    * [qmgo](https://github.com/qiniu/qmgo) **star:770** MongoDB司机走了。它是基于官方MongoDB司机但更容易使用像分别。   [![godoc][GoDoc]](https://godoc.org/github.com/qiniu/qmgo)   [![包含中文文档][CN]](https://github.com/qiniu/qmgo)
    * [mgm](https://github.com/kamva/mgm) **star:442** 基于MongoDB模型的ODM for Go(基于官方MongoDB驱动)。   [![godoc][GoDoc]](https://godoc.org/github.com/kamva/mgm)
    * [redeo](https://github.com/bsm/redeo) **star:409** 与 redis 协议兼容的 TCP 服务器/服务。   [![最近一年没有更新][Yellow]](https://github.com/bsm/redeo)   [![godoc][GoDoc]](https://godoc.org/github.com/bsm/redeo)
    * [neoism](https://github.com/jmcvetta/neoism) **star:382** Golang 的 Neo4j 客户端。   [![最近一年没有更新][Yellow]](https://github.com/jmcvetta/neoism)   [![godoc][GoDoc]](https://godoc.org/github.com/jmcvetta/neoism)
    * [aerospike-client-go](https://github.com/aerospike/aerospike-client-go) **star:372** Aerospike 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/aerospike/aerospike-client-go)
    * [gocb](https://github.com/couchbase/gocb) **star:329** 官方Couchbase Go SDK。   [![最近一周有更新][Green]](https://github.com/couchbase/gocb)   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/gocb)
    * [go-couchbase](https://github.com/couchbase/go-couchbase) **star:311** Couchbase客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/go-couchbase)
    * [go-rejson](https://github.com/nitishm/go-rejson) **star:235** 实现了基于 Redigo 客户端的redislabs' ReJSON 模块。可简单地将结构体存储为JSON对象并对其进行操作。   [![最近一周有更新][Green]](https://github.com/nitishm/go-rejson)   [![godoc][GoDoc]](https://godoc.org/github.com/nitishm/go-rejson)
    * [godis](https://github.com/piaohao/godis) **star:99** 由GoLang实现的redis客户端，灵感来自jedis。   [![最近一年没有更新][Yellow]](https://github.com/piaohao/godis)   [![godoc][GoDoc]](https://godoc.org/github.com/piaohao/godis)
    * [Neo4j-GO](https://github.com/davemeehan/Neo4j-GO) **star:77** Neo4j REST 客户端。   [![最近一年没有更新][Yellow]](https://github.com/davemeehan/Neo4j-GO)   [![godoc][GoDoc]](https://godoc.org/github.com/davemeehan/Neo4j-GO)
    * [arangolite](https://github.com/solher/arangolite) **star:69** 轻量级的 ArangoDB 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/solher/arangolite)
    * [go-pilosa](https://github.com/pilosa/go-pilosa) **star:50**  Pilosa客户端。   [![最近一年没有更新][Yellow]](https://github.com/pilosa/go-pilosa)   [![godoc][GoDoc]](https://godoc.org/github.com/pilosa/go-pilosa)
    * [forestdb](https://github.com/couchbase/goforestdb) **star:32** 基于 Go 的 ForestDB 接口实现。   [![最近一年没有更新][Yellow]](https://github.com/couchbase/goforestdb)   [![godoc][GoDoc]](https://godoc.org/github.com/couchbase/goforestdb)
    * [neo4j](https://github.com/cihangir/neo4j) **star:27** Neo4j Rest API实现。   [![最近一年没有更新][Yellow]](https://github.com/cihangir/neo4j)   [![godoc][GoDoc]](https://godoc.org/github.com/cihangir/neo4j)
    * [goriak](https://github.com/zegl/goriak) **star:26**  Riak KV 驱动。   [![godoc][GoDoc]](https://godoc.org/github.com/zegl/goriak)
    * [xredis](https://github.com/shomali11/xredis) **star:16** 类型安全，可定制，清晰和易用的Redis客户端。   [![最近一年没有更新][Yellow]](https://github.com/shomali11/xredis)   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/xredis)
    * [godscache](https://github.com/defcronyke/godscache) **star:9** 谷歌云平台Go Datastore包的封装，它采用了memcached添加缓存。   [![最近一年没有更新][Yellow]](https://github.com/defcronyke/godscache)   [![godoc][GoDoc]](https://godoc.org/github.com/defcronyke/godscache)
    * [gomemcache](https://github.com/bradfitz/gomemcache/)  memcache客户端库。
    * [asc](https://github.com/viant/asc) **star:6** Aerospike 的数据存储连接器。   [![最近一年没有更新][Yellow]](https://github.com/viant/asc)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/asc)
    * [gocosmos](https://github.com/btnguyen2k/gocosmos) **star:5** Azure Cosmos DB的REST客户端和标准的“数据库/sql”驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/btnguyen2k/gocosmos)
    * [gocql](https://gocql.github.io)  Apache Cassandra 的 Go 驱动。

* Search and Analytic Databases.
    * [bleve](https://github.com/blevesearch/bleve) **star:8158** 基于 Go 的现代文本索引库。   [![star > 2000][Awesome]](https://github.com/blevesearch/bleve)   [![godoc][GoDoc]](https://godoc.org/github.com/blevesearch/bleve)
    * [elastic](https://github.com/olivere/elastic) **star:6486** Elasticsearch 客户端。   [![star > 2000][Awesome]](https://github.com/olivere/elastic)   [![最近一周有更新][Green]](https://github.com/olivere/elastic)   [![godoc][GoDoc]](https://godoc.org/github.com/olivere/elastic)
    * [riot](https://github.com/go-ego/riot) **star:6034** 基于 Go 的 开源、分布式、简单高效的搜索引擎。   [![star > 2000][Awesome]](https://github.com/go-ego/riot)   [![最近一年没有更新][Yellow]](https://github.com/go-ego/riot)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ego/riot)   [![包含中文文档][CN]](https://github.com/go-ego/riot)   [![归档项目][Archived]](https://github.com/go-ego/riot)
    * [go-elasticsearch](https://github.com/elastic/go-elasticsearch) **star:3863** 官方 Elasticsearch 客户端。   [![star > 2000][Awesome]](https://github.com/elastic/go-elasticsearch)   [![最近一周有更新][Green]](https://github.com/elastic/go-elasticsearch)   [![godoc][GoDoc]](https://godoc.org/github.com/elastic/go-elasticsearch)
    * [elastigo](https://github.com/mattbaird/elastigo) **star:946** Elasticsearch 客户端。   [![最近一年没有更新][Yellow]](https://github.com/mattbaird/elastigo)   [![godoc][GoDoc]](https://godoc.org/github.com/mattbaird/elastigo)
    * [elasticsql](https://github.com/cch123/elasticsql) **star:843** 将 SQL 转换为 elasticsearch dsl。   [![godoc][GoDoc]](https://godoc.org/github.com/cch123/elasticsql)
    * [skizze](https://github.com/seiflotfy/skizze) **star:81** 面向概率数据结构的服务和存储。   [![最近一年没有更新][Yellow]](https://github.com/seiflotfy/skizze)   [![godoc][GoDoc]](https://godoc.org/github.com/seiflotfy/skizze)
    * [goes](https://github.com/OwnLocal/goes) **star:25** 实现了与 Elasticsearch 交互的库。   [![最近一年没有更新][Yellow]](https://github.com/OwnLocal/goes)   [![godoc][GoDoc]](https://godoc.org/github.com/OwnLocal/goes)

* Multiple Backends.
    * [cayley](https://github.com/google/cayley) **star:14044** 图形数据库，支持多个后端。   [![star > 2000][Awesome]](https://github.com/google/cayley)   [![最近一周有更新][Green]](https://github.com/google/cayley)   [![godoc][GoDoc]](https://godoc.org/github.com/google/cayley)
    * [gokv](https://github.com/philippgille/gokv) **star:390** 可扩展的简单的 K/V 存储(Redis、Consul、etcd、bbolt、BadgerDB、LevelDB、Memcached、DynamoDB、S3、PostgreSQL、MongoDB、CockroachDB等等)。   [![godoc][GoDoc]](https://godoc.org/github.com/philippgille/gokv)
    * [cachego](https://github.com/fabiorphp/cachego) **star:159** 基于多个驱动程序的缓存组件。   [![最近一周有更新][Green]](https://github.com/fabiorphp/cachego)   [![godoc][GoDoc]](https://godoc.org/github.com/fabiorphp/cachego)
    * [dsc](https://github.com/viant/dsc) **star:23** 面向 SQL、NoSQL、结构化文件的数据存储连接。   [![最近一年没有更新][Yellow]](https://github.com/viant/dsc)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/dsc)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#database-drivers) 吧~)*

## 日期和时间

*用于处理日期和时间的库。 (翻译出错了? 试试 [英文版](README_EN.md#date-and-time) 吧~)*

* [now](https://github.com/jinzhu/now) **star:3532** now 是时间有关的工具类。   [![star > 2000][Awesome]](https://github.com/jinzhu/now)   [![godoc][GoDoc]](https://godoc.org/github.com/jinzhu/now)
* [dateparse](https://github.com/araddon/dateparse) **star:1610** 可以解析很多格式不固定的日期字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/araddon/dateparse)
* [carbon](https://github.com/golang-module/carbon) **star:1560** datetime的一个简单、语义和开发人员友好的golang包。   [![godoc][GoDoc]](https://godoc.org/github.com/golang-module/carbon)
* [carbon](https://github.com/uniplaces/carbon) **star:673** 简单的时间扩展，包含了许多使用方法，从 PHP Carbon 库移植的。   [![godoc][GoDoc]](https://godoc.org/github.com/uniplaces/carbon)
* [durafmt](https://github.com/hako/durafmt) **star:411** 轻量级、可让time.Duration更加易读的库。   [![godoc][GoDoc]](https://godoc.org/github.com/hako/durafmt)
* [timeutil](https://github.com/leekchan/timeutil) **star:184** 面向 Golang 的时间库，集成了很多有用的扩展(Timedelta, Strftime, ...)。   [![最近一年没有更新][Yellow]](https://github.com/leekchan/timeutil)   [![godoc][GoDoc]](https://godoc.org/github.com/leekchan/timeutil)
* [gostradamus](https://github.com/bykof/gostradamus) **star:159** 和约会对象一起工作的软件包。   [![godoc][GoDoc]](https://godoc.org/github.com/bykof/gostradamus)
* [go-persian-calendar](https://github.com/yaa110/go-persian-calendar) **star:113** 太阳历实现。   [![godoc][GoDoc]](https://godoc.org/github.com/yaa110/go-persian-calendar)
* [iso8601](https://github.com/relvacode/iso8601) **star:97** 不用正则表达式有效解析 ISO8601 日期时间。   [![godoc][GoDoc]](https://godoc.org/github.com/relvacode/iso8601)
* [date](https://github.com/rickb777/date) **star:85** 增加处理日期、日期范围、时间跨度、时间段和time-of-day。   [![最近一周有更新][Green]](https://github.com/rickb777/date)   [![godoc][GoDoc]](https://godoc.org/github.com/rickb777/date)
* [timespan](https://github.com/SaidinWoT/timespan) **star:77** 用于处理时间间隔相关的库，可定义开始时间和持续时间。   [![最近一年没有更新][Yellow]](https://github.com/SaidinWoT/timespan)   [![godoc][GoDoc]](https://godoc.org/github.com/SaidinWoT/timespan)
* [feiertage](https://github.com/wlbr/feiertage) **star:40** 用于计算德国公共假期的函数，比如复活节、感恩节等   [![godoc][GoDoc]](https://godoc.org/github.com/wlbr/feiertage)
* [go-sunrise](https://github.com/nathan-osman/go-sunrise) **star:39** 计算指定位置的日出和日落时间。   [![godoc][GoDoc]](https://godoc.org/github.com/nathan-osman/go-sunrise)
* [go-str2duration](https://github.com/xhit/go-str2duration) **star:35** 将字符串转换为持续时间。支持的时间。持续时间返回字符串等。   [![最近一年没有更新][Yellow]](https://github.com/xhit/go-str2duration)   [![godoc][GoDoc]](https://godoc.org/github.com/xhit/go-str2duration)
* [kair](https://github.com/GuilhermeCaruso/kair) **star:21** 用于处理日期和时间的 golang 库。   [![最近一年没有更新][Yellow]](https://github.com/GuilhermeCaruso/kair)   [![godoc][GoDoc]](https://godoc.org/github.com/GuilhermeCaruso/kair)
* [cronrange](https://github.com/1set/cronrange) **star:13** 解析cron风格的时间范围表达式，检查给定的时间是否在任何范围内。   [![godoc][GoDoc]](https://godoc.org/github.com/1set/cronrange)
* [NullTime](https://github.com/kirillDanshin/nulltime) **star:11** 可以允许 time.Time 为null。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/nulltime)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/nulltime)
* [tuesday](https://github.com/osteele/tuesday) **star:9** Ruby-compatible Strftime function。   [![godoc][GoDoc]](https://godoc.org/github.com/osteele/tuesday)
* [go-week](https://github.com/stoewer/go-week) **star:7** 一个有效的软件包，以配合ISO8601周日期。   [![godoc][GoDoc]](https://godoc.org/github.com/stoewer/go-week)
* [strftime](https://github.com/awoodbeck/strftime) **star:7** C99-compatible strftime formatter。   [![最近一年没有更新][Yellow]](https://github.com/awoodbeck/strftime)   [![godoc][GoDoc]](https://godoc.org/github.com/awoodbeck/strftime)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#date-and-time) 吧~)*

## 分布式系统

*协助构建分布式系统的包。 (翻译出错了? 试试 [英文版](README_EN.md#distributed-systems) 吧~)*

* [go-kit](https://github.com/go-kit/kit) **star:22161** 支持服务发现、负载平衡、插件式传输、请求跟踪等功能的Microservice toolkit。   [![star > 2000][Awesome]](https://github.com/go-kit/kit)   [![最近一周有更新][Green]](https://github.com/go-kit/kit)   [![godoc][GoDoc]](https://godoc.org/github.com/go-kit/kit)
* [go-micro](https://github.com/micro/go-micro) **star:17532** 分布式系统开发框架。   [![star > 2000][Awesome]](https://github.com/micro/go-micro)   [![最近一周有更新][Green]](https://github.com/micro/go-micro)   [![godoc][GoDoc]](https://godoc.org/github.com/micro/go-micro)
* [Kratos](https://github.com/go-kratos/kratos) **star:16177** 一个模块化设计的易于使用的微服务框架。   [![star > 2000][Awesome]](https://github.com/go-kratos/kratos)   [![最近一周有更新][Green]](https://github.com/go-kratos/kratos)   [![godoc][GoDoc]](https://godoc.org/github.com/go-kratos/kratos)   [![包含中文文档][CN]](https://github.com/go-kratos/kratos)
* [grpc-go](https://github.com/grpc/grpc-go) **star:15219** gRPC的Go语言实现。   [![star > 2000][Awesome]](https://github.com/grpc/grpc-go)   [![最近一周有更新][Green]](https://github.com/grpc/grpc-go)   [![godoc][GoDoc]](https://godoc.org/github.com/grpc/grpc-go)
* [go-zero](https://github.com/tal-tech/go-zero) **star:13966** 一个web和rpc框架。它的诞生是为了确保繁忙场地的稳定性，弹性设计。内置的goctl大大提高了开发效率。   [![star > 2000][Awesome]](https://github.com/tal-tech/go-zero)   [![最近一周有更新][Green]](https://github.com/tal-tech/go-zero)   [![godoc][GoDoc]](https://godoc.org/github.com/tal-tech/go-zero)
* [micro](https://github.com/micro/micro) **star:10852** 一个分布式系统运行时，用于云及其他。   [![star > 2000][Awesome]](https://github.com/micro/micro)   [![最近一周有更新][Green]](https://github.com/micro/micro)   [![godoc][GoDoc]](https://godoc.org/github.com/micro/micro)
* [NATS](https://github.com/nats-io/gnatsd) **star:10354** 轻量级、高性能消息传递系统，可用于微服务、物联网(IoT)和云。   [![star > 2000][Awesome]](https://github.com/nats-io/gnatsd)   [![最近一周有更新][Green]](https://github.com/nats-io/gnatsd)   [![godoc][GoDoc]](https://godoc.org/github.com/nats-io/gnatsd)
* [rpcx](https://github.com/smallnest/rpcx) **star:6619** 分布式可插拔的RPC服务框架，如阿里巴巴Dubbo。   [![star > 2000][Awesome]](https://github.com/smallnest/rpcx)   [![godoc][GoDoc]](https://godoc.org/github.com/smallnest/rpcx)
* [raft](https://github.com/hashicorp/raft) **star:5582** Raft consensus协议的实现。 by HashiCorp。   [![star > 2000][Awesome]](https://github.com/hashicorp/raft)   [![最近一周有更新][Green]](https://github.com/hashicorp/raft)   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/raft)
* [raft](https://github.com/coreos/etcd/tree/master/raft)  Raft consensus协议的实现。 by CoreOS。
* [lura](https://github.com/luraproject/lura) **star:4809** 具有中间件的高性能API网关框架。   [![star > 2000][Awesome]](https://github.com/luraproject/lura)   [![最近一周有更新][Green]](https://github.com/luraproject/lura)   [![godoc][GoDoc]](https://godoc.org/github.com/luraproject/lura)
* [torrent](https://github.com/anacrolix/torrent) **star:4169** BitTorrent 客户端。   [![star > 2000][Awesome]](https://github.com/anacrolix/torrent)   [![最近一周有更新][Green]](https://github.com/anacrolix/torrent)   [![godoc][GoDoc]](https://godoc.org/github.com/anacrolix/torrent)
* [dragonboat](https://github.com/lni/dragonboat) **star:4050** 一个功能齐全，高性能的库集。   [![star > 2000][Awesome]](https://github.com/lni/dragonboat)   [![最近一周有更新][Green]](https://github.com/lni/dragonboat)   [![godoc][GoDoc]](https://godoc.org/github.com/lni/dragonboat)   [![包含中文文档][CN]](https://github.com/lni/dragonboat)
* [emitter-io](https://github.com/emitter-io/emitter) **star:3154** 高性能、分布式、安全和低延迟的发布-订阅平台，使用MQTT、Websockets和love构建。   [![star > 2000][Awesome]](https://github.com/emitter-io/emitter)   [![godoc][GoDoc]](https://godoc.org/github.com/emitter-io/emitter)
* [glow](https://github.com/chrislusf/glow) **star:3023** 全部用 Go 实现，易用、可伸缩，可用于分布式大数据处理，Map-Reduce, DAG执行。   [![star > 2000][Awesome]](https://github.com/chrislusf/glow)   [![最近一年没有更新][Yellow]](https://github.com/chrislusf/glow)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/glow)
* [gleam](https://github.com/chrislusf/gleam) **star:2964** 使用纯Go和Luajit编写的快速、可伸缩的分布式map/reduce系统，结合了Go的高并发性和Luajit的高性能，可以独立运行或分布式运行。   [![star > 2000][Awesome]](https://github.com/chrislusf/gleam)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/gleam)
* [liftbridge](https://github.com/liftbridge-io/liftbridge) **star:2190** 用于nat的轻量级、容错的消息流。   [![star > 2000][Awesome]](https://github.com/liftbridge-io/liftbridge)   [![最近一周有更新][Green]](https://github.com/liftbridge-io/liftbridge)   [![godoc][GoDoc]](https://godoc.org/github.com/liftbridge-io/liftbridge)
* [hprose](https://github.com/hprose/hprose-golang) **star:1194** 支持25+种语言RPC库。   [![godoc][GoDoc]](https://godoc.org/github.com/hprose/hprose-golang)   [![包含中文文档][CN]](https://github.com/hprose/hprose-golang)
* [ringpop-go](https://github.com/uber/ringpop-go) **star:716** 可伸缩的，容错、应用分层的的Go应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/uber/ringpop-go)
* [rain](https://github.com/cenkalti/rain) **star:664** BitTorrent客户端和库。   [![godoc][GoDoc]](https://godoc.org/github.com/cenkalti/rain)
* [gorpc](https://github.com/valyala/gorpc) **star:648** 简单、快速和可伸缩的RPC库。   [![最近一年没有更新][Yellow]](https://github.com/valyala/gorpc)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/gorpc)
* [go-health](https://github.com/InVisionApp/go-health) **star:613** 用于在服务中启用异步依赖项健康检查的库。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/go-health)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/go-health)
* [redis-lock](https://github.com/bsm/redislock) **star:572** 基于redis的分布式锁简易实现。   [![最近一周有更新][Green]](https://github.com/bsm/redislock)   [![godoc][GoDoc]](https://godoc.org/github.com/bsm/redislock)
* [resgate](https://resgate.io/)  用于构建REST、实时和RPC API的实时API网关，其中所有客户端都是无缝同步的。
* [arpc](https://github.com/lesismal/arpc) **star:447** 更有效的网络通信，支持双向呼叫、通知、广播。   [![最近一周有更新][Green]](https://github.com/lesismal/arpc)   [![godoc][GoDoc]](https://godoc.org/github.com/lesismal/arpc)
* [go-sundheit](https://github.com/AppsFlyer/go-sundheit) **star:446** 为支持为golang服务定义异步服务健康检查而构建的库。   [![godoc][GoDoc]](https://godoc.org/github.com/AppsFlyer/go-sundheit)
* [consistent](https://github.com/buraksezer/consistent) **star:441** Consistent hashing with bounded loads。   [![godoc][GoDoc]](https://godoc.org/github.com/buraksezer/consistent)
* [digota](https://github.com/digota/digota) **star:421** 基于 grpc 的电子商务微服务。   [![godoc][GoDoc]](https://godoc.org/github.com/digota/digota)
* [dot](https://github.com/dotchain/dot/)  基于 transformation/OT 的分布式同步。
* [sleuth](https://github.com/ursiform/sleuth) **star:340** 用于HTTP服务之间进行无中心p2p自动发现和RPC通信的库(使用[ZeroMQ](https://github.com/zeromq/libzmq))。   [![最近一年没有更新][Yellow]](https://github.com/ursiform/sleuth)   [![godoc][GoDoc]](https://godoc.org/github.com/ursiform/sleuth)
* [go-jump](https://github.com/dgryski/go-jump) **star:334** 提供了谷歌的 “Jump” 一致哈希函数接口。   [![godoc][GoDoc]](https://godoc.org/github.com/dgryski/go-jump)
* [go-doudou](https://github.com/unionj-cloud/go-doudou) **star:233** 八卦协议和基于OpenAPI 3.0规范的去中心化微服务框架。内置的go-doudou cli专注于低代码和快速开发，可以提高您的生产力。   [![最近一周有更新][Green]](https://github.com/unionj-cloud/go-doudou)   [![godoc][GoDoc]](https://godoc.org/github.com/unionj-cloud/go-doudou)   [![包含中文文档][CN]](https://github.com/unionj-cloud/go-doudou)
* [dht](https://github.com/anacrolix/dht) **star:218** BitTorrent Kademlia DHT的实现。   [![最近一周有更新][Green]](https://github.com/anacrolix/dht)   [![godoc][GoDoc]](https://godoc.org/github.com/anacrolix/dht)
* [jsonrpc](https://github.com/ybbus/jsonrpc) **star:200** JSON-RPC 2.0 HTTP客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/ybbus/jsonrpc)
* [jsonrpc](https://github.com/osamingo/jsonrpc) **star:157** jsonrpc 包，实现了 JSON-RPC 2.0。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/jsonrpc)
* [celeriac](https://github.com/svcavallar/celeriac.v1) **star:69** 用于对 Celery worker、任务、事件进行交互和监控的库。   [![最近一年没有更新][Yellow]](https://github.com/svcavallar/celeriac.v1)   [![godoc][GoDoc]](https://godoc.org/github.com/svcavallar/celeriac.v1)
* [doublejump](https://github.com/edwingeng/doublejump) **star:67** 实现了谷歌的jump consistent hash。   [![godoc][GoDoc]](https://godoc.org/github.com/edwingeng/doublejump)
* [Semaphore](https://github.com/jexia/semaphore) **star:65** 简单的(微)服务协调器。   [![godoc][GoDoc]](https://godoc.org/github.com/jexia/semaphore)
* [outboxer](https://github.com/italolelis/outboxer) **star:60** 实现了 outbox pattern Go 库。   [![最近一周有更新][Green]](https://github.com/italolelis/outboxer)   [![godoc][GoDoc]](https://godoc.org/github.com/italolelis/outboxer)
* [pglock](https://cirello.io/pglock)  postgresql 的分布式锁定实现。
* [pjrpc](https://gitlab.com/pjrpc/pjrpc)  Golang JSON-RPC服务器-客户端与原生buf规范。
* [flowgraph](https://github.com/vectaport/flowgraph) **star:43** flow-based programming package。   [![godoc][GoDoc]](https://godoc.org/github.com/vectaport/flowgraph)
* [drmaa](https://github.com/dgruber/drmaa) **star:36** 符合 DRMAA 标准的集群调度程序作业提交库。   [![最近一年没有更新][Yellow]](https://github.com/dgruber/drmaa)   [![godoc][GoDoc]](https://godoc.org/github.com/dgruber/drmaa)
* [dynamolock](https://cirello.io/dynamolock)  DynamoDB-backed 分布式锁定实现。
* [go-mysql-lock](https://github.com/sanketplus/go-mysql-lock) **star:35** 基于MySQL分布式锁。   [![godoc][GoDoc]](https://godoc.org/github.com/sanketplus/go-mysql-lock)
* [go-pdu](https://github.com/pdupub/go-pdu) **star:33** 一个去中心化的基于身份的社交网络。   [![godoc][GoDoc]](https://godoc.org/github.com/pdupub/go-pdu)
* [gmsec](https://github.com/gmsec/micro) **star:16** 一个Go分布式系统开发框架。   [![godoc][GoDoc]](https://godoc.org/github.com/gmsec/micro)
* [dynatomic](https://github.com/tylfin/dynatomic) **star:13** 基于 DynamoDB 的 原子计数器的库。   [![最近一年没有更新][Yellow]](https://github.com/tylfin/dynatomic)   [![godoc][GoDoc]](https://godoc.org/github.com/tylfin/dynatomic)
* [consistenthash](https://github.com/mbrostami/consistenthash) **star:9** 使用可配置副本的一致哈希。   [![最近一年没有更新][Yellow]](https://github.com/mbrostami/consistenthash)   [![godoc][GoDoc]](https://godoc.org/github.com/mbrostami/consistenthash)
* [failured](https://github.com/andy2046/failured) **star:2** 分布式系统的自适应应计故障检测器。   [![godoc][GoDoc]](https://godoc.org/github.com/andy2046/failured)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#distributed-systems) 吧~)*

## 动态域名

*更新动态DNS记录的工具。 (翻译出错了? 试试 [英文版](README_EN.md#dynamic-dns) 吧~)*

* [GoDNS](https://github.com/timothyye/godns) **star:942** 一个动态DNS客户端工具，支持DNSPod & HE.net。   [![godoc][GoDoc]](https://godoc.org/github.com/timothyye/godns)
* [DDNS](https://github.com/skibish/ddns) **star:201** 个人 DDNS 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/skibish/ddns)
* [dyndns](https://gitlab.com/alcastle/dyndns)  后台去处理定期和自动检查您的IP地址，并作出更新(一个或多个)动态DNS记录，为谷歌域，每当您的地址变化。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#dynamic-dns) 吧~)*

## 电子邮件

*实现了电子邮件创建和发送。 (翻译出错了? 试试 [英文版](README_EN.md#email) 吧~)*

* [MailHog](https://github.com/mailhog/MailHog) **star:9536** 电子邮件和SMTP测试工具，对外提供了 web 和 API 接口。   [![star > 2000][Awesome]](https://github.com/mailhog/MailHog)   [![godoc][GoDoc]](https://godoc.org/github.com/mailhog/MailHog)
* [hermes](https://github.com/matcornic/hermes) **star:2411** 可生成干净的、响应式的HTML电子邮件。   [![star > 2000][Awesome]](https://github.com/matcornic/hermes)   [![godoc][GoDoc]](https://godoc.org/github.com/matcornic/hermes)
* [email](https://github.com/jordan-wright/email) **star:1918** 一个强大和灵活的电子邮件库。   [![godoc][GoDoc]](https://godoc.org/github.com/jordan-wright/email)
* [go-imap](https://github.com/emersion/go-imap) **star:1434** 用于客户端和服务器的IMAP库。   [![godoc][GoDoc]](https://godoc.org/github.com/emersion/go-imap)
* [chasquid](https://blitiri.com.ar/p/chasquid)  用Go编写的SMTP服务器。
* [SendGrid](https://github.com/sendgrid/sendgrid-go) **star:784** SendGrid 的 Go语言库，用于发送电子邮件。   [![最近一周有更新][Green]](https://github.com/sendgrid/sendgrid-go)   [![godoc][GoDoc]](https://godoc.org/github.com/sendgrid/sendgrid-go)
* [mailgun-go](https://github.com/mailgun/mailgun-go) **star:576** 使用Mailgun API去库发送邮件。   [![godoc][GoDoc]](https://godoc.org/github.com/mailgun/mailgun-go)
* [email-verifier](https://github.com/AfterShip/email-verifier) **star:352** 一个Go库的电子邮件验证而不发送任何电子邮件。   [![godoc][GoDoc]](https://godoc.org/github.com/AfterShip/email-verifier)
* [go-simple-mail](https://github.com/xhit/go-simple-mail) **star:254** 非常简单的包发送电子邮件与SMTP保持活动和两个超时:连接和发送。   [![godoc][GoDoc]](https://godoc.org/github.com/xhit/go-simple-mail)
* [go-message](https://github.com/emersion/go-message) **star:232** 用于Internet消息格式化和邮件消息的流媒体库。   [![godoc][GoDoc]](https://godoc.org/github.com/emersion/go-message)
* [Hectane](https://github.com/hectane/hectane) **star:213** 轻量级的SMTP客户机，提供了HTTP API。   [![最近一年没有更新][Yellow]](https://github.com/hectane/hectane)   [![godoc][GoDoc]](https://godoc.org/github.com/hectane/hectane)
* [douceur](https://github.com/aymerick/douceur) **star:204** 在HTML邮件中支持CSS内联。   [![godoc][GoDoc]](https://godoc.org/github.com/aymerick/douceur)
* [mailchain](https://github.com/mailchain/mailchain) **star:101** 发送加密的电子邮件到区块链地址写在Go。   [![最近一周有更新][Green]](https://github.com/mailchain/mailchain)   [![godoc][GoDoc]](https://godoc.org/github.com/mailchain/mailchain)
* [go-premailer](https://github.com/vanng822/go-premailer) **star:79** 在HTML邮件中支持CSS内联。   [![godoc][GoDoc]](https://godoc.org/github.com/vanng822/go-premailer)
* [go-dkim](https://github.com/toorop/go-dkim) **star:74** DKIM库，用于签署 & 验证电子邮件。   [![最近一年没有更新][Yellow]](https://github.com/toorop/go-dkim)   [![godoc][GoDoc]](https://godoc.org/github.com/toorop/go-dkim)
* [smtp](https://github.com/mailhog/smtp) **star:66** SMTP服务器协议状态机。   [![godoc][GoDoc]](https://godoc.org/github.com/mailhog/smtp)
* [smtpmock](https://github.com/mocktools/go-smtp-mock) **star:23** 轻量级的可配置多线程假SMTP服务器。为您的测试环境模拟任何SMTP行为。   [![最近一周有更新][Green]](https://github.com/mocktools/go-smtp-mock)   [![godoc][GoDoc]](https://godoc.org/github.com/mocktools/go-smtp-mock)
* [go-email-validator](https://github.com/go-email-validator/go-email-validator) **star:17** 模块化电子邮件验证器的语法，一次性，smtp等…检查。   [![最近一周有更新][Green]](https://github.com/go-email-validator/go-email-validator)   [![godoc][GoDoc]](https://godoc.org/github.com/go-email-validator/go-email-validator)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#email) 吧~)*

## 可嵌入的脚本语言

*在go代码中嵌入其他语言。 (翻译出错了? 试试 [英文版](README_EN.md#embeddable-scripting-languages) 吧~)*

* [gopher-lua](https://github.com/yuin/gopher-lua) **star:4519** 用 Go 实现的 Lua 5.1 虚拟机和编译器。   [![star > 2000][Awesome]](https://github.com/yuin/gopher-lua)   [![godoc][GoDoc]](https://godoc.org/github.com/yuin/gopher-lua)
* [goja](https://github.com/dop251/goja) **star:2635** ECMAScript 5.1(+)实现在Go。   [![star > 2000][Awesome]](https://github.com/dop251/goja)   [![最近一周有更新][Green]](https://github.com/dop251/goja)   [![godoc][GoDoc]](https://godoc.org/github.com/dop251/goja)
* [tengo](https://github.com/d5/tengo) **star:2587** 字节码编译的脚本语言。   [![star > 2000][Awesome]](https://github.com/d5/tengo)   [![godoc][GoDoc]](https://godoc.org/github.com/d5/tengo)
* [expr](https://github.com/antonmedv/expr) **star:2270** Go的表达式计算引擎:快速，非图灵完备，动态类型，静态类型。   [![star > 2000][Awesome]](https://github.com/antonmedv/expr)   [![最近一周有更新][Green]](https://github.com/antonmedv/expr)   [![godoc][GoDoc]](https://godoc.org/github.com/antonmedv/expr)
* [go-lua](https://github.com/Shopify/go-lua) **star:2232** 用 Go 实现的 Lua 5.2 VM接口。   [![star > 2000][Awesome]](https://github.com/Shopify/go-lua)   [![最近一周有更新][Green]](https://github.com/Shopify/go-lua)   [![godoc][GoDoc]](https://godoc.org/github.com/Shopify/go-lua)
* [go-python](https://github.com/sbinet/go-python) **star:1341** CPython C-API 的 Go 接口。   [![godoc][GoDoc]](https://godoc.org/github.com/sbinet/go-python)
* [anko](https://github.com/mattn/anko) **star:1197** 用Go编写的解释器。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/anko)
* [cel-go](https://github.com/google/cel-go) **star:1025** 快速，可移植，非图灵完整的表达评估与渐进分型。   [![godoc][GoDoc]](https://godoc.org/github.com/google/cel-go)
* [metacall](https://github.com/metacall/core) **star:861** 跨平台多语言运行时，支持NodeJS, JavaScript, TypeScript, Python, Ruby, c#， WebAssembly, Java, Cobol等等。   [![最近一周有更新][Green]](https://github.com/metacall/core)
* [go-php](https://github.com/deuill/go-php) **star:833** PHP 的 Go 接口。   [![godoc][GoDoc]](https://godoc.org/github.com/deuill/go-php)
* [go-duktape](https://github.com/olebedev/go-duktape) **star:779** 支持 Duktape JavaScript 引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/go-duktape)   [![归档项目][Archived]](https://github.com/olebedev/go-duktape)
* [golua](https://github.com/aarzilli/golua) **star:578** Lua C 的 Go 接口。
* [gisp](https://github.com/jcla1/gisp) **star:477** LISP 的 Go 接口。   [![最近一年没有更新][Yellow]](https://github.com/jcla1/gisp)   [![godoc][GoDoc]](https://godoc.org/github.com/jcla1/gisp)
* [gval](https://github.com/PaesslerAG/gval) **star:430** 一种用Go编写的高度可定制的表达式语言。   [![godoc][GoDoc]](https://godoc.org/github.com/PaesslerAG/gval)
* [prolog](https://github.com/ichiban/prolog) **star:138** 可嵌入的序言。   [![最近一周有更新][Green]](https://github.com/ichiban/prolog)   [![godoc][GoDoc]](https://godoc.org/github.com/ichiban/prolog)
* [gentee](https://github.com/gentee/gentee) **star:87** 嵌入式脚本编程语言。   [![godoc][GoDoc]](https://godoc.org/github.com/gentee/gentee)
* [binder](https://github.com/alexeyco/binder) **star:54** Lua接口，基于[gopher-lua](https://github.com/yuin/gopher-lua)。   [![最近一年没有更新][Yellow]](https://github.com/alexeyco/binder)   [![godoc][GoDoc]](https://godoc.org/github.com/alexeyco/binder)
* [purl](https://github.com/ian-kent/purl) **star:34** 嵌入 Go 的 Perl 5.18.2。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/purl)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/purl)
* [ngaro](https://github.com/db47h/ngaro) **star:21** 嵌入式 Ngaro VM实现，支持在 Retro 中运行脚本。   [![最近一年没有更新][Yellow]](https://github.com/db47h/ngaro)   [![godoc][GoDoc]](https://godoc.org/github.com/db47h/ngaro)
* [ecal](https://github.com/krotik/ecal) **star:16** 一种简单的支持并发事件处理的可嵌入脚本语言。   [![godoc][GoDoc]](https://godoc.org/github.com/krotik/ecal)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#embeddable-scripting-languages) 吧~)*

## 错误处理

*处理错误的库。 (翻译出错了? 试试 [英文版](README_EN.md#error-handling) 吧~)*

* [errors](https://github.com/pkg/errors) **star:7565** 可让你很简单的进行错误处理。   [![star > 2000][Awesome]](https://github.com/pkg/errors)   [![godoc][GoDoc]](https://godoc.org/github.com/pkg/errors)   [![归档项目][Archived]](https://github.com/pkg/errors)
* [go-multierror](https://github.com/hashicorp/go-multierror) **star:1471** 可将一系列的错误作为一个整体来显示。   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/go-multierror)
* [eris](https://github.com/rotisserie/eris) **star:897** 在Go中处理、跟踪和记录错误的更好方法。兼容标准错误库和github.com/pkg/errors。   [![godoc][GoDoc]](https://godoc.org/github.com/rotisserie/eris)
* [errorx](https://github.com/joomcode/errorx) **star:794** 一个功能丰富的错误包，可进行堆栈跟踪、组装异常信息以及其他。   [![最近一周有更新][Green]](https://github.com/joomcode/errorx)   [![godoc][GoDoc]](https://godoc.org/github.com/joomcode/errorx)
* [tracerr](https://github.com/ztrue/tracerr) **star:697** 可展示错误的堆栈跟踪信息和源码片段。   [![最近一年没有更新][Yellow]](https://github.com/ztrue/tracerr)   [![godoc][GoDoc]](https://godoc.org/github.com/ztrue/tracerr)
* [errlog](https://github.com/snwfdhmp/errlog) **star:400** 用于定位抛出错误的源代码(以及一些其他快速调试特性)。可插入到任何 logger 的位置。   [![最近一年没有更新][Yellow]](https://github.com/snwfdhmp/errlog)   [![godoc][GoDoc]](https://godoc.org/github.com/snwfdhmp/errlog)
* [emperror](https://github.com/emperror/emperror) **star:240** 用于Go库和应用程序的错误处理工具和最佳实践。   [![最近一年没有更新][Yellow]](https://github.com/emperror/emperror)   [![godoc][GoDoc]](https://godoc.org/github.com/emperror/emperror)
* [errors](https://github.com/emperror/errors) **star:106** 替换标准库错误包和github.com/pkg/errors。提供各种错误处理原语。   [![godoc][GoDoc]](https://godoc.org/github.com/emperror/errors)
* [errors](https://github.com/bnkamalesh/errors) **star:26** 这是一个最小的错误处理包，自定义错误类型，用户友好的消息，Unwrap & is。与非常容易使用和直接的帮助函数。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/errors)
* [Falcon](https://github.com/SonicRoshan/falcon) **star:7** 一个简单但功能强大的错误处理包。   [![最近一年没有更新][Yellow]](https://github.com/SonicRoshan/falcon)   [![godoc][GoDoc]](https://godoc.org/github.com/SonicRoshan/falcon)
* [errors](https://github.com/neuronlabs/errors) **star:3** 使用分类原语进行简单的golang错误处理。   [![最近一年没有更新][Yellow]](https://github.com/neuronlabs/errors)   [![godoc][GoDoc]](https://godoc.org/github.com/neuronlabs/errors)
* [errors](https://github.com/PumpkinSeed/errors) **star:3** 最简单的错误包装器，具有出色的性能和最小的内存开销。   [![最近一年没有更新][Yellow]](https://github.com/PumpkinSeed/errors)   [![godoc][GoDoc]](https://godoc.org/github.com/PumpkinSeed/errors)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#error-handling) 吧~)*

## 文件处理

*处理文件和文件系统的库。 (翻译出错了? 试试 [英文版](README_EN.md#file-handling) 吧~)*

* [afero](https://github.com/spf13/afero) **star:4198** 文件系统的抽象系统。   [![star > 2000][Awesome]](https://github.com/spf13/afero)   [![最近一周有更新][Green]](https://github.com/spf13/afero)   [![godoc][GoDoc]](https://godoc.org/github.com/spf13/afero)
* [pdfcpu](https://github.com/pdfcpu/pdfcpu) **star:2919** PDF处理器。   [![star > 2000][Awesome]](https://github.com/pdfcpu/pdfcpu)   [![最近一周有更新][Green]](https://github.com/pdfcpu/pdfcpu)   [![godoc][GoDoc]](https://godoc.org/github.com/pdfcpu/pdfcpu)
* [gdu](https://github.com/dundee/gdu) **star:1504** 带有控制台接口的磁盘使用分析器。   [![最近一周有更新][Green]](https://github.com/dundee/gdu)   [![godoc][GoDoc]](https://godoc.org/github.com/dundee/gdu)
* [notify](https://github.com/rjeczalik/notify) **star:710** 文件系统事件通知库，具有类似于os/signal的简单API，。   [![godoc][GoDoc]](https://godoc.org/github.com/rjeczalik/notify)
* [copy](https://github.com/otiai10/copy) **star:376** 递归地复制目录。   [![godoc][GoDoc]](https://godoc.org/github.com/otiai10/copy)
* [bigfile](https://github.com/bigfile/bigfile) **star:213** 一个文件传输系统，支持管理文件与http api, rpc调用和ftp客户端。   [![最近一年没有更新][Yellow]](https://github.com/bigfile/bigfile)   [![godoc][GoDoc]](https://godoc.org/github.com/bigfile/bigfile)   [![包含中文文档][CN]](https://github.com/bigfile/bigfile)
* [afs](https://github.com/viant/afs) **star:172** 用于Go的抽象文件存储(mem、scp、zip、tar、cloud: s3、gs)。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/afs)
* [vfs](https://github.com/C2FO/vfs) **star:147** 一组可插拔的、可扩展的和自定义的文件系统功能，用于跨越许多文件系统类型，如os、S3和GCS。   [![godoc][GoDoc]](https://godoc.org/github.com/C2FO/vfs)
* [go-exiftool](https://github.com/barasher/go-exiftool) **star:95** ExifTool 的 Go 实现，这个著名的库用于从文件(图片、PDF、office，…)中提取尽可能多的元数据(EXIF、IPTC，…)。   [![godoc][GoDoc]](https://godoc.org/github.com/barasher/go-exiftool)
* [go-csv-tag](https://github.com/artonge/go-csv-tag) **star:94** 使用 tag 加载 csv 文件。   [![godoc][GoDoc]](https://godoc.org/github.com/artonge/go-csv-tag)
* [opc](https://github.com/qmuntal/opc) **star:69** 加载Open Packaging Conventions (OPC)文件。   [![godoc][GoDoc]](https://godoc.org/github.com/qmuntal/opc)
* [skywalker](https://github.com/dixonwille/skywalker) **star:68** 可以轻松地并发地遍历文件系统。   [![godoc][GoDoc]](https://godoc.org/github.com/dixonwille/skywalker)
* [stl](https://gitlab.com/russoj88/stl)  采用并行读取算法的进行读取和写入STL(立体光刻)文件的模块。
* [checksum](https://github.com/codingsince1985/checksum) **star:50** 计算消息摘要，如MD5, SHA256, SHA1, CRC或BLAKE2s，对于大文件。   [![godoc][GoDoc]](https://godoc.org/github.com/codingsince1985/checksum)
* [tarfs](https://github.com/posener/tarfs) **star:48** tar文件的实现[ FileSystem 接口](https://godoc.org/github.com/kr/fs#FileSystem)。   [![最近一年没有更新][Yellow]](https://github.com/posener/tarfs)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/tarfs)
* [parquet](https://github.com/parsyl/parquet) **star:43** 读写[parquet](https://parquet.apache.org)文件。   [![godoc][GoDoc]](https://godoc.org/github.com/parsyl/parquet)
* [baraka](https://github.com/xis/baraka) **star:36** 一个轻松处理http文件上传的库。   [![godoc][GoDoc]](https://godoc.org/github.com/xis/baraka)
* [go-gtfs](https://github.com/artonge/go-gtfs) **star:30** 加载gtfs文件。   [![最近一年没有更新][Yellow]](https://github.com/artonge/go-gtfs)   [![godoc][GoDoc]](https://godoc.org/github.com/artonge/go-gtfs)
* [flop](https://github.com/homedepot/flop) **star:29** 文件操作库，是[GNU cp](https://www.gnu.org/software/coreutils/manual/html_node/cp-invoc.html)的镜像。   [![godoc][GoDoc]](https://godoc.org/github.com/homedepot/flop)
* [gut/yos](https://github.com/1set/gut) **star:21** 简单和可靠的包文件操作，如复制/移动/diff/列表的文件，目录和符号链接。   [![最近一年没有更新][Yellow]](https://github.com/1set/gut)   [![godoc][GoDoc]](https://godoc.org/github.com/1set/gut)
* [go-decent-copy](https://github.com/hugocarreira/go-decent-copy) **star:14** 拷贝文件。   [![最近一年没有更新][Yellow]](https://github.com/hugocarreira/go-decent-copy)   [![godoc][GoDoc]](https://godoc.org/github.com/hugocarreira/go-decent-copy)
* [todotxt](https://github.com/1set/todotxt) **star:10** 去吉娜·特拉帕尼的[*todo.txt*](http://todotxt.org/)文件库，支持解析和操作任务列表中的[*todo。txt格式)(https://github.com/todotxt/todo.txt)。   [![godoc][GoDoc]](https://godoc.org/github.com/1set/todotxt)
* [higgs](https://github.com/dastoori/higgs) **star:6** 一个小小的跨平台Go库，用于隐藏/取消隐藏文件和目录。   [![godoc][GoDoc]](https://godoc.org/github.com/dastoori/higgs)
* [pathtype](https://github.com/jonchun/pathtype) **star:6** 将路径视为它们自己的类型，而不是使用字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/jonchun/pathtype)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#file-handling) 吧~)*

## 金融

*会计和财务软件包。 (翻译出错了? 试试 [英文版](README_EN.md#financial) 吧~)*

* [ticker](https://github.com/achannarasappa/ticker) **star:4022** 终端库存观察和库存位置跟踪。   [![star > 2000][Awesome]](https://github.com/achannarasappa/ticker)   [![godoc][GoDoc]](https://godoc.org/github.com/achannarasappa/ticker)
* [decimal](https://github.com/shopspring/decimal) **star:3671** 任意精度定点的十进制数。   [![star > 2000][Awesome]](https://github.com/shopspring/decimal)   [![最近一周有更新][Green]](https://github.com/shopspring/decimal)   [![godoc][GoDoc]](https://godoc.org/github.com/shopspring/decimal)
* [go-money](https://github.com/rhymond/go-money) **star:1039** Fowler 货币模式的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/rhymond/go-money)
* [accounting](https://github.com/leekchan/accounting) **star:695** 货币和货币格式。   [![godoc][GoDoc]](https://godoc.org/github.com/leekchan/accounting)
* [techan](https://github.com/sdcoffey/techan) **star:581** 拥有先进的市场分析和交易策略的技术分析库。   [![godoc][GoDoc]](https://godoc.org/github.com/sdcoffey/techan)
* [go-finance](https://github.com/FlashBoys/go-finance) **star:534** 综合金融市场数据。   [![最近一年没有更新][Yellow]](https://github.com/FlashBoys/go-finance)   [![godoc][GoDoc]](https://godoc.org/github.com/FlashBoys/go-finance)
* [ach](https://github.com/moov-io/ach) **star:277** 自动化票据交换所(ACH)文件的读取器、写入器和验证器。   [![最近一周有更新][Green]](https://github.com/moov-io/ach)   [![godoc][GoDoc]](https://godoc.org/github.com/moov-io/ach)
* [currency](https://github.com/bojanz/currency) **star:267** 处理货币金额，提供货币信息和格式。   [![最近一周有更新][Green]](https://github.com/bojanz/currency)   [![godoc][GoDoc]](https://godoc.org/github.com/bojanz/currency)
* [orderbook](https://github.com/i25959341/orderbook) **star:241** 限购单匹配引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/i25959341/orderbook)
* [go-finance](https://github.com/alpeb/go-finance) **star:120** 用于货币时间价值(年金)、现金流、利率转换、债券和折旧计算的金融函数库。   [![godoc][GoDoc]](https://godoc.org/github.com/alpeb/go-finance)
* [transaction](https://github.com/claygod/transaction) **star:100** 嵌入式事务数据库，可多线程模式运行。   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/transaction)
* [ofxgo](https://github.com/aclindsa/ofxgo) **star:95** 查询 OFX 服务器和/或解析响应。   [![godoc][GoDoc]](https://godoc.org/github.com/aclindsa/ofxgo)
* [vat](https://github.com/dannyvankooten/vat) **star:85** 增值税编号验证 & 欧盟增值税税率。   [![godoc][GoDoc]](https://godoc.org/github.com/dannyvankooten/vat)
* [sleet](https://github.com/BoltApp/sleet) **star:80** 多个付款服务供应商使用统一界面处理网上付款。   [![最近一周有更新][Green]](https://github.com/BoltApp/sleet)   [![godoc][GoDoc]](https://godoc.org/github.com/BoltApp/sleet)
* [go-finnhub](https://github.com/m1/go-finnhub) **star:63** 来自finnhu .io的股票市场、外汇和密码数据客户。从60多个证券交易所、10个外汇经纪人和15多个密码交易所获取实时金融市场数据。   [![最近一年没有更新][Yellow]](https://github.com/m1/go-finnhub)   [![godoc][GoDoc]](https://godoc.org/github.com/m1/go-finnhub)   [![归档项目][Archived]](https://github.com/m1/go-finnhub)
* [currency](https://github.com/bnkamalesh/currency) **star:44** 高性能、准确的货币计算软件包。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/currency)
* [fastme](https://github.com/newity/fastme) **star:26** 快速可扩展匹配引擎Go实现。   [![godoc][GoDoc]](https://godoc.org/github.com/newity/fastme)
* [payme](https://github.com/jovandeginste/payme) **star:8** 二维码生成器(ASCII & PNG)用于SEPA支付。   [![godoc][GoDoc]](https://godoc.org/github.com/jovandeginste/payme)
* [go-finance](https://github.com/pieterclaerhout/go-finance) **star:5** 模块获取汇率，通过VIES检查增值税号码，检查IBAN银行账号。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-finance)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-finance)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#financial) 吧~)*

## 表单

*用于处理表单的库。 (翻译出错了? 试试 [英文版](README_EN.md#forms) 吧~)*

* [nosurf](https://github.com/justinas/nosurf) **star:1239** CSRF保护中间件。   [![最近一年没有更新][Yellow]](https://github.com/justinas/nosurf)   [![godoc][GoDoc]](https://godoc.org/github.com/justinas/nosurf)
* [binding](https://github.com/mholt/binding) **star:786** 将来自 net/HTTP 请求的表单、JSON 数据绑定到结构体。   [![最近一年没有更新][Yellow]](https://github.com/mholt/binding)   [![godoc][GoDoc]](https://godoc.org/github.com/mholt/binding)   [![归档项目][Archived]](https://github.com/mholt/binding)
* [gorilla/csrf](https://github.com/gorilla/csrf) **star:735** 用于Go web应用程序和服务的CSRF保护。   [![godoc][GoDoc]](https://godoc.org/github.com/gorilla/csrf)
* [form](https://github.com/go-playground/form) **star:506**  将 url 中的数据解析到 Go 变量中，以及将 Go 语言变量编码进 url。支持 Dual Array 及 Full map。   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/form)
* [conform](https://github.com/leebenson/conform) **star:245** 控制用户输入。基于struct tags可对数据进行修剪、清理和擦除。   [![godoc][GoDoc]](https://godoc.org/github.com/leebenson/conform)
* [formam](https://github.com/monoculum/formam) **star:165** 将表单的值解码为 struct。   [![godoc][GoDoc]](https://godoc.org/github.com/monoculum/formam)
* [forms](https://github.com/albrow/forms) **star:128** 与框架无关的库，用于解析和验证支持多部分表单和文件的表单/JSON数据。   [![最近一年没有更新][Yellow]](https://github.com/albrow/forms)   [![godoc][GoDoc]](https://godoc.org/github.com/albrow/forms)
* [qs](https://github.com/sonh/qs) **star:59** 去模块编码结构到URL查询参数。   [![godoc][GoDoc]](https://godoc.org/github.com/sonh/qs)
* [bind](https://github.com/robfig/bind) **star:26** 将表单数据与任意 Go 变量进行绑定。   [![最近一年没有更新][Yellow]](https://github.com/robfig/bind)   [![godoc][GoDoc]](https://godoc.org/github.com/robfig/bind)
* [queryparam](https://github.com/tomwright/queryparam) **star:11** 解码的url。值转换为标准或自定义类型的可用结构值。   [![最近一年没有更新][Yellow]](https://github.com/tomwright/queryparam)   [![godoc][GoDoc]](https://godoc.org/github.com/tomwright/queryparam)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#forms) 吧~)*

## 方法

*在Go中支持函数式编程的包。 (翻译出错了? 试试 [英文版](README_EN.md#functional) 吧~)*

* [go-underscore](https://github.com/tobyhede/go-underscore) **star:1222** 常用辅助方法集合。   [![最近一年没有更新][Yellow]](https://github.com/tobyhede/go-underscore)   [![godoc][GoDoc]](https://godoc.org/github.com/tobyhede/go-underscore)
* [fpGo](https://github.com/TeaEntityLab/fpGo) **star:221** 提供函数式编程功能。   [![godoc][GoDoc]](https://godoc.org/github.com/TeaEntityLab/fpGo)
* [gofp](https://github.com/rbrahul/gofp) **star:103** 一个类似lodash的强大的Golang实用程序库。   [![godoc][GoDoc]](https://godoc.org/github.com/rbrahul/gofp)
* [fuego](https://github.com/seborama/fuego) **star:101** Functional Experiment in Go。   [![最近一年没有更新][Yellow]](https://github.com/seborama/fuego)   [![godoc][GoDoc]](https://godoc.org/github.com/seborama/fuego)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#functional) 吧~)*

## 游戏开发

*很棒的游戏开发库。 (翻译出错了? 试试 [英文版](README_EN.md#game-development) 吧~)*

* [Ebiten](https://github.com/hajimehoshi/ebiten) **star:5893** 很简单的 2D 游戏库。   [![star > 2000][Awesome]](https://github.com/hajimehoshi/ebiten)   [![最近一周有更新][Green]](https://github.com/hajimehoshi/ebiten)   [![godoc][GoDoc]](https://godoc.org/github.com/hajimehoshi/ebiten)
* [Leaf](https://github.com/name5566/leaf) **star:4271** 轻量级游戏服务器框架。   [![star > 2000][Awesome]](https://github.com/name5566/leaf)   [![godoc][GoDoc]](https://godoc.org/github.com/name5566/leaf)   [![包含中文文档][CN]](https://github.com/name5566/leaf)
* [Pixel](https://github.com/faiface/pixel) **star:3786** 手工制作的 2D 游戏库。   [![star > 2000][Awesome]](https://github.com/faiface/pixel)   [![godoc][GoDoc]](https://godoc.org/github.com/faiface/pixel)
* [goworld](https://github.com/xiaonanln/goworld) **star:2034** 可伸缩的游戏服务器引擎，具有 space-entity 框架和 hot-swapping 功能。   [![star > 2000][Awesome]](https://github.com/xiaonanln/goworld)   [![godoc][GoDoc]](https://godoc.org/github.com/xiaonanln/goworld)   [![包含中文文档][CN]](https://github.com/xiaonanln/goworld)
* [nano](https://github.com/lonng/nano) **star:1916** 轻量级、方便、高性能的基于golang的游戏服务器框架。   [![godoc][GoDoc]](https://godoc.org/github.com/lonng/nano)   [![包含中文文档][CN]](https://github.com/lonng/nano)
* [g3n](https://github.com/g3n/engine) **star:1805**  3D游戏引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/g3n/engine)
* [go-sdl2](https://github.com/veandco/go-sdl2) **star:1683** 实现了[Simple DirectMedia Layer](https://www.libsdl.org/)。   [![最近一周有更新][Green]](https://github.com/veandco/go-sdl2)
* [engo](https://github.com/EngoEngine/engo) **star:1466** 开源 2D 游戏引擎。它遵循 Entity-Component-System 范式。   [![godoc][GoDoc]](https://godoc.org/github.com/EngoEngine/engo)
* [Pitaya](https://github.com/topfreegames/pitaya) **star:1303** 可伸缩的游戏服务器框架，支持集群和客户端库的iOS, Android, Unity。   [![godoc][GoDoc]](https://godoc.org/github.com/topfreegames/pitaya)
* [termloop](https://github.com/JoelOtter/termloop) **star:1255** 基于终端的 Go 游戏引擎，建立在 Termbox 之上。   [![godoc][GoDoc]](https://godoc.org/github.com/JoelOtter/termloop)
* [gonet](https://github.com/xtaci/gonet) **star:1167** 实现了游戏服务器骨架。   [![最近一年没有更新][Yellow]](https://github.com/xtaci/gonet)   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/gonet)
* [Oak](https://github.com/oakmound/oak) **star:1002** 纯 Go 实现的游戏引擎。   [![最近一周有更新][Green]](https://github.com/oakmound/oak)   [![godoc][GoDoc]](https://godoc.org/github.com/oakmound/oak)
* [raylib-go](https://github.com/gen2brain/raylib-go) **star:719** 去绑定[raylib](https://www.raylib.com/)，一个简单易用的库学习视频游戏编程。   [![最近一周有更新][Green]](https://github.com/gen2brain/raylib-go)
* [Azul3D](https://github.com/azul3d/engine) **star:523** 用Go编写的 3D 游戏引擎。
* [go-astar](https://github.com/beefsack/go-astar) **star:470** 实现了A\*路径查找算法。   [![最近一年没有更新][Yellow]](https://github.com/beefsack/go-astar)   [![godoc][GoDoc]](https://godoc.org/github.com/beefsack/go-astar)
* [go3d](https://github.com/ungerik/go3d) **star:218** 以性能为主的2D/3D数学相关包。   [![最近一周有更新][Green]](https://github.com/ungerik/go3d)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go3d)
* [prototype](https://github.com/gonutz/prototype) **star:67** 跨平台(Windows/Linux/Mac)库，用于使用最少的API创建桌面游戏。   [![godoc][GoDoc]](https://godoc.org/github.com/gonutz/prototype)
* [tile](https://github.com/kelindar/tile) **star:40** 面向数据和缓存友好的2D网格库(TileMap)，包括寻路、观察者和导入/导出。   [![godoc][GoDoc]](https://godoc.org/github.com/kelindar/tile)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#game-development) 吧~)*

## 代码生成与泛型

*增强语言的工具，例如通过代码生成支持泛型。 (翻译出错了? 试试 [英文版](README_EN.md#generation-and-generics) 吧~)*

* [go-linq](https://github.com/ahmetalpbalkan/go-linq) **star:2825** 提供类似 .NET LINQ 的查询方法。   [![star > 2000][Awesome]](https://github.com/ahmetalpbalkan/go-linq)   [![godoc][GoDoc]](https://godoc.org/github.com/ahmetalpbalkan/go-linq)
* [jennifer](https://github.com/dave/jennifer) **star:2282** 不使用模板生成任意 Go 代码。   [![star > 2000][Awesome]](https://github.com/dave/jennifer)   [![godoc][GoDoc]](https://godoc.org/github.com/dave/jennifer)
* [gen](https://github.com/clipperhouse/gen) **star:1346** 用于生成泛型等类似方法的功能代码生成工具。   [![最近一年没有更新][Yellow]](https://github.com/clipperhouse/gen)   [![godoc][GoDoc]](https://godoc.org/github.com/clipperhouse/gen)
* [goderive](https://github.com/awalterschulze/goderive) **star:955** 从输入类型来派生函数。   [![godoc][GoDoc]](https://godoc.org/github.com/awalterschulze/goderive)
* [GoWrap](https://github.com/hexdigest/gowrap) **star:557** 使用简单模板为 Go 接口生成装饰器。   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/gowrap)
* [interfaces](https://github.com/rjeczalik/interfaces) **star:322** 用于生成接口定义的命令行工具。   [![godoc][GoDoc]](https://godoc.org/github.com/rjeczalik/interfaces)
* [go-enum](https://github.com/abice/go-enum) **star:269** 从代码注释中生成枚举。   [![最近一周有更新][Green]](https://github.com/abice/go-enum)   [![godoc][GoDoc]](https://godoc.org/github.com/abice/go-enum)
* [pkgreflect](https://github.com/ungerik/pkgreflect) **star:99** 用于包作用域反射的 Go 预处理器。   [![最近一年没有更新][Yellow]](https://github.com/ungerik/pkgreflect)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/pkgreflect)
* [goverter](https://github.com/jmattheis/goverter) **star:96** 通过定义接口生成转换器。   [![最近一周有更新][Green]](https://github.com/jmattheis/goverter)   [![godoc][GoDoc]](https://godoc.org/github.com/jmattheis/goverter)
* [efaceconv](https://github.com/t0pep0/efaceconv) **star:51** 代码生成工具，可以不通过内存分配就可以高效的将interface{}转换为不可变类型，。   [![最近一年没有更新][Yellow]](https://github.com/t0pep0/efaceconv)   [![godoc][GoDoc]](https://godoc.org/github.com/t0pep0/efaceconv)
* [gotype](https://github.com/wzshiming/gotype) **star:36** Golang 源码解析，用法类似reflect(反射)。   [![godoc][GoDoc]](https://godoc.org/github.com/wzshiming/gotype)   [![包含中文文档][CN]](https://github.com/wzshiming/gotype)
* [generis](https://github.com/senselogic/GENERIS) **star:30** 提供泛型、free-form 宏、条件编译和HTML模板的代码生成工具。
* [go-xray](https://github.com/pieterclaerhout/go-xray) **star:21** 帮助更容易地使用反射。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-xray)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-xray)
* [typeregistry](https://github.com/xiaoxin01/typeregistry) **star:12** 动态创建类型的库。   [![最近一年没有更新][Yellow]](https://github.com/xiaoxin01/typeregistry)   [![godoc][GoDoc]](https://godoc.org/github.com/xiaoxin01/typeregistry)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#generation-and-generics) 吧~)*

## 地理

*地理工具和服务器 (翻译出错了? 试试 [英文版](README_EN.md#geographic) 吧~)*

* [Tile38](https://github.com/tidwall/tile38) **star:7925** 具有空间索引和实时地理定位功能的地理定位数据库。   [![star > 2000][Awesome]](https://github.com/tidwall/tile38)   [![godoc][GoDoc]](https://godoc.org/github.com/tidwall/tile38)
* [S2 geometry](https://github.com/golang/geo) **star:1315** S2 geometry 库。   [![godoc][GoDoc]](https://godoc.org/github.com/golang/geo)
* [mbtileserver](https://github.com/consbio/mbtileserver) **star:298** 一个简单的基于go的服务器，用于存储mbtiles格式的地图块。   [![godoc][GoDoc]](https://godoc.org/github.com/consbio/mbtileserver)
* [osm](https://github.com/paulmach/osm) **star:186** 用于读取、写入和处理 OpenStreetMap 数据和 APIs。   [![godoc][GoDoc]](https://godoc.org/github.com/paulmach/osm)
* [WGS84](https://github.com/wroge/wgs84) **star:68** 坐标转换和转换库(ETRS89, OSGB36, NAD83, RGF93, Web Mercator, UTM)。   [![godoc][GoDoc]](https://godoc.org/github.com/wroge/wgs84)
* [geoserver](https://github.com/hishamkaram/geoserver) **star:66** 基于geoserver REST API的 geoserver 实例。   [![godoc][GoDoc]](https://godoc.org/github.com/hishamkaram/geoserver)
* [godal](https://github.com/airbusgeo/godal) **star:59** 去包装GDAL。   [![最近一周有更新][Green]](https://github.com/airbusgeo/godal)   [![godoc][GoDoc]](https://godoc.org/github.com/airbusgeo/godal)
* [gismanager](https://github.com/hishamkaram/gismanager) **star:40** 将你的 GIS 数据(矢量数据)发布到 PostGIS 和 Geoserver。   [![最近一年没有更新][Yellow]](https://github.com/hishamkaram/gismanager)   [![godoc][GoDoc]](https://godoc.org/github.com/hishamkaram/gismanager)
* [simplefeatures](https://github.com/peterstace/simplefeatures) **star:39** simplesfeatures是一个2D几何库，提供了建模几何图形的Go类型，以及对几何图形进行操作的算法。   [![godoc][GoDoc]](https://godoc.org/github.com/peterstace/simplefeatures)
* [pbf](https://github.com/maguro/pbf) **star:30** 基于Golang 的 OpenStreetMap PBF 编码器/解码器。   [![godoc][GoDoc]](https://godoc.org/github.com/maguro/pbf)
* [S2 geojson](https://github.com/pantrif/s2-geojson) **star:15** 将geojson转换为s2单元格&在map上演示一些s2的几何特性。   [![最近一年没有更新][Yellow]](https://github.com/pantrif/s2-geojson)   [![godoc][GoDoc]](https://godoc.org/github.com/pantrif/s2-geojson)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#geographic) 吧~)*

## Go 编译器

*可将 Go 转换为其他语言的编译工具。 (翻译出错了? 试试 [英文版](README_EN.md#go-compilers) 吧~)*

* [gopherjs](https://github.com/gopherjs/gopherjs) **star:10799** 将 Go 编译成 JavaScript。   [![star > 2000][Awesome]](https://github.com/gopherjs/gopherjs)   [![godoc][GoDoc]](https://godoc.org/github.com/gopherjs/gopherjs)
* [tardisgo](https://github.com/tardisgo/tardisgo) **star:414** Golang 转换为 Haxe，再转换为 CPP/CSharp/Java/JavaScript 的编译器.   [![最近一年没有更新][Yellow]](https://github.com/tardisgo/tardisgo)   [![godoc][GoDoc]](https://godoc.org/github.com/tardisgo/tardisgo)
* [c4go](https://github.com/Konstantin8105/c4go) **star:294** 将 C 代码转换为 Go 代码。   [![godoc][GoDoc]](https://godoc.org/github.com/Konstantin8105/c4go)
* [esp32](https://github.com/andygeiss/esp32-transpiler) **star:37** 转到Arduino代码。   [![godoc][GoDoc]](https://godoc.org/github.com/andygeiss/esp32-transpiler)
* [f4go](https://github.com/Konstantin8105/f4go) **star:31** 将 FORTRAN 77 转换为 Go代码。   [![godoc][GoDoc]](https://godoc.org/github.com/Konstantin8105/f4go)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#go-compilers) 吧~)*

## Goroutines

*管理和处理 Goroutines 的工具。 (翻译出错了? 试试 [英文版](README_EN.md#goroutines) 吧~)*

* [ants](https://github.com/panjf2000/ants) **star:7506** 一个高性能且低损耗的 goroutine 池。   [![star > 2000][Awesome]](https://github.com/panjf2000/ants)   [![godoc][GoDoc]](https://godoc.org/github.com/panjf2000/ants)   [![包含中文文档][CN]](https://github.com/panjf2000/ants)
* [tunny](https://github.com/Jeffail/tunny) **star:2803** golang 的协程池。   [![star > 2000][Awesome]](https://github.com/Jeffail/tunny)   [![最近一周有更新][Green]](https://github.com/Jeffail/tunny)   [![godoc][GoDoc]](https://godoc.org/github.com/Jeffail/tunny)
* [goworker](https://github.com/benmanns/goworker) **star:2625** 基于 go 的后台 worker。   [![star > 2000][Awesome]](https://github.com/benmanns/goworker)   [![godoc][GoDoc]](https://godoc.org/github.com/benmanns/goworker)
* [workerpool](https://github.com/gammazero/workerpool) **star:714** 限制任务执行并发数，而不是队列中的任务数量的协程池，。   [![godoc][GoDoc]](https://godoc.org/github.com/gammazero/workerpool)
* [grpool](https://github.com/ivpusic/grpool) **star:670** 轻量级协程池。   [![最近一年没有更新][Yellow]](https://github.com/ivpusic/grpool)   [![godoc][GoDoc]](https://godoc.org/github.com/ivpusic/grpool)
* [pool](https://github.com/go-playground/pool) **star:667** 有限消费者协程或无限协程池，可用于更加简单的处理和取消协程   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/pool)
* [pond](https://github.com/alitto/pond) **star:434** 简约和高性能的goroutine工作池写在Go。   [![godoc][GoDoc]](https://godoc.org/github.com/alitto/pond)
* [gowp](https://github.com/xxjwxc/gowp) **star:352** gowp是高并发性限制异步工作池。   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/gowp)   [![包含中文文档][CN]](https://github.com/xxjwxc/gowp)
* [go-floc](https://github.com/workanator/go-floc) **star:221** 轻松编排 goroutines。   [![godoc][GoDoc]](https://godoc.org/github.com/workanator/go-floc)
* [go-flow](https://github.com/kamildrazkiewicz/go-flow) **star:182** 控制 goroutines 的执行顺序。   [![最近一年没有更新][Yellow]](https://github.com/kamildrazkiewicz/go-flow)   [![godoc][GoDoc]](https://godoc.org/github.com/kamildrazkiewicz/go-flow)
* [semaphore](https://github.com/marusama/semaphore) **star:134** 基于 CAS 的可快速调整的信号量实现(比基于通道的信号量实现更快)。   [![godoc][GoDoc]](https://godoc.org/github.com/marusama/semaphore)
* [go-workers](https://github.com/catmullet/go-workers) **star:129** 为大型数据处理管道轻松安全地运行工人。   [![最近一周有更新][Green]](https://github.com/catmullet/go-workers)   [![godoc][GoDoc]](https://godoc.org/github.com/catmullet/go-workers)
* [artifex](https://github.com/borderstech/artifex) **star:124** 简单的内存作业队列。   [![最近一年没有更新][Yellow]](https://github.com/borderstech/artifex)   [![godoc][GoDoc]](https://godoc.org/github.com/borderstech/artifex)
* [neilotoole/errgroup](https://github.com/neilotoole/errgroup) **star:108** “sync/errgroup”的替代方案，仅限于N个worker goroutines池。   [![godoc][GoDoc]](https://godoc.org/github.com/neilotoole/errgroup)
* [async](https://github.com/studiosol/async) **star:97** 一种异步执行函数的安全方法，在出现 panic 时恢复它们。   [![最近一年没有更新][Yellow]](https://github.com/studiosol/async)   [![godoc][GoDoc]](https://godoc.org/github.com/studiosol/async)
* [cyclicbarrier](https://github.com/marusama/cyclicbarrier) **star:90** 基于 Go 的 CyclicBarrier 实现。   [![最近一年没有更新][Yellow]](https://github.com/marusama/cyclicbarrier)   [![godoc][GoDoc]](https://godoc.org/github.com/marusama/cyclicbarrier)
* [semaphore](https://github.com/kamilsk/semaphore) **star:89** 信号量模式实现，可根据通道和上下文进行具备超时功能的锁定/解锁操作。   [![最近一年没有更新][Yellow]](https://github.com/kamilsk/semaphore)   [![godoc][GoDoc]](https://godoc.org/github.com/kamilsk/semaphore)
* [gpool](https://github.com/Sherifabdlnaby/gpool) **star:82** manages a resizeable pool of context-aware goroutines to bound concurrency   [![最近一年没有更新][Yellow]](https://github.com/Sherifabdlnaby/gpool)   [![godoc][GoDoc]](https://godoc.org/github.com/Sherifabdlnaby/gpool)
* [worker-pool](https://github.com/vardius/worker-pool) **star:80** 一个简单的 Go 异步工作池。   [![最近一年没有更新][Yellow]](https://github.com/vardius/worker-pool)   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/worker-pool)
* [gollback](https://github.com/vardius/gollback) **star:75** 异步简单的函数实用程序，用于管理闭包和回调的执行。   [![最近一周有更新][Green]](https://github.com/vardius/gollback)   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/gollback)
* [Hunch](https://github.com/AaronJan/Hunch) **star:71** Hunch 提供了诸如 All、First、Retry、Waterfall 等功能，这使得异步流控制更加直观。   [![最近一年没有更新][Yellow]](https://github.com/AaronJan/Hunch)   [![godoc][GoDoc]](https://godoc.org/github.com/AaronJan/Hunch)
* [threadpool](https://github.com/shettyh/threadpool) **star:62** Golang 的 threadpool 实现。   [![最近一年没有更新][Yellow]](https://github.com/shettyh/threadpool)   [![godoc][GoDoc]](https://godoc.org/github.com/shettyh/threadpool)
* [routine](https://github.com/x-mod/routine) **star:47** go routine control with context, support: Main, Go, Pool and some useful Executors.   [![最近一年没有更新][Yellow]](https://github.com/x-mod/routine)   [![godoc][GoDoc]](https://godoc.org/github.com/x-mod/routine)
* [goccm](https://github.com/zenthangplus/goccm) **star:41** Go并发管理器包限制了允许并发运行的goroutines的数量。   [![godoc][GoDoc]](https://godoc.org/github.com/zenthangplus/goccm)
* [nursery](https://github.com/arunsworld/nursery) **star:38** Go中的结构化并发。   [![godoc][GoDoc]](https://godoc.org/github.com/arunsworld/nursery)
* [oversight](https://cirello.io/oversight)  完整的实现了Erlang supervision trees。
* [kyoo](https://github.com/dirkaholic/kyoo) **star:36** 提供无限的作业队列和并发工作池。   [![最近一年没有更新][Yellow]](https://github.com/dirkaholic/kyoo)   [![godoc][GoDoc]](https://godoc.org/github.com/dirkaholic/kyoo)
* [async](https://github.com/reugn/async) **star:34** 可选的Go同步库(Future, Promise, Locks)。   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/async)
* [parallel-fn](https://github.com/rafaeljesus/parallel-fn) **star:31** 并行运行函数。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/parallel-fn)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/parallel-fn)
* [gohive](https://github.com/loveleshsharma/gohive) **star:29** 一个高性能和易于使用的Goroutine池去。   [![godoc][GoDoc]](https://godoc.org/github.com/loveleshsharma/gohive)
* [go-trylock](https://github.com/subchen/go-trylock) **star:23** 支持 read-write 锁。   [![godoc][GoDoc]](https://godoc.org/github.com/subchen/go-trylock)
* [go-waitgroup](https://github.com/pieterclaerhout/go-waitgroup) **star:23** 像“同步。有错误处理和并发控制。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-waitgroup)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-waitgroup)
* [stl](https://github.com/ssgreg/stl) **star:21** 基于软件事务内存(STM)并发控制机制的软件事务锁。   [![最近一年没有更新][Yellow]](https://github.com/ssgreg/stl)   [![godoc][GoDoc]](https://godoc.org/github.com/ssgreg/stl)
* [channelify](https://github.com/ddelizia/channelify) **star:15** 将函数转换为返回通道，以便进行简单而强大的并行处理。   [![godoc][GoDoc]](https://godoc.org/github.com/ddelizia/channelify)
* [gowl](https://github.com/hamed-yousefi/gowl) **star:12** Gowl同时是一个流程管理和流程监控工具。无限工作者池使您能够控制池和进程并监视它们的状态。   [![godoc][GoDoc]](https://godoc.org/github.com/hamed-yousefi/gowl)
* [conexec](https://github.com/ITcathyh/conexec) **star:11** 一个并发工具包，帮助以高效和安全的方式并发执行函数。它支持指定总体超时来避免阻塞，并使用goroutine池来提高效率。   [![最近一年没有更新][Yellow]](https://github.com/ITcathyh/conexec)   [![godoc][GoDoc]](https://godoc.org/github.com/ITcathyh/conexec)
* [queue](https://github.com/AnikHasibul/queue) **star:10** 提供类似队列组可访问性 sync.WaitGroup 的功能。帮助你节流和限制协程、等待所有协程结束以及更多功能。   [![最近一年没有更新][Yellow]](https://github.com/AnikHasibul/queue)   [![godoc][GoDoc]](https://godoc.org/github.com/AnikHasibul/queue)
* [execpool](https://github.com/hexdigest/execpool) **star:7** 一个围绕exec建立的池。Cmd，它预先启动给定数量的进程，并在需要时将stdin和stdout附加到它们。非常类似于FastCGI或Apache Prefork MPM，但适用于任何命令。   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/execpool)
* [hands](https://github.com/duanckham/hands) **star:7** 进程控制器，用于控制多个goroutine的执行和返回策略。   [![最近一年没有更新][Yellow]](https://github.com/duanckham/hands)   [![godoc][GoDoc]](https://godoc.org/github.com/duanckham/hands)
* [concurrency-limiter](https://github.com/vivek-ng/concurrency-limiter) **star:6** 支持超时、动态优先级和上下文取消的并发限制器。   [![最近一年没有更新][Yellow]](https://github.com/vivek-ng/concurrency-limiter)   [![godoc][GoDoc]](https://godoc.org/github.com/vivek-ng/concurrency-limiter)
* [go-tools/multithreading](https://github.com/nikhilsaraf/go-tools) **star:5** 轻量级的协程池库，可以通过简单的API来管理。   [![最近一年没有更新][Yellow]](https://github.com/nikhilsaraf/go-tools)   [![godoc][GoDoc]](https://godoc.org/github.com/nikhilsaraf/go-tools)
* [breaker](https://github.com/kamilsk/breaker) **star:2** 灵活的机制，可以使执行流可中断。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#goroutines) 吧~)*

## GUI

*用于构建GUI应用程序的库。 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

*工具包 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

* [fyne](https://github.com/fyne-io/fyne) **star:15429** 基于材料设计的Go跨平台本机gui设计。支持:Linux, macOS, Windows, BSD, iOS和Android。   [![star > 2000][Awesome]](https://github.com/fyne-io/fyne)   [![最近一周有更新][Green]](https://github.com/fyne-io/fyne)   [![godoc][GoDoc]](https://godoc.org/github.com/fyne-io/fyne)
* [webview](https://github.com/zserge/webview) **star:9377** 跨平台webview窗口，具有简单的双向JavaScript绑定(Windows / macOS / Linux)。   [![star > 2000][Awesome]](https://github.com/zserge/webview)   [![最近一周有更新][Green]](https://github.com/zserge/webview)
* [qt](https://github.com/therecipe/qt) **star:9010** 实现了 Qt 的 Go接口(支持Windows / macOS / Linux / Android / iOS / Sailfish OS / Raspberry Pi)。   [![star > 2000][Awesome]](https://github.com/therecipe/qt)   [![最近一年没有更新][Yellow]](https://github.com/therecipe/qt)   [![godoc][GoDoc]](https://godoc.org/github.com/therecipe/qt)
* [ui](https://github.com/andlabs/ui) **star:8057** 跨平台的 Platform-native GUI 库。   [![star > 2000][Awesome]](https://github.com/andlabs/ui)   [![godoc][GoDoc]](https://godoc.org/github.com/andlabs/ui)
* [Wails](https://wails.app)  Mac, Windows, Linux桌面应用程序，主要基于含有内置的OS HTML渲染器的HTML UI。
* [walk](https://github.com/lxn/walk) **star:5886** Windows应用程序库。   [![star > 2000][Awesome]](https://github.com/lxn/walk)   [![godoc][GoDoc]](https://godoc.org/github.com/lxn/walk)
* [app](https://github.com/murlokswarm/app) **star:5793** 用于创建包含了 GO, HTML 和 CSS 的应用程序。支持 MacOS, Windows 正在开发中。   [![star > 2000][Awesome]](https://github.com/murlokswarm/app)   [![最近一周有更新][Green]](https://github.com/murlokswarm/app)   [![godoc][GoDoc]](https://godoc.org/github.com/murlokswarm/app)
* [go-astilectron](https://github.com/asticode/go-astilectron) **star:4198** 使用 GO 和 HTML/JS/CSS (电子驱动)进行构建跨平台 GUI 应用程序。   [![star > 2000][Awesome]](https://github.com/asticode/go-astilectron)   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astilectron)
* [go-gtk](https://mattn.github.io/go-gtk/)  实现了 GTK 的 Go接口。
* [go-sciter](https://github.com/sciter-sdk/go-sciter) **star:2305** 实现了 Sciter 的 Go 接口 : 用于现代桌面 UI 开发的可嵌入HTML/CSS/脚本引擎。可跨平台。   [![star > 2000][Awesome]](https://github.com/sciter-sdk/go-sciter)   [![godoc][GoDoc]](https://godoc.org/github.com/sciter-sdk/go-sciter)
* [gotk3](https://github.com/gotk3/gotk3) **star:1673** 实现了 GTK3 的 Go接口。   [![godoc][GoDoc]](https://godoc.org/github.com/gotk3/gotk3)
* [gowd](https://github.com/dtylman/gowd) **star:339** 跨平台、快速、简单的桌面UI开发，采用了GO, HTML, CSS和NW.js实现。   [![最近一年没有更新][Yellow]](https://github.com/dtylman/gowd)   [![godoc][GoDoc]](https://godoc.org/github.com/dtylman/gowd)

*交互 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

* [robotgo](https://github.com/go-vgo/robotgo) **star:7170** 实现跨平台的GUI系统自动化。包含了控制鼠标、键盘等功能。   [![star > 2000][Awesome]](https://github.com/go-vgo/robotgo)   [![最近一周有更新][Green]](https://github.com/go-vgo/robotgo)
* [systray](https://github.com/getlantern/systray) **star:2097** 跨平台 Go 库，可在通知区放置图标和菜单。   [![star > 2000][Awesome]](https://github.com/getlantern/systray)   [![godoc][GoDoc]](https://godoc.org/github.com/getlantern/systray)
* [gosx-notifier](https://github.com/deckarep/gosx-notifier) **star:554** OSX 桌面通知库。   [![最近一年没有更新][Yellow]](https://github.com/deckarep/gosx-notifier)   [![godoc][GoDoc]](https://godoc.org/github.com/deckarep/gosx-notifier)
* [trayhost](https://github.com/shurcooL/trayhost) **star:221** 跨平台 Go 库，可用于在主机操作系统的任务栏中放置图标。   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/trayhost)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/trayhost)
* [zenity](https://github.com/ncruces/zenity) **star:214** 跨平台的Go库和CLI创建简单的对话框，与用户进行图形化交互。   [![godoc][GoDoc]](https://godoc.org/github.com/ncruces/zenity)
* [go-appindicator](https://github.com/dawidd6/go-appindicator) **star:17** 实现了 libappindicator3 C库 的 Go接口。   [![最近一年没有更新][Yellow]](https://github.com/dawidd6/go-appindicator)   [![godoc][GoDoc]](https://godoc.org/github.com/dawidd6/go-appindicator)   [![归档项目][Archived]](https://github.com/dawidd6/go-appindicator)
* [mac-activity-tracker](https://github.com/prashantgupta24/activity-tracker) **star:13** 用于通知计算机上的任何(可插入的)活动的 OSX 库。   [![最近一年没有更新][Yellow]](https://github.com/prashantgupta24/activity-tracker)   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/activity-tracker)
* [mac-sleep-notifier](https://github.com/prashantgupta24/mac-sleep-notifier) **star:11** OSX 睡眠/唤醒通知。   [![最近一年没有更新][Yellow]](https://github.com/prashantgupta24/mac-sleep-notifier)   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/mac-sleep-notifier)


**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)*

## 硬件

*硬件交互相关的库、工具和教程。 (翻译出错了? 试试 [英文版](README_EN.md#hardware) 吧~)*

* [arduino-cli](https://github.com/arduino/arduino-cli) **star:3208** 官方Arduino CLI和库。可以独立运行，也可以合并到更大的Go项目中。   [![star > 2000][Awesome]](https://github.com/arduino/arduino-cli)   [![最近一周有更新][Green]](https://github.com/arduino/arduino-cli)   [![godoc][GoDoc]](https://godoc.org/github.com/arduino/arduino-cli)
* [go-rpio](https://github.com/stianeikeland/go-rpio) **star:1786** GPIO for Go，不需要cgo。   [![godoc][GoDoc]](https://godoc.org/github.com/stianeikeland/go-rpio)
* [ghw](https://github.com/jaypipes/ghw) **star:1097** Golang硬件发现/检查库。   [![godoc][GoDoc]](https://godoc.org/github.com/jaypipes/ghw)
* [emgo](https://github.com/ziutek/emgo) **star:952** 用于嵌入式系统(如STM32 MCU)编程的Go-like语言。
* [sysinfo](https://github.com/zcalusic/sysinfo) **star:309** 一个提供Linux操作系统/内核/硬件系统信息的纯Go库。   [![最近一周有更新][Green]](https://github.com/zcalusic/sysinfo)   [![godoc][GoDoc]](https://godoc.org/github.com/zcalusic/sysinfo)
* [goroslib](https://github.com/aler9/goroslib) **star:154** Go机器人操作系统(ROS)库。   [![godoc][GoDoc]](https://godoc.org/github.com/aler9/goroslib)
* [go-osc](https://github.com/hypebeast/go-osc) **star:139** 为Go打开声音控制(OSC)绑定。   [![godoc][GoDoc]](https://godoc.org/github.com/hypebeast/go-osc)
* [joystick](https://github.com/0xcafed00d/joystick) **star:29** 用于读取附加操纵杆状态的轮询API。   [![最近一年没有更新][Yellow]](https://github.com/0xcafed00d/joystick)   [![godoc][GoDoc]](https://godoc.org/github.com/0xcafed00d/joystick)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#hardware) 吧~)*

## 图片

*图像处理相关的库。 (翻译出错了? 试试 [英文版](README_EN.md#images) 吧~)*

* [gocv](https://github.com/hybridgroup/gocv) **star:4575** 使用OpenCV 3.3+实现的计算机视觉(ComputerVision)的Go语言包。   [![star > 2000][Awesome]](https://github.com/hybridgroup/gocv)   [![godoc][GoDoc]](https://godoc.org/github.com/hybridgroup/gocv)
* [imaginary](https://github.com/h2non/imaginary) **star:4151** 用于图像大小调整的快速、简单的HTTP微服务。   [![star > 2000][Awesome]](https://github.com/h2non/imaginary)   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/imaginary)
* [imaging](https://github.com/disintegration/imaging) **star:4072** 简单的Go图像处理包。   [![star > 2000][Awesome]](https://github.com/disintegration/imaging)   [![最近一年没有更新][Yellow]](https://github.com/disintegration/imaging)   [![godoc][GoDoc]](https://godoc.org/github.com/disintegration/imaging)
* [bild](https://github.com/anthonynsimon/bild) **star:3462** 纯Go语言实现的图像处理算法合集。   [![star > 2000][Awesome]](https://github.com/anthonynsimon/bild)   [![godoc][GoDoc]](https://godoc.org/github.com/anthonynsimon/bild)
* [gg](https://github.com/fogleman/gg) **star:3230** 纯Go语言实现的2D渲染。   [![star > 2000][Awesome]](https://github.com/fogleman/gg)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/gg)
* [ln](https://github.com/fogleman/ln) **star:3024** Go实现的3D线艺术（3D Line Art）渲染。   [![star > 2000][Awesome]](https://github.com/fogleman/ln)   [![最近一年没有更新][Yellow]](https://github.com/fogleman/ln)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/ln)
* [resize](https://github.com/nfnt/resize) **star:2775** Go实现的使用常用的插值法（interpolation methods）调整图像大小的库。   [![star > 2000][Awesome]](https://github.com/nfnt/resize)   [![最近一年没有更新][Yellow]](https://github.com/nfnt/resize)   [![godoc][GoDoc]](https://godoc.org/github.com/nfnt/resize)
* [pt](https://github.com/fogleman/pt) **star:1986** Go实现的路径跟踪（path tracing）引擎。   [![最近一年没有更新][Yellow]](https://github.com/fogleman/pt)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/pt)
* [svgo](https://github.com/ajstarks/svgo) **star:1795**  Go实现的SVG生成库。   [![godoc][GoDoc]](https://godoc.org/github.com/ajstarks/svgo)
* [bimg](https://github.com/h2non/bimg) **star:1769** 使用libvips实现的快速高效的图像处理包。   [![最近一周有更新][Green]](https://github.com/h2non/bimg)   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/bimg)
* [picfit](https://github.com/thoas/picfit) **star:1599** Go实现的图像调整服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/thoas/picfit)
* [smartcrop](https://github.com/muesli/smartcrop) **star:1572** 为任意图片寻找合适的位置进行图片裁剪。   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/smartcrop)
* [gift](https://github.com/disintegration/gift) **star:1492** 图像处理包。   [![最近一年没有更新][Yellow]](https://github.com/disintegration/gift)   [![godoc][GoDoc]](https://godoc.org/github.com/disintegration/gift)
* [imagick](https://github.com/gographics/imagick) **star:1386**  ImageMagick下MagickWand的C API的Go binding。   [![godoc][GoDoc]](https://godoc.org/github.com/gographics/imagick)
* [gowitness](https://github.com/sensepost/gowitness) **star:1337** 在命令行上使用go和headless chrome截屏网页。   [![godoc][GoDoc]](https://godoc.org/github.com/sensepost/gowitness)
* [go-opencv](https://github.com/lazywei/go-opencv) **star:1257** OpenCV库的Go bindings。   [![最近一年没有更新][Yellow]](https://github.com/lazywei/go-opencv)   [![godoc][GoDoc]](https://godoc.org/github.com/lazywei/go-opencv)
* [geopattern](https://github.com/pravj/geopattern) **star:1160** 由字符串创建漂亮图案的图片生成器。   [![最近一年没有更新][Yellow]](https://github.com/pravj/geopattern)   [![godoc][GoDoc]](https://godoc.org/github.com/pravj/geopattern)
* [stegify](https://github.com/DimitarPetrov/stegify) **star:976**  Go实现的LSB隐写（LSB steganography），能够隐藏任何文件到一个图像中。   [![最近一年没有更新][Yellow]](https://github.com/DimitarPetrov/stegify)   [![godoc][GoDoc]](https://godoc.org/github.com/DimitarPetrov/stegify)
* [canvas](https://github.com/tdewolff/canvas) **star:884** 矢量图形到PDF, SVG或光栅图像。   [![最近一周有更新][Green]](https://github.com/tdewolff/canvas)   [![godoc][GoDoc]](https://godoc.org/github.com/tdewolff/canvas)
* [image2ascii](https://github.com/qeesung/image2ascii) **star:622** 将图像转换为ASCII码。   [![godoc][GoDoc]](https://godoc.org/github.com/qeesung/image2ascii)
* [govips](https://github.com/davidbyttow/govips) **star:614** 闪电快速的图像处理和调整库的Go。   [![最近一周有更新][Green]](https://github.com/davidbyttow/govips)   [![godoc][GoDoc]](https://godoc.org/github.com/davidbyttow/govips)
* [draft](https://github.com/lucasepe/draft) **star:518** 使用简单的YAML语法为GraphViz生成高级微服务架构图。   [![godoc][GoDoc]](https://godoc.org/github.com/lucasepe/draft)
* [govatar](https://github.com/o1egl/govatar) **star:475** 生成有趣头像的库和CMD工具。   [![godoc][GoDoc]](https://godoc.org/github.com/o1egl/govatar)
* [goimagehash](https://github.com/corona10/goimagehash) **star:461**  图像哈希处理的Go语言包。   [![godoc][GoDoc]](https://godoc.org/github.com/corona10/goimagehash)
* [mort](https://github.com/aldor007/mort) **star:443** Go语言实现的图像存储和处理服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/aldor007/mort)
* [go-nude](https://github.com/koyachi/go-nude) **star:341** Go语言实现的裸照检测工具。   [![最近一年没有更新][Yellow]](https://github.com/koyachi/go-nude)   [![godoc][GoDoc]](https://godoc.org/github.com/koyachi/go-nude)
* [rez](https://github.com/bamiaux/rez) **star:202** 纯Go语言和SIMD实现的图像大小调整。   [![最近一年没有更新][Yellow]](https://github.com/bamiaux/rez)   [![godoc][GoDoc]](https://godoc.org/github.com/bamiaux/rez)
* [darkroom](https://github.com/gojek/darkroom) **star:180** An image proxy with changeable storage backends and image processing engines with focus on speed and resiliency.   [![godoc][GoDoc]](https://godoc.org/github.com/gojek/darkroom)
* [mergi](https://github.com/noelyahan/mergi) **star:159** 用于图像处理(合并、裁剪、调整大小、水印、动画)的工具和Go库。   [![最近一年没有更新][Yellow]](https://github.com/noelyahan/mergi)   [![godoc][GoDoc]](https://godoc.org/github.com/noelyahan/mergi)
* [gltf](https://github.com/qmuntal/gltf) **star:146** 一个高效、健壮的glTF 2.0文件读取、写入和验证器。   [![最近一周有更新][Green]](https://github.com/qmuntal/gltf)   [![godoc][GoDoc]](https://godoc.org/github.com/qmuntal/gltf)
* [img](https://github.com/hawx/img) **star:137** 图像处理工具的集合。   [![最近一年没有更新][Yellow]](https://github.com/hawx/img)   [![godoc][GoDoc]](https://godoc.org/github.com/hawx/img)
* [steganography](https://github.com/auyer/steganography) **star:124** 纯Go实现的LSB隐写（LSB steganography）的库。   [![godoc][GoDoc]](https://godoc.org/github.com/auyer/steganography)
* [go-cairo](https://github.com/ungerik/go-cairo) **star:116**  cairo图形库的Go binding。   [![最近一周有更新][Green]](https://github.com/ungerik/go-cairo)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go-cairo)
* [cameron](https://github.com/aofei/cameron) **star:80** 一个Go语言的头像生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/cameron)
* [go-gd](https://github.com/bolknote/go-gd) **star:52**  GD库的Go binding。   [![最近一年没有更新][Yellow]](https://github.com/bolknote/go-gd)   [![godoc][GoDoc]](https://godoc.org/github.com/bolknote/go-gd)
* [gridder](https://github.com/shomali11/gridder) **star:49** 一个基于网格的2D图形库。   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/gridder)
* [go-webp](https://github.com/kolesa-team/go-webp) **star:40** 为编码和解码webp图片的库，使用libwebp。   [![godoc][GoDoc]](https://godoc.org/github.com/kolesa-team/go-webp)
* [goimghdr](https://github.com/corona10/goimghdr) **star:37** Go语言实现的imghdr模块用于确定文件的图像类型。   [![最近一年没有更新][Yellow]](https://github.com/corona10/goimghdr)   [![godoc][GoDoc]](https://godoc.org/github.com/corona10/goimghdr)
* [webp-server](https://github.com/mehdipourfar/webp-server) **star:32** 能够存储、调整大小、转换和缓存图像的简单和最小的图像服务器。   [![最近一年没有更新][Yellow]](https://github.com/mehdipourfar/webp-server)   [![godoc][GoDoc]](https://godoc.org/github.com/mehdipourfar/webp-server)
* [tga](https://github.com/ftrvxmtrx/tga) **star:28** tga包是一个TARGA图像的解码、编码器。   [![最近一年没有更新][Yellow]](https://github.com/ftrvxmtrx/tga)   [![godoc][GoDoc]](https://godoc.org/github.com/ftrvxmtrx/tga)   [![归档项目][Archived]](https://github.com/ftrvxmtrx/tga)
* [go-webcolors](https://github.com/jyotiska/go-webcolors) **star:25** Python下webcolors库的Go语言调用。   [![最近一年没有更新][Yellow]](https://github.com/jyotiska/go-webcolors)   [![godoc][GoDoc]](https://godoc.org/github.com/jyotiska/go-webcolors)
* [mpo](https://github.com/donatj/mpo) **star:7** MPO三维照片的解码和转换工具。   [![最近一年没有更新][Yellow]](https://github.com/donatj/mpo)   [![godoc][GoDoc]](https://godoc.org/github.com/donatj/mpo)
* [scout](https://github.com/jonoton/scout) **star:1** Scout是一款独立的开源视频安全软件解决方案。   [![godoc][GoDoc]](https://godoc.org/github.com/jonoton/scout)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#images) 吧~)*

## 物联网

*物联网设备编程库。 (翻译出错了? 试试 [英文版](README_EN.md#iot-(internet-of-things)) 吧~)*

* [flogo](https://github.com/tibcosoftware/flogo) **star:1902** Flogo是一个面向物联网边缘应用和集成的开源框架。   [![最近一年没有更新][Yellow]](https://github.com/tibcosoftware/flogo)
* [mainflux](https://github.com/Mainflux/mainflux) **star:1665** 工业物联网消息和设备管理服务器。   [![最近一周有更新][Green]](https://github.com/Mainflux/mainflux)   [![godoc][GoDoc]](https://godoc.org/github.com/Mainflux/mainflux)
* [periph](https://periph.io/)  外围设备I/O与低级板(low-level board)设备接口。
* [gatt](https://github.com/paypal/gatt) **star:1005** Gatt是一个用于构建低能耗蓝牙外围设备的Go语言包。   [![最近一年没有更新][Yellow]](https://github.com/paypal/gatt)   [![godoc][GoDoc]](https://godoc.org/github.com/paypal/gatt)
* [gobot](https://github.com/hybridgroup/gobot/)  Gobot是一个用于机器人、物理计算和物联网的框架。
* [connectordb](https://github.com/connectordb/connectordb) **star:318** 自我量化和物联网的开源平台。   [![最近一周有更新][Green]](https://github.com/connectordb/connectordb)   [![godoc][GoDoc]](https://godoc.org/github.com/connectordb/connectordb)
* [devices](https://github.com/goiot/devices) **star:250** 一套用于物联网设备的库，实验性地用于x/exp/io。   [![最近一年没有更新][Yellow]](https://github.com/goiot/devices)   [![godoc][GoDoc]](https://godoc.org/github.com/goiot/devices)
* [sensorbee](https://github.com/sensorbee/sensorbee) **star:209** 轻量级物联网流处理引擎。   [![最近一年没有更新][Yellow]](https://github.com/sensorbee/sensorbee)   [![godoc][GoDoc]](https://godoc.org/github.com/sensorbee/sensorbee)
* [huego](https://github.com/amimof/huego) **star:195** 一个包含广泛的Philips Hue客户端的Go语言库。   [![最近一周有更新][Green]](https://github.com/amimof/huego)   [![godoc][GoDoc]](https://godoc.org/github.com/amimof/huego)
* [iot](https://github.com/vaelen/iot/)  IoT是一个实现谷歌物联网核心设备的简单框架。
* [eywa](https://github.com/xcodersun/eywa) **star:51** Eywa是一个用于跟踪连接的设备连接管理器。   [![最近一年没有更新][Yellow]](https://github.com/xcodersun/eywa)   [![godoc][GoDoc]](https://godoc.org/github.com/xcodersun/eywa)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#iot-(internet-of-things)) 吧~)*

## 作业调度器

*用于作业调度的库。 (翻译出错了? 试试 [英文版](README_EN.md#job-scheduler) 吧~)*

* [gocron](https://github.com/go-co-op/gocron) **star:1498** 熟练掌握Go工作调度。这是一个积极维护的分叉[jasonlvhit/gocron](https://github.com/jasonlvhit/gocron)。   [![godoc][GoDoc]](https://godoc.org/github.com/go-co-op/gocron)
* [JobRunner](https://github.com/bamzi/jobrunner) **star:899** 智能和功能丰富的cron作业调度程序（包含任务队列和实时监控）。   [![最近一年没有更新][Yellow]](https://github.com/bamzi/jobrunner)   [![godoc][GoDoc]](https://godoc.org/github.com/bamzi/jobrunner)
* [gron](https://github.com/roylee0704/gron) **star:881** 使用简单的Go API定义基于时间的任务。 之后Gron的调度程序将运行它们。   [![最近一年没有更新][Yellow]](https://github.com/roylee0704/gron)   [![godoc][GoDoc]](https://godoc.org/github.com/roylee0704/gron)
* [go-quartz](https://github.com/reugn/go-quartz) **star:574** 简单的，无依赖的Go调度库。   [![最近一周有更新][Green]](https://github.com/reugn/go-quartz)   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/go-quartz)
* [jobs](https://github.com/albrow/jobs) **star:485** 持久和灵活的后台作业库。   [![最近一年没有更新][Yellow]](https://github.com/albrow/jobs)   [![godoc][GoDoc]](https://godoc.org/github.com/albrow/jobs)
* [scheduler](https://github.com/carlescere/scheduler) **star:373** Cronjobs让调度变得很简单。   [![最近一年没有更新][Yellow]](https://github.com/carlescere/scheduler)   [![godoc][GoDoc]](https://godoc.org/github.com/carlescere/scheduler)
* [go-cron](https://github.com/rk/go-cron) **star:208** 一个Go实现的简单的定时任务库。可以在不同的时间间隔（每秒一次到在每年在特定的日期执行）执行闭包或函数。主要用于web应用和长时间运行的守护进程。   [![最近一年没有更新][Yellow]](https://github.com/rk/go-cron)   [![godoc][GoDoc]](https://godoc.org/github.com/rk/go-cron)
* [gronx](https://github.com/adhocore/gronx) **star:182** Cron表达式解析器、任务运行器和守护进程像任务列表一样使用crontab。   [![godoc][GoDoc]](https://godoc.org/github.com/adhocore/gronx)
* [clockwerk](https://github.com/onatm/clockwerk) **star:115** 使用简单、流畅的语法调度作业的Go语言库。   [![最近一年没有更新][Yellow]](https://github.com/onatm/clockwerk)   [![godoc][GoDoc]](https://godoc.org/github.com/onatm/clockwerk)
* [leprechaun](https://github.com/kilgaloon/leprechaun) **star:84** 支持webhook、crons和经典调度的作业调度程序。   [![godoc][GoDoc]](https://godoc.org/github.com/kilgaloon/leprechaun)
* [tasks](https://github.com/madflojo/tasks) **star:68** 一个易于使用的进程内调度器，用于Go中的重复任务。   [![godoc][GoDoc]](https://godoc.org/github.com/madflojo/tasks)
* [sched](https://github.com/romshark/sched) **star:21** 具有快进时间能力的作业调度程序。   [![godoc][GoDoc]](https://godoc.org/github.com/romshark/sched)
* [cronticker](https://github.com/krayzpipes/cronticker) **star:1** 支持cron调度的一个自动报价器实现。   [![最近一年没有更新][Yellow]](https://github.com/krayzpipes/cronticker)   [![godoc][GoDoc]](https://godoc.org/github.com/krayzpipes/cronticker)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#job-scheduler) 吧~)*

## JSON

*用于JSON处理的库。 (翻译出错了? 试试 [英文版](README_EN.md#json) 吧~)*

* [GJSON](https://github.com/tidwall/gjson) **star:9613** 使用一行代码获取JSON的值。   [![star > 2000][Awesome]](https://github.com/tidwall/gjson)   [![最近一周有更新][Green]](https://github.com/tidwall/gjson)   [![godoc][GoDoc]](https://godoc.org/github.com/tidwall/gjson)
* [gojson](https://github.com/ChimeraCoder/gojson) **star:2449** 从JSON自动生成Go的结构（struct）定义。   [![star > 2000][Awesome]](https://github.com/ChimeraCoder/gojson)   [![godoc][GoDoc]](https://godoc.org/github.com/ChimeraCoder/gojson)
* [fastjson](https://github.com/valyala/fastjson) **star:1416** 用于Go的快速JSON解析器和验证器。没有自定义结构，没有代码生成，没有反射。   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/fastjson)
* [OjG](https://github.com/ohler55/ojg) **star:449** 优化JSON for Go是一个高性能的解析器，具有多种额外的JSON工具，包括JSONPath。   [![godoc][GoDoc]](https://godoc.org/github.com/ohler55/ojg)
* [kazaam](https://github.com/Qntfy/kazaam) **star:216** 用于任意JSON文档转换的API。   [![godoc][GoDoc]](https://godoc.org/github.com/Qntfy/kazaam)
* [gojq](https://github.com/elgs/gojq) **star:178** Go语言实现的JSON请求。   [![最近一年没有更新][Yellow]](https://github.com/elgs/gojq)   [![godoc][GoDoc]](https://godoc.org/github.com/elgs/gojq)
* [jsondiff](https://github.com/wI2L/jsondiff) **star:140** Go的JSON diff库基于RFC6902 (JSON Patch)。   [![godoc][GoDoc]](https://godoc.org/github.com/wI2L/jsondiff)
* [jettison](https://github.com/wI2L/jettison) **star:114** Go的快速灵活的JSON编码器。   [![godoc][GoDoc]](https://godoc.org/github.com/wI2L/jettison)
* [JSON-to-Go](https://mholt.github.io/json-to-go/)  将JSON转换为Go的结构（struct）。
* [JSON-to-Proto](https://json-to-proto.github.io/)  转换JSON到Protobuf在线。
* [jsongo](https://github.com/ricardolonga/jsongo) **star:98** 使用Fluent API来更容易地创建Json对象。   [![godoc][GoDoc]](https://godoc.org/github.com/ricardolonga/jsongo)
* [gjo](https://github.com/skanehira/gjo) **star:97** 用于创建JSON对象的小工具。   [![godoc][GoDoc]](https://godoc.org/github.com/skanehira/gjo)
* [json2go](https://github.com/m-zajac/json2go) **star:94** 高级JSON去结构转换。提供一个包，该包可以解析多个JSON文档并创建结构体以适应所有这些文档。   [![godoc][GoDoc]](https://godoc.org/github.com/m-zajac/json2go)
* [ajson](https://github.com/spyzhov/ajson) **star:93** 为Go语言开发的包含JSONPath支持的抽象JSON。   [![godoc][GoDoc]](https://godoc.org/github.com/spyzhov/ajson)
* [JayDiff](https://github.com/yazgazan/jaydiff) **star:83** 用Go编写的JSON比对工具。   [![godoc][GoDoc]](https://godoc.org/github.com/yazgazan/jaydiff)
* [jsonf](https://github.com/miolini/jsonf) **star:62** 用于高亮展示和查询JSON的控制台工具。   [![最近一年没有更新][Yellow]](https://github.com/miolini/jsonf)   [![godoc][GoDoc]](https://godoc.org/github.com/miolini/jsonf)
* [ujson](https://github.com/olvrng/ujson) **star:52** 快速和最小的JSON解析器和转换器，工作在非结构化JSON。   [![godoc][GoDoc]](https://godoc.org/github.com/olvrng/ujson)
* [go-respond](https://github.com/nicklaw5/go-respond) **star:43** 用于处理常见的HTTP JSON响应的Go语言库。   [![godoc][GoDoc]](https://godoc.org/github.com/nicklaw5/go-respond)
* [mp](https://github.com/sanbornm/mp) **star:43** 简单的cli电子邮件解析器。它目前接受stdin并输出JSON。   [![最近一年没有更新][Yellow]](https://github.com/sanbornm/mp)   [![godoc][GoDoc]](https://godoc.org/github.com/sanbornm/mp)
* [jsoncolor](https://github.com/neilotoole/jsoncolor) **star:26** Drop-in替换' encoding/json '，输出彩色json。   [![godoc][GoDoc]](https://godoc.org/github.com/neilotoole/jsoncolor)
* [vjson](https://github.com/miladibra10/vjson) **star:23** 用流畅API声明JSON模式来验证JSON对象的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/miladibra10/vjson)
* [ask](https://github.com/simonnilsson/ask) **star:13** 容易访问映射和片中的嵌套值。与encoding/json和其他将任意数据“解编组”为Go数据类型的包一起工作。   [![godoc][GoDoc]](https://godoc.org/github.com/simonnilsson/ask)
* [go-jsonerror](https://github.com/ddymko/go-jsonerror) **star:10** Go-JsonError允许我们轻松创建符合JsonApi规范的json响应错误。   [![最近一年没有更新][Yellow]](https://github.com/ddymko/go-jsonerror)   [![godoc][GoDoc]](https://godoc.org/github.com/ddymko/go-jsonerror)
* [jsonapi-errors](https://github.com/AmuzaTkts/jsonapi-errors) **star:10** 基于JSON API错误引用的Go bindings。   [![最近一年没有更新][Yellow]](https://github.com/AmuzaTkts/jsonapi-errors)   [![godoc][GoDoc]](https://godoc.org/github.com/AmuzaTkts/jsonapi-errors)
* [dynjson](https://github.com/cocoonspace/dynjson) **star:9** 用于动态api的可定制的JSON格式。   [![godoc][GoDoc]](https://godoc.org/github.com/cocoonspace/dynjson)
* [jsonhal](https://github.com/RichardKnop/jsonhal) **star:9** 让自定义结构（struct）转化为JSON兼容的HAL（Hypertext Application Language）返回数据的简单Go包。   [![最近一年没有更新][Yellow]](https://github.com/RichardKnop/jsonhal)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/jsonhal)
* [mapslice-json](https://github.com/mickep76/mapslice-json) **star:8** 去MapSlice的有序封送/解封的JSON地图。   [![godoc][GoDoc]](https://godoc.org/github.com/mickep76/mapslice-json)
* [epoch](https://github.com/vtopc/epoch) **star:7** 包含用于封送/解封送Unix时间戳/纪元到内建时间的原语。时间类型为JSON。   [![godoc][GoDoc]](https://godoc.org/github.com/vtopc/epoch)
* [ej](https://github.com/lucassscaravelli/ej) **star:6** 简洁地编写和读取来自不同来源的JSON。   [![最近一年没有更新][Yellow]](https://github.com/lucassscaravelli/ej)   [![godoc][GoDoc]](https://godoc.org/github.com/lucassscaravelli/ej)
* [jsonic](https://github.com/sinhashubham95/jsonic) **star:5** 处理和查询JSON的实用程序，无需以类型安全的方式定义结构。   [![最近一年没有更新][Yellow]](https://github.com/sinhashubham95/jsonic)   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/jsonic)
* [jzon](https://github.com/zerosnake0/jzon) **star:5** 具有标准兼容API/行为的JSON库。   [![godoc][GoDoc]](https://godoc.org/github.com/zerosnake0/jzon)
* [omg.jsonparser](https://github.com/dedalqq/omg.jsonparser) **star:1** 简单的JSON解析器，通过golang结构字段标签进行条件验证。   [![godoc][GoDoc]](https://godoc.org/github.com/dedalqq/omg.jsonparser)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#json) 吧~)*

## 日志记录

*用于生成和处理日志文件的库。 (翻译出错了? 试试 [英文版](README_EN.md#logging) 吧~)*

* [logrus](https://github.com/Sirupsen/logrus) **star:19671** Go的结构化日志操作 。   [![star > 2000][Awesome]](https://github.com/Sirupsen/logrus)   [![最近一周有更新][Green]](https://github.com/Sirupsen/logrus)   [![godoc][GoDoc]](https://godoc.org/github.com/Sirupsen/logrus)
* [zap](https://github.com/uber-go/zap) **star:14660** 快速、结构化、多等级的日志记录。   [![star > 2000][Awesome]](https://github.com/uber-go/zap)   [![最近一周有更新][Green]](https://github.com/uber-go/zap)   [![godoc][GoDoc]](https://godoc.org/github.com/uber-go/zap)
* [zerolog](https://github.com/rs/zerolog) **star:5767** Zero-allocation JSON日志记录。   [![star > 2000][Awesome]](https://github.com/rs/zerolog)   [![最近一周有更新][Green]](https://github.com/rs/zerolog)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/zerolog)
* [spew](https://github.com/davecgh/go-spew) **star:4812** 为Go数据结构实现一个漂亮的printer用于帮助调试。   [![star > 2000][Awesome]](https://github.com/davecgh/go-spew)   [![godoc][GoDoc]](https://godoc.org/github.com/davecgh/go-spew)
* [glog](https://github.com/golang/glog) **star:3088** 为Go提供了多等级日志记录。   [![star > 2000][Awesome]](https://github.com/golang/glog)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/glog)
* [lumberjack](https://github.com/natefinch/lumberjack) **star:3032** 简单的滚动日志，io.WriteCloser的实现。   [![star > 2000][Awesome]](https://github.com/natefinch/lumberjack)   [![godoc][GoDoc]](https://godoc.org/github.com/natefinch/lumberjack)
* [tail](https://github.com/hpcloud/tail) **star:2251** 努力模拟实现BSD的tail的特性的Go包。   [![star > 2000][Awesome]](https://github.com/hpcloud/tail)   [![最近一周有更新][Green]](https://github.com/hpcloud/tail)   [![godoc][GoDoc]](https://godoc.org/github.com/hpcloud/tail)
* [seelog](https://github.com/cihub/seelog) **star:1582** 具有灵活调度、过滤和格式化的日志功能。   [![最近一年没有更新][Yellow]](https://github.com/cihub/seelog)   [![godoc][GoDoc]](https://godoc.org/github.com/cihub/seelog)
* [log](https://github.com/apex/log) **star:1195** Go的结构化日志包。   [![godoc][GoDoc]](https://godoc.org/github.com/apex/log)
* [log15](https://github.com/inconshreveable/log15) **star:1036** 简单、强大的日志操作。   [![godoc][GoDoc]](https://godoc.org/github.com/inconshreveable/log15)
* [phuslu/log](https://github.com/phuslu/log) **star:412** 简化了结构化日志记录。   [![godoc][GoDoc]](https://godoc.org/github.com/phuslu/log)
* [onelog](https://github.com/francoispqt/onelog) **star:401** Onelog是一个非常简单但非常高效的JSON日志记录器。它是所有场景中最快的JSON记录器。而且，它是配置最低的记录器之一。   [![最近一年没有更新][Yellow]](https://github.com/francoispqt/onelog)   [![godoc][GoDoc]](https://godoc.org/github.com/francoispqt/onelog)
* [logxi](https://github.com/mgutz/logxi) **star:349** 12-factor app的日志程序，快速且让人高兴地使用。   [![最近一年没有更新][Yellow]](https://github.com/mgutz/logxi)   [![godoc][GoDoc]](https://godoc.org/github.com/mgutz/logxi)
* [logutils](https://github.com/hashicorp/logutils) **star:305** Go的用于更好地进行日志操作的实用程序，继承了标准日志库。   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/logutils)
* [log](https://github.com/go-playground/log) **star:276** Go的简单、可配置和可伸缩的结构化日志。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/log)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/log)
* [go-logger](https://github.com/apsdehal/go-logger) **star:271** 简单的日志程序的 Go 程序，与级别处理程序。   [![最近一年没有更新][Yellow]](https://github.com/apsdehal/go-logger)   [![godoc][GoDoc]](https://godoc.org/github.com/apsdehal/go-logger)
* [httpretty](https://github.com/henvic/httpretty) **star:247** 在终端上美化您的常规HTTP请求以便调试(类似于HTTP . dumprequest)。   [![最近一年没有更新][Yellow]](https://github.com/henvic/httpretty)   [![godoc][GoDoc]](https://godoc.org/github.com/henvic/httpretty)
* [sqldb-logger](https://github.com/simukti/sqldb-logger) **star:203** 一个日志程序，用于不修改现有的* SQL . db stdlib用法的Go SQL数据库驱动程序。   [![godoc][GoDoc]](https://godoc.org/github.com/simukti/sqldb-logger)
* [rollingwriter](https://github.com/arthurkiller/rollingWriter) **star:184** RollingWriter是一个自动循环的io.Writer的实现,带有多种策略以提供日志文件循环(rotation)。   [![godoc][GoDoc]](https://godoc.org/github.com/arthurkiller/rollingWriter)
* [logger](https://github.com/azer/logger) **star:149** Go的精简日志库。   [![godoc][GoDoc]](https://godoc.org/github.com/azer/logger)
* [logur](https://github.com/logur/logur) **star:148** 一个固执的logger接口，集合了著名库的适配器和集成的日志最佳实践([logrus](https://github.com/sirupsen/logrus)， [go-kit log](https://github.com/go-kit/kit/tree/master/log)， [zap](https://github.com/ugo/zap)， [zerolog](https://github.com/rs/zerolog)，等等)。   [![最近一年没有更新][Yellow]](https://github.com/logur/logur)   [![godoc][GoDoc]](https://godoc.org/github.com/logur/logur)
* [glg](https://github.com/kpango/glg) **star:136** glg是一个简单而快速的Go日志库。   [![godoc][GoDoc]](https://godoc.org/github.com/kpango/glg)
* [xlog](https://github.com/rs/xlog) **star:135** 针对'net/context`实现的结构化的记录器，用于HTTP处理程序。   [![godoc][GoDoc]](https://godoc.org/github.com/rs/xlog)
* [yell](https://github.com/jfcg/yell)  这是另一个极简的日志库。
* [ozzo-log](https://github.com/go-ozzo/ozzo-log) **star:118** 支持日志多等级、分类和过滤的高性能日志记录。可以发送过滤后的日志消息到各种目标(如控制台，网络，邮件)。   [![最近一年没有更新][Yellow]](https://github.com/go-ozzo/ozzo-log)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-log)   [![包含中文文档][CN]](https://github.com/go-ozzo/ozzo-log)
* [log-voyage](https://github.com/firstrow/logvoyage) **star:89** 用Go编写的功能齐全的日志写入saas。   [![最近一年没有更新][Yellow]](https://github.com/firstrow/logvoyage)   [![godoc][GoDoc]](https://godoc.org/github.com/firstrow/logvoyage)
* [go-cronowriter](https://github.com/utahta/go-cronowriter) **star:46** 基于当前日期和时间的自动日志文件写入工具，类似cronolog。   [![godoc][GoDoc]](https://godoc.org/github.com/utahta/go-cronowriter)
* [stdlog](https://github.com/alexcesaro/log) **star:45** Stdlog是一个面向对象的库，提供了多等级日志记录。它对cron任务非常有用。   [![最近一年没有更新][Yellow]](https://github.com/alexcesaro/log)   [![godoc][GoDoc]](https://godoc.org/github.com/alexcesaro/log)
* [gologger](https://github.com/sadlil/gologger) **star:39** 为Go提供方便简单的日志操作; 在彩色控制台，简单控制台，文件或Elasticsearch上。   [![最近一年没有更新][Yellow]](https://github.com/sadlil/gologger)   [![godoc][GoDoc]](https://godoc.org/github.com/sadlil/gologger)   [![归档项目][Archived]](https://github.com/sadlil/gologger)
* [go-log](https://github.com/ian-kent/go-log) **star:38** Log4j的Go语言。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/go-log)
* [logex](https://github.com/chzyer/logex) **star:38** 由标准日志库封装的Go日志库，支持跟踪和多等级。   [![godoc][GoDoc]](https://godoc.org/github.com/chzyer/logex)
* [noodlog](https://github.com/gyozatech/noodlog) **star:35** 参数化JSON日志记录库，允许您混淆敏感数据和封送任何类型的内容。不再打印指针代替值，也不再为JSON字符串输出转义字符。   [![godoc][GoDoc]](https://godoc.org/github.com/gyozatech/noodlog)
* [go-log](https://github.com/siddontang/go-log) **star:29** 支持多等级和多处理程序的日志库。   [![最近一年没有更新][Yellow]](https://github.com/siddontang/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/siddontang/go-log)
* [journald](https://github.com/ssgreg/journald) **star:29**  Go实现systemd Journal的原生API用于日志记录。   [![godoc][GoDoc]](https://godoc.org/github.com/ssgreg/journald)
* [logrusly](https://github.com/sebest/logrusly) **star:27** [logrus](https://github.com/sirupsen/logrus)的插件，将错误信息发送到[Loggly](https://www.loggly.com/)。   [![godoc][GoDoc]](https://godoc.org/github.com/sebest/logrusly)
* [distillog](https://github.com/amoghe/distillog) **star:25** distilled日志记录(可以将其视为stdlib +日志)。   [![最近一年没有更新][Yellow]](https://github.com/amoghe/distillog)   [![godoc][GoDoc]](https://godoc.org/github.com/amoghe/distillog)
* [log](https://github.com/teris-io/log) **star:24** Go的结构化日志接口，清晰地将日志facade与其实现(implementation)分离开来。   [![最近一年没有更新][Yellow]](https://github.com/teris-io/log)   [![godoc][GoDoc]](https://godoc.org/github.com/teris-io/log)
* [mlog](https://github.com/jbrodriguez/mlog) **star:24** 简单的go日志模块，有5个级别，可选循环(rotation)日志文件记录功能和stdout/stderr输出。   [![最近一年没有更新][Yellow]](https://github.com/jbrodriguez/mlog)   [![godoc][GoDoc]](https://godoc.org/github.com/jbrodriguez/mlog)
* [gomol](https://github.com/aphistic/gomol) **star:18** 为Go实现可多方式输出、结构化日志, 并可扩展日志输出方式。   [![最近一年没有更新][Yellow]](https://github.com/aphistic/gomol)   [![godoc][GoDoc]](https://godoc.org/github.com/aphistic/gomol)
* [gone/log](https://github.com/One-com/gone/tree/master/log)  快速、可扩展、功能齐全、std-lib源兼容的日志库。
* [zkits-logger](https://github.com/edoger/zkits-logger) **star:15** 一个强大的零依赖JSON记录器。   [![godoc][GoDoc]](https://godoc.org/github.com/edoger/zkits-logger)
* [glo](https://github.com/lajosbencz/glo) **star:14** 参照PHP的Monolog实现的具有相同日志等级的Go日志库。   [![最近一年没有更新][Yellow]](https://github.com/lajosbencz/glo)   [![godoc][GoDoc]](https://godoc.org/github.com/lajosbencz/glo)
* [logrusiowriter](https://github.com/cabify/logrusiowriter) **star:13** io。作者的实现使用[logrus](https://github.com/sirupsen/logrus) logger。   [![最近一年没有更新][Yellow]](https://github.com/cabify/logrusiowriter)   [![godoc][GoDoc]](https://godoc.org/github.com/cabify/logrusiowriter)
* [logmatic](https://github.com/borderstech/logmatic) **star:12** Go的彩色日志记录器，带有可配置的日志级别。   [![最近一年没有更新][Yellow]](https://github.com/borderstech/logmatic)   [![godoc][GoDoc]](https://godoc.org/github.com/borderstech/logmatic)
* [go-log](https://github.com/subchen/go-log) **star:11** Go实现的简单且可配置的日志工具，并带有多等级、日志格式化和日志写入工具。   [![最近一年没有更新][Yellow]](https://github.com/subchen/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/subchen/go-log)
* [log](https://github.com/aerogo/log) **star:9** 一个O(1)日志系统，允许您将一个日志连接到多个日志写入(例如stdout、文件和TCP连接)。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/log)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/log)
* [logdump](https://github.com/ewwwwwqm/logdump) **star:9** 用于多等级级日志记录的包。   [![最近一年没有更新][Yellow]](https://github.com/ewwwwwqm/logdump)   [![godoc][GoDoc]](https://godoc.org/github.com/ewwwwwqm/logdump)
* [logo](https://github.com/mbndr/logo) **star:9** Go的日志工具，可配置的日志写入器。   [![最近一年没有更新][Yellow]](https://github.com/mbndr/logo)   [![godoc][GoDoc]](https://godoc.org/github.com/mbndr/logo)
* [go-log](https://github.com/pieterclaerhout/go-log) **star:8** 具有strack跟踪、对象转储和可选时间戳的日志记录库。   [![最近一年没有更新][Yellow]](https://github.com/pieterclaerhout/go-log)   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-log)
* [kemba](https://github.com/clok/kemba) **star:7** 一个小的调试日志工具，灵感来自[debug](https://github.com/visionmedia/debug)，非常适合CLI工具和应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/clok/kemba)
* [xlog](https://github.com/xfxdev/xlog) **star:6** 插件架构和灵活的日志系统，带有多级别、多日志目标和自定义日志格式。   [![最近一年没有更新][Yellow]](https://github.com/xfxdev/xlog)   [![godoc][GoDoc]](https://godoc.org/github.com/xfxdev/xlog)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#logging) 吧~)*

## 机器学习

*机器学习库。 (翻译出错了? 试试 [英文版](README_EN.md#machine-learning) 吧~)*

* [GoLearn](https://github.com/sjwhitworth/golearn) **star:8171** 通用机器学习库。   [![star > 2000][Awesome]](https://github.com/sjwhitworth/golearn)   [![godoc][GoDoc]](https://godoc.org/github.com/sjwhitworth/golearn)   [![包含中文文档][CN]](https://github.com/sjwhitworth/golearn)
* [gorse](https://github.com/zhenghaoz/gorse) **star:5111** 基于协同过滤的离线推荐系统后端。   [![star > 2000][Awesome]](https://github.com/zhenghaoz/gorse)   [![最近一周有更新][Green]](https://github.com/zhenghaoz/gorse)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenghaoz/gorse)   [![包含中文文档][CN]](https://github.com/zhenghaoz/gorse)
* [gorgonia](https://github.com/gorgonia/gorgonia) **star:4346** 基于图形（graph-based）的计算库，如Theano：它为构建各种机器学习和神经网络算法提供了基本框架。   [![star > 2000][Awesome]](https://github.com/gorgonia/gorgonia)   [![最近一周有更新][Green]](https://github.com/gorgonia/gorgonia)   [![godoc][GoDoc]](https://godoc.org/github.com/gorgonia/gorgonia)
* [m2cgen](https://github.com/BayesWitnesses/m2cgen) **star:1991** 这是一个CLI工具，可以将经过训练的经典ML模型转换成零依赖的本地Go代码，使用Python编写，并支持Go语言。   [![最近一周有更新][Green]](https://github.com/BayesWitnesses/m2cgen)
* [tfgo](https://github.com/galeone/tfgo) **star:1868** 易于使用的Tensorflow bindings:简化了官方Tensorflow Go bindings的使用。在Go中定义计算图形，在Python中加载和执行训练的模型。   [![godoc][GoDoc]](https://godoc.org/github.com/galeone/tfgo)
* [gosseract](https://github.com/otiai10/gosseract) **star:1636** 使用c++的Tesseract库实现的OCR。   [![godoc][GoDoc]](https://godoc.org/github.com/otiai10/gosseract)
* [goml](https://github.com/cdipaolo/goml) **star:1298** 在线机器学习。   [![godoc][GoDoc]](https://godoc.org/github.com/cdipaolo/goml)
* [eaopt](https://github.com/MaxHalford/eaopt) **star:768** 一个进化优化（evolutionary optimization）库。   [![godoc][GoDoc]](https://godoc.org/github.com/MaxHalford/eaopt)
* [bayesian](https://github.com/jbrukh/bayesian) **star:722** Go的朴素贝叶斯分类。   [![最近一年没有更新][Yellow]](https://github.com/jbrukh/bayesian)   [![godoc][GoDoc]](https://godoc.org/github.com/jbrukh/bayesian)
* [CloudForest](https://github.com/ryanbressler/CloudForest) **star:701** 快速、灵活、多线程集成的决策树，用于机器学习。   [![最近一年没有更新][Yellow]](https://github.com/ryanbressler/CloudForest)   [![godoc][GoDoc]](https://godoc.org/github.com/ryanbressler/CloudForest)
* [gobrain](https://github.com/goml/gobrain) **star:504** 用 Go 编写的神经网络库。   [![最近一年没有更新][Yellow]](https://github.com/goml/gobrain)   [![godoc][GoDoc]](https://godoc.org/github.com/goml/gobrain)
* [ocrserver](https://github.com/otiai10/ocrserver) **star:452** 一个简单的OCR API服务器，非常容易地使用Docker和Heroku部署。   [![godoc][GoDoc]](https://godoc.org/github.com/otiai10/ocrserver)
* [onnx-go](https://github.com/owulveryck/onnx-go) **star:367** Go Interface， 用于开放式神经网络交换(Open Neural Network Exchange)。   [![godoc][GoDoc]](https://godoc.org/github.com/owulveryck/onnx-go)
* [go-deep](https://github.com/patrikeh/go-deep) **star:339** 一个功能丰富的神经网络库 。   [![godoc][GoDoc]](https://godoc.org/github.com/patrikeh/go-deep)
* [regommend](https://github.com/muesli/regommend) **star:298** 推荐和协同过滤引擎。   [![最近一年没有更新][Yellow]](https://github.com/muesli/regommend)   [![godoc][GoDoc]](https://godoc.org/github.com/muesli/regommend)
* [Goptuna](https://github.com/c-bata/goptuna) **star:196** Bayesian optimization framework for black-box functions written in Go. Everything will be optimized.   [![godoc][GoDoc]](https://godoc.org/github.com/c-bata/goptuna)
* [go-galib](https://github.com/thoj/go-galib) **star:187** 用Go编写的遗传算法库。   [![最近一年没有更新][Yellow]](https://github.com/thoj/go-galib)   [![godoc][GoDoc]](https://godoc.org/github.com/thoj/go-galib)
* [goRecommend](https://github.com/timkaye11/goRecommend) **star:181** 用Go编写的推荐算法库。   [![最近一年没有更新][Yellow]](https://github.com/timkaye11/goRecommend)   [![godoc][GoDoc]](https://godoc.org/github.com/timkaye11/goRecommend)
* [goga](https://github.com/tomcraven/goga) **star:147** Go的遗传算法库。   [![godoc][GoDoc]](https://godoc.org/github.com/tomcraven/goga)
* [shield](https://github.com/eaigner/shield) **star:147** 贝叶斯文本分类器，具有灵活的tokenizers和存储后端。   [![最近一年没有更新][Yellow]](https://github.com/eaigner/shield)   [![godoc][GoDoc]](https://godoc.org/github.com/eaigner/shield)
* [go-fann](https://github.com/white-pony/go-fann) **star:105** 快速人工神经网络(FANN)库的Go bindings。   [![最近一年没有更新][Yellow]](https://github.com/white-pony/go-fann)   [![godoc][GoDoc]](https://godoc.org/github.com/white-pony/go-fann)
* [goscore](https://github.com/asafschers/goscore) **star:72**  为预言模型标记语言（PMML）实现的评分API。   [![最近一年没有更新][Yellow]](https://github.com/asafschers/goscore)   [![godoc][GoDoc]](https://godoc.org/github.com/asafschers/goscore)
* [gonet](https://github.com/dathoangnd/gonet) **star:70** 基于go的神经网络。   [![最近一年没有更新][Yellow]](https://github.com/dathoangnd/gonet)   [![godoc][GoDoc]](https://godoc.org/github.com/dathoangnd/gonet)
* [libsvm](https://github.com/datastream/libsvm) **star:69** 基于LIBSVM 3.14实现。   [![最近一年没有更新][Yellow]](https://github.com/datastream/libsvm)   [![godoc][GoDoc]](https://godoc.org/github.com/datastream/libsvm)
* [go-featureprocessing](https://github.com/nikolaydubina/go-featureprocessing) **star:68** 快速和方便的特征处理，低延迟机器学习在Go。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/go-featureprocessing)
* [neural-go](https://github.com/schuyler/neural-go) **star:61** 多层感知器网络在Go中的实现，使用反向传播算法进行训练。   [![最近一年没有更新][Yellow]](https://github.com/schuyler/neural-go)   [![godoc][GoDoc]](https://godoc.org/github.com/schuyler/neural-go)
* [go-pr](https://github.com/daviddengcn/go-pr) **star:60** Go编写的模式识别包。   [![最近一年没有更新][Yellow]](https://github.com/daviddengcn/go-pr)   [![godoc][GoDoc]](https://godoc.org/github.com/daviddengcn/go-pr)
* [neat](https://github.com/jinyeom/neat) **star:60** 即插即用的并行Go框架，用于增强拓扑的神经进化(NeuroEvolution of Augmenting Topologies)。   [![最近一年没有更新][Yellow]](https://github.com/jinyeom/neat)   [![godoc][GoDoc]](https://godoc.org/github.com/jinyeom/neat)   [![归档项目][Archived]](https://github.com/jinyeom/neat)
* [fonet](https://github.com/Fontinalis/fonet) **star:52** 一个用Go编写的深度神经网络库。   [![godoc][GoDoc]](https://godoc.org/github.com/Fontinalis/fonet)
* [golinear](https://github.com/danieldk/golinear) **star:43**  Go实现的liblinear bindings。   [![最近一年没有更新][Yellow]](https://github.com/danieldk/golinear)   [![godoc][GoDoc]](https://godoc.org/github.com/danieldk/golinear)
* [Varis](https://github.com/Xamber/Varis) **star:41** Go实现的神经网络。   [![最近一年没有更新][Yellow]](https://github.com/Xamber/Varis)   [![godoc][GoDoc]](https://godoc.org/github.com/Xamber/Varis)
* [godist](https://github.com/e-dard/godist) **star:31** 各种概率分布，以及相关的method。   [![最近一年没有更新][Yellow]](https://github.com/e-dard/godist)   [![godoc][GoDoc]](https://godoc.org/github.com/e-dard/godist)
* [go-cluster](https://github.com/e-XpertSolutions/go-cluster) **star:29** Go实现的k-modes和k-prototypes聚类算法。   [![最近一年没有更新][Yellow]](https://github.com/e-XpertSolutions/go-cluster)   [![godoc][GoDoc]](https://godoc.org/github.com/e-XpertSolutions/go-cluster)
* [evoli](https://github.com/khezen/evoli) **star:21** 遗传算法（Genetic Algorithm）和粒子群优化（Particle Swarm Optimization）库。   [![godoc][GoDoc]](https://godoc.org/github.com/khezen/evoli)
* [GoMind](https://github.com/surenderthakran/gomind) **star:20** 一个简单的神经网络库。   [![最近一年没有更新][Yellow]](https://github.com/surenderthakran/gomind)   [![godoc][GoDoc]](https://godoc.org/github.com/surenderthakran/gomind)
* [randomforest](https://github.com/malaschitz/randomForest) **star:18** 容易使用随机森林库去。   [![godoc][GoDoc]](https://godoc.org/github.com/malaschitz/randomForest)
* [ddt](https://github.com/sgrodriguez/ddt) **star:16** 动态决策树，创建定义可定制规则的树。   [![godoc][GoDoc]](https://godoc.org/github.com/sgrodriguez/ddt)
* [probab](https://github.com/ThePaw/probab) **star:16** 概率分布函数。贝叶斯推理。使用Go写的。   [![最近一年没有更新][Yellow]](https://github.com/ThePaw/probab)   [![godoc][GoDoc]](https://godoc.org/github.com/ThePaw/probab)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#machine-learning) 吧~)*

## 消息

*实现消息传递系统的库。 (翻译出错了? 试试 [英文版](README_EN.md#messaging) 吧~)*

* [sarama](https://github.com/Shopify/sarama) **star:8054**  Apache Kafka的Go库。   [![star > 2000][Awesome]](https://github.com/Shopify/sarama)   [![最近一周有更新][Green]](https://github.com/Shopify/sarama)   [![godoc][GoDoc]](https://godoc.org/github.com/Shopify/sarama)
* [gorush](https://github.com/appleboy/gorush) **star:6002** 使用[APNs2](https://github.com/sideshow/apns2)和谷歌[GCM](https://github.com/google/go-gcm)推送通知服务器。   [![star > 2000][Awesome]](https://github.com/appleboy/gorush)   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/gorush)
* [machinery](https://github.com/RichardKnop/machinery) **star:5908** 基于分布式消息传递的异步任务/作业队列。   [![star > 2000][Awesome]](https://github.com/RichardKnop/machinery)   [![godoc][GoDoc]](https://godoc.org/github.com/RichardKnop/machinery)
* [Centrifugo](https://github.com/centrifugal/centrifugo) **star:5734** 实时消息(Websockets或SockJS)服务器。   [![star > 2000][Awesome]](https://github.com/centrifugal/centrifugo)   [![最近一周有更新][Green]](https://github.com/centrifugal/centrifugo)   [![godoc][GoDoc]](https://godoc.org/github.com/centrifugal/centrifugo)
* [go-socket.io](https://github.com/googollee/go-socket.io) **star:4447** go的socket.io库，一个实时应用程序框架。   [![star > 2000][Awesome]](https://github.com/googollee/go-socket.io)   [![godoc][GoDoc]](https://godoc.org/github.com/googollee/go-socket.io)
* [Benthos](https://github.com/Jeffail/benthos) **star:3888** 一系列协议之间的消息流桥接。   [![star > 2000][Awesome]](https://github.com/Jeffail/benthos)   [![最近一周有更新][Green]](https://github.com/Jeffail/benthos)   [![godoc][GoDoc]](https://godoc.org/github.com/Jeffail/benthos)
* [NATS Go Client](https://github.com/nats-io/nats) **star:3727** 轻量级和高性能的发布-订阅(publish-subscribe)和分布式队列消息传递系统——这是一个Go库。   [![star > 2000][Awesome]](https://github.com/nats-io/nats)   [![最近一周有更新][Green]](https://github.com/nats-io/nats)   [![godoc][GoDoc]](https://godoc.org/github.com/nats-io/nats)
* [Confluent Kafka Golang Client](https://github.com/confluentinc/confluent-kafka-go) **star:3095** confluent-kafka-go是Confluent为Apache Kafka和Confluent平台开发的Golang客户端。   [![star > 2000][Awesome]](https://github.com/confluentinc/confluent-kafka-go)   [![最近一周有更新][Green]](https://github.com/confluentinc/confluent-kafka-go)   [![godoc][GoDoc]](https://godoc.org/github.com/confluentinc/confluent-kafka-go)
* [Mercure](https://github.com/dunglas/mercure) **star:2638** 使用Mercure协议分派服务器发送(server-sent)更新的服务器和库(构建在服务器发送事件之上)。   [![star > 2000][Awesome]](https://github.com/dunglas/mercure)   [![godoc][GoDoc]](https://godoc.org/github.com/dunglas/mercure)
* [APNs2](https://github.com/sideshow/apns2) **star:2579** HTTP / 2苹果消息推送provider——发送推送消息到iOS, tvOS, Safari和OSX应用。   [![star > 2000][Awesome]](https://github.com/sideshow/apns2)   [![godoc][GoDoc]](https://godoc.org/github.com/sideshow/apns2)
* [Asynq](https://github.com/hibiken/asynq) **star:2482** 一个简单、可靠、高效的基于Redis的分布式任务队列。   [![star > 2000][Awesome]](https://github.com/hibiken/asynq)   [![最近一周有更新][Green]](https://github.com/hibiken/asynq)   [![godoc][GoDoc]](https://godoc.org/github.com/hibiken/asynq)
* [melody](https://github.com/olahol/melody) **star:2334** 处理websocket session的极简框架，包括广播和自动ping/pong处理。   [![star > 2000][Awesome]](https://github.com/olahol/melody)   [![godoc][GoDoc]](https://godoc.org/github.com/olahol/melody)
* [go-nsq](https://github.com/nsqio/go-nsq) **star:2069** NSQ的官方Go包。   [![star > 2000][Awesome]](https://github.com/nsqio/go-nsq)   [![godoc][GoDoc]](https://godoc.org/github.com/nsqio/go-nsq)
* [gopush-cluster](https://github.com/Terry-Mao/gopush-cluster) **star:2020** gopush-cluster是一个gopush服务器集群。   [![star > 2000][Awesome]](https://github.com/Terry-Mao/gopush-cluster)   [![最近一年没有更新][Yellow]](https://github.com/Terry-Mao/gopush-cluster)   [![godoc][GoDoc]](https://godoc.org/github.com/Terry-Mao/gopush-cluster)   [![包含中文文档][CN]](https://github.com/Terry-Mao/gopush-cluster)
* [Beaver](https://github.com/Clivern/Beaver) **star:1301** 一个实时消息服务器，可用于在web和手机app端构建一个可伸缩的应用内通知，多人游戏，聊天应用。   [![godoc][GoDoc]](https://godoc.org/github.com/Clivern/Beaver)
* [Uniqush-Push](https://github.com/uniqush/uniqush-push) **star:1295** Redis支持的统一推送服务, 用于服务端向移动设备的消息通知。   [![最近一年没有更新][Yellow]](https://github.com/uniqush/uniqush-push)   [![godoc][GoDoc]](https://godoc.org/github.com/uniqush/uniqush-push)
* [EventBus](https://github.com/asaskevich/EventBus) **star:1076** 具有异步兼容性的轻量级事件总线。   [![godoc][GoDoc]](https://godoc.org/github.com/asaskevich/EventBus)
* [zmq4](https://github.com/pebbe/zmq4) **star:953** ZeroMQ的Go interface第4版。也可用于[第3版](https://github.com/pebbe/zmq3)和[第2版](https://github.com/pebbe/zmq2)。   [![godoc][GoDoc]](https://godoc.org/github.com/pebbe/zmq4)
* [Gollum](https://github.com/trivago/gollum) **star:911** 一个n:m多路复用器(n:m multiplexer)，收集不同来源的消息并将其广播到一组目的地。   [![godoc][GoDoc]](https://godoc.org/github.com/trivago/gollum)
* [Chanify](https://github.com/chanify/chanify) **star:716** 推送通知服务器向你的iOS设备发送消息。   [![godoc][GoDoc]](https://godoc.org/github.com/chanify/chanify)   [![包含中文文档][CN]](https://github.com/chanify/chanify)
* [dbus](https://github.com/godbus/dbus) **star:663** D-Bus的Go bindings。   [![最近一周有更新][Green]](https://github.com/godbus/dbus)   [![godoc][GoDoc]](https://godoc.org/github.com/godbus/dbus)
* [golongpoll](https://github.com/jcuga/golongpoll) **star:588** HTTP longpoll服务器库，使web发布-订阅变得简单。   [![godoc][GoDoc]](https://godoc.org/github.com/jcuga/golongpoll)
* [mangos](https://github.com/nanomsg/mangos) **star:475** 具有传输互操作性的Nanomsg(“可伸缩性协议”)的纯go实现。   [![godoc][GoDoc]](https://godoc.org/github.com/nanomsg/mangos)
* [emitter](https://github.com/olebedev/emitter) **star:415** 使用Go的方式发出事件, 带有通配符、谓词、取消可能性和许多其他优点。   [![最近一年没有更新][Yellow]](https://github.com/olebedev/emitter)   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/emitter)
* [Glue](https://github.com/desertbit/glue) **star:393** 健壮的Go和Javascript Socket库(替代Socket.io)。   [![最近一年没有更新][Yellow]](https://github.com/desertbit/glue)   [![godoc][GoDoc]](https://godoc.org/github.com/desertbit/glue)
* [pubsub](https://github.com/tuxychandru/pubsub) **star:364** 简单的pubsub的go包。   [![最近一年没有更新][Yellow]](https://github.com/tuxychandru/pubsub)   [![godoc][GoDoc]](https://godoc.org/github.com/tuxychandru/pubsub)
* [Bus](https://github.com/mustafaturan/bus) **star:242** 内部通信的最小消息总线实现。   [![godoc][GoDoc]](https://godoc.org/github.com/mustafaturan/bus)
* [messagebus](https://github.com/vardius/message-bus) **star:203** messagebus是一个Go的简单异步消息总线，非常适合在执行事件sourcing、CQRS和DDD时用作事件总线。   [![最近一年没有更新][Yellow]](https://github.com/vardius/message-bus)
* [rabtap](https://github.com/jandelgado/rabtap) **star:203** RabbitMQ的瑞士军刀cli应用。   [![godoc][GoDoc]](https://godoc.org/github.com/jandelgado/rabtap)
* [amqp](https://github.com/rabbitmq/amqp091-go) **star:201** 进入RabbitMQ客户端库。   [![最近一周有更新][Green]](https://github.com/rabbitmq/amqp091-go)   [![godoc][GoDoc]](https://godoc.org/github.com/rabbitmq/amqp091-go)
* [guble](https://github.com/smancke/guble) **star:150** 使用推送通知服务(谷歌Firebase云消息、苹果推送通知服务、SMS)的消息服务器, 支持websockets,REST API，并具有分布式操作和消息持久性。   [![最近一年没有更新][Yellow]](https://github.com/smancke/guble)   [![godoc][GoDoc]](https://godoc.org/github.com/smancke/guble)
* [hub](https://github.com/leandro-lugaresi/hub) **star:113** 适用于Go应用程序的消息/事件中心，使用publish/subscribe模式，并支持别名(类似rabbitMQ exchanges)。   [![最近一年没有更新][Yellow]](https://github.com/leandro-lugaresi/hub)   [![godoc][GoDoc]](https://godoc.org/github.com/leandro-lugaresi/hub)
* [oplog](https://github.com/dailymotion/oplog) **star:110** 用于REST api的通用oplog/replication系统。   [![最近一年没有更新][Yellow]](https://github.com/dailymotion/oplog)   [![godoc][GoDoc]](https://godoc.org/github.com/dailymotion/oplog)
* [rabbus](https://github.com/rafaeljesus/rabbus) **star:92** amqp exchanges和队列上的一个小工具。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/rabbus)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/rabbus)
* [drone-line](https://github.com/appleboy/drone-line) **star:75** 使用二进制、docker或Drone CI发送[Line](https://at.line.me/en)通知。   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/drone-line)
* [go-mq](https://github.com/cheshir/go-mq) **star:73** 具有声明式配置的RabbitMQ客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/cheshir/go-mq)
* [nsq-event-bus](https://github.com/rafaeljesus/nsq-event-bus) **star:70** 一个围绕NSQ topic和channel的小工具。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/nsq-event-bus)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/nsq-event-bus)
* [redisqueue](https://github.com/robinjoseph08/redisqueue) **star:70** 基于Redis streams的队列的生产者和消费者。   [![godoc][GoDoc]](https://godoc.org/github.com/robinjoseph08/redisqueue)
* [RapidMQ](https://github.com/sybrexsys/RapidMQ) **star:63** RapidMQ是用于管理本地消息队列的轻量且可靠的库。   [![最近一年没有更新][Yellow]](https://github.com/sybrexsys/RapidMQ)   [![godoc][GoDoc]](https://godoc.org/github.com/sybrexsys/RapidMQ)
* [Commander](https://github.com/jeroenrinzema/commander) **star:57** 高级事件驱动的消费者/生产者(consumer/producer)，支持各种“方言”，如Apache Kafka。   [![godoc][GoDoc]](https://godoc.org/github.com/jeroenrinzema/commander)
* [go-notify](https://github.com/TheCreeper/go-notify) **star:56** 原生的freedesktop通知规范实现。   [![最近一年没有更新][Yellow]](https://github.com/TheCreeper/go-notify)   [![godoc][GoDoc]](https://godoc.org/github.com/TheCreeper/go-notify)
* [go-res](https://github.com/jirenius/go-res) **star:53** 用于构建REST/实时服务的包，其中客户端使用NATS和Resgate进行无缝同步。   [![godoc][GoDoc]](https://godoc.org/github.com/jirenius/go-res)
* [event](https://github.com/agoalofalife/event) **star:44** 观察者模式的实现。   [![最近一年没有更新][Yellow]](https://github.com/agoalofalife/event)   [![godoc][GoDoc]](https://godoc.org/github.com/agoalofalife/event)
* [hare](https://github.com/leozz37/hare) **star:32** 一个用户友好的库，用于发送消息和监听TCP套接字。   [![godoc][GoDoc]](https://godoc.org/github.com/leozz37/hare)
* [ami](https://github.com/kak-tus/ami) **star:21** 基于Redis集群流的客户端到可靠队列。   [![最近一年没有更新][Yellow]](https://github.com/kak-tus/ami)   [![godoc][GoDoc]](https://godoc.org/github.com/kak-tus/ami)
* [gosd](https://github.com/alexsniffin/gosd) **star:18** 一种用于调度何时将消息分派到通道的库。   [![最近一年没有更新][Yellow]](https://github.com/alexsniffin/gosd)   [![godoc][GoDoc]](https://godoc.org/github.com/alexsniffin/gosd)
* [go-vitotrol](https://github.com/maxatome/go-vitotrol) **star:16** 用于Viessmann Vitotrol web服务的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/maxatome/go-vitotrol)
* [rmqconn](https://github.com/sbabiv/rmqconn) **star:15** RabbitMQ重新连接。amqp.Connection和amqp.Dial之上的Wrapper。允许在强制调用Close()方法关闭连接之前重新连接。   [![最近一年没有更新][Yellow]](https://github.com/sbabiv/rmqconn)   [![godoc][GoDoc]](https://godoc.org/github.com/sbabiv/rmqconn)
* [jazz](https://github.com/socifi/jazz) **star:13** 一个简单的RabbitMQ抽象层，用于队列管理和消息的发布和消费。   [![最近一年没有更新][Yellow]](https://github.com/socifi/jazz)   [![godoc][GoDoc]](https://godoc.org/github.com/socifi/jazz)
* [gaurun-client](https://github.com/osamingo/gaurun-client) **star:9** 用Go编写的Gaurun客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/gaurun-client)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#messaging) 吧~)*

## 微软办公软件

* [unioffice](https://github.com/unidoc/unioffice) **star:3147** 用于创建和处理Office Word (.docx)、Excel (.xlsx)和Powerpoint (.pptx)文档的纯go库。   [![star > 2000][Awesome]](https://github.com/unidoc/unioffice)   [![最近一周有更新][Green]](https://github.com/unidoc/unioffice)   [![godoc][GoDoc]](https://godoc.org/github.com/unidoc/unioffice)

### Microsoft Excel

*用于操作Microsoft Excel的库。 (翻译出错了? 试试 [英文版](README_EN.md#microsoft-excel) 吧~)*

* [excelize](https://github.com/xuri/excelize) **star:10645** Golang图书馆阅读和写作微软Excel&trade;(XLSX)文件。   [![star > 2000][Awesome]](https://github.com/xuri/excelize)   [![最近一周有更新][Green]](https://github.com/xuri/excelize)   [![godoc][GoDoc]](https://godoc.org/github.com/xuri/excelize)
* [xlsx](https://github.com/tealeg/xlsx) **star:5219** 用以简化在Go程序中读取使用最新版本Microsoft Excel的XML格式文件的库。   [![star > 2000][Awesome]](https://github.com/tealeg/xlsx)   [![godoc][GoDoc]](https://godoc.org/github.com/tealeg/xlsx)
* [xlsx](https://github.com/plandem/xlsx) **star:146** 在Go程序以快速和安全的方式读取/更新现有的Microsoft Excel文件。   [![最近一年没有更新][Yellow]](https://github.com/plandem/xlsx)   [![godoc][GoDoc]](https://godoc.org/github.com/plandem/xlsx)
* [go-excel](https://github.com/szyhf/go-excel) **star:133** 一个简单轻便的阅读器，可以将类关系型数据库(relate-db-like)的excel作为表来读取。   [![godoc][GoDoc]](https://godoc.org/github.com/szyhf/go-excel)
* [goxlsxwriter](https://github.com/fterrag/goxlsxwriter) **star:17** libxlsxwriter的Go binding, 用于编写XLSX (Microsoft Excel)文件。   [![最近一年没有更新][Yellow]](https://github.com/fterrag/goxlsxwriter)   [![godoc][GoDoc]](https://godoc.org/github.com/fterrag/goxlsxwriter)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#microsoft-excel) 吧~)*

## 杂项

### 依赖注入

*用于处理依赖项注入的库。 (翻译出错了? 试试 [英文版](README_EN.md#dependency-injection) 吧~)*

* [google/wire](https://github.com/google/wire) **star:7275** Go中的自动初始化。   [![star > 2000][Awesome]](https://github.com/google/wire)   [![最近一周有更新][Green]](https://github.com/google/wire)   [![godoc][GoDoc]](https://godoc.org/github.com/google/wire)
* [fx](https://github.com/uber-go/fx) **star:2434** 基于依赖注入的Go应用程序框架(构建在dig之上)。   [![star > 2000][Awesome]](https://github.com/uber-go/fx)   [![godoc][GoDoc]](https://godoc.org/github.com/uber-go/fx)
* [dig](https://github.com/uber-go/dig) **star:2306** 一个基于反射的Go依赖注入工具包。   [![star > 2000][Awesome]](https://github.com/uber-go/dig)   [![最近一周有更新][Green]](https://github.com/uber-go/dig)   [![godoc][GoDoc]](https://godoc.org/github.com/uber-go/dig)
* [container](https://github.com/golobby/container) **star:287** 一个强大的IoC容器，具有流畅且易于使用的接口。   [![最近一周有更新][Green]](https://github.com/golobby/container)   [![godoc][GoDoc]](https://godoc.org/github.com/golobby/container)
* [goioc/di](https://github.com/goioc/di) **star:142** 受spring启发的依赖注入容器。   [![最近一周有更新][Green]](https://github.com/goioc/di)   [![godoc][GoDoc]](https://godoc.org/github.com/goioc/di)
* [dingo](https://github.com/i-love-flamingo/dingo) **star:122** 基于Guice的Go依赖注入工具包。   [![godoc][GoDoc]](https://godoc.org/github.com/i-love-flamingo/dingo)
* [di](https://github.com/goava/di) **star:118** go编程语言的依赖注入容器。   [![godoc][GoDoc]](https://godoc.org/github.com/goava/di)
* [alice](https://github.com/magic003/alice) **star:43** Go的外挂的依赖注入容器。   [![最近一年没有更新][Yellow]](https://github.com/magic003/alice)   [![godoc][GoDoc]](https://godoc.org/github.com/magic003/alice)
* [wire](https://github.com/Fs02/wire) **star:35** 适用于Go的严格运行时依赖注入(Strict Runtime Dependency Injection)。   [![godoc][GoDoc]](https://godoc.org/github.com/Fs02/wire)
* [linker](https://github.com/logrange/linker) **star:32** A reflection based dependency injection and inversion of control library with components lifecycle support.   [![最近一年没有更新][Yellow]](https://github.com/logrange/linker)   [![godoc][GoDoc]](https://godoc.org/github.com/logrange/linker)
* [gocontainer](https://github.com/vardius/gocontainer) **star:14** 简单的依赖注入容器。   [![最近一年没有更新][Yellow]](https://github.com/vardius/gocontainer)   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/gocontainer)
* [kinit](https://github.com/go-kata/kinit) **star:5** 可定制的依赖注入容器，具有全局模式，级联初始化和紧急安全结束。   [![godoc][GoDoc]](https://godoc.org/github.com/go-kata/kinit)
* [nject](https://github.com/muir/nject) **star:5** 一个类型安全的反射框架，用于库、测试、http端点和服务启动。   [![godoc][GoDoc]](https://godoc.org/github.com/muir/nject)
* [HnH/di](https://github.com/HnH/di) **star:3** DI容器库，专注于干净的API和灵活性。   [![最近一周有更新][Green]](https://github.com/HnH/di)   [![godoc][GoDoc]](https://godoc.org/github.com/HnH/di)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#dependency-injection) 吧~)*

### 项目布局

_**Unofficial** set of patterns for structuring projects._

* [golang-standards/project-layout](https://github.com/golang-standards/project-layout) **star:28857** 围棋生态系统中常见的历史和新兴项目布局模式。注意:尽管这个组织名称并不代表golang的官方标准，更多信息请参见[本期](https://github.com/golang-standards/project-layout/issues/117)。尽管如此，有些人可能会发现这种布局很有用。   [![star > 2000][Awesome]](https://github.com/golang-standards/project-layout)
* [ardanlabs/service](https://github.com/ardanlabs/service) **star:2138** 用于构建产品级可扩展web服务应用程序的[starter kit](https://github.com/ardanlabs/service/wiki)。   [![star > 2000][Awesome]](https://github.com/ardanlabs/service)   [![最近一周有更新][Green]](https://github.com/ardanlabs/service)   [![godoc][GoDoc]](https://godoc.org/github.com/ardanlabs/service)
* [modern-go-application](https://github.com/sagikazarmark/modern-go-application) **star:1126** 应用程序样板和应用现代实践的例子。   [![godoc][GoDoc]](https://godoc.org/github.com/sagikazarmark/modern-go-application)
* [cookiecutter-golang](https://github.com/lacion/cookiecutter-golang) **star:495** 遵循生产最佳实践快速启动项目的Go应用程序样板模板。   [![godoc][GoDoc]](https://godoc.org/github.com/lacion/cookiecutter-golang)
* [golang-templates/seed](https://github.com/golang-templates/seed) **star:237** Go应用程序GitHub存储库模板。   [![最近一周有更新][Green]](https://github.com/golang-templates/seed)
* [go-starter](https://github.com/allaboutapps/go-starter) **star:116** 一个自以为是的面向生产的RESTful JSON后端模板，与VSCode DevContainers高度集成。   [![最近一周有更新][Green]](https://github.com/allaboutapps/go-starter)   [![godoc][GoDoc]](https://godoc.org/github.com/allaboutapps/go-starter)
* [go-todo-backend](https://github.com/Fs02/go-todo-backend) **star:111** 去Todo后端示例使用模块化项目布局的产品微服务。   [![最近一周有更新][Green]](https://github.com/Fs02/go-todo-backend)   [![godoc][GoDoc]](https://godoc.org/github.com/Fs02/go-todo-backend)
* [scaffold](https://github.com/catchplay/scaffold) **star:105** Scaffold生成一个starter Go项目布局。让您关注已实现的业务逻辑。   [![最近一年没有更新][Yellow]](https://github.com/catchplay/scaffold)   [![godoc][GoDoc]](https://godoc.org/github.com/catchplay/scaffold)
* [go-sample](https://github.com/zitryss/go-sample) **star:96** 带有实际代码的Go应用程序项目的示例布局。   [![最近一年没有更新][Yellow]](https://github.com/zitryss/go-sample)   [![godoc][GoDoc]](https://godoc.org/github.com/zitryss/go-sample)
* [gobase](https://github.com/wajox/gobase) **star:16** 一个简单的golang应用框架，带有真实golang应用程序的基本设置。   [![godoc][GoDoc]](https://godoc.org/github.com/wajox/gobase)
* [wangyoucao577/go-project-layout](https://github.com/wangyoucao577/go-project-layout) **star:12** 关于如何构造Go项目布局的一组实践和讨论。   [![godoc][GoDoc]](https://godoc.org/github.com/wangyoucao577/go-project-layout)
* [insidieux/inizio](https://github.com/insidieux/inizio) **star:9** 带有插件的Golang项目布局生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/insidieux/inizio)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#project-layout) 吧~)*

### 字符串

*处理字符串的库。 (翻译出错了? 试试 [英文版](README_EN.md#strings) 吧~)*

* [xstrings](https://github.com/huandu/xstrings) **star:973** 从其他语言移植的有用字符串函数合集。   [![godoc][GoDoc]](https://godoc.org/github.com/huandu/xstrings)
* [sttr](https://github.com/abhimanyu003/sttr) **star:333** 跨平台的cli应用程序，对字符串执行各种操作。   [![godoc][GoDoc]](https://godoc.org/github.com/abhimanyu003/sttr)
* [strutil](https://github.com/ozgio/strutil) **star:151** 字符串处理工具。   [![godoc][GoDoc]](https://godoc.org/github.com/ozgio/strutil)
* [gobeam/Stringy](https://github.com/gobeam/Stringy) **star:103** 字符串操作库，可以将字符串转换为驼色，蛇色，烤肉色等。   [![godoc][GoDoc]](https://godoc.org/github.com/gobeam/Stringy)
* [bexp](https://github.com/mkungla/bexp) **star:4** 执行大括号扩展机制来生成任意字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/mkungla/bexp)
* [go-formatter](https://gitlab.com/tymonx/go-formatter)  实现**替换字段**由大括号'{}'格式字符串包围。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#strings) 吧~)*

### 未分类的

*这些库之所以放在这里，是因为不适合放在其他分类。 (翻译出错了? 试试 [英文版](README_EN.md#uncategorized) 吧~)*

* [gopsutil](https://github.com/shirou/gopsutil) **star:7223** 用于检索进程和系统利用率(CPU、内存、磁盘等)的跨平台的库。   [![star > 2000][Awesome]](https://github.com/shirou/gopsutil)   [![最近一周有更新][Green]](https://github.com/shirou/gopsutil)   [![godoc][GoDoc]](https://godoc.org/github.com/shirou/gopsutil)
* [archiver](https://github.com/mholt/archiver) **star:3437** 用于生成和解压.zip和.tar.gz文档的库和命令。   [![star > 2000][Awesome]](https://github.com/mholt/archiver)   [![最近一周有更新][Green]](https://github.com/mholt/archiver)   [![godoc][GoDoc]](https://godoc.org/github.com/mholt/archiver)
* [gofakeit](https://github.com/brianvoe/gofakeit) **star:2228** 用go编写的随机数据生成器。   [![star > 2000][Awesome]](https://github.com/brianvoe/gofakeit)   [![最近一周有更新][Green]](https://github.com/brianvoe/gofakeit)   [![godoc][GoDoc]](https://godoc.org/github.com/brianvoe/gofakeit)
* [gatus](https://github.com/TwinProduction/gatus) **star:2098** 自动服务运行状况仪表板。   [![star > 2000][Awesome]](https://github.com/TwinProduction/gatus)   [![最近一周有更新][Green]](https://github.com/TwinProduction/gatus)   [![godoc][GoDoc]](https://godoc.org/github.com/TwinProduction/gatus)
* [gosms](https://github.com/haxpax/gosms) **star:1361** Go编写的私人的本地短信网关，可以用来发送短信。   [![godoc][GoDoc]](https://godoc.org/github.com/haxpax/gosms)
* [base64Captcha](https://github.com/mojocn/base64Captcha) **star:1320** base64Captcha支持数字，字母，算术，音频和混合模式的验证码。   [![godoc][GoDoc]](https://godoc.org/github.com/mojocn/base64Captcha)   [![包含中文文档][CN]](https://github.com/mojocn/base64Captcha)
* [go-resiliency](https://github.com/eapache/go-resiliency) **star:1314**  Go语言弹性模式(resiliency pattern)。   [![godoc][GoDoc]](https://godoc.org/github.com/eapache/go-resiliency)
* [go-commons-pool](https://github.com/jolestar/go-commons-pool) **star:1000** Go语言的通用对象池。   [![godoc][GoDoc]](https://godoc.org/github.com/jolestar/go-commons-pool)   [![包含中文文档][CN]](https://github.com/jolestar/go-commons-pool)
* [go-openapi](https://github.com/go-openapi)  用于解析和使用开放api模式(open-api schemas)的包的集合。
* [llvm](https://github.com/llir/llvm) **star:839** 用于在纯Go中与LLVM IR交互的库。   [![godoc][GoDoc]](https://godoc.org/github.com/llir/llvm)
* [shortid](https://github.com/teris-io/shortid) **star:730** 分布式地生成超短、唯一、非顺序、URL友好的id。   [![最近一年没有更新][Yellow]](https://github.com/teris-io/shortid)   [![godoc][GoDoc]](https://godoc.org/github.com/teris-io/shortid)
* [health](https://github.com/alexliesenfeld/health) **star:482** 一个简单而灵活的Go健康检查库。   [![最近一周有更新][Green]](https://github.com/alexliesenfeld/health)   [![godoc][GoDoc]](https://godoc.org/github.com/alexliesenfeld/health)
* [health](https://github.com/dimiro1/health) **star:425** 易于使用，可扩展的健康检查库。   [![最近一年没有更新][Yellow]](https://github.com/dimiro1/health)   [![godoc][GoDoc]](https://godoc.org/github.com/dimiro1/health)
* [stateless](https://github.com/qmuntal/stateless) **star:394** 用于创建状态机的流畅库。   [![godoc][GoDoc]](https://godoc.org/github.com/qmuntal/stateless)
* [banner](https://github.com/dimiro1/banner) **star:375** 在Go应用程序中添加漂亮的横幅(banner)。   [![最近一年没有更新][Yellow]](https://github.com/dimiro1/banner)   [![godoc][GoDoc]](https://godoc.org/github.com/dimiro1/banner)
* [conv](https://github.com/cstockton/go-conv) **star:373** conv包提供了跨Go类型(Go types)的快速和直观的转换。   [![godoc][GoDoc]](https://godoc.org/github.com/cstockton/go-conv)
* [gountries](https://github.com/pariz/gountries) **star:332** 获取国家和细节数据的包。   [![godoc][GoDoc]](https://godoc.org/github.com/pariz/gountries)
* [shoutrrr](https://github.com/containrrr/shoutrrr) **star:286** 通知库提供了对各种消息服务(如slack、mattermost、fy和smtp等)的轻松访问。   [![godoc][GoDoc]](https://godoc.org/github.com/containrrr/shoutrrr)
* [ffmt](https://github.com/go-ffmt/ffmt) **star:248** 美化数据,使其更适合人查看。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ffmt/ffmt)   [![包含中文文档][CN]](https://github.com/go-ffmt/ffmt)
* [lk](https://github.com/hyperboloide/lk) **star:230** 一个简单的版权许可证库。   [![最近一年没有更新][Yellow]](https://github.com/hyperboloide/lk)   [![godoc][GoDoc]](https://godoc.org/github.com/hyperboloide/lk)
* [antch](https://github.com/antchfx/antch) **star:225** 一个快速、强大和可扩展的web爬虫框架。   [![最近一年没有更新][Yellow]](https://github.com/antchfx/antch)   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/antch)   [![包含中文文档][CN]](https://github.com/antchfx/antch)
* [healthcheck](https://github.com/etherlabsio/healthcheck) **star:211** 用于RESTful服务的强制的(opinionated)并发健康检查HTTP处理程序。   [![godoc][GoDoc]](https://godoc.org/github.com/etherlabsio/healthcheck)
* [battery](https://github.com/distatus/battery) **star:199** 跨平台、标准化的电池信息库。   [![最近一周有更新][Green]](https://github.com/distatus/battery)   [![godoc][GoDoc]](https://godoc.org/github.com/distatus/battery)
* [bitio](https://github.com/icza/bitio) **star:178** 高度优化的位级读写器。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/bitio)
* [go-unarr](https://github.com/gen2brain/go-unarr) **star:165** 用于RAR、TAR、ZIP和7z文件的解压缩库。   [![最近一周有更新][Green]](https://github.com/gen2brain/go-unarr)   [![godoc][GoDoc]](https://godoc.org/github.com/gen2brain/go-unarr)
* [stats](https://github.com/go-playground/stats) **star:158** Monitors Go MemStats + 诸如如内存，Swap和CPU的系统状态统计，并通过UDP发送到任何你想记录的地方   [![最近一年没有更新][Yellow]](https://github.com/go-playground/stats)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/stats)
* [turtle](https://github.com/hackebrot/turtle) **star:128** Go的Emojis库。   [![godoc][GoDoc]](https://godoc.org/github.com/hackebrot/turtle)
* [gommit](https://github.com/antham/gommit) **star:95** 分析git提交消息，确保它们遵循已定义的格式。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/gommit)
* [indigo](https://github.com/osamingo/indigo) **star:93** 分布式唯一ID生成器, 使用Sonyflake并由Base58编码。   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/indigo)
* [gotoprom](https://github.com/cabify/gotoprom) **star:92** 为Prometheus客户端提供类型安全的指标(metric)构建工具库。   [![最近一年没有更新][Yellow]](https://github.com/cabify/gotoprom)   [![godoc][GoDoc]](https://godoc.org/github.com/cabify/gotoprom)
* [captcha](https://github.com/steambap/captcha) **star:89** captcha包为验证码生成提供了一个易于使用的、unopinionated的API。   [![godoc][GoDoc]](https://godoc.org/github.com/steambap/captcha)
* [morse](https://github.com/alwindoss/morse) **star:73** 实现字符串与摩尔斯电码转换的库。   [![godoc][GoDoc]](https://godoc.org/github.com/alwindoss/morse)
* [persian](https://github.com/mavihq/persian) **star:61** 一些适用于波斯语的Go工具库。   [![godoc][GoDoc]](https://godoc.org/github.com/mavihq/persian)
* [faker](https://github.com/pioz/faker) **star:56** 随机假数据和结构生成器为Go。   [![godoc][GoDoc]](https://godoc.org/github.com/pioz/faker)
* [pdfgen](https://github.com/hyperboloide/pdfgen) **star:56** 通过Json请求生成PDF的HTTP服务。   [![最近一年没有更新][Yellow]](https://github.com/hyperboloide/pdfgen)   [![godoc][GoDoc]](https://godoc.org/github.com/hyperboloide/pdfgen)
* [xkg](https://github.com/go-xkg/xkg) **star:53** X Keyboard Grabber(键盘事件捕获)   [![最近一年没有更新][Yellow]](https://github.com/go-xkg/xkg)   [![godoc][GoDoc]](https://godoc.org/github.com/go-xkg/xkg)
* [browscap_go](https://github.com/digitalcrab/browscap_go) **star:39** GoLang库[浏览器功能项目](https://browscap.org/)。   [![godoc][GoDoc]](https://godoc.org/github.com/digitalcrab/browscap_go)
* [datacounter](https://github.com/miolini/datacounter) **star:37** 用于readers/writer/http.ResponseWriter的计数器。   [![最近一年没有更新][Yellow]](https://github.com/miolini/datacounter)   [![godoc][GoDoc]](https://godoc.org/github.com/miolini/datacounter)
* [autoflags](https://github.com/artyom/autoflags) **star:36** 从struct字段自动定义命令行flag的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/artyom/autoflags)
* [sandid](https://github.com/aofei/sandid) **star:34** 能沟让地球上的每一粒沙子都有自己的ID。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/sandid)
* [url-shortener](https://github.com/pantrif/url-shortener) **star:34** 一个现代的、强大的、健壮的URL转短链接微服务，带有mysql支持。   [![最近一年没有更新][Yellow]](https://github.com/pantrif/url-shortener)   [![godoc][GoDoc]](https://godoc.org/github.com/pantrif/url-shortener)
* [VarHandler](https://github.com/azr/generators/tree/master/varhandler)  用于生成http输入和输出处理模板。
* [gosh](https://github.com/osamingo/gosh) **star:29** 提供Go统计处理程序，结构和测量方法。   [![最近一年没有更新][Yellow]](https://github.com/osamingo/gosh)   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/gosh)
* [gtree](https://github.com/ddddddO/gtree) **star:28** 从Markdown或以编程方式为树输出和目录创建提供CLI和Package。   [![最近一周有更新][Green]](https://github.com/ddddddO/gtree)   [![godoc][GoDoc]](https://godoc.org/github.com/ddddddO/gtree)
* [xdg](https://github.com/rkoesters/xdg) **star:28** FreeDesktop.org (xdg)规范在Go中的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/rkoesters/xdg)
* [metrics](https://github.com/pascaldekloe/metrics) **star:23** 用于instrumentation和Prometheus exposition的库。   [![godoc][GoDoc]](https://godoc.org/github.com/pascaldekloe/metrics)
* [shellwords](https://github.com/Wing924/shellwords) **star:16** 一个Go库，实现了依照UNIX Bourne shell的关键词解析规则进行字符串操纵。   [![最近一年没有更新][Yellow]](https://github.com/Wing924/shellwords)   [![godoc][GoDoc]](https://godoc.org/github.com/Wing924/shellwords)
* [anagent](https://github.com/mudler/anagent) **star:13** Go语言的最小化，可插入的evloop/timer处理程序, 带有依赖注入。   [![最近一年没有更新][Yellow]](https://github.com/mudler/anagent)   [![godoc][GoDoc]](https://godoc.org/github.com/mudler/anagent)
* [avgRating](https://github.com/kirillDanshin/avgRating) **star:11** 根据威尔逊得分排序算法(Wilson Score Equation)计算平均分和评分。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/avgRating)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/avgRating)
* [hostutils](https://github.com/Wing924/hostutils) **star:10** 一个用于打包和解包FQDNs列表的go语言库。   [![最近一年没有更新][Yellow]](https://github.com/Wing924/hostutils)   [![godoc][GoDoc]](https://godoc.org/github.com/Wing924/hostutils)
* [numa](https://github.com/lrita/numa) **star:6** NUMA是一个用go编写的实用程序库。它可以帮助我们编写一些NUMA-AWARED代码。   [![最近一年没有更新][Yellow]](https://github.com/lrita/numa)   [![godoc][GoDoc]](https://godoc.org/github.com/lrita/numa)
* [go-commandbus](https://github.com/lana/go-commandbus) **star:4** 一个微小的可插拔的Go命令总线。   [![最近一年没有更新][Yellow]](https://github.com/lana/go-commandbus)   [![godoc][GoDoc]](https://godoc.org/github.com/lana/go-commandbus)
* [varint](https://github.com/chmike/varint) **star:2** 一个比标准库中提供的更快的变长整数编码器/解码器。   [![godoc][GoDoc]](https://godoc.org/github.com/chmike/varint)
* [basexx](https://github.com/bobg/basexx) **star:1** 转换为，从，和之间的数字字符串在不同的数字基数。   [![godoc][GoDoc]](https://godoc.org/github.com/bobg/basexx)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#uncategorized) 吧~)*

## 自然语言处理

*用于处理人类语言的库。 (翻译出错了? 试试 [英文版](README_EN.md#natural-language-processing) 吧~)*

* [prose](https://github.com/jdkato/prose) **star:2857** 支持标记化、词性标记、命名实体提取等文本处理的库。只说英语。   [![star > 2000][Awesome]](https://github.com/jdkato/prose)   [![godoc][GoDoc]](https://godoc.org/github.com/jdkato/prose)
* [gojieba](https://github.com/yanyiwu/gojieba) **star:1761** 这是一个Go实现的[jieba](https://github.com/fxsjy/jieba)，这是一个中文分词算法。   [![godoc][GoDoc]](https://godoc.org/github.com/yanyiwu/gojieba)   [![包含中文文档][CN]](https://github.com/yanyiwu/gojieba)
* [gse](https://github.com/go-ego/gse) **star:1727** 高效的文本分割;支持英语、汉语、日语等。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ego/gse)   [![包含中文文档][CN]](https://github.com/go-ego/gse)
* [when](https://github.com/olebedev/when) **star:1137** 带有可插入规则的自然EN和RU语言日期/时间解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/olebedev/when)
* [spaGO](https://github.com/nlpodyssey/spago) **star:1075** Go中的独立机器学习和自然语言处理库。   [![godoc][GoDoc]](https://godoc.org/github.com/nlpodyssey/spago)
* [go-pinyin](https://github.com/mozillazg/go-pinyin) **star:1067** 中文汉字到汉语拼音的转换。   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-pinyin)
* [kagome](https://github.com/ikawaha/kagome) **star:599** JP形态学分析仪编写的纯Go。   [![godoc][GoDoc]](https://godoc.org/github.com/ikawaha/kagome)
* [whatlanggo](https://github.com/abadojack/whatlanggo) **star:517** Go的自然语言检测包。支持84种语言和24种脚本(书写系统，如拉丁语、西里尔语等)。   [![最近一年没有更新][Yellow]](https://github.com/abadojack/whatlanggo)   [![godoc][GoDoc]](https://godoc.org/github.com/abadojack/whatlanggo)
* [nlp](https://github.com/Shixzie/nlp) **star:376** 从字符串中提取值并用nlp填充结构。   [![最近一年没有更新][Yellow]](https://github.com/Shixzie/nlp)   [![godoc][GoDoc]](https://godoc.org/github.com/Shixzie/nlp)
* [nlp](https://github.com/james-bowman/nlp) **star:351** 支持LSA(潜在语义分析)的Go自然语言处理库。   [![godoc][GoDoc]](https://godoc.org/github.com/james-bowman/nlp)
* [sentences](https://github.com/neurosnap/sentences) **star:315** 句子标记器:将文本转换为句子列表。   [![godoc][GoDoc]](https://godoc.org/github.com/neurosnap/sentences)
* [getlang](https://github.com/rylans/getlang) **star:126** 快速自然语言检测包。   [![最近一年没有更新][Yellow]](https://github.com/rylans/getlang)   [![godoc][GoDoc]](https://godoc.org/github.com/rylans/getlang)
* [go-i18n](https://github.com/nicksnyder/go-i18n/)  软件包和用于处理本地化文本的附带工具。
* [go-nlp](https://github.com/nuance/go-nlp) **star:90** 用于处理离散概率分布的实用程序和用于进行NLP工作的其他工具。   [![最近一年没有更新][Yellow]](https://github.com/nuance/go-nlp)   [![godoc][GoDoc]](https://godoc.org/github.com/nuance/go-nlp)   [![归档项目][Archived]](https://github.com/nuance/go-nlp)
* [go-unidecode](https://github.com/mozillazg/go-unidecode) **star:90** Unicode文本的ASCII音译。   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-unidecode)
* [RAKE.go](https://github.com/afjoseph/RAKE.Go) **star:86** 快速自动关键字提取算法(RAKE)的Go端口。   [![最近一年没有更新][Yellow]](https://github.com/afjoseph/RAKE.Go)   [![godoc][GoDoc]](https://godoc.org/github.com/afjoseph/RAKE.Go)
* [gounidecode](https://github.com/fiam/gounidecode) **star:73** 用于Go的Unicode音译器(也称为unidecode)。   [![最近一年没有更新][Yellow]](https://github.com/fiam/gounidecode)   [![godoc][GoDoc]](https://godoc.org/github.com/fiam/gounidecode)
* [segment](https://github.com/blevesearch/segment) **star:69** Go库用于执行Unicode文本分割，如[Unicode标准附件#29](https://www.unicode.org/reports/tr29/)所述。   [![最近一年没有更新][Yellow]](https://github.com/blevesearch/segment)   [![godoc][GoDoc]](https://godoc.org/github.com/blevesearch/segment)
* [textcat](https://github.com/pebbe/textcat) **star:65** Go package支持基于n-gram的文本分类，支持utf-8和原始文本。   [![godoc][GoDoc]](https://godoc.org/github.com/pebbe/textcat)
* [go-stem](https://github.com/agonopol/go-stem) **star:64** 波特词干算法的实现。   [![最近一年没有更新][Yellow]](https://github.com/agonopol/go-stem)   [![godoc][GoDoc]](https://godoc.org/github.com/agonopol/go-stem)
* [MMSEGO](https://github.com/awsong/MMSEGO) **star:59** 这是一个 Go 实现的[MMSEG](http://technology.chtsai.org/mmseg/)，这是一个中文分词算法。   [![最近一年没有更新][Yellow]](https://github.com/awsong/MMSEGO)   [![godoc][GoDoc]](https://godoc.org/github.com/awsong/MMSEGO)
* [stemmer](https://github.com/dchest/stemmer) **star:50** 用于Go编程语言的Stemmer包。包括英语和德语词根。   [![最近一年没有更新][Yellow]](https://github.com/dchest/stemmer)   [![godoc][GoDoc]](https://godoc.org/github.com/dchest/stemmer)
* [address](https://github.com/bojanz/address) **star:43** 处理地址表示、验证和格式。   [![godoc][GoDoc]](https://godoc.org/github.com/bojanz/address)
* [go2vec](https://github.com/danieldk/go2vec) **star:43** 用于word2vec嵌入式的阅读器和实用程序函数。   [![最近一年没有更新][Yellow]](https://github.com/danieldk/go2vec)   [![godoc][GoDoc]](https://godoc.org/github.com/danieldk/go2vec)
* [porter2](https://github.com/zhenjl/porter2) **star:41** 非常快的波特2史坦默。   [![最近一年没有更新][Yellow]](https://github.com/zhenjl/porter2)   [![godoc][GoDoc]](https://godoc.org/github.com/zhenjl/porter2)
* [petrovich](https://github.com/striker2000/petrovich) **star:36** 彼得罗维奇是一个图书馆，它把俄语名字的词形变化成特定的语法格。   [![godoc][GoDoc]](https://godoc.org/github.com/striker2000/petrovich)
* [go-localize](https://github.com/m1/go-localize) **star:29** 简单易用的i18n(国际化和本地化)引擎——用于翻译语言环境字符串。   [![godoc][GoDoc]](https://godoc.org/github.com/m1/go-localize)
* [snowball](https://github.com/goodsign/snowball) **star:29** 滚雪球柄端口(cgo包装)为 Go 。提供词干提取功能[Snowball native](http://snowball.tartarus.org/)。   [![最近一年没有更新][Yellow]](https://github.com/goodsign/snowball)
* [go-mystem](https://github.com/dveselov/mystem) **star:27** CGo绑定到Yandex。Mystem -俄罗斯形态学分析仪。   [![最近一年没有更新][Yellow]](https://github.com/dveselov/mystem)   [![godoc][GoDoc]](https://godoc.org/github.com/dveselov/mystem)
* [iuliia-go](https://github.com/mehanizm/iuliia-go) **star:27** 直译斯拉夫字母→拉丁以所有可能的方式。   [![godoc][GoDoc]](https://godoc.org/github.com/mehanizm/iuliia-go)
* [paicehusk](https://github.com/rookii/paicehusk) **star:27** Golang实现了Paice/外壳阻塞算法。   [![最近一年没有更新][Yellow]](https://github.com/rookii/paicehusk)   [![godoc][GoDoc]](https://godoc.org/github.com/rookii/paicehusk)
* [golibstemmer](https://github.com/rjohnsondev/golibstemmer) **star:19**  Go 绑定斯诺鲍libstemmer库，包括波特2。   [![最近一年没有更新][Yellow]](https://github.com/rjohnsondev/golibstemmer)   [![godoc][GoDoc]](https://godoc.org/github.com/rjohnsondev/golibstemmer)
* [icu](https://github.com/goodsign/icu) **star:19** Cgo绑定用于icu4c C库的检测和转换功能。保证与版本50.1兼容。   [![最近一年没有更新][Yellow]](https://github.com/goodsign/icu)   [![godoc][GoDoc]](https://godoc.org/github.com/goodsign/icu)
* [transliterator](https://github.com/alexsergivan/transliterator) **star:18** 提供单向字符串音译，并支持特定于语言的音译规则。   [![最近一年没有更新][Yellow]](https://github.com/alexsergivan/transliterator)   [![godoc][GoDoc]](https://godoc.org/github.com/alexsergivan/transliterator)
* [govader](https://github.com/jonreiter/govader) **star:17** [VADER情绪分析]的Go实现(https://github.com/cjhutto/vaderSentiment)。   [![godoc][GoDoc]](https://godoc.org/github.com/jonreiter/govader)
* [gotokenizer](https://github.com/xujiajun/gotokenizer) **star:13** 一种基于字典和双字母格朗语言模型的记号赋予器。(现在只支持中文分割)   [![最近一年没有更新][Yellow]](https://github.com/xujiajun/gotokenizer)   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/gotokenizer)
* [shamoji](https://github.com/osamingo/shamoji) **star:12** shamoji是用Go编写的word过滤包。   [![最近一年没有更新][Yellow]](https://github.com/osamingo/shamoji)   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/shamoji)
* [detectlanguage](https://github.com/detectlanguage/detectlanguage-go) **star:10** 语言检测API Go客户端。支持批量请求，短短语或单字语言检测。   [![最近一年没有更新][Yellow]](https://github.com/detectlanguage/detectlanguage-go)   [![godoc][GoDoc]](https://godoc.org/github.com/detectlanguage/detectlanguage-go)
* [libtextcat](https://github.com/goodsign/libtextcat) **star:10** 用于libtextcat C库的Cgo绑定。保证与版本2.2兼容。   [![最近一年没有更新][Yellow]](https://github.com/goodsign/libtextcat)   [![godoc][GoDoc]](https://godoc.org/github.com/goodsign/libtextcat)
* [porter](https://github.com/a2800276/porter) **star:8** 这是Martin Porter在C语言中实现的Porter词干分析算法的一个相当简单的移植。   [![最近一年没有更新][Yellow]](https://github.com/a2800276/porter)   [![godoc][GoDoc]](https://godoc.org/github.com/a2800276/porter)
* [t](https://github.com/youthlin/t) **star:8** 另一个用于golang的i18n pkg，它遵循GNU gettext风格并支持.po/。mo文件:“t。T (gettext)”、“T。N (ngettext)”,等等。它包含一个cmd工具[xtemplate](https://github.com/youthlin/t/blob/main/cmd/xtemplate)，可以从文本/html模板中提取消息作为pot文件。   [![godoc][GoDoc]](https://godoc.org/github.com/youthlin/t)   [![包含中文文档][CN]](https://github.com/youthlin/t)
* [gosentiwordnet](https://github.com/dinopuguh/gosentiwordnet) **star:7** 情绪分析器使用的多愁善感网词汇在Go。   [![godoc][GoDoc]](https://godoc.org/github.com/dinopuguh/gosentiwordnet)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#natural-language-processing) 吧~)*

## 网络

*用于处理各种网络层的库。 (翻译出错了? 试试 [英文版](README_EN.md#networking) 吧~)*

* [fasthttp](https://github.com/valyala/fasthttp) **star:16754** 一个快速HTTP实现，比net/http快10倍。   [![star > 2000][Awesome]](https://github.com/valyala/fasthttp)   [![最近一周有更新][Green]](https://github.com/valyala/fasthttp)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/fasthttp)
* [kcptun](https://github.com/xtaci/kcptun) **star:12740** 基于KCP协议的非常简单和快速udp隧道。   [![star > 2000][Awesome]](https://github.com/xtaci/kcptun)   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/kcptun)
* [webrtc](https://github.com/pions/webrtc) **star:8563** WebRTC API的纯Go实现。   [![star > 2000][Awesome]](https://github.com/pions/webrtc)   [![最近一周有更新][Green]](https://github.com/pions/webrtc)   [![godoc][GoDoc]](https://godoc.org/github.com/pions/webrtc)
* [quic-go](https://github.com/lucas-clemente/quic-go) **star:6197** 在纯Go中实现了QUIC协议。   [![star > 2000][Awesome]](https://github.com/lucas-clemente/quic-go)   [![最近一周有更新][Green]](https://github.com/lucas-clemente/quic-go)   [![godoc][GoDoc]](https://godoc.org/github.com/lucas-clemente/quic-go)
* [dns](https://github.com/miekg/dns) **star:6012** 用于 DNS 的库。   [![star > 2000][Awesome]](https://github.com/miekg/dns)   [![最近一周有更新][Green]](https://github.com/miekg/dns)   [![godoc][GoDoc]](https://godoc.org/github.com/miekg/dns)
* [gnet](https://github.com/panjf2000/gnet) **star:5978** “gnet”是一个用纯Go编写的高性能、轻量级、非阻塞、事件驱动的网络框架。   [![star > 2000][Awesome]](https://github.com/panjf2000/gnet)   [![最近一周有更新][Green]](https://github.com/panjf2000/gnet)   [![godoc][GoDoc]](https://godoc.org/github.com/panjf2000/gnet)   [![包含中文文档][CN]](https://github.com/panjf2000/gnet)
* [gopacket](https://github.com/google/gopacket) **star:4597** Go library for packet processing with libpcap bindings.   [![star > 2000][Awesome]](https://github.com/google/gopacket)   [![godoc][GoDoc]](https://godoc.org/github.com/google/gopacket)
* [HTTPLab](https://github.com/gchaincl/httplab) **star:3763** HTTPLabs 允许你检查 HTTP 请求和伪造响应。   [![star > 2000][Awesome]](https://github.com/gchaincl/httplab)   [![最近一年没有更新][Yellow]](https://github.com/gchaincl/httplab)   [![godoc][GoDoc]](https://godoc.org/github.com/gchaincl/httplab)
* [kcp-go](https://github.com/xtaci/kcp-go) **star:3194** 快速可靠的ARQ协议。   [![star > 2000][Awesome]](https://github.com/xtaci/kcp-go)   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/kcp-go)
* [gobgp](https://github.com/osrg/gobgp) **star:2382** 基于 Go 的 BGP 实现。   [![star > 2000][Awesome]](https://github.com/osrg/gobgp)   [![最近一周有更新][Green]](https://github.com/osrg/gobgp)   [![godoc][GoDoc]](https://godoc.org/github.com/osrg/gobgp)
* [ssh](https://github.com/gliderlabs/ssh) **star:2310** 用于构建SSH服务器的高级API(封装密码/ SSH)。   [![star > 2000][Awesome]](https://github.com/gliderlabs/ssh)   [![godoc][GoDoc]](https://godoc.org/github.com/gliderlabs/ssh)
* [fortio](https://github.com/fortio/fortio) **star:2236** 负载测试库和命令行工具，高级的echo服务器和web UI。允许指定一组每秒查询的负载，并记录延迟直方图和其他有用的统计数据，并将它们作图。支持Tcp、Http、gRPC。   [![star > 2000][Awesome]](https://github.com/fortio/fortio)   [![godoc][GoDoc]](https://godoc.org/github.com/fortio/fortio)
* [water](https://github.com/songgao/water) **star:1355** 简单TUN / TAP图书馆。   [![godoc][GoDoc]](https://godoc.org/github.com/songgao/water)
* [gev](https://github.com/Allenxuxu/gev) **star:1326** gev是一个基于反应器模式的轻量级、快速的非阻塞TCP网络库。   [![godoc][GoDoc]](https://godoc.org/github.com/Allenxuxu/gev)
* [go-getter](https://github.com/hashicorp/go-getter) **star:1279**  通过URL来下载文件或目录。   [![最近一周有更新][Green]](https://github.com/hashicorp/go-getter)   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/go-getter)
* [NFF-Go](https://github.com/intel-go/nff-go) **star:1150** 用于快速开发云计算和裸机网络功能的框架(原YANFF)。   [![godoc][GoDoc]](https://godoc.org/github.com/intel-go/nff-go)
* [sftp](https://github.com/pkg/sftp) **star:1084** Package sftp implements the SSH File Transfer Protocol as described in https://filezilla-project.org/specs/draft-ietf-secsh-filexfer-02.txt.   [![godoc][GoDoc]](https://godoc.org/github.com/pkg/sftp)
* [grab](https://github.com/cavaliercoder/grab) **star:971**  用于管理文件下载。   [![godoc][GoDoc]](https://godoc.org/github.com/cavaliercoder/grab)
* [ftp](https://github.com/jlaffaye/ftp) **star:875** Package ftp实现了[RFC 959](https://tools.ietf.org/html/rfc959)中描述的ftp客户端。   [![最近一周有更新][Green]](https://github.com/jlaffaye/ftp)   [![godoc][GoDoc]](https://godoc.org/github.com/jlaffaye/ftp)
* [mdns](https://github.com/hashicorp/mdns) **star:840** 简单mDNS(Multicast DNS)客户端/服务器库。   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/mdns)
* [mqttPaho](https://eclipse.org/paho/clients/golang/)  Paho Go客户端提供了一个 MQTT 客户端库，用于通过TCP、TLS或WebSockets连接到MQTT代理。
* [gosnmp](https://github.com/soniah/gosnmp) **star:791** 用于执行 SNMP 操作的原生 Go 库。   [![godoc][GoDoc]](https://godoc.org/github.com/soniah/gosnmp)
* [vssh](https://github.com/yahoo/vssh) **star:764** Go库建立网络和服务器自动化的SSH协议。   [![最近一年没有更新][Yellow]](https://github.com/yahoo/vssh)   [![godoc][GoDoc]](https://godoc.org/github.com/yahoo/vssh)
* [cidranger](https://github.com/yl2chen/cidranger) **star:658** 快速得 IP 到 CIDR 查找。   [![godoc][GoDoc]](https://godoc.org/github.com/yl2chen/cidranger)
* [lhttp](https://github.com/fanux/lhttp) **star:656** 强大的websocket框架，可以让你更容易的构建IM服务器。   [![最近一年没有更新][Yellow]](https://github.com/fanux/lhttp)   [![godoc][GoDoc]](https://godoc.org/github.com/fanux/lhttp)   [![包含中文文档][CN]](https://github.com/fanux/lhttp)
* [gmqtt](https://github.com/DrmagicE/gmqtt) **star:557** Gmqtt是一个灵活、高性能的MQTT代理库，它完全实现了MQTT协议V3.1.1。   [![godoc][GoDoc]](https://godoc.org/github.com/DrmagicE/gmqtt)   [![包含中文文档][CN]](https://github.com/DrmagicE/gmqtt)
* [peerdiscovery](https://github.com/schollz/peerdiscovery) **star:521** 基于UDP组播的跨平台本地对等点发现库。   [![godoc][GoDoc]](https://godoc.org/github.com/schollz/peerdiscovery)
* [gotcp](https://github.com/gansidui/gotcp) **star:487** 用于快速编写 tcp 应用程序。   [![最近一年没有更新][Yellow]](https://github.com/gansidui/gotcp)   [![godoc][GoDoc]](https://godoc.org/github.com/gansidui/gotcp)
* [stun](https://github.com/go-rtc/stun) **star:476** Go实现的RFC 5389 STUN协议。   [![godoc][GoDoc]](https://godoc.org/github.com/go-rtc/stun)   [![归档项目][Archived]](https://github.com/go-rtc/stun)
* [go-stun](https://github.com/ccding/go-stun) **star:466** 实现了 STUN 客户端(RFC 3489和RFC 5389)。   [![godoc][GoDoc]](https://godoc.org/github.com/ccding/go-stun)
* [nbio](https://github.com/lesismal/nbio) **star:452** 纯Go 1000k+连接解决方案，支持tls/http1。X /websocket和基本兼容的net/http，具有高性能和低内存成本，无阻塞，事件驱动，易于使用。   [![godoc][GoDoc]](https://godoc.org/github.com/lesismal/nbio)
* [gopcap](https://github.com/akrennmair/gopcap) **star:437**  用 Go 实现了对 libpcap 的封装。   [![godoc][GoDoc]](https://godoc.org/github.com/akrennmair/gopcap)
* [raw](https://github.com/mdlayher/raw) **star:414** Package raw支持在设备驱动程序级别读取和写入网络接口的数据。   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/raw)
* [gaio](https://github.com/xtaci/gaio) **star:412** 高性能异步io网络在proactor模式下的Golang。   [![godoc][GoDoc]](https://godoc.org/github.com/xtaci/gaio)
* [tcp_server](https://github.com/firstrow/tcp_server) **star:406**  Go 图书馆建设tcp服务器更快。   [![godoc][GoDoc]](https://godoc.org/github.com/firstrow/tcp_server)
* [winrm](https://github.com/masterzen/winrm) **star:349**  Go WinRM客户端远程执行Windows机器上的命令。   [![godoc][GoDoc]](https://godoc.org/github.com/masterzen/winrm)
* [ftpserverlib](https://github.com/fclairamb/ftpserverlib) **star:281** 功能齐全的FTP服务器库。   [![最近一周有更新][Green]](https://github.com/fclairamb/ftpserverlib)   [![godoc][GoDoc]](https://godoc.org/github.com/fclairamb/ftpserverlib)
* [arp](https://github.com/mdlayher/arp) **star:268** 实现了arp协议，如RFC 826中所述。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/arp)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/arp)
* [buffstreams](https://github.com/stabbycutyou/buffstreams) **star:246** 通过TCP传输协议缓冲区数据。   [![最近一年没有更新][Yellow]](https://github.com/stabbycutyou/buffstreams)   [![godoc][GoDoc]](https://godoc.org/github.com/stabbycutyou/buffstreams)
* [ethernet](https://github.com/mdlayher/ethernet) **star:236** 实现了对IEEE 802.3以太网II帧和IEEE 802.1Q VLAN标签的编组和解组。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/ethernet)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/ethernet)
* [easytcp](https://github.com/DarthPestilane/easytcp) **star:234** 一个用Go (Golang)编写的轻量级TCP框架，与消息路由器一起构建。EasyTCP可以帮助您轻松、快速地构建TCP服务器，而且不那么痛苦。   [![最近一周有更新][Green]](https://github.com/DarthPestilane/easytcp)   [![godoc][GoDoc]](https://godoc.org/github.com/DarthPestilane/easytcp)
* [gNxI](https://github.com/google/gnxi) **star:200** 一组基于 gNMI 和 gNOI 协议的网络管理工具。   [![最近一周有更新][Green]](https://github.com/google/gnxi)   [![godoc][GoDoc]](https://godoc.org/github.com/google/gnxi)
* [jazigo](https://github.com/udhos/jazigo) **star:172** Jazigo是一个用Go编写的工具，用于检索多个网络设备的配置。   [![最近一年没有更新][Yellow]](https://github.com/udhos/jazigo)   [![godoc][GoDoc]](https://godoc.org/github.com/udhos/jazigo)
* [utp](https://github.com/anacrolix/utp) **star:162** Go uTP微传输协议的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/anacrolix/utp)
* [canopus](https://github.com/zubairhamed/canopus) **star:147** CoAP客户端/服务器实现(RFC 7252)。   [![最近一年没有更新][Yellow]](https://github.com/zubairhamed/canopus)   [![godoc][GoDoc]](https://godoc.org/github.com/zubairhamed/canopus)
* [sslb](https://github.com/eduardonunesp/sslb) **star:134** 它是一个超级简单的负载平衡器，只是一个实现某种性能的小项目。   [![最近一年没有更新][Yellow]](https://github.com/eduardonunesp/sslb)   [![godoc][GoDoc]](https://godoc.org/github.com/eduardonunesp/sslb)
* [xtcp](https://github.com/xfxdev/xtcp) **star:128** TCP服务器框架，同时全双工通信，优雅的关机，和自定义协议。   [![最近一年没有更新][Yellow]](https://github.com/xfxdev/xtcp)   [![godoc][GoDoc]](https://godoc.org/github.com/xfxdev/xtcp)
* [dnsmonster](https://github.com/mosajjal/dnsmonster) **star:127** 被动DNS捕获/监控框架。   [![最近一周有更新][Green]](https://github.com/mosajjal/dnsmonster)   [![godoc][GoDoc]](https://godoc.org/github.com/mosajjal/dnsmonster)
* [ether](https://github.com/songgao/ether) **star:73** 一个用于发送和接收以太网帧的跨平台 Go 库。   [![最近一年没有更新][Yellow]](https://github.com/songgao/ether)   [![godoc][GoDoc]](https://godoc.org/github.com/songgao/ether)
* [dhcp6](https://github.com/mdlayher/dhcp6) **star:71** 实现了一个DHCPv6服务器，如RFC 3315所述。   [![最近一年没有更新][Yellow]](https://github.com/mdlayher/dhcp6)   [![godoc][GoDoc]](https://godoc.org/github.com/mdlayher/dhcp6)
* [iplib](https://github.com/c-robinson/iplib) **star:65** 用于处理IP地址的库(net)。借鉴于python 的 [ipaddress](https://docy-doc.org/3/library/ipaddress.html)和ruby [ipaddr](https://ruby-doc.org/stdlib-2.5.1/libdoc/ipaddr/rdoc/IPAddr.html)   [![godoc][GoDoc]](https://godoc.org/github.com/c-robinson/iplib)
* [packet](https://github.com/aerogo/packet) **star:61** 通过TCP和UDP发送数据包。它可以缓冲消息和热交换连接。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/packet)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/packet)
* [go-powerdns](https://github.com/joeig/go-powerdns) **star:50** Golang的PowerDNS API绑定。   [![godoc][GoDoc]](https://godoc.org/github.com/joeig/go-powerdns)
* [linkio](https://github.com/ian-kent/linkio) **star:49** 网络链路速度模拟，主要用于接口的读/写。   [![最近一年没有更新][Yellow]](https://github.com/ian-kent/linkio)   [![godoc][GoDoc]](https://godoc.org/github.com/ian-kent/linkio)
* [portproxy](https://github.com/aybabtme/portproxy) **star:45** Simple TCP proxy which adds CORS support to API's which don't support it.   [![最近一年没有更新][Yellow]](https://github.com/aybabtme/portproxy)   [![godoc][GoDoc]](https://godoc.org/github.com/aybabtme/portproxy)
* [panoptes-stream](https://github.com/yahoo/panoptes-stream) **star:32** 云本地分布式流媒体网络遥测(gNMI, Juniper JTI和Cisco MDT)。   [![godoc][GoDoc]](https://godoc.org/github.com/yahoo/panoptes-stream)
* [graval](https://github.com/koofr/graval) **star:27** FTP服务器框架。   [![最近一年没有更新][Yellow]](https://github.com/koofr/graval)   [![godoc][GoDoc]](https://godoc.org/github.com/koofr/graval)
* [publicip](https://github.com/polera/publicip) **star:24** 包publicip返回面向公共的IPv4地址(internet出口)。   [![最近一年没有更新][Yellow]](https://github.com/polera/publicip)   [![godoc][GoDoc]](https://godoc.org/github.com/polera/publicip)
* [golibwireshark](https://github.com/sunwxg/golibwireshark) **star:22** 用于解码 pcap 文件和分析解剖数据。   [![最近一年没有更新][Yellow]](https://github.com/sunwxg/golibwireshark)   [![godoc][GoDoc]](https://godoc.org/github.com/sunwxg/golibwireshark)
* [gohooks](https://github.com/averageflow/gohooks) **star:15** gohook使得从Go应用程序发送和使用安全的web钩子变得很容易。灵感来自空间的Laravel Webhook客户端和服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/averageflow/gohooks)
* [goshark](https://github.com/sunwxg/goshark) **star:14** 用于解码IP包，创建用于分析的数据结构包。   [![最近一年没有更新][Yellow]](https://github.com/sunwxg/goshark)   [![godoc][GoDoc]](https://godoc.org/github.com/sunwxg/goshark)
* [httpproxy](https://github.com/wzshiming/httpproxy) **star:11** HTTP代理处理程序和拨号。   [![godoc][GoDoc]](https://godoc.org/github.com/wzshiming/httpproxy)
* [llb](https://github.com/kirillDanshin/llb) **star:11** 一个非常简单、快速的代理服务器后端。可用于快速重定向到预定义域，具有零内存分配和快速响应。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/llb)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/llb)
* [tspool](https://github.com/two/tspool) **star:11** TCP库使用工作池来提高性能并保护服务器。   [![最近一年没有更新][Yellow]](https://github.com/two/tspool)   [![godoc][GoDoc]](https://godoc.org/github.com/two/tspool)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#networking) 吧~)*

### HTTP客户端

*用于发出HTTP请求的库。 (翻译出错了? 试试 [英文版](README_EN.md#http-clients) 吧~)*

* [resty](https://github.com/go-resty/resty) **star:5521** 简单的 HTTP 和 REST 客户端，受到 Ruby rest-client 的启发。   [![star > 2000][Awesome]](https://github.com/go-resty/resty)   [![godoc][GoDoc]](https://godoc.org/github.com/go-resty/resty)
* [heimdall](https://github.com/gojektech/heimdall) **star:2163** 一个增强的http客户端，具有重试和hystrix功能。   [![star > 2000][Awesome]](https://github.com/gojektech/heimdall)   [![godoc][GoDoc]](https://godoc.org/github.com/gojektech/heimdall)
* [grequests](https://github.com/levigross/grequests) **star:1854** 一个 Go “克隆”的伟大和著名的请求库。   [![最近一年没有更新][Yellow]](https://github.com/levigross/grequests)   [![godoc][GoDoc]](https://godoc.org/github.com/levigross/grequests)
* [sling](https://github.com/dghubble/sling) **star:1405** Sling是一个用于创建和发送API请求的Go HTTP客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/dghubble/sling)
* [go-retryablehttp](https://github.com/hashicorp/go-retryablehttp) **star:1071** Go中可重试的HTTP客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/hashicorp/go-retryablehttp)
* [gentleman](https://github.com/h2non/gentleman) **star:933** 功能齐全的插件驱动HTTP客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/gentleman)
* [pester](https://github.com/sethgrid/pester) **star:565** 使用重试、后退和并发执行HTTP客户机调用。   [![最近一周有更新][Green]](https://github.com/sethgrid/pester)   [![godoc][GoDoc]](https://godoc.org/github.com/sethgrid/pester)
* [requests](https://github.com/carlmjohnson/requests) **star:247** gopher的HTTP请求。使用上下文。上下文，并且不隐藏底层的net/http。客户端，使其与标准Go api兼容。还包括测试工具。   [![最近一周有更新][Green]](https://github.com/carlmjohnson/requests)   [![godoc][GoDoc]](https://godoc.org/github.com/carlmjohnson/requests)
* [request](https://github.com/monaco-io/request) **star:156** golang的HTTP客户端。如果您有关于axios或请求的经验，您会喜欢它。没有第三依赖性。   [![godoc][GoDoc]](https://godoc.org/github.com/monaco-io/request)
* [rq](https://github.com/ddo/rq) **star:39** golang stdlib HTTP客户端更好的接口。   [![最近一年没有更新][Yellow]](https://github.com/ddo/rq)   [![godoc][GoDoc]](https://godoc.org/github.com/ddo/rq)
* [go-http-client](https://github.com/bozd4g/go-http-client) **star:33** 简单而容易地进行http调用。   [![godoc][GoDoc]](https://godoc.org/github.com/bozd4g/go-http-client)
* [httpretry](https://github.com/ybbus/httpretry) **star:15** 用重试功能丰富默认的go HTTP客户端。   [![最近一年没有更新][Yellow]](https://github.com/ybbus/httpretry)   [![godoc][GoDoc]](https://godoc.org/github.com/ybbus/httpretry)
* [go-req](https://github.com/wenerme/go-req) **star:12** 声明式golang HTTP客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/wenerme/go-req)
* [httpc](https://github.com/valord577/httpc) **star:3** 一个可定制的简单HTTP客户端库。仅依赖于标准lib HTTP客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/valord577/httpc)   [![归档项目][Archived]](https://github.com/valord577/httpc)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#http-clients) 吧~)*

## OpenGL

*用于在Go中使用OpenGL的库。 (翻译出错了? 试试 [英文版](README_EN.md#opengl) 吧~)*

* [glfw](https://github.com/go-gl/glfw) **star:1204** GLFW 3 的 Go 接口实现。   [![最近一周有更新][Green]](https://github.com/go-gl/glfw)
* [gl](https://github.com/go-gl/gl) **star:865** OpenGL 的 Go 接口实现(通过glow生成)。
* [mathgl](https://github.com/go-gl/mathgl) **star:405** 完全基于 Go 实现的数学软件包，专门用于处理三维数学。借鉴于 GLM。   [![最近一年没有更新][Yellow]](https://github.com/go-gl/mathgl)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gl/mathgl)
* [goxjs/gl](https://github.com/goxjs/gl) **star:154** 跨平台的OpenGL 接口实现(OS X, Linux, Windows，浏览器，iOS, Android)。   [![最近一年没有更新][Yellow]](https://github.com/goxjs/gl)   [![godoc][GoDoc]](https://godoc.org/github.com/goxjs/gl)
* [goxjs/glfw](https://github.com/goxjs/glfw) **star:71** 跨平台 glfw 库，可用于创建 OpenGL 上下文并接收事件。   [![最近一年没有更新][Yellow]](https://github.com/goxjs/glfw)   [![godoc][GoDoc]](https://godoc.org/github.com/goxjs/glfw)
* [go-glmatrix](https://github.com/technohippy/go-glmatrix) **star:2** 进入[glMatrix](https://glmatrix.net/)库的端口。   [![godoc][GoDoc]](https://godoc.org/github.com/technohippy/go-glmatrix)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#opengl) 吧~)*

## ORM

*Libraries that implement Object-Relational Mapping or datamapping techniques. (翻译出错了? 试试 [英文版](README_EN.md#orm) 吧~)*

* [beego orm](https://github.com/beego/beego) **star:27574** 强大的orm框架。支持: pq/mysql/sqlite3。   [![star > 2000][Awesome]](https://github.com/beego/beego)   [![最近一周有更新][Green]](https://github.com/beego/beego)   [![godoc][GoDoc]](https://godoc.org/github.com/beego/beego)
* [GORM](https://github.com/go-gorm/gorm) **star:26526** 一个出色的 ORM 库。主要目标是对开发人员友好。   [![star > 2000][Awesome]](https://github.com/go-gorm/gorm)   [![最近一周有更新][Green]](https://github.com/go-gorm/gorm)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gorm/gorm)
* [ent](https://github.com/facebook/ent) **star:9640** 一个用于Go的实体框架。用于建模和查询数据的简单而强大的ORM。   [![star > 2000][Awesome]](https://github.com/facebook/ent)   [![最近一周有更新][Green]](https://github.com/facebook/ent)   [![godoc][GoDoc]](https://godoc.org/github.com/facebook/ent)
* [go-pg](https://github.com/go-pg/pg) **star:4958** 用于 PostgreSQL 的ORM。侧重于 PostgreSQL 的特性和性能。   [![star > 2000][Awesome]](https://github.com/go-pg/pg)   [![godoc][GoDoc]](https://godoc.org/github.com/go-pg/pg)
* [SQLBoiler](https://github.com/volatiletech/sqlboiler) **star:4568** ORM 生成器。根据数据库 schema 生成一个功能强大且运行速度快的ORM。   [![star > 2000][Awesome]](https://github.com/volatiletech/sqlboiler)   [![最近一周有更新][Green]](https://github.com/volatiletech/sqlboiler)   [![godoc][GoDoc]](https://godoc.org/github.com/volatiletech/sqlboiler)
* [gorp](https://github.com/go-gorp/gorp) **star:3546** 基于 Go 的关系持久性 ORM-ish 库。   [![star > 2000][Awesome]](https://github.com/go-gorp/gorp)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gorp/gorp)
* [upper.io/db](https://github.com/upper/db) **star:2872** 对外提供统一的接口用于访问不同的存储介质，例如PostgreSQL, MySQL, SQLite, MSSQL, QL、MongoDB.。   [![star > 2000][Awesome]](https://github.com/upper/db)   [![godoc][GoDoc]](https://godoc.org/github.com/upper/db)
* [XORM](https://gitea.com/xorm/xorm)  简单而强大的ORM for Go。(支持:MySQL, MyMysql, PostgreSQL, Tidb, SQLite3, MsSql和Oracle)。
* [gormt](https://github.com/xxjwxc/gormt) **star:1639** Mysql数据库到golang gorm结构。   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/gormt)
* [reform](https://github.com/go-reform/reform) **star:1218** 基于非空接口和代码生成的 ORM。   [![最近一周有更新][Green]](https://github.com/go-reform/reform)   [![godoc][GoDoc]](https://godoc.org/github.com/go-reform/reform)
* [pop/soda](https://github.com/gobuffalo/pop) **star:1158** 数据库迁移、创建、ORM等。用于MySQL、PostgreSQL和SQLite。   [![最近一周有更新][Green]](https://github.com/gobuffalo/pop)   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/pop)
* [Prisma](https://github.com/prisma/prisma-client-go) **star:1101** Prisma客户端Go，类型安全的数据库访问。   [![godoc][GoDoc]](https://godoc.org/github.com/prisma/prisma-client-go)
* [go-sqlbuilder](https://github.com/huandu/go-sqlbuilder) **star:691** 一个灵活而强大的SQL字符串构建器库。   [![godoc][GoDoc]](https://godoc.org/github.com/huandu/go-sqlbuilder)
* [go-queryset](https://github.com/jirfag/go-queryset) **star:646** 基于 GORM 100% 类型安全的 ORM。可支持 MySQL, PostgreSQL, Sqlite3, SQL Server。   [![godoc][GoDoc]](https://godoc.org/github.com/jirfag/go-queryset)
* [rel](https://github.com/go-rel/rel) **star:470** Golang的现代数据库访问层——可测试、可扩展，并精心设计成一个干净优雅的API。   [![godoc][GoDoc]](https://godoc.org/github.com/go-rel/rel)
* [Zoom](https://github.com/albrow/zoom) **star:284** 基于 Redis 的快速数据存储和查询引擎。   [![最近一年没有更新][Yellow]](https://github.com/albrow/zoom)   [![godoc][GoDoc]](https://godoc.org/github.com/albrow/zoom)
* [grimoire](https://github.com/Fs02/grimoire) **star:156** 基于 golang 的数据库访问层和验证库。(支持: MySQL, PostgreSQL和SQLite3)。   [![godoc][GoDoc]](https://godoc.org/github.com/Fs02/grimoire)
* [go-sql](https://github.com/rushteam/gosql) **star:151** 一个简单的ORM为mysql。   [![godoc][GoDoc]](https://godoc.org/github.com/rushteam/gosql)
* [go-store](https://github.com/gosuri/go-store) **star:106** 简单且快速的 Redis 键值存储库。   [![最近一年没有更新][Yellow]](https://github.com/gosuri/go-store)   [![godoc][GoDoc]](https://godoc.org/github.com/gosuri/go-store)
* [go-firestorm](https://github.com/jschoedt/go-firestorm) **star:26** 一个轻量级的ORM。用于Google/Firebase Cloud Firestore。   [![godoc][GoDoc]](https://godoc.org/github.com/jschoedt/go-firestorm)
* [cacheme](https://github.com/Yiling-J/cacheme-go) **star:17** 基于模式的，类型化的Redis缓存/记忆框架。   [![godoc][GoDoc]](https://godoc.org/github.com/Yiling-J/cacheme-go)   [![包含中文文档][CN]](https://github.com/Yiling-J/cacheme-go)
* [lore](https://github.com/abrahambotros/lore) **star:10** Simple and lightweight pseudo-ORM/pseudo-struct-mapping environment for Go.   [![最近一年没有更新][Yellow]](https://github.com/abrahambotros/lore)   [![godoc][GoDoc]](https://godoc.org/github.com/abrahambotros/lore)
* [marlow](https://github.com/marlow/marlow) **star:9** 从项目结构生成ORM。   [![最近一年没有更新][Yellow]](https://github.com/marlow/marlow)   [![godoc][GoDoc]](https://godoc.org/github.com/marlow/marlow)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#orm) 吧~)*

## 包管理

*用于管理依赖和包的官方工具 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

* [go modules](https://golang.org/cmd/go/#hdr-Modules__module_versions__and_more)  Modules 是源码的版本控制和交换的单位。go命令直接支持处理模块，包括记录和解决对其他模块的依赖关系。

*包管理的官方实验工具 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

* [dep](https://github.com/golang/dep) **star:13095**  Go 的依赖管理工具，需要 Go 1.9+   [![star > 2000][Awesome]](https://github.com/golang/dep)   [![最近一年没有更新][Yellow]](https://github.com/golang/dep)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/dep)   [![归档项目][Archived]](https://github.com/golang/dep)
* [vgo](https://go.googlesource.com/vgo/)  Go 命令版本管理

*用于包和依赖项管理的非官方库。 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

* [glide](https://github.com/Masterminds/glide) **star:8142** 轻松管理您的 golang 第三方包。受Maven、Bundler和Pip等工具的启发。   [![star > 2000][Awesome]](https://github.com/Masterminds/glide)   [![godoc][GoDoc]](https://godoc.org/github.com/Masterminds/glide)
* [godep](https://github.com/tools/godep) **star:5606** godep是go的依赖工具，它通过修复包的依赖关系来帮助构建可重复的包。   [![star > 2000][Awesome]](https://github.com/tools/godep)   [![最近一年没有更新][Yellow]](https://github.com/tools/godep)   [![godoc][GoDoc]](https://godoc.org/github.com/tools/godep)   [![归档项目][Archived]](https://github.com/tools/godep)
* [govendor](https://github.com/kardianos/govendor) **star:4986** 包管理器。使用 vendor 文件的 Go vendor 工具。   [![star > 2000][Awesome]](https://github.com/kardianos/govendor)   [![最近一年没有更新][Yellow]](https://github.com/kardianos/govendor)   [![godoc][GoDoc]](https://godoc.org/github.com/kardianos/govendor)   [![归档项目][Archived]](https://github.com/kardianos/govendor)
* [gopm](https://github.com/gpmgo/gopm) **star:2492** 包管理器。   [![star > 2000][Awesome]](https://github.com/gpmgo/gopm)   [![最近一年没有更新][Yellow]](https://github.com/gpmgo/gopm)   [![godoc][GoDoc]](https://godoc.org/github.com/gpmgo/gopm)   [![归档项目][Archived]](https://github.com/gpmgo/gopm)
* [gom](https://github.com/mattn/gom) **star:1396** Go Manager - bundle for Go。   [![最近一年没有更新][Yellow]](https://github.com/mattn/gom)   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/gom)   [![归档项目][Archived]](https://github.com/mattn/gom)
* [gpm](https://github.com/pote/gpm) **star:1200** 基本的 Go 依赖管理器。   [![最近一年没有更新][Yellow]](https://github.com/pote/gpm)
* [goop](https://github.com/nitrous-io/goop) **star:779** Go 的简单依赖管理器，灵感来自Bundler。   [![最近一年没有更新][Yellow]](https://github.com/nitrous-io/goop)   [![godoc][GoDoc]](https://godoc.org/github.com/nitrous-io/goop)
* [modgv](https://github.com/lucasepe/modgv) **star:400** 将'go mod graph'输出转换为Graphviz的点语言。   [![最近一年没有更新][Yellow]](https://github.com/lucasepe/modgv)   [![godoc][GoDoc]](https://godoc.org/github.com/lucasepe/modgv)
* [nut](https://github.com/jingweno/nut) **star:238** vendor 依赖。   [![最近一年没有更新][Yellow]](https://github.com/jingweno/nut)   [![godoc][GoDoc]](https://godoc.org/github.com/jingweno/nut)
* [johnny-deps](https://github.com/VividCortex/johnny-deps) **star:212** 使用Git的最小依赖版本。   [![最近一年没有更新][Yellow]](https://github.com/VividCortex/johnny-deps)
* [mvn-golang](https://github.com/raydac/mvn-golang) **star:131** 插件，为自动加载Golang SDK，依赖关系管理和启动Maven项目基础设施中的构建环境提供了方法。
* [VenGO](https://github.com/DamnWidget/VenGO) **star:120** 创建和管理可导出的隔离go虚拟环境。   [![最近一年没有更新][Yellow]](https://github.com/DamnWidget/VenGO)   [![godoc][GoDoc]](https://godoc.org/github.com/DamnWidget/VenGO)
* [gop](https://github.com/lunny/gop) **star:48** 在GOPATH之外构建和管理Go应用程序。   [![最近一年没有更新][Yellow]](https://github.com/lunny/gop)   [![godoc][GoDoc]](https://godoc.org/github.com/lunny/gop)   [![包含中文文档][CN]](https://github.com/lunny/gop)   [![归档项目][Archived]](https://github.com/lunny/gop)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)*

## 性能

* [jaeger](https://github.com/jaegertracing/jaeger) **star:15008** 分布式跟踪系统。   [![star > 2000][Awesome]](https://github.com/jaegertracing/jaeger)   [![最近一周有更新][Green]](https://github.com/jaegertracing/jaeger)   [![godoc][GoDoc]](https://godoc.org/github.com/jaegertracing/jaeger)
* [pixie](https://github.com/pixie-labs/pixie) **star:2736** 通过eBPF对Golang应用程序没有检测跟踪。   [![star > 2000][Awesome]](https://github.com/pixie-labs/pixie)   [![最近一周有更新][Green]](https://github.com/pixie-labs/pixie)
* [statsviz](https://github.com/arl/statsviz) **star:1755** 实时可视化您的Go应用程序运行时统计数据。   [![godoc][GoDoc]](https://godoc.org/github.com/arl/statsviz)
* [profile](https://github.com/pkg/profile) **star:1645** Go的简单分析支持包。   [![godoc][GoDoc]](https://godoc.org/github.com/pkg/profile)
* [tracer](https://github.com/kamilsk/tracer) **star:61** 简单、轻量级的跟踪。   [![godoc][GoDoc]](https://godoc.org/github.com/kamilsk/tracer)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#performance) 吧~)*

## 查询语言

* [graphql-go](https://github.com/graphql-go/graphql) **star:8243** 为Go实现GraphQL。   [![star > 2000][Awesome]](https://github.com/graphql-go/graphql)   [![最近一周有更新][Green]](https://github.com/graphql-go/graphql)   [![godoc][GoDoc]](https://godoc.org/github.com/graphql-go/graphql)
* [gqlgen](https://github.com/99designs/gqlgen) **star:6983** 去生成基于graphql服务器库。   [![star > 2000][Awesome]](https://github.com/99designs/gqlgen)   [![最近一周有更新][Green]](https://github.com/99designs/gqlgen)   [![godoc][GoDoc]](https://godoc.org/github.com/99designs/gqlgen)
* [graphql](https://github.com/neelance/graphql-go) **star:4021** 关注易用性的GraphQL服务器。   [![star > 2000][Awesome]](https://github.com/neelance/graphql-go)   [![godoc][GoDoc]](https://godoc.org/github.com/neelance/graphql-go)
* [gojsonq](https://github.com/thedevsaddam/gojsonq) **star:1803** 一个用来查询JSON数据的Go包。   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/gojsonq)
* [dasel](https://github.com/tomwright/dasel) **star:1755** 使用命令行中的选择器查询和更新数据结构。与jq/yq类似，但支持JSON、YAML、TOML和XML，运行时依赖关系为零。   [![godoc][GoDoc]](https://godoc.org/github.com/tomwright/dasel)
* [jsonql](https://github.com/elgs/jsonql) **star:248** Golang中的JSON查询表达式库。   [![最近一年没有更新][Yellow]](https://github.com/elgs/jsonql)   [![godoc][GoDoc]](https://godoc.org/github.com/elgs/jsonql)
* [rql](https://github.com/a8m/rql) **star:243** 用于REST API的资源查询语言。   [![最近一周有更新][Green]](https://github.com/a8m/rql)   [![godoc][GoDoc]](https://godoc.org/github.com/a8m/rql)
* [jsonslice](https://github.com/bhmj/jsonslice) **star:59** 使用高级过滤器查询Jsonpath。   [![godoc][GoDoc]](https://godoc.org/github.com/bhmj/jsonslice)
* [graphql](https://github.com/tmc/graphql) **star:54** graphql解析器+工具集   [![最近一年没有更新][Yellow]](https://github.com/tmc/graphql)   [![godoc][GoDoc]](https://godoc.org/github.com/tmc/graphql)
* [api-fu](https://github.com/ccbrown/api-fu) **star:37** 综合GraphQL实现。   [![godoc][GoDoc]](https://godoc.org/github.com/ccbrown/api-fu)
* [straf](https://github.com/SonicRoshan/straf) **star:32** 轻松地将Golang结构转换为GraphQL对象。   [![最近一年没有更新][Yellow]](https://github.com/SonicRoshan/straf)   [![godoc][GoDoc]](https://godoc.org/github.com/SonicRoshan/straf)
* [rqp](https://github.com/timsolov/rest-query-parser) **star:29** REST API的查询解析器。查询中直接支持筛选、验证、'和'或'操作。   [![godoc][GoDoc]](https://godoc.org/github.com/timsolov/rest-query-parser)
* [jsonpath](https://github.com/AsaiYusuke/jsonpath) **star:9** 一个基于JSONPath语法检索部分JSON的查询库。   [![godoc][GoDoc]](https://godoc.org/github.com/AsaiYusuke/jsonpath)
* [gws](https://github.com/Zaba505/gws) **star:4** Apollos的“GraphQL over Websocket”客户端和服务器实现。   [![最近一年没有更新][Yellow]](https://github.com/Zaba505/gws)   [![godoc][GoDoc]](https://godoc.org/github.com/Zaba505/gws)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#query-language) 吧~)*

## 嵌入的资源

* [statik](https://github.com/rakyll/statik) **star:3361** 将静态文件嵌入到Go可执行文件中。   [![star > 2000][Awesome]](https://github.com/rakyll/statik)   [![最近一年没有更新][Yellow]](https://github.com/rakyll/statik)   [![godoc][GoDoc]](https://godoc.org/github.com/rakyll/statik)
* [packr](https://github.com/gobuffalo/packr) **star:3344** 将静态文件嵌入到Go二进制文件中的简单方法。   [![star > 2000][Awesome]](https://github.com/gobuffalo/packr)   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/packr)
* [go.rice](https://github.com/GeertJohan/go.rice) **star:2267** 走了。rice是一个Go包，它使得处理HTML、JS、CSS、图像和模板等资源非常容易。   [![star > 2000][Awesome]](https://github.com/GeertJohan/go.rice)   [![godoc][GoDoc]](https://godoc.org/github.com/GeertJohan/go.rice)
* [vfsgen](https://github.com/shurcooL/vfsgen) **star:936** 生成一个vfsdata。静态实现给定虚拟文件系统的go文件。   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/vfsgen)
* [esc](https://github.com/mjibson/esc) **star:605** 将文件嵌入到Go程序中并提供http文件系统接口。   [![最近一年没有更新][Yellow]](https://github.com/mjibson/esc)   [![godoc][GoDoc]](https://godoc.org/github.com/mjibson/esc)
* [fileb0x](https://github.com/UnnoTed/fileb0x) **star:601** 一个可定制的工具用来在Go中嵌入文件   [![godoc][GoDoc]](https://godoc.org/github.com/UnnoTed/fileb0x)
* [go-resources](https://github.com/omeid/go-resources) **star:173** 嵌入到Go中的普通资源。   [![godoc][GoDoc]](https://godoc.org/github.com/omeid/go-resources)
* [statics](https://github.com/go-playground/statics) **star:64** 将静态资源嵌入到go文件中，用于单个二进制编译+使用http。文件系统+符号链接。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/statics)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/statics)
* [templify](https://github.com/wlbr/templify) **star:26** 将外部模板文件嵌入到Go代码中，以创建单个文件二进制文件。   [![godoc][GoDoc]](https://godoc.org/github.com/wlbr/templify)
* [rebed](https://github.com/soypat/rebed) **star:19** 重新创建Go 1.16' embed中的文件夹结构和文件。FS的类型   [![godoc][GoDoc]](https://godoc.org/github.com/soypat/rebed)
* [debme](https://github.com/leaanthony/debme) **star:13** 创建一个“嵌入。FS '从一个现有的'嵌入。FS的子目录。   [![godoc][GoDoc]](https://godoc.org/github.com/leaanthony/debme)
* [mule](https://github.com/wlbr/mule) **star:9** 嵌入外部资源，如图像，电影…   [![godoc][GoDoc]](https://godoc.org/github.com/wlbr/mule)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#resource-embedding) 吧~)*

## 科学与数据分析

*用于科学计算和数据分析的库。 (翻译出错了? 试试 [英文版](README_EN.md#science-and-data-analysis) 吧~)*

* [gonum](https://github.com/gonum/gonum) **star:5436** Gonum是一组用于Go编程语言的数字库。它包含用于矩阵、统计、优化等的库。   [![star > 2000][Awesome]](https://github.com/gonum/gonum)   [![最近一周有更新][Green]](https://github.com/gonum/gonum)   [![godoc][GoDoc]](https://godoc.org/github.com/gonum/gonum)
* [stats](https://github.com/montanaflynn/stats) **star:2215** 包含Golang标准库中缺少的公共函数的统计软件包。   [![star > 2000][Awesome]](https://github.com/montanaflynn/stats)   [![godoc][GoDoc]](https://godoc.org/github.com/montanaflynn/stats)
* [gonum/plot](https://github.com/gonum/plot) **star:2085** gonum/plot提供了一个API，用于在Go中构建和绘制绘图。   [![star > 2000][Awesome]](https://github.com/gonum/plot)   [![godoc][GoDoc]](https://godoc.org/github.com/gonum/plot)
* [gosl](https://github.com/cpmech/gosl) **star:1636** 提供线性代数，FFT，几何，NURBS，数值方法，概率，优化，微分方程，等等。   [![godoc][GoDoc]](https://godoc.org/github.com/cpmech/gosl)
* [streamtools](https://github.com/nytlabs/streamtools) **star:1317** 通用图形工具，用于处理数据流。   [![最近一年没有更新][Yellow]](https://github.com/nytlabs/streamtools)   [![godoc][GoDoc]](https://godoc.org/github.com/nytlabs/streamtools)
* [go-dsp](https://github.com/mjibson/go-dsp) **star:762** Go数字信号处理。   [![最近一年没有更新][Yellow]](https://github.com/mjibson/go-dsp)   [![godoc][GoDoc]](https://godoc.org/github.com/mjibson/go-dsp)
* [dataframe-go](https://github.com/rocketlaunchr/dataframe-go) **star:729** 用于机器学习和统计的数据框架(类似于panda)。   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/dataframe-go)
* [chart](https://github.com/vdobler/chart) **star:711** 简单的图表绘制库。支持多种图形类型。   [![godoc][GoDoc]](https://godoc.org/github.com/vdobler/chart)
* [goraph](https://github.com/gyuho/goraph) **star:652** 纯围棋图论库(数据结构，算法可视化)。   [![最近一年没有更新][Yellow]](https://github.com/gyuho/goraph)   [![godoc][GoDoc]](https://godoc.org/github.com/gyuho/goraph)
* [graph](https://github.com/yourbasic/graph) **star:512** 基本图形算法库。   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/graph)
* [orb](https://github.com/paulmach/orb) **star:463** 2D几何类型，支持剪切、GeoJSON和Mapbox矢量平铺。   [![godoc][GoDoc]](https://godoc.org/github.com/paulmach/orb)
* [ewma](https://github.com/VividCortex/ewma) **star:343** 提供指数加权移动平均算法。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/ewma)
* [calendarheatmap](https://github.com/nikolaydubina/calendarheatmap) **star:332** 基于Github贡献活动的日历热图。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/calendarheatmap)
* [gohistogram](https://github.com/VividCortex/gohistogram) **star:158** 数据流的近似直方图。   [![最近一年没有更新][Yellow]](https://github.com/VividCortex/gohistogram)   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/gohistogram)
* [TextRank](https://github.com/DavidBelicza/TextRank) **star:148** TextRank在Golang中的实现，支持扩展特性(摘要、加权、短语提取)和多线程(goroutine)。   [![godoc][GoDoc]](https://godoc.org/github.com/DavidBelicza/TextRank)
* [sparse](https://github.com/james-bowman/sparse) **star:124**  Go 稀疏矩阵格式的线性代数支持科学和机器学习应用程序，兼容gonum矩阵库。   [![godoc][GoDoc]](https://godoc.org/github.com/james-bowman/sparse)
* [go-estimate](https://github.com/milosgajdos/go-estimate) **star:89** Go中的状态估计和滤波算法。   [![godoc][GoDoc]](https://godoc.org/github.com/milosgajdos/go-estimate)
* [pagerank](https://github.com/alixaxel/pagerank) **star:72** 加权 PageRank 算法在Go中的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/alixaxel/pagerank)
* [jsonl-graph](https://github.com/nikolaydubina/jsonl-graph) **star:54** 使用graphviz支持操作JSONL图形的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/jsonl-graph)
* [geom](https://github.com/skelterjohn/geom) **star:49**  Go 的二维几何。   [![最近一年没有更新][Yellow]](https://github.com/skelterjohn/geom)   [![godoc][GoDoc]](https://godoc.org/github.com/skelterjohn/geom)
* [evaler](https://github.com/soniah/evaler) **star:46** 简单的浮点算术表达式求值器。   [![最近一年没有更新][Yellow]](https://github.com/soniah/evaler)   [![godoc][GoDoc]](https://godoc.org/github.com/soniah/evaler)
* [goent](https://github.com/kzahedi/goent) **star:25**  Go 实现熵度量。   [![最近一年没有更新][Yellow]](https://github.com/kzahedi/goent)   [![godoc][GoDoc]](https://godoc.org/github.com/kzahedi/goent)
* [triangolatte](https://github.com/tchayen/triangolatte) **star:24** 二维三角库。允许将线和多边形(都基于点)转换为gpu语言。   [![godoc][GoDoc]](https://godoc.org/github.com/tchayen/triangolatte)
* [decimal](https://github.com/db47h/decimal) **star:23** Package decimal实现任意精度的十进制浮点运算。   [![最近一年没有更新][Yellow]](https://github.com/db47h/decimal)   [![godoc][GoDoc]](https://godoc.org/github.com/db47h/decimal)
* [piecewiselinear](https://github.com/sgreben/piecewiselinear) **star:20** 微型线性插值库。   [![最近一年没有更新][Yellow]](https://github.com/sgreben/piecewiselinear)   [![godoc][GoDoc]](https://godoc.org/github.com/sgreben/piecewiselinear)
* [GoStats](https://github.com/OGFris/GoStats) **star:18** GoStats是一个开放源码的GoLang库，主要用于机器学习领域的数学统计，它涵盖了大多数统计度量函数。   [![最近一年没有更新][Yellow]](https://github.com/OGFris/GoStats)   [![godoc][GoDoc]](https://godoc.org/github.com/OGFris/GoStats)
* [godesim](https://github.com/soypat/godesim) **star:17** 扩展/多变量ODE求解器框架，用于基于事件的模拟与简单的API。   [![godoc][GoDoc]](https://godoc.org/github.com/soypat/godesim)
* [PiHex](https://github.com/claygod/PiHex) **star:14** 实现了针对16进制数 Pi 的“bailee - borwein - plouffe”算法。   [![最近一年没有更新][Yellow]](https://github.com/claygod/PiHex)   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/PiHex)
* [ode](https://github.com/ChristopherRabotin/ode) **star:13** 常微分方程(ODE)求解器，支持扩展状态和基于信道的迭代停止条件。   [![最近一年没有更新][Yellow]](https://github.com/ChristopherRabotin/ode)   [![godoc][GoDoc]](https://godoc.org/github.com/ChristopherRabotin/ode)
* [rootfinding](https://github.com/khezen/rootfinding) **star:6** 二次函数求根算法库。   [![最近一年没有更新][Yellow]](https://github.com/khezen/rootfinding)   [![godoc][GoDoc]](https://godoc.org/github.com/khezen/rootfinding)
* [assocentity](https://github.com/ndabAP/assocentity) **star:5** assocentity 返回单词到给定实体的平均距离。   [![最近一年没有更新][Yellow]](https://github.com/ndabAP/assocentity)   [![godoc][GoDoc]](https://godoc.org/github.com/ndabAP/assocentity)
* [go-gt](https://github.com/ThePaw/go-gt) **star:5** 用“Go”语言编写的图论算法。   [![最近一年没有更新][Yellow]](https://github.com/ThePaw/go-gt)   [![godoc][GoDoc]](https://godoc.org/github.com/ThePaw/go-gt)
* [bradleyterry](https://github.com/seanhagen/bradleyterry) **star:4** 为成对比较提供了一个 Bradley-Terry 模型。   [![最近一年没有更新][Yellow]](https://github.com/seanhagen/bradleyterry)   [![godoc][GoDoc]](https://godoc.org/github.com/seanhagen/bradleyterry)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#science-and-data-analysis) 吧~)*

## 安全

*用于帮助您的应用程序更安全的库。 (翻译出错了? 试试 [英文版](README_EN.md#security) 吧~)*

* [age](https://github.com/FiloSottile/age) **star:9716** 一个简单、现代和安全的加密工具(和Go库)，具有小的显式密钥，没有配置选项，并且具有unix风格的可组合性。   [![star > 2000][Awesome]](https://github.com/FiloSottile/age)   [![最近一周有更新][Green]](https://github.com/FiloSottile/age)   [![godoc][GoDoc]](https://godoc.org/github.com/FiloSottile/age)
* [lego](https://github.com/go-acme/lego) **star:5043** 纯 Go ACME 客户端库及命令行工具   [![star > 2000][Awesome]](https://github.com/go-acme/lego)   [![最近一周有更新][Green]](https://github.com/go-acme/lego)   [![godoc][GoDoc]](https://godoc.org/github.com/go-acme/lego)
* [CertMagic](https://github.com/caddyserver/certmagic) **star:3885** 成熟、健壮和强大的ACME客户端集成，用于完全托管的TLS证书颁发和续签。   [![star > 2000][Awesome]](https://github.com/caddyserver/certmagic)   [![godoc][GoDoc]](https://godoc.org/github.com/caddyserver/certmagic)
* [Cameradar](https://github.com/Ullaakut/cameradar) **star:2798** 工具和库，以远程入侵RTSP流从监控摄像头。   [![star > 2000][Awesome]](https://github.com/Ullaakut/cameradar)   [![godoc][GoDoc]](https://godoc.org/github.com/Ullaakut/cameradar)
* [memguard](https://github.com/awnumar/memguard) **star:2042** 一个用于处理内存中敏感值的纯Go库。   [![star > 2000][Awesome]](https://github.com/awnumar/memguard)   [![godoc][GoDoc]](https://godoc.org/github.com/awnumar/memguard)
* [acmetool](https://github.com/hlandau/acme) **star:1886** ACME(让我们用自动更新加密)客户端工具。   [![godoc][GoDoc]](https://godoc.org/github.com/hlandau/acme)
* [secure](https://github.com/unrolled/secure) **star:1866** Go 语言 HTTP 中间件，为 Go 提供了一些安全功能   [![godoc][GoDoc]](https://godoc.org/github.com/unrolled/secure)
* [themis](https://github.com/cossacklabs/themis) **star:1412** 用于解决典型数据安全任务(安全数据存储、安全消息传递、零知识证明认证)的高级加密库，可用于14种语言，最适合多平台应用程序。
* [acra](https://github.com/cossacklabs/acra) **star:915** 网络加密代理保护基于数据库的应用程序免受数据泄漏:强选择性加密，SQL注入预防，入侵检测系统。   [![最近一周有更新][Green]](https://github.com/cossacklabs/acra)   [![godoc][GoDoc]](https://godoc.org/github.com/cossacklabs/acra)
* [nacl](https://github.com/kevinburke/nacl) **star:518**  Go 实现NaCL API的集合。   [![godoc][GoDoc]](https://godoc.org/github.com/kevinburke/nacl)
* [ssh-vault](https://github.com/ssh-vault/ssh-vault) **star:331** 使用ssh密钥加密/解密。   [![godoc][GoDoc]](https://godoc.org/github.com/ssh-vault/ssh-vault)
* [firewalld-rest](https://github.com/prashantgupta24/firewalld-rest) **star:312** 用于动态更新linux服务器上的firewalld规则的rest应用程序。   [![最近一年没有更新][Yellow]](https://github.com/prashantgupta24/firewalld-rest)   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/firewalld-rest)
* [go-password-validator](https://github.com/lane-c-wagner/go-password-validator) **star:310** 基于原始密码熵值的密码验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/lane-c-wagner/go-password-validator)
* [BadActor](https://github.com/jaredfolkins/badactor) **star:304** 一个驻留在内存中的，应用驱动的监控程序，受 fail2ban 的启发   [![最近一年没有更新][Yellow]](https://github.com/jaredfolkins/badactor)   [![godoc][GoDoc]](https://godoc.org/github.com/jaredfolkins/badactor)
* [optimus-go](https://github.com/pjebs/optimus-go) **star:297** 使用Knuth的算法进行ID哈希和混淆。   [![最近一年没有更新][Yellow]](https://github.com/pjebs/optimus-go)   [![godoc][GoDoc]](https://godoc.org/github.com/pjebs/optimus-go)
* [passlib](https://github.com/hlandau/passlib) **star:260** 不过时的密码哈希库。   [![godoc][GoDoc]](https://godoc.org/github.com/hlandau/passlib)
* [go-yara](https://github.com/hillu/go-yara) **star:240** YARA的 Go 语言接口，号称是 “对于恶意软件研究者（以及其他人）来说是模式匹配的瑞士军刀”   [![godoc][GoDoc]](https://godoc.org/github.com/hillu/go-yara)
* [simple-scrypt](https://github.com/elithrar/simple-scrypt) **star:173** Scrypt 库，具有简单、易懂的 API，同时具有内置的自动校准功能   [![godoc][GoDoc]](https://godoc.org/github.com/elithrar/simple-scrypt)
* [argon2pw](https://github.com/raja/argon2pw) **star:88** 使用常量时间密码比较生成Argon2密码散列。   [![godoc][GoDoc]](https://godoc.org/github.com/raja/argon2pw)
* [autocert](https://godoc.org/golang.org/x/crypto/acme/autocert)  让我们加密证书并启动TLS服务器。
* [dongle](https://github.com/golang-module/dongle) **star:69** 一个简单的，语义和开发人员友好的golang包的编码和解码和加密和解密。   [![godoc][GoDoc]](https://godoc.org/github.com/golang-module/dongle)   [![包含中文文档][CN]](https://github.com/golang-module/dongle)
* [goSecretBoxPassword](https://github.com/dwin/goSecretBoxPassword) **star:44** 一个安全哈希和加密密码的偏执包。   [![最近一年没有更新][Yellow]](https://github.com/dwin/goSecretBoxPassword)   [![godoc][GoDoc]](https://godoc.org/github.com/dwin/goSecretBoxPassword)
* [Interpol](https://bitbucket.org/vahidi/interpol)  基于规则的数据生成器，用于模糊和渗透测试。
* [go-generate-password](https://github.com/m1/go-generate-password) **star:29** 可以在cli上或作为库使用的密码生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/m1/go-generate-password)
* [secureio](https://github.com/xaionaro-go/secureio) **star:22** 一个密钥交换+认证+加密的包装和多路复用的' io。读写ecloser '基于XChaCha20-poly1305, ECDH和ED25519。   [![最近一年没有更新][Yellow]](https://github.com/xaionaro-go/secureio)   [![godoc][GoDoc]](https://godoc.org/github.com/xaionaro-go/secureio)
* [certificates](https://github.com/mvmaasakkers/certificates) **star:21** 用于生成tls证书的自定义工具。   [![最近一年没有更新][Yellow]](https://github.com/mvmaasakkers/certificates)   [![godoc][GoDoc]](https://godoc.org/github.com/mvmaasakkers/certificates)
* [go-htpasswd](https://github.com/tg123/go-htpasswd) **star:19** Apache htpasswd解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/tg123/go-htpasswd)
* [argon2-hashing](https://github.com/andskur/argon2-hashing) **star:15** 轻包装周围的Go的argon2包，它与Go的标准库Bcrypt和simple-scrypt包密切镜像。   [![最近一年没有更新][Yellow]](https://github.com/andskur/argon2-hashing)   [![godoc][GoDoc]](https://godoc.org/github.com/andskur/argon2-hashing)
* [goArgonPass](https://github.com/dwin/goArgonPass) **star:13** Argon2密码散列和验证设计为与现有Python和PHP实现兼容。   [![最近一年没有更新][Yellow]](https://github.com/dwin/goArgonPass)   [![godoc][GoDoc]](https://godoc.org/github.com/dwin/goArgonPass)
* [sslmgr](https://github.com/adrianosela/sslmgr) **star:11** 使用围绕acme/autocert的高级包装器，SSL证书变得很容易。   [![最近一年没有更新][Yellow]](https://github.com/adrianosela/sslmgr)   [![godoc][GoDoc]](https://godoc.org/github.com/adrianosela/sslmgr)


**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#security) 吧~)*

## 序列化

*用于二进制序列化的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#serialization) 吧~)*

* [jsoniter](https://github.com/json-iterator/go) **star:10377** 高性能，100% 兼容的“encoding/json” 替代品   [![star > 2000][Awesome]](https://github.com/json-iterator/go)   [![最近一周有更新][Green]](https://github.com/json-iterator/go)   [![godoc][GoDoc]](https://godoc.org/github.com/json-iterator/go)
* [goprotobuf](https://github.com/golang/protobuf) **star:8180** 通过库和协议编译器插件使 Go 语言支持 Google的 protocol buffers.   [![star > 2000][Awesome]](https://github.com/golang/protobuf)   [![最近一周有更新][Green]](https://github.com/golang/protobuf)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/protobuf)
* [mapstructure](https://github.com/mitchellh/mapstructure) **star:5281** 用于对原生键值对进行解码生成 Go 语言结构体   [![star > 2000][Awesome]](https://github.com/mitchellh/mapstructure)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/mapstructure)
* [gogoprotobuf](https://github.com/gogo/protobuf) **star:5040** Go 语言的 Protocol Buffer 库。   [![star > 2000][Awesome]](https://github.com/gogo/protobuf)   [![最近一周有更新][Green]](https://github.com/gogo/protobuf)   [![godoc][GoDoc]](https://godoc.org/github.com/gogo/protobuf)
* [go-codec](https://github.com/ugorji/go) **star:1617** 高性能、多功能、规范化编码解码以及 rpc 库， 用于 msgpack, cbor 和 json，支持基于运行时的 OR 码生成   [![godoc][GoDoc]](https://godoc.org/github.com/ugorji/go)
* [csvutil](https://github.com/jszwec/csvutil) **star:651** 高性能、惯用的CSV记录编码和解码到本机Go结构。   [![godoc][GoDoc]](https://godoc.org/github.com/jszwec/csvutil)
* [colfer](https://github.com/pascaldekloe/colfer) **star:645** 为Colfer二进制格式生成代码。   [![godoc][GoDoc]](https://godoc.org/github.com/pascaldekloe/colfer)
* [cbor](https://github.com/fxamacker/cbor) **star:369** 小，安全，容易的CBOR编码和解码库。   [![godoc][GoDoc]](https://godoc.org/github.com/fxamacker/cbor)
* [go-capnproto](https://github.com/glycerine/go-capnproto) **star:279** Go 语言用的 Cap'n Proto 库及解析器   [![最近一年没有更新][Yellow]](https://github.com/glycerine/go-capnproto)   [![godoc][GoDoc]](https://godoc.org/github.com/glycerine/go-capnproto)
* [php_session_decoder](https://github.com/yvasiyarov/php_session_decoder) **star:153** 用于协同 PHP session 格式数据和 PHP 序列化／反序列化函数工作的go语言库   [![最近一年没有更新][Yellow]](https://github.com/yvasiyarov/php_session_decoder)   [![godoc][GoDoc]](https://godoc.org/github.com/yvasiyarov/php_session_decoder)
* [structomap](https://github.com/tuvistavie/structomap) **star:130** 用于从静态结构体简单、动态的生成键值对的库   [![最近一年没有更新][Yellow]](https://github.com/tuvistavie/structomap)   [![godoc][GoDoc]](https://godoc.org/github.com/tuvistavie/structomap)
* [bambam](https://github.com/glycerine/bambam) **star:62** 用于 Go 语言生成 Cap'n Proto schemas 的生成器   [![最近一年没有更新][Yellow]](https://github.com/glycerine/bambam)   [![godoc][GoDoc]](https://godoc.org/github.com/glycerine/bambam)
* [asn1](https://github.com/PromonLogicalis/asn1) **star:47** 面向golang的BER和DER编码库。   [![最近一年没有更新][Yellow]](https://github.com/PromonLogicalis/asn1)   [![godoc][GoDoc]](https://godoc.org/github.com/PromonLogicalis/asn1)   [![归档项目][Archived]](https://github.com/PromonLogicalis/asn1)
* [binstruct](https://github.com/ghostiam/binstruct) **star:39** 用于将数据映射到结构中的Golang二进制解码器。   [![godoc][GoDoc]](https://godoc.org/github.com/ghostiam/binstruct)
* [bel](https://github.com/32leaves/bel) **star:16** 从Go structs/interface生成TypeScript接口。对JSON RPC很有用。   [![最近一年没有更新][Yellow]](https://github.com/32leaves/bel)   [![godoc][GoDoc]](https://godoc.org/github.com/32leaves/bel)
* [fwencoder](https://github.com/o1egl/fwencoder) **star:16** 用于Go的固定宽度文件解析器(编码和解码库)。   [![最近一年没有更新][Yellow]](https://github.com/o1egl/fwencoder)   [![godoc][GoDoc]](https://godoc.org/github.com/o1egl/fwencoder)
* [pletter](https://github.com/vimeda/pletter) **star:16** A standard way to wrap a proto message for message brokers.   [![godoc][GoDoc]](https://godoc.org/github.com/vimeda/pletter)
* [elastic](https://github.com/epiclabs-io/elastic) **star:15** 在运行时跨不同类型转换片、映射或任何其他未知值   [![godoc][GoDoc]](https://godoc.org/github.com/epiclabs-io/elastic)
* [fixedwidth](https://github.com/huydang284/fixedwidth) **star:5** 固定宽度的文本格式(支持UTF-8)。   [![最近一年没有更新][Yellow]](https://github.com/huydang284/fixedwidth)   [![godoc][GoDoc]](https://godoc.org/github.com/huydang284/fixedwidth)
* [unitpacking](https://github.com/recolude/unitpacking) **star:3** 标准库将单元向量打包到尽可能少的字节中。   [![godoc][GoDoc]](https://godoc.org/github.com/recolude/unitpacking)
* [go-lctree](https://github.com/sbourlon/go-lctree) **star:2** 提供一个CLI和原语来序列化和反序列化[LeetCode二进制树](https://support.leetcode.com/hc/en-us/articles/360011883654-what-does -1-null-2-3-mean-in-二进制树表示)。   [![最近一年没有更新][Yellow]](https://github.com/sbourlon/go-lctree)   [![godoc][GoDoc]](https://godoc.org/github.com/sbourlon/go-lctree)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#serialization) 吧~)*

## 服务器应用程序

* [etcd](https://github.com/coreos/etcd) **star:38518** 为共享配置和服务发现提供高可用的键值存储。   [![star > 2000][Awesome]](https://github.com/coreos/etcd)   [![最近一周有更新][Green]](https://github.com/coreos/etcd)   [![godoc][GoDoc]](https://godoc.org/github.com/coreos/etcd)
* [Caddy](https://github.com/caddyserver/caddy) **star:36476** Caddy是另一种HTTP/2 web服务器，易于配置和使用。   [![star > 2000][Awesome]](https://github.com/caddyserver/caddy)   [![最近一周有更新][Green]](https://github.com/caddyserver/caddy)   [![godoc][GoDoc]](https://godoc.org/github.com/caddyserver/caddy)
* [consul](https://www.consul.io/)  Consul 是一个用于服务发现、监控和配置的工具
* [minio](https://github.com/minio/minio) **star:31069** Minio是一个分布式对象存储服务器。   [![star > 2000][Awesome]](https://github.com/minio/minio)   [![最近一周有更新][Green]](https://github.com/minio/minio)   [![godoc][GoDoc]](https://godoc.org/github.com/minio/minio)
* [RoadRunner](https://github.com/spiral/roadrunner) **star:6174** 高性能PHP应用服务器，负载平衡器和进程管理器。   [![star > 2000][Awesome]](https://github.com/spiral/roadrunner)   [![最近一周有更新][Green]](https://github.com/spiral/roadrunner)   [![godoc][GoDoc]](https://godoc.org/github.com/spiral/roadrunner)
* [Easegress](https://github.com/megaease/easegress) **star:4173** 具有可观察性和可扩展性的云本地高可用性/性能流量编排系统。   [![star > 2000][Awesome]](https://github.com/megaease/easegress)   [![最近一周有更新][Green]](https://github.com/megaease/easegress)   [![godoc][GoDoc]](https://godoc.org/github.com/megaease/easegress)
* [SFTPGo](https://github.com/drakkan/sftpgo) **star:3664** 完全功能和高度可配置的SFTP服务器与可选的FTP/S和WebDAV支持。它可以为本地文件系统和云存储后端(如S3和谷歌云存储)提供服务。   [![star > 2000][Awesome]](https://github.com/drakkan/sftpgo)   [![最近一周有更新][Green]](https://github.com/drakkan/sftpgo)   [![godoc][GoDoc]](https://godoc.org/github.com/drakkan/sftpgo)
* [devd](https://github.com/cortesi/devd) **star:3198** 为开发人员提供本地web服务器。   [![star > 2000][Awesome]](https://github.com/cortesi/devd)   [![godoc][GoDoc]](https://godoc.org/github.com/cortesi/devd)
* [algernon](https://github.com/xyproto/algernon) **star:1897** 内置支持Lua、Markdown、GCSS和Amber的HTTP/2 web服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/xyproto/algernon)
* [Fider](https://github.com/getfider/fider) **star:1804** Fider是一个收集和组织客户反馈的开放平台。   [![最近一周有更新][Green]](https://github.com/getfider/fider)   [![godoc][GoDoc]](https://godoc.org/github.com/getfider/fider)
* [Flagr](https://github.com/checkr/flagr) **star:1790** Flagr是一个开源特性标记和A/B测试服务。   [![最近一周有更新][Green]](https://github.com/checkr/flagr)   [![godoc][GoDoc]](https://godoc.org/github.com/checkr/flagr)
* [flipt](https://github.com/markphelps/flipt) **star:1699** 一个用Go和Vue.js编写的自包含特性标志解决方案   [![最近一周有更新][Green]](https://github.com/markphelps/flipt)   [![godoc][GoDoc]](https://godoc.org/github.com/markphelps/flipt)
* [Trickster](https://github.com/tricksterproxy/trickster) **star:1602** HTTP反向代理缓存和时间序列加速器。   [![godoc][GoDoc]](https://godoc.org/github.com/tricksterproxy/trickster)
* [discovery](https://github.com/Bilibili/discovery) **star:1583** 用于弹性中间层负载平衡和故障转移的注册表。   [![godoc][GoDoc]](https://godoc.org/github.com/Bilibili/discovery)
* [jackal](https://github.com/ortuman/jackal) **star:1183** 用Go编写的XMPP服务器。   [![最近一周有更新][Green]](https://github.com/ortuman/jackal)   [![godoc][GoDoc]](https://godoc.org/github.com/ortuman/jackal)
* [go-feature-flag](https://github.com/thomaspoignant/go-feature-flag) **star:383** 一个特性标志解决方案，在后端只有一个YAML文件(S3、GitHub、HTTP、本地文件……)，不需要安装服务器，只需要在中央系统中添加一个文件并引用它。   [![最近一周有更新][Green]](https://github.com/thomaspoignant/go-feature-flag)   [![godoc][GoDoc]](https://godoc.org/github.com/thomaspoignant/go-feature-flag)
* [Euterpe](https://github.com/ironsmile/euterpe) **star:370** 自带web UI和REST API的自托管音乐流媒体服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/ironsmile/euterpe)
* [dudeldu](https://github.com/krotik/dudeldu) **star:131** 一个简单的SHOUTcast服务器。   [![最近一年没有更新][Yellow]](https://github.com/krotik/dudeldu)   [![godoc][GoDoc]](https://godoc.org/github.com/krotik/dudeldu)
* [lets-proxy2](https://github.com/rekby/lets-proxy2) **star:58** Reverse proxy for handle https with issue certificates in fly from lets-encrypt.   [![godoc][GoDoc]](https://godoc.org/github.com/rekby/lets-proxy2)
* [psql-streamer](https://github.com/blind-oracle/psql-streamer) **star:36** 从PostgreSQL到Kafka的流数据库事件。   [![最近一年没有更新][Yellow]](https://github.com/blind-oracle/psql-streamer)   [![godoc][GoDoc]](https://godoc.org/github.com/blind-oracle/psql-streamer)
* [riemann-relay](https://github.com/blind-oracle/riemann-relay)  传递到负载平衡Riemann事件并/或将其转换为 Carbon。
* [go-proxy-cache](https://github.com/fabiocicerchia/go-proxy-cache) **star:35** 简单的反向代理与缓存，写在Go，使用Redis。   [![godoc][GoDoc]](https://godoc.org/github.com/fabiocicerchia/go-proxy-cache)
* [cortex-tenant](https://github.com/blind-oracle/cortex-tenant) **star:29** Prometheus远程写代理，添加了基于度量标签的add Cortex租户ID头。   [![godoc][GoDoc]](https://godoc.org/github.com/blind-oracle/cortex-tenant)
* [nginx-prometheus](https://github.com/blind-oracle/nginx-prometheus) **star:27** Nginx日志解析器和Prometheus 导出。   [![最近一年没有更新][Yellow]](https://github.com/blind-oracle/nginx-prometheus)   [![godoc][GoDoc]](https://godoc.org/github.com/blind-oracle/nginx-prometheus)
* [nsq](https://nsq.io/)  一个实时分布式消息平台。
* [simple-jwt-provider](https://github.com/leberKleber/simple-jwt-provider) **star:20** 展示JWTs的简单轻量级提供者，支持登录、密码重置(通过邮件)和用户管理。   [![godoc][GoDoc]](https://godoc.org/github.com/leberKleber/simple-jwt-provider)
* [protoxy](https://github.com/camgraff/protoxy) **star:19** 将JSON请求体转换为协议缓冲区的代理服务器。   [![最近一年没有更新][Yellow]](https://github.com/camgraff/protoxy)   [![godoc][GoDoc]](https://godoc.org/github.com/camgraff/protoxy)
* [Moxy](https://github.com/sinhashubham95/moxy) **star:3** Moxy是一个简单的模拟和代理应用程序服务器，您可以创建模拟端点以及代理请求，以防端点不存在模拟。   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/moxy)


**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#server-applications) 吧~)*

## 流处理

*用于流处理和响应式编程的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#stream-processing) 吧~)*

* [go-streams](https://github.com/reugn/go-streams) **star:824** 流处理库。   [![最近一周有更新][Green]](https://github.com/reugn/go-streams)   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/go-streams)
* [machine](https://github.com/whitaker-io/machine) **star:101** 使用内置的度量和可跟踪性来编写和生成流工作人员。   [![最近一周有更新][Green]](https://github.com/whitaker-io/machine)   [![godoc][GoDoc]](https://godoc.org/github.com/whitaker-io/machine)
* [stream](https://github.com/youthlin/stream) **star:50** 去流，像Java 8流:过滤器/地图/平面地图/Peek/排序/ForEach/减少…   [![最近一年没有更新][Yellow]](https://github.com/youthlin/stream)   [![godoc][GoDoc]](https://godoc.org/github.com/youthlin/stream)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#stream-processing) 吧~)*

## 模板引擎

*用于模板和词法分析的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#template-engines) 吧~)*

* [gofpdf](https://github.com/jung-kurt/gofpdf) **star:3922** PDF 文档生成器，支持文本，绘图和图片   [![star > 2000][Awesome]](https://github.com/jung-kurt/gofpdf)   [![godoc][GoDoc]](https://godoc.org/github.com/jung-kurt/gofpdf)   [![归档项目][Archived]](https://github.com/jung-kurt/gofpdf)
* [sprig](https://github.com/Masterminds/sprig) **star:2750** Go模板的有用模板函数。   [![star > 2000][Awesome]](https://github.com/Masterminds/sprig)   [![godoc][GoDoc]](https://godoc.org/github.com/Masterminds/sprig)
* [quicktemplate](https://github.com/valyala/quicktemplate) **star:2308** 快速、强大且易用的模板引擎。将模板转化为 Go 语言并进行编译   [![star > 2000][Awesome]](https://github.com/valyala/quicktemplate)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/quicktemplate)
* [pongo2](https://github.com/flosch/pongo2) **star:2133** 类似 DjanGo 的模板引擎   [![star > 2000][Awesome]](https://github.com/flosch/pongo2)   [![godoc][GoDoc]](https://godoc.org/github.com/flosch/pongo2)
* [hero](https://github.com/shiyanhui/hero) **star:1487** Hero是一个方便、快速和强大的go模板引擎。   [![最近一年没有更新][Yellow]](https://github.com/shiyanhui/hero)   [![godoc][GoDoc]](https://godoc.org/github.com/shiyanhui/hero)   [![包含中文文档][CN]](https://github.com/shiyanhui/hero)
* [mustache](https://github.com/hoisie/mustache) **star:1028** Go 语言实现的 Mustache 模板语言   [![最近一周有更新][Green]](https://github.com/hoisie/mustache)   [![godoc][GoDoc]](https://godoc.org/github.com/hoisie/mustache)
* [amber](https://github.com/eknkc/amber) **star:887** Amber是一个优雅的Go编程语言模板引擎，它的灵感来自HAML和Jade。   [![最近一年没有更新][Yellow]](https://github.com/eknkc/amber)   [![godoc][GoDoc]](https://godoc.org/github.com/eknkc/amber)
* [jet](https://github.com/CloudyKit/jet) **star:873** Jet模板引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/CloudyKit/jet)
* [ace](https://github.com/yosssi/ace) **star:807** Ace 是一个 Go 语言的 HTML 模板引擎，受到了 Slim 和 Jade 的启发。 Ace 是对Gold的一种改进。   [![最近一年没有更新][Yellow]](https://github.com/yosssi/ace)   [![godoc][GoDoc]](https://godoc.org/github.com/yosssi/ace)
* [Razor](https://github.com/sipin/gorazor) **star:790** Go 语言的 Razor 视图引擎   [![最近一年没有更新][Yellow]](https://github.com/sipin/gorazor)   [![godoc][GoDoc]](https://godoc.org/github.com/sipin/gorazor)
* [fasttemplate](https://github.com/valyala/fasttemplate) **star:564** 简单和快速的模板引擎。替换模板占位符的速度比[text/template](https://golang.org/pkg/text/template/)快10倍。   [![最近一年没有更新][Yellow]](https://github.com/valyala/fasttemplate)   [![godoc][GoDoc]](https://godoc.org/github.com/valyala/fasttemplate)
* [maroto](https://github.com/johnfercher/maroto) **star:532** 创建pdf文件的maroto方法。Maroto的灵感来自于Bootstrap并使用gofpdf。快速和简单。   [![godoc][GoDoc]](https://godoc.org/github.com/johnfercher/maroto)
* [ego](https://github.com/benbjohnson/ego) **star:513** 轻量级模板语言，允许您在Go中编写模板。模板被翻译成Go并编译。   [![godoc][GoDoc]](https://godoc.org/github.com/benbjohnson/ego)
* [raymond](https://github.com/aymerick/raymond) **star:456** 使用 Go 语言实现的完整的 handlebars   [![godoc][GoDoc]](https://godoc.org/github.com/aymerick/raymond)
* [goview](https://github.com/foolin/goview) **star:263** Goview是一个轻量级、极简的模板库，基于golang html/template构建Go web应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/foolin/goview)
* [Soy](https://github.com/robfig/soy) **star:157** Go 语言实现的谷歌闭包模板(也就是 Soy templates) ,遵循[官方规范](https://developer.google.com/closure/templates/)。   [![godoc][GoDoc]](https://godoc.org/github.com/robfig/soy)
* [liquid](https://github.com/osteele/liquid) **star:144** Go 语言实现的 Shopify Liquid 模板.   [![godoc][GoDoc]](https://godoc.org/github.com/osteele/liquid)
* [velvet](https://github.com/gobuffalo/velvet) **star:73** 使用 Go 语言实现的完整的 handlebars   [![最近一年没有更新][Yellow]](https://github.com/gobuffalo/velvet)   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/velvet)
* [kasia.go](https://github.com/ziutek/kasia.go) **star:72** 一个用于HTML 和其他文本文件的模板系统，使用go语言实现   [![最近一年没有更新][Yellow]](https://github.com/ziutek/kasia.go)   [![godoc][GoDoc]](https://godoc.org/github.com/ziutek/kasia.go)
* [extemplate](https://github.com/dannyvankooten/extemplate) **star:41**  对 html/template 进行了简单的封装，支持基于文件的模板可以利用其他模板文件进行扩展   [![godoc][GoDoc]](https://godoc.org/github.com/dannyvankooten/extemplate)
* [gospin](https://github.com/m1/gospin) **star:33** 文章纺纱和spintax/纺纱语法引擎，适用于A/B，测试文本/文章片段和创建更多的自然对话。   [![godoc][GoDoc]](https://godoc.org/github.com/m1/gospin)
* [damsel](https://github.com/dskinner/damsel) **star:24** 标记语言，通过css选择器实现了 html 框架 ，并可以通过 pkg html/template 等进行扩展   [![最近一年没有更新][Yellow]](https://github.com/dskinner/damsel)   [![godoc][GoDoc]](https://godoc.org/github.com/dskinner/damsel)
* [tbd](https://github.com/lucasepe/tbd) **star:16** 用占位符创建文本模板的一种非常简单的方法——暴露额外的Git repo元数据。   [![godoc][GoDoc]](https://godoc.org/github.com/lucasepe/tbd)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#template-engines) 吧~)*

## 测试

*用于测试代码库和生成测试数据的库。 (翻译出错了? 试试 [英文版](README_EN.md#testing) 吧~)*

* Testing Frameworks
    * [Testify](https://github.com/stretchr/testify) **star:15204** 对标准测试包的扩展。   [![star > 2000][Awesome]](https://github.com/stretchr/testify)   [![最近一周有更新][Green]](https://github.com/stretchr/testify)   [![godoc][GoDoc]](https://godoc.org/github.com/stretchr/testify)
    * [testmd](https://godoc.org/github.com/tvastar/test/cmd/testmd)  将markdown代码段转换为可测试的go代码。
    * [go-cmp](https://github.com/google/go-cmp) **star:2655** 用于比较测试中的Go值的包。   [![star > 2000][Awesome]](https://github.com/google/go-cmp)   [![godoc][GoDoc]](https://godoc.org/github.com/google/go-cmp)
    * [httpexpect](https://github.com/gavv/httpexpect) **star:1841** 简洁的、声明式的、易用的端到端HTTP 及 REST API 测试   [![godoc][GoDoc]](https://godoc.org/github.com/gavv/httpexpect)
    * [godog](https://github.com/DATA-DOG/godog) **star:1543** 类似 Cucumber 或 Behat 的 BDD 框架   [![最近一周有更新][Green]](https://github.com/DATA-DOG/godog)   [![godoc][GoDoc]](https://godoc.org/github.com/DATA-DOG/godog)
    * [is](https://github.com/matryer/is) **star:1313** 专业的Go轻量级测试迷你框架。   [![godoc][GoDoc]](https://godoc.org/github.com/matryer/is)
    * [go-vcr](https://github.com/dnaeon/go-vcr) **star:842** 记录并回放HTTP交互，以便进行快速、确定和准确的测试。   [![godoc][GoDoc]](https://godoc.org/github.com/dnaeon/go-vcr)
    * [goblin](https://github.com/franela/goblin) **star:824** 类似Mocha的测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/franela/goblin)
    * [testfixtures](https://github.com/go-testfixtures/testfixtures) **star:729** 类似 Rails 的测试工具，用于测试数据库应用   [![最近一周有更新][Green]](https://github.com/go-testfixtures/testfixtures)   [![godoc][GoDoc]](https://godoc.org/github.com/go-testfixtures/testfixtures)
    * [baloo](https://github.com/h2non/baloo) **star:718** 表达性强、多功能的、端到端的HTTP API 测试工具   [![最近一周有更新][Green]](https://github.com/h2non/baloo)   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/baloo)
    * [gnomock](https://github.com/orlangure/gnomock) **star:626** 在Docker中运行与真实依赖项(数据库、缓存，甚至是Kubernetes或AWS)的集成测试，而不使用模拟。   [![最近一周有更新][Green]](https://github.com/orlangure/gnomock)   [![godoc][GoDoc]](https://godoc.org/github.com/orlangure/gnomock)
    * [go-mutesting](https://github.com/zimmski/go-mutesting) **star:501** 变异测试的Go源代码。   [![godoc][GoDoc]](https://godoc.org/github.com/zimmski/go-mutesting)
    * [goc](https://github.com/qiniu/goc) **star:474** Goc是一个针对Go编程语言的全面覆盖测试系统。   [![最近一周有更新][Green]](https://github.com/qiniu/goc)   [![godoc][GoDoc]](https://godoc.org/github.com/qiniu/goc)
    * [gocheck](https://labix.org/gocheck)  更加高级的测试框架，用于替换 Gotest
    * [GoConvey](https://github.com/smartystreets/goconvey/)  BDD 风格的测试框架，具有 web 界面和计时刷新功能
    * [gofight](https://github.com/appleboy/gofight) **star:399** 对 Go 语言的路由框架进行 API 测试   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/gofight)
    * [embedded-postgres](https://github.com/fergusstrange/embedded-postgres) **star:326** 作为另一个Go应用程序或测试的一部分，在Linux、OSX或Windows上本地运行一个真正的Postgres数据库。   [![最近一周有更新][Green]](https://github.com/fergusstrange/embedded-postgres)   [![godoc][GoDoc]](https://godoc.org/github.com/fergusstrange/embedded-postgres)
    * [testza](https://github.com/MarvinJWendt/testza) **star:312** 功能齐全的测试框架，带有漂亮的彩色输出。   [![最近一周有更新][Green]](https://github.com/MarvinJWendt/testza)   [![godoc][GoDoc]](https://godoc.org/github.com/MarvinJWendt/testza)
    * [gotest.tools](https://github.com/gotestyourself/gotest.tools) **star:273** 一组包，用于增强go测试包并支持公共模式。   [![最近一周有更新][Green]](https://github.com/gotestyourself/gotest.tools)   [![godoc][GoDoc]](https://godoc.org/github.com/gotestyourself/gotest.tools)
    * [frisby](https://github.com/verdverm/frisby) **star:271** REST API测试框架。   [![最近一年没有更新][Yellow]](https://github.com/verdverm/frisby)   [![godoc][GoDoc]](https://godoc.org/github.com/verdverm/frisby)
    * [ginkgo](https://onsi.github.io/ginkgo/)  Go的BDD测试框架。
    * [go-testdeep](https://github.com/maxatome/go-testdeep) **star:244** 极具灵活性的golang深度比较，扩展了go测试包。   [![最近一周有更新][Green]](https://github.com/maxatome/go-testdeep)   [![godoc][GoDoc]](https://godoc.org/github.com/maxatome/go-testdeep)
    * [go-carpet](https://github.com/msoap/go-carpet) **star:217** 在终端中查看测试覆盖率的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/msoap/go-carpet)
    * [endly](https://github.com/viant/endly) **star:201** 声明性端到端功能测试。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/endly)
    * [cupaloy](https://github.com/bradleyjkemp/cupaloy) **star:200** 测试框架的简单快照测试插件。   [![godoc][GoDoc]](https://godoc.org/github.com/bradleyjkemp/cupaloy)
    * [charlatan](https://github.com/percolate/charlatan) **star:194** 为测试生成假接口实现的工具。   [![最近一年没有更新][Yellow]](https://github.com/percolate/charlatan)   [![godoc][GoDoc]](https://godoc.org/github.com/percolate/charlatan)
    * [commander](https://github.com/SimonBaeumer/commander) **star:190** 用于在windows、linux和osx上测试cli应用程序的工具。   [![godoc][GoDoc]](https://godoc.org/github.com/SimonBaeumer/commander)
    * [dbcleaner](https://github.com/khaiql/dbcleaner) **star:135** 清空数据库用于测试，受到database_cleaner 的启发   [![godoc][GoDoc]](https://godoc.org/github.com/khaiql/dbcleaner)
    * [GoSpec](https://github.com/orfjackal/gospec) **star:114** 用于 Go 编程语言的bdd风格的测试框架。   [![最近一年没有更新][Yellow]](https://github.com/orfjackal/gospec)   [![godoc][GoDoc]](https://godoc.org/github.com/orfjackal/gospec)
    * [wstest](https://github.com/posener/wstest) **star:86** 用于单元测试Websocket http.Handler的Websocket客户机。   [![最近一年没有更新][Yellow]](https://github.com/posener/wstest)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/wstest)
    * [gocrest](https://github.com/corbym/gocrest) **star:81** 用于 Go 断言的可组合的类似 hamcrest 的 matchers。   [![最近一年没有更新][Yellow]](https://github.com/corbym/gocrest)   [![godoc][GoDoc]](https://godoc.org/github.com/corbym/gocrest)
    * [testcase](https://github.com/adamluzsi/testcase) **star:80** 行为驱动开发的惯用测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/adamluzsi/testcase)
    * [jsonassert](https://github.com/kinbiko/jsonassert) **star:76** 用于验证JSON有效负载已正确序列化的包。   [![godoc][GoDoc]](https://godoc.org/github.com/kinbiko/jsonassert)
    * [omg.testingtools](https://github.com/dedalqq/omg.testingtools)  用于更改用于测试的私有字段值的简单库。
    * [apitest](https://apitest.dev)  基于REST的服务/HTTP处理程序的简单且可扩展的行为测试库,支持模拟外部HTTP调用和呈现序列图
    * [go-hit](https://github.com/Eun/go-hit) **star:63** Hit是一个用golang编写的http集成测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/Eun/go-hit)
    * [restit](https://github.com/yookoala/restit) **star:55** 帮助编写 RESTful API 集成测试的 Go 语言微型框架.。   [![最近一年没有更新][Yellow]](https://github.com/yookoala/restit)   [![godoc][GoDoc]](https://godoc.org/github.com/yookoala/restit)
    * [gospecify](https://github.com/stesla/gospecify) **star:52** 支持 BDD 语法 。对于任何使用过 rspec 等库的人来说应该非常熟悉。   [![最近一年没有更新][Yellow]](https://github.com/stesla/gospecify)   [![godoc][GoDoc]](https://godoc.org/github.com/stesla/gospecify)
    * [covergates](https://github.com/covergates/covergates) **star:47** 自托管的代码覆盖报告审查和管理服务。   [![最近一年没有更新][Yellow]](https://github.com/covergates/covergates)   [![godoc][GoDoc]](https://godoc.org/github.com/covergates/covergates)
    * [gomatch](https://github.com/jfilipczyk/gomatch) **star:41** 为针对模式测试JSON而创建的库。   [![最近一年没有更新][Yellow]](https://github.com/jfilipczyk/gomatch)   [![godoc][GoDoc]](https://godoc.org/github.com/jfilipczyk/gomatch)
    * [gomega](https://onsi.github.io/gomega/)  类似 Rspec 的 matcher/assertion 库
    * [dsunit](https://github.com/viant/dsunit) **star:39** 用于SQL、NoSQL、结构化文件的数据存储测试。   [![最近一年没有更新][Yellow]](https://github.com/viant/dsunit)   [![godoc][GoDoc]](https://godoc.org/github.com/viant/dsunit)
    * [assert](https://github.com/go-playground/assert) **star:36** 基础断言库，用于对 Go 语言程序进行测试，提供了一些用于自定义断言的代码块   [![最近一年没有更新][Yellow]](https://github.com/go-playground/assert)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/assert)
    * [Hamcrest](https://github.com/rdrdr/hamcrest) **star:27** 用于声明性 Matcher 对象的连贯框架，当将其应用于输入值时，将产生自描述结果。   [![最近一年没有更新][Yellow]](https://github.com/rdrdr/hamcrest)   [![godoc][GoDoc]](https://godoc.org/github.com/rdrdr/hamcrest)
    * [schema](https://github.com/jgroeneveld/schema) **star:16** 快速、简单地匹配请求和响应中使用的JSON模式的表达式。   [![最近一年没有更新][Yellow]](https://github.com/jgroeneveld/schema)   [![godoc][GoDoc]](https://godoc.org/github.com/jgroeneveld/schema)
    * [flute](https://github.com/suzuki-shunsuke/flute) **star:15** HTTP客户端测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/suzuki-shunsuke/flute)
    * [gogiven](https://github.com/corbym/gogiven) **star:11** 类似于 YATSPEC 的Go BDD测试框架。   [![godoc][GoDoc]](https://godoc.org/github.com/corbym/gogiven)
    * [testsql](https://github.com/zhulongcheng/testsql) **star:11** 在测试前从SQL文件生成测试数据，并在测试完成后清除数据。   [![最近一年没有更新][Yellow]](https://github.com/zhulongcheng/testsql)   [![godoc][GoDoc]](https://godoc.org/github.com/zhulongcheng/testsql)
    * [gosuite](https://github.com/pavlo/gosuite) **star:10** 轻量级测试套，为 Go1.7's Subtests 带来了setup/teardown 功能   [![最近一年没有更新][Yellow]](https://github.com/pavlo/gosuite)   [![godoc][GoDoc]](https://godoc.org/github.com/pavlo/gosuite)
    * [badio](https://github.com/cavaliercoder/badio) **star:9** Go 语言 testing/iotest 包的扩展。   [![最近一年没有更新][Yellow]](https://github.com/cavaliercoder/badio)   [![godoc][GoDoc]](https://godoc.org/github.com/cavaliercoder/badio)
    * [biff](https://github.com/fulldump/biff) **star:9** 分支测试框架，BDD兼容。   [![godoc][GoDoc]](https://godoc.org/github.com/fulldump/biff)
    * [stop-and-go](https://github.com/elgohr/stop-and-go) **star:6** 并发性测试助手。   [![godoc][GoDoc]](https://godoc.org/github.com/elgohr/stop-and-go)
    * [trial](https://github.com/jgroeneveld/trial) **star:5** 无需引入太多样板，即可快速轻松地扩展断言。   [![最近一年没有更新][Yellow]](https://github.com/jgroeneveld/trial)   [![godoc][GoDoc]](https://godoc.org/github.com/jgroeneveld/trial)
    * [fixenv](https://github.com/rekby/fixenv) **star:4** 夹具管理引擎，灵感来自pytest夹具。   [![godoc][GoDoc]](https://godoc.org/github.com/rekby/fixenv)
    * [Tt](https://github.com/vcaesar/tt) **star:4** 简单而丰富多彩的测试工具。   [![godoc][GoDoc]](https://godoc.org/github.com/vcaesar/tt)
    * [go-testpredicate](https://github.com/maargenton/go-testpredicate) **star:3** 测试带有大量诊断输出的断言样式断言库。   [![godoc][GoDoc]](https://godoc.org/github.com/maargenton/go-testpredicate)

* Mock
    * [gomock](https://github.com/golang/mock) **star:6669** 用于Go编程语言的mock框架。   [![star > 2000][Awesome]](https://github.com/golang/mock)   [![最近一周有更新][Green]](https://github.com/golang/mock)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/mock)
    * [go-sqlmock](https://github.com/DATA-DOG/go-sqlmock) **star:4093** Mock SQL ，用于测试数据库交互   [![star > 2000][Awesome]](https://github.com/DATA-DOG/go-sqlmock)   [![godoc][GoDoc]](https://godoc.org/github.com/DATA-DOG/go-sqlmock)
    * [mockery](https://github.com/vektra/mockery) **star:3198** 生成Go界面的工具。   [![star > 2000][Awesome]](https://github.com/vektra/mockery)   [![godoc][GoDoc]](https://godoc.org/github.com/vektra/mockery)
    * [hoverfly](https://github.com/SpectoLabs/hoverfly) **star:1821** 使用可扩展中间件和易于使用的CLI记录和模拟REST/SOAP api的HTTP(S)代理。   [![godoc][GoDoc]](https://godoc.org/github.com/SpectoLabs/hoverfly)
    * [gock](https://github.com/h2non/gock) **star:1547** 多功能、易用 HTTP mock   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/gock)
    * [httpmock](https://github.com/jarcoal/httpmock) **star:1282** 轻松模拟来自外部资源的HTTP响应。   [![godoc][GoDoc]](https://godoc.org/github.com/jarcoal/httpmock)
    * [counterfeiter](https://github.com/maxbrunsfeld/counterfeiter) **star:612** 用于生成自包含 mock 对象的工具   [![godoc][GoDoc]](https://godoc.org/github.com/maxbrunsfeld/counterfeiter)
    * [genmock](https://gitlab.com/so_literate/genmock)  使用代码生成器构建接口方法的调用来模拟系统。
    * [minimock](https://github.com/gojuno/minimock) **star:436** Go接口的模拟生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/gojuno/minimock)
    * [go-txdb](https://github.com/DATA-DOG/go-txdb) **star:410** 基于单事务的数据库驱动，主要用于测试目的   [![godoc][GoDoc]](https://godoc.org/github.com/DATA-DOG/go-txdb)
    * [govcr](https://github.com/seborama/govcr) **star:100** HTTP mock : 离线测试时记录和重放浏览器的动作   [![最近一年没有更新][Yellow]](https://github.com/seborama/govcr)   [![godoc][GoDoc]](https://godoc.org/github.com/seborama/govcr)
    * [timex](https://github.com/cabify/timex) **star:58** 一个测试友好的本地“时间”包的替代品。   [![最近一年没有更新][Yellow]](https://github.com/cabify/timex)   [![godoc][GoDoc]](https://godoc.org/github.com/cabify/timex)
    * [go-localstack](https://github.com/elgohr/go-localstack) **star:30** 用于在AWS测试中使用localstack的工具。   [![最近一周有更新][Green]](https://github.com/elgohr/go-localstack)   [![godoc][GoDoc]](https://godoc.org/github.com/elgohr/go-localstack)
    * [mockhttp](https://github.com/tv42/mockhttp) **star:22** Go http.ResponseWriter的模拟对象。   [![最近一年没有更新][Yellow]](https://github.com/tv42/mockhttp)   [![godoc][GoDoc]](https://godoc.org/github.com/tv42/mockhttp)
    * [mockit](https://github.com/pasdam/mockit) **star:8** 允许函数和方法容易被模拟，而不需要定义新的类型;它类似于Java的Mockito。   [![godoc][GoDoc]](https://godoc.org/github.com/pasdam/mockit)

* Fuzzing and delta-debugging/reducing/shrinking.
    * [go-fuzz](https://github.com/dvyukov/go-fuzz) **star:4233** 随机测试系统。   [![star > 2000][Awesome]](https://github.com/dvyukov/go-fuzz)   [![godoc][GoDoc]](https://godoc.org/github.com/dvyukov/go-fuzz)
    * [gofuzz](https://github.com/google/gofuzz) **star:1213** 用于生成随机值来初始化 Go 语言对象的库   [![godoc][GoDoc]](https://godoc.org/github.com/google/gofuzz)
    * [Tavor](https://github.com/zimmski/tavor) **star:231** 通用模糊测试框架   [![最近一年没有更新][Yellow]](https://github.com/zimmski/tavor)   [![godoc][GoDoc]](https://godoc.org/github.com/zimmski/tavor)

* Selenium and browser control tools.
    * [chromedp](https://github.com/knq/chromedp) **star:7149** 用于驱动和测试 Chrome, Safari, Edge, Android Webviews, 以及其他支持 Chrome 调试协议的产品   [![star > 2000][Awesome]](https://github.com/knq/chromedp)   [![最近一周有更新][Green]](https://github.com/knq/chromedp)   [![godoc][GoDoc]](https://godoc.org/github.com/knq/chromedp)
    * [selenoid](https://github.com/aerokube/selenoid) **star:2083** Selenium hub 服务器的替代品，在容器中启动浏览器   [![star > 2000][Awesome]](https://github.com/aerokube/selenoid)   [![godoc][GoDoc]](https://godoc.org/github.com/aerokube/selenoid)
    * [rod](https://github.com/go-rod/rod) **star:2055** 一个Devtools驱动程序，使web自动化和抓取更加容易。   [![star > 2000][Awesome]](https://github.com/go-rod/rod)   [![godoc][GoDoc]](https://godoc.org/github.com/go-rod/rod)
    * [playwright-go](https://github.com/mxschmitt/playwright-go) **star:602** 浏览器自动化库控制铬，Firefox和WebKit与一个单一的API。
    * [cdp](https://github.com/mafredri/cdp) **star:595** 用于Chrome调试协议的类型安全绑定，可与实现该协议的浏览器或其他调试目标一起使用。   [![godoc][GoDoc]](https://godoc.org/github.com/mafredri/cdp)
    * [ggr](https://github.com/aerokube/ggr) **star:277** 一个轻量级服务器，可以将 Selenium Wedriver 的请求路由或代理到多个 Selenium hubs   [![godoc][GoDoc]](https://godoc.org/github.com/aerokube/ggr)

* Fail injection
    * [failpoint](https://github.com/pingcap/failpoint) **star:649** Golang的[故障点](https://www.freebsd.org/cgi/man.cgi?query=fail)实现。   [![godoc][GoDoc]](https://godoc.org/github.com/pingcap/failpoint)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#testing) 吧~)*

## 文本处理

*用于解析和操作文本的库。 (翻译出错了? 试试 [英文版](README_EN.md#text-processing) 吧~)*

* Specific Formats
    * [colly](https://github.com/asciimoo/colly) **star:15755** 快速和优雅的 Scraping 框架。   [![star > 2000][Awesome]](https://github.com/asciimoo/colly)   [![最近一周有更新][Green]](https://github.com/asciimoo/colly)   [![godoc][GoDoc]](https://godoc.org/github.com/asciimoo/colly)
    * [GoQuery](https://github.com/PuerkitoBio/goquery) **star:11027** GoQuery 为 Go 语言带来了一组类似 jQuery 的语法和功能   [![star > 2000][Awesome]](https://github.com/PuerkitoBio/goquery)   [![godoc][GoDoc]](https://godoc.org/github.com/PuerkitoBio/goquery)
    * [blackfriday](https://github.com/russross/blackfriday) **star:4860** Markdown 解析器   [![star > 2000][Awesome]](https://github.com/russross/blackfriday)   [![godoc][GoDoc]](https://godoc.org/github.com/russross/blackfriday)
    * [sh](https://github.com/mvdan/sh) **star:4414** Shell解析器和格式化工具。   [![star > 2000][Awesome]](https://github.com/mvdan/sh)   [![最近一周有更新][Green]](https://github.com/mvdan/sh)   [![godoc][GoDoc]](https://godoc.org/github.com/mvdan/sh)
    * [toml](https://github.com/BurntSushi/toml) **star:3723** TOML配置格式(带反射的编码器/解码器)。   [![star > 2000][Awesome]](https://github.com/BurntSushi/toml)   [![最近一周有更新][Green]](https://github.com/BurntSushi/toml)   [![godoc][GoDoc]](https://godoc.org/github.com/BurntSushi/toml)
    * [go-humanize](https://github.com/dustin/go-humanize) **star:3005** 格式化程序，用于将时间、数字和内存大小转换为可读格式。   [![star > 2000][Awesome]](https://github.com/dustin/go-humanize)   [![godoc][GoDoc]](https://godoc.org/github.com/dustin/go-humanize)
    * [bluemonday](https://github.com/microcosm-cc/bluemonday) **star:2156** HTML 清理工具   [![star > 2000][Awesome]](https://github.com/microcosm-cc/bluemonday)   [![godoc][GoDoc]](https://godoc.org/github.com/microcosm-cc/bluemonday)
    * [gofeed](https://github.com/mmcdole/gofeed) **star:1788** 在Go中解析RSS和Atom feeds。   [![最近一周有更新][Green]](https://github.com/mmcdole/gofeed)   [![godoc][GoDoc]](https://godoc.org/github.com/mmcdole/gofeed)
    * [inject](https://github.com/facebookgo/inject) **star:1359** 包注入提供了一个基于反射的注入器。   [![最近一年没有更新][Yellow]](https://github.com/facebookgo/inject)   [![godoc][GoDoc]](https://godoc.org/github.com/facebookgo/inject)   [![归档项目][Archived]](https://github.com/facebookgo/inject)
    * [go-toml](https://github.com/pelletier/go-toml) **star:1148** 使用带有查询支持和方便的cli工具的TOML格式库。   [![godoc][GoDoc]](https://godoc.org/github.com/pelletier/go-toml)
    * [commonregex](https://github.com/mingrammer/commonregex) **star:793** 一组用于Go的公共正则表达式。   [![最近一年没有更新][Yellow]](https://github.com/mingrammer/commonregex)   [![godoc][GoDoc]](https://godoc.org/github.com/mingrammer/commonregex)
    * [slug](https://github.com/gosimple/slug) **star:773** URL 友好的 slug 化工具，支持多种语言   [![godoc][GoDoc]](https://godoc.org/github.com/gosimple/slug)
    * [dataflowkit](https://github.com/slotix/dataflowkit) **star:506** Web抓取框架将网站转换为结构化数据。   [![最近一年没有更新][Yellow]](https://github.com/slotix/dataflowkit)   [![godoc][GoDoc]](https://godoc.org/github.com/slotix/dataflowkit)
    * [mxj](https://github.com/clbanning/mxj) **star:499** 将XML编码/解码为JSON或map[string]接口{};使用点符号路径和通配符提取值。替换x2j和j2x包。   [![godoc][GoDoc]](https://godoc.org/github.com/clbanning/mxj)
    * [gographviz](https://github.com/awalterschulze/gographviz) **star:460** 解析Graphviz DOT语言。   [![godoc][GoDoc]](https://godoc.org/github.com/awalterschulze/gographviz)
    * [gommon/bytes](https://github.com/labstack/gommon/tree/master/bytes)  格式化二进制为字符串。
    * [htmlquery](https://github.com/antchfx/htmlquery) **star:444** 用于HTML的XPath查询包，允许您通过XPath表达式从HTML文档中提取数据或求值。   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/htmlquery)
    * [omniparser](https://github.com/jf-tech/omniparser) **star:408** 一个通用的ETL库，以流方式解析文本输入(CSV/txt/JSON/XML/EDI/X12/EDIFACT/etc)，并使用数据驱动模式将数据转换为JSON输出。   [![godoc][GoDoc]](https://godoc.org/github.com/jf-tech/omniparser)
    * [go-runewidth](https://github.com/mattn/go-runewidth) **star:402** 函数获取字符或字符串的固定宽度。   [![godoc][GoDoc]](https://godoc.org/github.com/mattn/go-runewidth)
    * [gotext](https://github.com/leonelquinteros/gotext) **star:316** GNU gettext 工具   [![godoc][GoDoc]](https://godoc.org/github.com/leonelquinteros/gotext)
    * [html-to-markdown](https://github.com/JohannesKaufmann/html-to-markdown) **star:306** 将HTML转换成Markdown   [![最近一周有更新][Green]](https://github.com/JohannesKaufmann/html-to-markdown)   [![godoc][GoDoc]](https://godoc.org/github.com/JohannesKaufmann/html-to-markdown)
    * [goq](https://github.com/andrewstuart/goq) **star:206**  声明式 HTML 编组，使用结构标签和 jQuery 语法 (使用 GoQuery).   [![godoc][GoDoc]](https://godoc.org/github.com/andrewstuart/goq)
    * [go-nmea](https://github.com/adrianmo/go-nmea) **star:163** 用于Go语言的NMEA解析器库。   [![最近一周有更新][Green]](https://github.com/adrianmo/go-nmea)   [![godoc][GoDoc]](https://godoc.org/github.com/adrianmo/go-nmea)
    * [gospider](https://github.com/zhshch2002/gospider) **star:140** 一个简单的golang蜘蛛/抓取框架，用3行代码构建一个蜘蛛。从[goribot] (https://github.com/zhshch2002/goribot)   [![godoc][GoDoc]](https://godoc.org/github.com/zhshch2002/gospider)
    * [sdp](https://github.com/gortc/sdp) **star:110** SDP:会话描述协议[[RFC 4566](https://tools.ietf.org/html/rfc4566)]。   [![最近一年没有更新][Yellow]](https://github.com/gortc/sdp)   [![godoc][GoDoc]](https://godoc.org/github.com/gortc/sdp)   [![归档项目][Archived]](https://github.com/gortc/sdp)
    * [podcast](https://github.com/eduncan911/podcast) **star:101** 在Golang兼容iTunes和RSS 2.0播客生成器   [![最近一年没有更新][Yellow]](https://github.com/eduncan911/podcast)   [![godoc][GoDoc]](https://godoc.org/github.com/eduncan911/podcast)
    * [go-zero-width](https://github.com/trubitsyn/go-zero-width) **star:96** 用于Go的零宽度字符检测和删除。   [![最近一年没有更新][Yellow]](https://github.com/trubitsyn/go-zero-width)   [![godoc][GoDoc]](https://godoc.org/github.com/trubitsyn/go-zero-width)
    * [editorconfig-core-go](https://github.com/editorconfig/editorconfig-core-go) **star:89** Editorconfig文件解析器和Go操作器。   [![godoc][GoDoc]](https://godoc.org/github.com/editorconfig/editorconfig-core-go)
    * [align](https://github.com/Guitarbum722/align) **star:72** 对文本进行对齐的通用应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/Guitarbum722/align)
    * [go-slugify](https://github.com/mozillazg/go-slugify) **star:70** 生成漂亮的固定链接地址（slug），支持多种语言   [![最近一年没有更新][Yellow]](https://github.com/mozillazg/go-slugify)   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-slugify)
    * [go-vcard](https://github.com/emersion/go-vcard) **star:65** 解析和格式化vCard。   [![godoc][GoDoc]](https://godoc.org/github.com/emersion/go-vcard)
    * [genex](https://github.com/alixaxel/genex) **star:62** 将正则表达式计数并展开为所有匹配的字符串。   [![最近一年没有更新][Yellow]](https://github.com/alixaxel/genex)   [![godoc][GoDoc]](https://godoc.org/github.com/alixaxel/genex)
    * [github_flavored_markdown](https://godoc.org/github.com/shurcooL/github_flavored_markdown)  GitHub 风格的 Markdown 渲染器 (使用 blackfriday) ，支持代码块高亮以及可点击的锚点
    * [goregen](https://github.com/zach-klippenstein/goregen) **star:60** 根据正则表达式生成随机字符串   [![godoc][GoDoc]](https://godoc.org/github.com/zach-klippenstein/goregen)
    * [go-fixedwidth](https://github.com/ianlopshire/go-fixedwidth) **star:57** 固定宽度的文本格式(带反射的编码器/解码器)。   [![最近一周有更新][Green]](https://github.com/ianlopshire/go-fixedwidth)   [![godoc][GoDoc]](https://godoc.org/github.com/ianlopshire/go-fixedwidth)
    * [did](https://github.com/ockam-network/did) **star:56** DID(分散标识符)解析器和Stringer。   [![最近一年没有更新][Yellow]](https://github.com/ockam-network/did)   [![godoc][GoDoc]](https://godoc.org/github.com/ockam-network/did)
    * [guesslanguage](https://github.com/endeveit/guesslanguage) **star:52** 通过一个 unicode 文本来猜测该文本使用的语言   [![最近一年没有更新][Yellow]](https://github.com/endeveit/guesslanguage)   [![godoc][GoDoc]](https://godoc.org/github.com/endeveit/guesslanguage)
    * [allot](https://github.com/sbstjn/allot) **star:50** 用于CLI工具和机器人的占位符和通配符文本解析。   [![godoc][GoDoc]](https://godoc.org/github.com/sbstjn/allot)
    * [pagser](https://github.com/foolin/pagser) **star:48** Pagser是一个简单的，可扩展的，可配置的解析和反序列化的html页面结构，基于goquery和结构标签的golang爬虫。   [![godoc][GoDoc]](https://godoc.org/github.com/foolin/pagser)
    * [bafi](https://github.com/mmalcek/bafi) **star:46** 通用JSON, BSON, YAML, XML翻译到任何格式使用模板。   [![godoc][GoDoc]](https://godoc.org/github.com/mmalcek/bafi)
    * [gonameparts](https://github.com/polera/gonameparts) **star:32** 将人名解析为单独的名称部分。   [![最近一年没有更新][Yellow]](https://github.com/polera/gonameparts)   [![godoc][GoDoc]](https://godoc.org/github.com/polera/gonameparts)
    * [Slugify](https://github.com/avelino/slugify) **star:30** 字符串 slug 化的工具。   [![最近一年没有更新][Yellow]](https://github.com/avelino/slugify)   [![godoc][GoDoc]](https://godoc.org/github.com/avelino/slugify)
    * [normalize](https://github.com/avito-tech/normalize) **star:23** 消毒，规范化和比较模糊的文本。   [![godoc][GoDoc]](https://godoc.org/github.com/avito-tech/normalize)
    * [codetree](https://github.com/aerogo/codetree) **star:18** 解析缩进代码(python、pixy、scarlet等)并返回树结构。   [![最近一年没有更新][Yellow]](https://github.com/aerogo/codetree)   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/codetree)
    * [enca](https://github.com/endeveit/enca) **star:10** 最小的cgo绑定[libenca](https://cihar.com/software/enca/)。   [![最近一年没有更新][Yellow]](https://github.com/endeveit/enca)   [![godoc][GoDoc]](https://godoc.org/github.com/endeveit/enca)
    * [syndfeed](https://github.com/zhengchun/syndfeed) **star:7** Atom 1.0和RSS 2.0的联合提要。   [![最近一年没有更新][Yellow]](https://github.com/zhengchun/syndfeed)   [![godoc][GoDoc]](https://godoc.org/github.com/zhengchun/syndfeed)
    * [ltsv](https://github.com/Wing924/ltsv) **star:6** 高性能[LTSV(Labeled Tab Separated Value)](http://ltsv.org/)。   [![最近一年没有更新][Yellow]](https://github.com/Wing924/ltsv)   [![godoc][GoDoc]](https://godoc.org/github.com/Wing924/ltsv)
    * [bbConvert](https://github.com/CalebQ42/bbConvert) **star:5** 将bbCode转换为HTML，使您可以添加对自定义bbCode标记的支持。   [![最近一年没有更新][Yellow]](https://github.com/CalebQ42/bbConvert)   [![godoc][GoDoc]](https://godoc.org/github.com/CalebQ42/bbConvert)
    * [doi](https://github.com/hscells/doi) **star:5** 文档对象标识符(doi)解析器。   [![最近一年没有更新][Yellow]](https://github.com/hscells/doi)   [![godoc][GoDoc]](https://godoc.org/github.com/hscells/doi)
    * [go-wildcard](https://github.com/IGLOU-EU/go-wildcard) **star:5** 简单而轻量级的通配符模式匹配。   [![最近一周有更新][Green]](https://github.com/IGLOU-EU/go-wildcard)   [![godoc][GoDoc]](https://godoc.org/github.com/IGLOU-EU/go-wildcard)
    * [encdec](https://github.com/mickep76/encdec) **star:4** 软件包为编码器和解码器提供了通用接口。   [![最近一年没有更新][Yellow]](https://github.com/mickep76/encdec)   [![godoc][GoDoc]](https://godoc.org/github.com/mickep76/encdec)
    * [go-output-format](https://github.com/drewstinnett/go-output-format) **star:4** 在你的命令行应用程序中将go结构输出为多种格式(YAML/JSON/etc)。   [![godoc][GoDoc]](https://godoc.org/github.com/drewstinnett/go-output-format)
* Utility
    * [xurls](https://github.com/mvdan/xurls) **star:851** 从文本中提取url。   [![godoc][GoDoc]](https://godoc.org/github.com/mvdan/xurls)
    * [gotabulate](https://github.com/bndr/gotabulate) **star:274** 使用 Go 语言简单、美观的打印表格数据   [![godoc][GoDoc]](https://godoc.org/github.com/bndr/gotabulate)
    * [radix](https://github.com/yourbasic/radix) **star:170** 快速字符串排序算法。   [![最近一年没有更新][Yellow]](https://github.com/yourbasic/radix)   [![godoc][GoDoc]](https://godoc.org/github.com/yourbasic/radix)
    * [regroup](https://github.com/oriser/regroup) **star:99** 使用结构标记和自动解析将正则表达式命名组匹配到go结构中。   [![godoc][GoDoc]](https://godoc.org/github.com/oriser/regroup)
    * [gofuckyourself](https://github.com/JoshuaDoes/gofuckyourself) **star:40** 一个基于 sanitization 的 Go 敏感词过滤器。   [![godoc][GoDoc]](https://godoc.org/github.com/JoshuaDoes/gofuckyourself)
    * [parth](https://github.com/codemodus/parth) **star:39** URL路径分割解析。   [![最近一年没有更新][Yellow]](https://github.com/codemodus/parth)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/parth)
    * [xj2go](https://github.com/stackerzzq/xj2go) **star:21** 将xml或json转换为struct。   [![godoc][GoDoc]](https://godoc.org/github.com/stackerzzq/xj2go)
    * [Tagify](https://github.com/zoomio/tagify) **star:17** 从给定源生成一组标记。   [![最近一周有更新][Green]](https://github.com/zoomio/tagify)   [![godoc][GoDoc]](https://godoc.org/github.com/zoomio/tagify)
    * [kace](https://github.com/codemodus/kace) **star:16** 通用大小写转换工具   [![最近一年没有更新][Yellow]](https://github.com/codemodus/kace)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/kace)
    * [TySug](https://github.com/Dynom/TySug) **star:9** 关于键盘布局的其他建议。   [![最近一年没有更新][Yellow]](https://github.com/Dynom/TySug)   [![godoc][GoDoc]](https://godoc.org/github.com/Dynom/TySug)
    * [parseargs-go](https://github.com/nproc/parseargs-go) **star:8** 字符串参数解析器，能够理解引用及反斜杠。   [![最近一年没有更新][Yellow]](https://github.com/nproc/parseargs-go)   [![godoc][GoDoc]](https://godoc.org/github.com/nproc/parseargs-go)
	* [textwrap](https://github.com/isbm/textwrap) **star:1** 从Python实现“textwrap”模块。   [![最近一年没有更新][Yellow]](https://github.com/isbm/textwrap)   [![godoc][GoDoc]](https://godoc.org/github.com/isbm/textwrap)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#text-processing) 吧~)*

## 第三方api

*用于访问第三方api的库。 (翻译出错了? 试试 [英文版](README_EN.md#third-party-apis) 吧~)*

* [github](https://github.com/google/go-github) **star:8053** 访问GitHub REST API v3的库。   [![star > 2000][Awesome]](https://github.com/google/go-github)   [![最近一周有更新][Green]](https://github.com/google/go-github)   [![godoc][GoDoc]](https://godoc.org/github.com/google/go-github)
* [aws-sdk-go](https://github.com/aws/aws-sdk-go) **star:7327** AWS 提供的官方go语言 SDK   [![star > 2000][Awesome]](https://github.com/aws/aws-sdk-go)   [![最近一周有更新][Green]](https://github.com/aws/aws-sdk-go)   [![godoc][GoDoc]](https://godoc.org/github.com/aws/aws-sdk-go)
* [slack](https://github.com/slack-go/slack) **star:3777** Slack API。   [![star > 2000][Awesome]](https://github.com/slack-go/slack)   [![最近一周有更新][Green]](https://github.com/slack-go/slack)   [![godoc][GoDoc]](https://godoc.org/github.com/slack-go/slack)
* [google](https://github.com/google/google-api-go-client) **star:2881** 为Go自动生成谷歌api。   [![star > 2000][Awesome]](https://github.com/google/google-api-go-client)   [![最近一周有更新][Green]](https://github.com/google/google-api-go-client)   [![godoc][GoDoc]](https://godoc.org/github.com/google/google-api-go-client)
* [google-cloud](https://github.com/GoogleCloudPlatform/gcloud-golang) **star:2736** 谷歌云api Go 客户端库。   [![star > 2000][Awesome]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![最近一周有更新][Green]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/GoogleCloudPlatform/gcloud-golang)
* [discordgo](https://github.com/bwmarrin/discordgo) **star:2656**  Discord Chat API的客户端。   [![star > 2000][Awesome]](https://github.com/bwmarrin/discordgo)   [![最近一周有更新][Green]](https://github.com/bwmarrin/discordgo)   [![godoc][GoDoc]](https://godoc.org/github.com/bwmarrin/discordgo)
* [minio-go](https://github.com/minio/minio-go) **star:1491** 用于Amazon S3兼容云存储的Minio Go库。   [![最近一周有更新][Green]](https://github.com/minio/minio-go)   [![godoc][GoDoc]](https://godoc.org/github.com/minio/minio-go)
* [stripe](https://github.com/stripe/stripe-go) **star:1489**  Stripe API 的 Go 语言客户端   [![最近一周有更新][Green]](https://github.com/stripe/stripe-go)   [![godoc][GoDoc]](https://godoc.org/github.com/stripe/stripe-go)
* [go-twitter](https://github.com/dghubble/go-twitter) **star:1376**  Twitter v1.1 api 的客户端.   [![godoc][GoDoc]](https://godoc.org/github.com/dghubble/go-twitter)
* [anaconda](https://github.com/ChimeraCoder/anaconda) **star:1108**  Twitter 1.1 API 的 go 语言客户端   [![godoc][GoDoc]](https://godoc.org/github.com/ChimeraCoder/anaconda)
* [go-jira](https://github.com/andygrunwald/go-jira) **star:1048**  Go [Atlassian JIRA](https://www.atlassian.com/software/jira)的客户端库   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/go-jira)
* [facebook](https://github.com/huandu/facebook) **star:1027** 支持 Facebook Graph API 的库   [![godoc][GoDoc]](https://godoc.org/github.com/huandu/facebook)
* [githubql](https://github.com/shurcooL/githubql) **star:836** 访问GitHub GraphQL API v4的库。   [![最近一周有更新][Green]](https://github.com/shurcooL/githubql)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/githubql)
* [webhooks](https://github.com/go-playground/webhooks) **star:687** GitHub 和 Bitbucket 的Webhook接收器。   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/webhooks)
* [paypal](https://github.com/logpacker/PayPal-Go-SDK) **star:463** PayPal支付API的包装器。   [![godoc][GoDoc]](https://godoc.org/github.com/logpacker/PayPal-Go-SDK)
* [geo-golang](https://github.com/codingsince1985/geo-golang) **star:423** 去图书馆访问谷歌地图(https://developers.google.com/maps/documentation/geocoding/intro), (MapQuest) (https://open.mapquestapi.com/geocoding/), (Nominatim) (https://developer.mapquest.com/documentation/open/nominatim-search), (OpenCage) (https://opencagedata.com/api), (Bing) (https://msdn.microsoft.com/en-us/library/ff701715.aspx),[Mapbox](https://www.mapbox.com/developers/api/geocoding/)和[OpenStreetMap](https://wiki.openstreetmap.org/wiki/Nominatim)地理编码/反向地理编码api。   [![godoc][GoDoc]](https://godoc.org/github.com/codingsince1985/geo-golang)
* [ethrpc](https://github.com/onrik/ethrpc) **star:221**  Ethereum JSON RPC API的客户端。   [![最近一年没有更新][Yellow]](https://github.com/onrik/ethrpc)   [![godoc][GoDoc]](https://godoc.org/github.com/onrik/ethrpc)
* [go-marathon](https://github.com/gambol99/go-marathon) **star:196**  用于和 Mesosphere's Marathon PAAS 交互的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/gambol99/go-marathon)   [![godoc][GoDoc]](https://godoc.org/github.com/gambol99/go-marathon)
* [Trello](https://github.com/adlio/trello) **star:191**  Trello API的 Go 语言封装。   [![godoc][GoDoc]](https://godoc.org/github.com/adlio/trello)
* [twitter-scraper](https://github.com/n0madic/twitter-scraper) **star:170** 刮Twitter前端API没有认证和限制。   [![最近一周有更新][Green]](https://github.com/n0madic/twitter-scraper)   [![godoc][GoDoc]](https://godoc.org/github.com/n0madic/twitter-scraper)
* [Medium](https://github.com/Medium/medium-sdk-go) **star:131** Medium的OAuth2 API 客户端。   [![最近一年没有更新][Yellow]](https://github.com/Medium/medium-sdk-go)   [![godoc][GoDoc]](https://godoc.org/github.com/Medium/medium-sdk-go)
* [gostorm](https://github.com/jsgilmore/gostorm) **star:128** GoStorm是一个Go库，它实现了编写Storm spout和bolt所需的通信协议，这些协议用于与Storm shell通信。   [![最近一年没有更新][Yellow]](https://github.com/jsgilmore/gostorm)   [![godoc][GoDoc]](https://godoc.org/github.com/jsgilmore/gostorm)
* [lark](https://github.com/chyroc/lark) **star:121** [飞舒](https://open.feishu.cn/)/[Lark](https://open.larksuite.com/) Go SDK开放API，支持所有开放API和事件回调。   [![最近一周有更新][Green]](https://github.com/chyroc/lark)   [![godoc][GoDoc]](https://godoc.org/github.com/chyroc/lark)   [![包含中文文档][CN]](https://github.com/chyroc/lark)
* [go-trending](https://github.com/andygrunwald/go-trending) **star:119** 在Github上访问[trends repository](https://github.com/trends)和[developers](https://github.com/trending/developers)的库。   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/go-trending)
* [wit-go](https://github.com/wit-ai/wit-go) **star:112** wit.ai HTTP API 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/wit-ai/wit-go)
* [hipchat (xmpp)](https://github.com/daneharrigan/hipchat) **star:110** 一个用于通过XMPP与HipChat通信的golang包。   [![最近一年没有更新][Yellow]](https://github.com/daneharrigan/hipchat)   [![godoc][GoDoc]](https://godoc.org/github.com/daneharrigan/hipchat)
* [pushover](https://github.com/gregdel/pushover) **star:108**  Go 包装的 Pushover API。   [![godoc][GoDoc]](https://godoc.org/github.com/gregdel/pushover)
* [hipchat](https://github.com/andybons/hipchat) **star:104** 这个项目为Hipchat API实现了一个golang客户端库。   [![最近一年没有更新][Yellow]](https://github.com/andybons/hipchat)   [![godoc][GoDoc]](https://godoc.org/github.com/andybons/hipchat)
* [cachet](https://github.com/andygrunwald/cachet) **star:89** 使用客户端库[Cachet(开源状态页系统)](https://cachethq.io/)。   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/cachet)
* [simples3](https://github.com/rhnvrm/simples3) **star:74** 使用REST和用Go编写的V4签名的AWS S3库非常简单。   [![godoc][GoDoc]](https://godoc.org/github.com/rhnvrm/simples3)
* [go-lark](https://github.com/go-lark/lark) **star:70** 一个易于使用的非官方SDK为[飞书](https://open.feishu.cn/)和[Lark](https://open.larksuite.com/)开放平台。   [![godoc][GoDoc]](https://godoc.org/github.com/go-lark/lark)   [![包含中文文档][CN]](https://github.com/go-lark/lark)
* [gosip](https://github.com/koltyakov/gosip) **star:70** 去客户端库SharePoint API。   [![godoc][GoDoc]](https://godoc.org/github.com/koltyakov/gosip)
* [igdb](https://github.com/Henry-Sarabia/igdb) **star:69** [Internet Game Database API](https://api.igdb.com/) 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/igdb)
* [circleci](https://github.com/jszwedko/go-circleci) **star:61** CircleCI的API的客户端   [![最近一年没有更新][Yellow]](https://github.com/jszwedko/go-circleci)   [![godoc][GoDoc]](https://godoc.org/github.com/jszwedko/go-circleci)
* [go-unsplash](https://github.com/hbagdi/go-unsplash) **star:58** 使用[Unsplash.com](https://unsplash.com) API的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/hbagdi/go-unsplash)
* [gogtrends](https://github.com/groovili/gogtrends) **star:58** 非官方的Google Trends API。   [![godoc][GoDoc]](https://godoc.org/github.com/groovili/gogtrends)
* [clarifai](https://github.com/samuelcouch/clarifai) **star:55** Clarifai API的客户端。   [![最近一年没有更新][Yellow]](https://github.com/samuelcouch/clarifai)   [![godoc][GoDoc]](https://godoc.org/github.com/samuelcouch/clarifai)
* [megos](https://github.com/andygrunwald/megos) **star:54** 用于访问[Apache Mesos](https://mesos.apache.org/)集群的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/andygrunwald/megos)
* [amazon-product-advertising-api](https://github.com/ngs/go-amazon-product-advertising-api) **star:51** [Amazon Product Advertising API](https://program.amazon.com/gp/advertising/api/detail/main.html)的客户端库。   [![最近一年没有更新][Yellow]](https://github.com/ngs/go-amazon-product-advertising-api)   [![godoc][GoDoc]](https://godoc.org/github.com/ngs/go-amazon-product-advertising-api)
* [gads](https://github.com/emiddleton/gads) **star:49**  Google Adwords 非官方 API   [![godoc][GoDoc]](https://godoc.org/github.com/emiddleton/gads)
* [ynab](https://github.com/brunomvsouza/ynab.go) **star:49**  YNAB API 的 Go 语言封装。   [![godoc][GoDoc]](https://godoc.org/github.com/brunomvsouza/ynab.go)
* [golang-tmdb](https://github.com/cyruzin/golang-tmdb) **star:47** 电影数据库API v3的Golang包装器。   [![godoc][GoDoc]](https://godoc.org/github.com/cyruzin/golang-tmdb)
* [go-xkcd](https://github.com/nishanths/go-xkcd) **star:45**  xkcd API 的客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/nishanths/go-xkcd)
* [go-yapla](https://git.iglou.eu/Production/go-yapla)  Go ypla v2.0 API的客户端库。
* [uptimerobot](https://github.com/bitfield/uptimerobot) **star:45** 运行时Robot v2 API 的 Go 语言封装和命令行客户端。   [![最近一年没有更新][Yellow]](https://github.com/bitfield/uptimerobot)   [![godoc][GoDoc]](https://godoc.org/github.com/bitfield/uptimerobot)
* [fcm](https://github.com/maddevsio/fcm) **star:44**  Firebase Cloud Messaging 的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/maddevsio/fcm)   [![godoc][GoDoc]](https://godoc.org/github.com/maddevsio/fcm)
* [GoMusicBrainz](https://github.com/michiwend/gomusicbrainz) **star:44**  Go MusicBrainz WS2客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/michiwend/gomusicbrainz)
* [mixpanel](https://github.com/dukex/mixpanel) **star:42** Mixpanel是一个库，用于跟踪事件并将Mixpanel概要文件更新从go应用程序发送到Mixpanel。   [![godoc][GoDoc]](https://godoc.org/github.com/dukex/mixpanel)
* [spotify](https://github.com/rapito/go-spotify) **star:42**  用于接入 Spotify WEB API 的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/rapito/go-spotify)   [![godoc][GoDoc]](https://godoc.org/github.com/rapito/go-spotify)
* [go-postman-collection](https://github.com/rbretecher/go-postman-collection) **star:38** 去模块工作与[邮递员收集](https://learning.getpostman.com/docs/postman/collections/creating-collections/)(兼容失眠)。   [![godoc][GoDoc]](https://godoc.org/github.com/rbretecher/go-postman-collection)
* [golyrics](https://github.com/mamal72/golyrics) **star:36** Golyrics是一个从Wikia网站获取音乐歌词数据的Go库。   [![最近一年没有更新][Yellow]](https://github.com/mamal72/golyrics)   [![godoc][GoDoc]](https://godoc.org/github.com/mamal72/golyrics)
* [airtable](https://github.com/mehanizm/airtable) **star:31** 去客户端库[Airtable API](https://airtable.com/api)。   [![godoc][GoDoc]](https://godoc.org/github.com/mehanizm/airtable)
* [translate](https://github.com/poorny/translate) **star:31**  Go 在线翻译包。   [![最近一年没有更新][Yellow]](https://github.com/poorny/translate)   [![godoc][GoDoc]](https://godoc.org/github.com/poorny/translate)   [![归档项目][Archived]](https://github.com/poorny/translate)
* [gami](https://github.com/bit4bit/gami) **star:30**  Asterisk Manager Interface 的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/bit4bit/gami)   [![godoc][GoDoc]](https://godoc.org/github.com/bit4bit/gami)   [![归档项目][Archived]](https://github.com/bit4bit/gami)
* [gcm](https://github.com/Aorioli/gcm) **star:30**  Google Cloud Messaging 库   [![最近一年没有更新][Yellow]](https://github.com/Aorioli/gcm)   [![godoc][GoDoc]](https://godoc.org/github.com/Aorioli/gcm)
* [patreon-go](https://github.com/mxpv/patreon-go) **star:27**  Go Patreon API库。   [![最近一年没有更新][Yellow]](https://github.com/mxpv/patreon-go)   [![godoc][GoDoc]](https://godoc.org/github.com/mxpv/patreon-go)
* [go-myanimelist](https://github.com/nstratos/go-myanimelist) **star:26** 去访问[MyAnimeList API]的客户端库(https://myanimelist.net/apiconfig/references/api/v2)。   [![godoc][GoDoc]](https://godoc.org/github.com/nstratos/go-myanimelist)
* [steam](https://github.com/sostronk/go-steam) **star:24**  用于与Steam服务器进行交互的库。   [![godoc][GoDoc]](https://godoc.org/github.com/sostronk/go-steam)
* [google-play-scraper](https://github.com/n0madic/google-play-scraper) **star:23** 从谷歌播放存储获取数据。   [![最近一周有更新][Green]](https://github.com/n0madic/google-play-scraper)   [![godoc][GoDoc]](https://godoc.org/github.com/n0madic/google-play-scraper)
* [lastpass-go](https://github.com/ansd/lastpass-go) **star:23** 使用[LastPass](https://www.lastpass.com/) API的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/ansd/lastpass-go)
* [shopify](https://github.com/rapito/go-shopify) **star:22** 一个用于通过 Shopify API 进行增删改查的 Go 语言库。   [![最近一年没有更新][Yellow]](https://github.com/rapito/go-shopify)   [![godoc][GoDoc]](https://godoc.org/github.com/rapito/go-shopify)
* [go-imgur](https://github.com/koffeinsource/go-imgur) **star:21** Go [imgur](https://imgur.com)的客户端库   [![godoc][GoDoc]](https://godoc.org/github.com/koffeinsource/go-imgur)
* [go-twitch](https://github.com/knspriggs/go-twitch) **star:21**  Twitch v3 API 的客户端。   [![最近一年没有更新][Yellow]](https://github.com/knspriggs/go-twitch)   [![godoc][GoDoc]](https://godoc.org/github.com/knspriggs/go-twitch)
* [codeship-go](https://github.com/codeship/codeship-go) **star:18**  Codeship API v2的客户端。   [![最近一年没有更新][Yellow]](https://github.com/codeship/codeship-go)   [![godoc][GoDoc]](https://godoc.org/github.com/codeship/codeship-go)
* [brewerydb](https://github.com/naegelejd/brewerydb) **star:17** 用于访问 BreweryDB API的 Go 语言库   [![最近一年没有更新][Yellow]](https://github.com/naegelejd/brewerydb)   [![godoc][GoDoc]](https://godoc.org/github.com/naegelejd/brewerydb)
* [textbelt](https://github.com/dietsche/textbelt) **star:17** textbelt.com txt messaging API 的go语言客户端。   [![最近一年没有更新][Yellow]](https://github.com/dietsche/textbelt)   [![godoc][GoDoc]](https://godoc.org/github.com/dietsche/textbelt)
* [coinpaprika-go](https://github.com/coinpaprika/coinpaprika-api-go-client) **star:14** Coinpaprika API的客户端。   [![最近一年没有更新][Yellow]](https://github.com/coinpaprika/coinpaprika-api-go-client)   [![godoc][GoDoc]](https://godoc.org/github.com/coinpaprika/coinpaprika-api-go-client)
* [go-hacknews](https://github.com/PaulRosset/go-hacknews) **star:14** HackerNews API的小型Go客户端。   [![最近一年没有更新][Yellow]](https://github.com/PaulRosset/go-hacknews)   [![godoc][GoDoc]](https://godoc.org/github.com/PaulRosset/go-hacknews)
* [go-aws-news](https://github.com/circa10a/go-aws-news) **star:13** 去应用程序和库获取AWS的新内容。   [![godoc][GoDoc]](https://godoc.org/github.com/circa10a/go-aws-news)
* [google-analytics](https://github.com/chonthu/go-google-analytics) **star:12** 简单的包装，方便的谷歌分析报告。   [![最近一年没有更新][Yellow]](https://github.com/chonthu/go-google-analytics)   [![godoc][GoDoc]](https://godoc.org/github.com/chonthu/go-google-analytics)
* [jokeapi-go](https://github.com/icelain/jokeapi) **star:12** 去客户端[JokeAPI](https://sv443.net/jokeapi/v2/)。   [![godoc][GoDoc]](https://godoc.org/github.com/icelain/jokeapi)
* [gopaapi5](https://github.com/utekaravinash/gopaapi5) **star:11** Go客户端库[亚马逊产品广告API 5.0](https://webservices.amazon.com/paapi5/documentation/)。   [![最近一年没有更新][Yellow]](https://github.com/utekaravinash/gopaapi5)   [![godoc][GoDoc]](https://godoc.org/github.com/utekaravinash/gopaapi5)
* [device-check-go](https://github.com/rinchsan/device-check-go) **star:10** Go客户端库与[iOS DeviceCheck API](https://developer.apple.com/documentation/devicecheck) v1交互。   [![godoc][GoDoc]](https://godoc.org/github.com/rinchsan/device-check-go)
* [go-here](https://github.com/abdullahselek/go-here) **star:10** 转到基于这里位置的api的客户端库。   [![最近一年没有更新][Yellow]](https://github.com/abdullahselek/go-here)   [![godoc][GoDoc]](https://godoc.org/github.com/abdullahselek/go-here)
* [go-openproject](https://github.com/manuelbcd/go-openproject) **star:10** 去与[OpenProject](https://docs.openproject.org/api/) API交互的客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/manuelbcd/go-openproject)
* [smite](https://github.com/sergiotapia/smitego) **star:10** 对 Smite game API 的封装。   [![最近一年没有更新][Yellow]](https://github.com/sergiotapia/smitego)   [![godoc][GoDoc]](https://godoc.org/github.com/sergiotapia/smitego)
* [gomalshare](https://github.com/MonaxGT/gomalshare) **star:9** 去图书馆MalShare API [malshare.com](https://www.malshare.com/)   [![最近一年没有更新][Yellow]](https://github.com/MonaxGT/gomalshare)   [![godoc][GoDoc]](https://godoc.org/github.com/MonaxGT/gomalshare)
* [bqwriter](https://github.com/OTA-Insight/bqwriter) **star:8** High Level Go Library将数据写入[谷歌BigQuery](https://cloud.google.com/bigquery)在高位贯穿。   [![godoc][GoDoc]](https://godoc.org/github.com/OTA-Insight/bqwriter)
* [go-sophos](https://github.com/esurdam/go-sophos) **star:8** 无任何依赖的[Sophos UTM REST API](https://www.sophos.com/en-us/medialibrary/pdfs/documentation/utmonaws/sophos-ut-restful-api.pdf?la=en)客户端   [![最近一年没有更新][Yellow]](https://github.com/esurdam/go-sophos)   [![godoc][GoDoc]](https://godoc.org/github.com/esurdam/go-sophos)
* [rrdaclient](https://github.com/Omie/rrdaclient) **star:8** 用于接入 statdns.com API 的库——RRDA API。通过HTTP协议进行 DNS查询。   [![最近一年没有更新][Yellow]](https://github.com/Omie/rrdaclient)   [![godoc][GoDoc]](https://godoc.org/github.com/Omie/rrdaclient)   [![归档项目][Archived]](https://github.com/Omie/rrdaclient)
* [google-email-audit-api](https://github.com/ngs/go-google-email-audit-api) **star:7** [谷歌G Suite Email Audit API](https://developer.google.com/admin-sdk/email-audit/) 的客户端。   [![最近一年没有更新][Yellow]](https://github.com/ngs/go-google-email-audit-api)   [![godoc][GoDoc]](https://godoc.org/github.com/ngs/go-google-email-audit-api)
* [zooz](https://github.com/gojuno/go-zooz) **star:7**  Zooz API 的 Go 语言客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/gojuno/go-zooz)
* [go-sptrans](https://github.com/sergioaugrod/go-sptrans) **star:6**  SPTrans Olho Vivo API 的客户端。   [![最近一年没有更新][Yellow]](https://github.com/sergioaugrod/go-sptrans)   [![godoc][GoDoc]](https://godoc.org/github.com/sergioaugrod/go-sptrans)
* [tumblr](https://github.com/mattcunningham/gumblr) **star:6**  Tumblr v2 API 的 Go 语言封装。   [![最近一年没有更新][Yellow]](https://github.com/mattcunningham/gumblr)   [![godoc][GoDoc]](https://godoc.org/github.com/mattcunningham/gumblr)
* [libgoffi](https://github.com/clevabit/libgoffi) **star:5** 用于本地[libffi](https://sourceware.org/libffi/)集成的库适配器工具箱   [![最近一年没有更新][Yellow]](https://github.com/clevabit/libgoffi)   [![godoc][GoDoc]](https://godoc.org/github.com/clevabit/libgoffi)
* [go-chronos](https://github.com/axelspringer/go-chronos) **star:4** 用于与[Chronos](https://mesos.github.io/chronos/)作业调度程序进行交互的Go库   [![最近一年没有更新][Yellow]](https://github.com/axelspringer/go-chronos)   [![godoc][GoDoc]](https://godoc.org/github.com/axelspringer/go-chronos)
* [go-swagger-ui](https://github.com/esurdam/go-swagger-ui) **star:4** Go库包含预编译[Swagger UI](https://swagger.io/tools/swagger-ui/)，用于服务Swagger json。
* [go-telegraph](https://gitlab.com/toby3d/telegraph)  Telegraph 发布平台 API 客户端。
* [rawg-sdk-go](https://github.com/dimuska139/rawg-sdk-go) **star:4** 去[RAWG视频游戏数据库](https://rawg.io/) API库   [![godoc][GoDoc]](https://godoc.org/github.com/dimuska139/rawg-sdk-go)
* [go-restcountries](https://github.com/chriscross0/go-restcountries) **star:3** 去[REST国家API]库(https://restcountries.eu/)。   [![godoc][GoDoc]](https://godoc.org/github.com/chriscross0/go-restcountries)
* [kanka](https://github.com/Henry-Sarabia/kanka) **star:3** [Kanka API](https://kanka.io/en-US/docs/1.0)的Go客户端。   [![最近一年没有更新][Yellow]](https://github.com/Henry-Sarabia/kanka)   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/kanka)
* [appstore-sdk-go](https://github.com/Kachit/appstore-sdk-go) **star:2** 非官方的用于AppStore Connect API的Golang SDK。   [![godoc][GoDoc]](https://godoc.org/github.com/Kachit/appstore-sdk-go)
* [playlyfe](https://github.com/playlyfe/playlyfe-go-sdk) **star:1** Playlyfe Rest API Go SDK。   [![最近一年没有更新][Yellow]](https://github.com/playlyfe/playlyfe-go-sdk)   [![godoc][GoDoc]](https://godoc.org/github.com/playlyfe/playlyfe-go-sdk)
* [TripAdvisor](https://github.com/mrbenosborne/tripadvisor-golang) **star:1**  TripAdvisor API 的 Go 语言封装。   [![最近一年没有更新][Yellow]](https://github.com/mrbenosborne/tripadvisor-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/mrbenosborne/tripadvisor-golang)
* [vl-go](https://github.com/verifid/vl-go) **star:1** 使用客户端库中的VerifID身份验证层API。   [![godoc][GoDoc]](https://godoc.org/github.com/verifid/vl-go)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#third-party-apis) 吧~)*

## 公用事业公司

*可以让你的生活变得更简单的实用工具.。 (翻译出错了? 试试 [英文版](README_EN.md#utilities) 吧~)*

* [fzf](https://github.com/junegunn/fzf) **star:41525** 用Go编写的命令行模糊查找器。   [![star > 2000][Awesome]](https://github.com/junegunn/fzf)   [![最近一周有更新][Green]](https://github.com/junegunn/fzf)   [![godoc][GoDoc]](https://godoc.org/github.com/junegunn/fzf)
* [hub](https://github.com/github/hub) **star:21470** 封装了 git 命令，提供了额外的功能用于在终端中和 Github 进行交互。   [![star > 2000][Awesome]](https://github.com/github/hub)   [![最近一周有更新][Green]](https://github.com/github/hub)   [![godoc][GoDoc]](https://godoc.org/github.com/github/hub)
* [ctop](https://github.com/bcicen/ctop) **star:12261** [Top-like](https://ctop.sh)接口(例如htop)用于容器度量。   [![star > 2000][Awesome]](https://github.com/bcicen/ctop)   [![godoc][GoDoc]](https://godoc.org/github.com/bcicen/ctop)
* [sqlx](https://github.com/jmoiron/sqlx) **star:11310** 为内建的数据库/sql 软件包提供一组扩展。   [![star > 2000][Awesome]](https://github.com/jmoiron/sqlx)   [![godoc][GoDoc]](https://godoc.org/github.com/jmoiron/sqlx)
* [wuzz](https://github.com/asciimoo/wuzz) **star:9870** 用于HTTP检查的交互式cli工具。   [![star > 2000][Awesome]](https://github.com/asciimoo/wuzz)   [![最近一周有更新][Green]](https://github.com/asciimoo/wuzz)   [![godoc][GoDoc]](https://godoc.org/github.com/asciimoo/wuzz)
* [goreleaser](https://github.com/goreleaser/goreleaser) **star:9435** 尽可能快速的发布 Go 语言二进制文件。   [![star > 2000][Awesome]](https://github.com/goreleaser/goreleaser)   [![最近一周有更新][Green]](https://github.com/goreleaser/goreleaser)   [![godoc][GoDoc]](https://godoc.org/github.com/goreleaser/goreleaser)
* [usql](https://github.com/knq/usql) **star:6901** usql 是一个通用的命令行接口，用于操作 sql 数据库。   [![star > 2000][Awesome]](https://github.com/knq/usql)   [![最近一周有更新][Green]](https://github.com/knq/usql)   [![godoc][GoDoc]](https://godoc.org/github.com/knq/usql)
* [peco](https://github.com/peco/peco) **star:6700** 简单的交互过滤工具。   [![star > 2000][Awesome]](https://github.com/peco/peco)   [![godoc][GoDoc]](https://godoc.org/github.com/peco/peco)
* [godropbox](https://github.com/dropbox/godropbox) **star:4004** 用于编写 Go 语言服务／应用的库，来自 Dropbox.。   [![star > 2000][Awesome]](https://github.com/dropbox/godropbox)   [![最近一年没有更新][Yellow]](https://github.com/dropbox/godropbox)   [![godoc][GoDoc]](https://godoc.org/github.com/dropbox/godropbox)
* [hystrix-go](https://github.com/afex/hystrix-go) **star:3505** 实现 Hystrix 风格的、程序员预定义的 fallback 机制（熔断。   [![star > 2000][Awesome]](https://github.com/afex/hystrix-go)   [![godoc][GoDoc]](https://godoc.org/github.com/afex/hystrix-go)
* [go-funk](https://github.com/thoas/go-funk) **star:3172** 现代 Go 语言工具库，提供了很多有用的工具 (map, find, contains, filter, chunk, reverse, ...)   [![star > 2000][Awesome]](https://github.com/thoas/go-funk)   [![godoc][GoDoc]](https://godoc.org/github.com/thoas/go-funk)
* [panicparse](https://github.com/maruel/panicparse) **star:3000** 将类似的协程分组并对调用栈进行着色   [![star > 2000][Awesome]](https://github.com/maruel/panicparse)   [![godoc][GoDoc]](https://godoc.org/github.com/maruel/panicparse)
* [goreporter](https://github.com/wgliang/goreporter) **star:2955** 进行代码静态分析，单元测试，代码检视并生成代码质量报告的工具   [![star > 2000][Awesome]](https://github.com/wgliang/goreporter)   [![最近一年没有更新][Yellow]](https://github.com/wgliang/goreporter)   [![godoc][GoDoc]](https://godoc.org/github.com/wgliang/goreporter)
* [minify](https://github.com/tdewolff/minify) **star:2844** 用于HTML、CSS、JS、XML、JSON和SVG文件格式的快速缩小器。   [![star > 2000][Awesome]](https://github.com/tdewolff/minify)   [![最近一周有更新][Green]](https://github.com/tdewolff/minify)   [![godoc][GoDoc]](https://godoc.org/github.com/tdewolff/minify)
* [mc](https://github.com/minio/mc) **star:1984** Minio Client 提供了一组工具，用于操作 Amazon S3 兼容云存储和文件系统。   [![最近一周有更新][Green]](https://github.com/minio/mc)   [![godoc][GoDoc]](https://godoc.org/github.com/minio/mc)
* [Storm](https://github.com/asdine/storm) **star:1834** 一个简单又强大的用于 BoltDB 的工具   [![godoc][GoDoc]](https://godoc.org/github.com/asdine/storm)
* [mergo](https://github.com/imdario/mergo) **star:1826** 用于将结构体和map合并进 Go 语言的工具。对于配置默认值，避免杂乱的if语句很有帮助。   [![godoc][GoDoc]](https://godoc.org/github.com/imdario/mergo)
* [mole](https://github.com/davrodpin/mole) **star:1527** cli应用程序可以轻松创建ssh隧道。   [![godoc][GoDoc]](https://godoc.org/github.com/davrodpin/mole)
* [filetype](https://github.com/h2non/filetype) **star:1472** 通过数字签名来推测文件类型。   [![godoc][GoDoc]](https://godoc.org/github.com/h2non/filetype)
* [boilr](https://github.com/tmrts/boilr) **star:1423** 非常快的CLI工具，用于从样板模板创建项目。   [![godoc][GoDoc]](https://godoc.org/github.com/tmrts/boilr)
* [jump](https://github.com/gsamokovarov/jump) **star:1291** 通过学习你的习惯，可以帮助你更快地导航。   [![godoc][GoDoc]](https://godoc.org/github.com/gsamokovarov/jump)
* [create-go-app](https://github.com/create-go-app/cli) **star:1242** 一个强大的CLI，用于通过运行一个命令创建一个后端服务(Golang)，前端(JavaScript, TypeScript)和部署自动化(Ansible, Docker)的可生产项目。   [![godoc][GoDoc]](https://godoc.org/github.com/create-go-app/cli)
* [circuitbreaker](https://github.com/rubyist/circuitbreaker) **star:972** 接通断路器。   [![最近一年没有更新][Yellow]](https://github.com/rubyist/circuitbreaker)   [![godoc][GoDoc]](https://godoc.org/github.com/rubyist/circuitbreaker)
* [git-time-metric](https://github.com/git-time-metric/gtm) **star:886** git-time-metric - 。   [![最近一年没有更新][Yellow]](https://github.com/git-time-metric/gtm)   [![godoc][GoDoc]](https://godoc.org/github.com/git-time-metric/gtm)
* [immortal](https://github.com/immortal/immortal) **star:716** \*nix 跨平台 (与操作系统无关的)监控程序。   [![最近一年没有更新][Yellow]](https://github.com/immortal/immortal)   [![godoc][GoDoc]](https://godoc.org/github.com/immortal/immortal)
* [hostctl](https://github.com/guumaster/hostctl) **star:706** 一个使用简单命令管理/etc/主机的CLI工具。   [![godoc][GoDoc]](https://godoc.org/github.com/guumaster/hostctl)
* [mimetype](https://github.com/gabriel-vasile/mimetype) **star:647** 用于基于神奇数字的MIME类型检测的包。   [![最近一周有更新][Green]](https://github.com/gabriel-vasile/mimetype)   [![godoc][GoDoc]](https://godoc.org/github.com/gabriel-vasile/mimetype)
* [circuit](https://github.com/cep21/circuit) **star:620** 一个高效和功能齐全的 类似 Hystrix Go 实现断路器模式。   [![godoc][GoDoc]](https://godoc.org/github.com/cep21/circuit)
* [htcat](https://github.com/htcat/htcat) **star:536** 并行及流水线的 HTTP GET 工具。   [![最近一年没有更新][Yellow]](https://github.com/htcat/htcat)   [![godoc][GoDoc]](https://godoc.org/github.com/htcat/htcat)
* [ergo](https://github.com/cristianoliveira/ergo) **star:492** 管理运行在不同端口上的多个本地服务变得很容易。   [![godoc][GoDoc]](https://godoc.org/github.com/cristianoliveira/ergo)
* [godaemon](https://github.com/VividCortex/godaemon) **star:484** 用于编写守护进程的工具   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/godaemon)
* [koazee](https://github.com/wesovilabs/koazee) **star:481** 库的灵感来自于延迟计算和函数式编程，从而减少了使用数组的麻烦。   [![最近一年没有更新][Yellow]](https://github.com/wesovilabs/koazee)   [![godoc][GoDoc]](https://godoc.org/github.com/wesovilabs/koazee)
* [go-dry](https://github.com/ungerik/go-dry) **star:474** DRY(don't repeat yourself)库。   [![最近一周有更新][Green]](https://github.com/ungerik/go-dry)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go-dry)
* [scany](https://github.com/georgysavva/scany) **star:474** 库扫描数据从数据库到Go structs和更多。   [![最近一周有更新][Green]](https://github.com/georgysavva/scany)   [![godoc][GoDoc]](https://godoc.org/github.com/georgysavva/scany)
* [delve](https://github.com/derekparker/delve) **star:443** Go 语言调试器   [![最近一周有更新][Green]](https://github.com/derekparker/delve)   [![godoc][GoDoc]](https://godoc.org/github.com/derekparker/delve)
* [gopencils](https://github.com/bndr/gopencils) **star:438** 小而简单的包，可以轻松地使用REST api。   [![最近一年没有更新][Yellow]](https://github.com/bndr/gopencils)   [![godoc][GoDoc]](https://godoc.org/github.com/bndr/gopencils)
* [request](https://github.com/mozillazg/request) **star:407** Go 语言版的 HTTP Requests for Humans™.。   [![最近一年没有更新][Yellow]](https://github.com/mozillazg/request)   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/request)
* [gubrak](https://github.com/novalagung/gubrak) **star:382** 带有语法糖的Golang实用工具，就像lodash。   [![最近一年没有更新][Yellow]](https://github.com/novalagung/gubrak)   [![godoc][GoDoc]](https://godoc.org/github.com/novalagung/gubrak)
* [Deepcopier](https://github.com/ulule/deepcopier) **star:375** 结构体拷贝   [![最近一年没有更新][Yellow]](https://github.com/ulule/deepcopier)   [![godoc][GoDoc]](https://godoc.org/github.com/ulule/deepcopier)
* [clockwork](https://github.com/jonboulle/clockwork) **star:368** 一个简单的假 clock 。   [![godoc][GoDoc]](https://godoc.org/github.com/jonboulle/clockwork)
* [go-rate](https://github.com/beefsack/go-rate) **star:346**  Go 限速器。   [![最近一年没有更新][Yellow]](https://github.com/beefsack/go-rate)   [![godoc][GoDoc]](https://godoc.org/github.com/beefsack/go-rate)
* [retry](https://github.com/kamilsk/retry) **star:312** 基于上下文的功能机制，反复执行命令直到成功。   [![godoc][GoDoc]](https://godoc.org/github.com/kamilsk/retry)
* [serve](https://github.com/syntaqx/serve) **star:258** 任何您需要的静态http服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/syntaqx/serve)
* [gohper](https://github.com/cosiner/gohper) **star:255** 多种能够帮助你进行软件开发的工具和模块。   [![最近一年没有更新][Yellow]](https://github.com/cosiner/gohper)   [![godoc][GoDoc]](https://godoc.org/github.com/cosiner/gohper)   [![归档项目][Archived]](https://github.com/cosiner/gohper)
* [scan](https://github.com/blockloop/scan) **star:242** 扫描golang的sql。行直接指向结构、片或基本类型。   [![godoc][GoDoc]](https://godoc.org/github.com/blockloop/scan)
* [util](https://github.com/shomali11/util) **star:236** 有用实用函数的集合。(字符串，并发，操作，…)   [![最近一年没有更新][Yellow]](https://github.com/shomali11/util)   [![godoc][GoDoc]](https://godoc.org/github.com/shomali11/util)
* [go-trigger](https://github.com/sadlil/go-trigger) **star:225** Go 语言全局事件触发器，通过 id 和触发器，在程序的任何地方注册事件。   [![最近一年没有更新][Yellow]](https://github.com/sadlil/go-trigger)   [![godoc][GoDoc]](https://godoc.org/github.com/sadlil/go-trigger)
* [gotenv](https://github.com/subosito/gotenv) **star:212** 从 `.env` 或者任何 `io.Reader`。   [![godoc][GoDoc]](https://godoc.org/github.com/subosito/gotenv)
* [grofer](https://github.com/pesos/grofer) **star:190** 一个用Golang编写的系统和资源监控工具!   [![最近一周有更新][Green]](https://github.com/pesos/grofer)   [![godoc][GoDoc]](https://godoc.org/github.com/pesos/grofer)
* [Death](https://github.com/vrecan/death) **star:176** 利用信号管理应用程序的关闭。   [![godoc][GoDoc]](https://godoc.org/github.com/vrecan/death)
* [go-bind-plugin](https://github.com/wendigo/go-bind-plugin) **star:175** Go:generate 工具，用于构建 Go 语言插件(1.8 only)，并对导出的符号进行包装。   [![最近一年没有更新][Yellow]](https://github.com/wendigo/go-bind-plugin)   [![godoc][GoDoc]](https://godoc.org/github.com/wendigo/go-bind-plugin)
* [mani](https://github.com/alajmo/mani) **star:173** CLI工具，帮助您管理多个存储库。   [![godoc][GoDoc]](https://godoc.org/github.com/alajmo/mani)
* [toolbox](https://github.com/viant/toolbox) **star:169** 切片, map, multimap, 结构体, 函数,数据转换工具。服务路由，宏求值和标记器。   [![godoc][GoDoc]](https://godoc.org/github.com/viant/toolbox)
* [go-sitemap-generator](https://github.com/ikeikeikeike/go-sitemap-generator) **star:168** 用Go编写的XML站点地图生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/ikeikeikeike/go-sitemap-generator)
* [pattern-match](https://github.com/alexpantyukhin/go-pattern-match) **star:164** 模式匹配图书馆。   [![最近一年没有更新][Yellow]](https://github.com/alexpantyukhin/go-pattern-match)   [![godoc][GoDoc]](https://godoc.org/github.com/alexpantyukhin/go-pattern-match)
* [rerun](https://github.com/ivpusic/rerun) **star:161** 当源代码发生更改时，重新编译和重新运行go应用程序。   [![最近一年没有更新][Yellow]](https://github.com/ivpusic/rerun)   [![godoc][GoDoc]](https://godoc.org/github.com/ivpusic/rerun)
* [moldova](https://github.com/StabbyCutyou/moldova) **star:160** 基于输入目标生成随机数据的工具   [![最近一年没有更新][Yellow]](https://github.com/StabbyCutyou/moldova)   [![godoc][GoDoc]](https://godoc.org/github.com/StabbyCutyou/moldova)
* [apm](https://github.com/topfreegames/apm) **star:154** Go 语言进程管理工具具有HTTP API.。   [![最近一年没有更新][Yellow]](https://github.com/topfreegames/apm)   [![godoc][GoDoc]](https://godoc.org/github.com/topfreegames/apm)
* [robustly](https://github.com/VividCortex/robustly) **star:151** 有弹性的执行函数，遇到错误时捕获并重新运行。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/robustly)
* [clipboard](https://github.com/golang-design/clipboard) **star:148** 📋跨平台剪贴板包中去。   [![godoc][GoDoc]](https://godoc.org/github.com/golang-design/clipboard)
* [changie](https://github.com/miniscruff/changie) **star:144** 自动化的变更日志工具，用于准备带有大量定制选项的版本。   [![最近一周有更新][Green]](https://github.com/miniscruff/changie)   [![godoc][GoDoc]](https://godoc.org/github.com/miniscruff/changie)
* [countries](https://github.com/biter777/countries) **star:142** 完整实现ISO-3166-1、ISO-4217、ITU-T E.164、Unicode CLDR和IANA ccTLD标准。   [![godoc][GoDoc]](https://godoc.org/github.com/biter777/countries)
* [chyle](https://github.com/antham/chyle) **star:139** 使用具有多种配置可能性的git存储库生成变更日志。   [![最近一周有更新][Green]](https://github.com/antham/chyle)   [![godoc][GoDoc]](https://godoc.org/github.com/antham/chyle)
* [onecache](https://github.com/adelowo/onecache) **star:125** 支持多个后端存储(Redis、Memcached、文件系统等)的缓存库。   [![最近一年没有更新][Yellow]](https://github.com/adelowo/onecache)   [![godoc][GoDoc]](https://godoc.org/github.com/adelowo/onecache)
* [go-bsdiff](https://github.com/gabstv/go-bsdiff) **star:121** 纯Go bsdiff和bspatch库和CLI工具。   [![最近一年没有更新][Yellow]](https://github.com/gabstv/go-bsdiff)   [![godoc][GoDoc]](https://godoc.org/github.com/gabstv/go-bsdiff)
* [lrserver](https://github.com/jaschaephraim/lrserver) **star:120** LiveReload 服务器。   [![最近一年没有更新][Yellow]](https://github.com/jaschaephraim/lrserver)   [![godoc][GoDoc]](https://godoc.org/github.com/jaschaephraim/lrserver)
* [cryptgo](https://github.com/Gituser143/cryptgo) **star:101** Crytpgo是一个基于TUI的应用程序，纯粹在Go中编写，实时监控和观察加密货币价格!   [![godoc][GoDoc]](https://godoc.org/github.com/Gituser143/cryptgo)
* [rospo](https://github.com/ferama/rospo) **star:100** 简单可靠的ssh隧道，嵌入式ssh服务器在Golang。   [![godoc][GoDoc]](https://godoc.org/github.com/ferama/rospo)
* [sorty](https://github.com/jfcg/sorty) **star:94** 快速并发/并行排序。   [![godoc][GoDoc]](https://godoc.org/github.com/jfcg/sorty)
* [goseaweedfs](https://github.com/linxGnu/goseaweedfs) **star:91** conseilSeaweedFS 客户端，几乎具有全部的特性。   [![godoc][GoDoc]](https://godoc.org/github.com/linxGnu/goseaweedfs)
* [nostromo](https://github.com/pokanop/nostromo) **star:91** CLI用于构建强大的别名。   [![最近一周有更新][Green]](https://github.com/pokanop/nostromo)   [![godoc][GoDoc]](https://godoc.org/github.com/pokanop/nostromo)
* [mssqlx](https://github.com/linxGnu/mssqlx) **star:89** 数据库客户端，用于主-从 (或主-主) 数据库，集成了简单的、轻量级的轮询调度负载均衡。   [![godoc][GoDoc]](https://godoc.org/github.com/linxGnu/mssqlx)
* [xferspdy](https://github.com/monmohan/xferspdy) **star:89** Xferspdy在golang中提供二进制diff和补丁库。   [![godoc][GoDoc]](https://godoc.org/github.com/monmohan/xferspdy)
* [mongo-go-pagination](https://github.com/gobeam/mongo-go-pagination) **star:86** 用于官方Mongodb /mongo-go驱动程序包的Mongodb分页，它支持正常的查询和聚合管道。   [![godoc][GoDoc]](https://godoc.org/github.com/gobeam/mongo-go-pagination)
* [go-health](https://github.com/Talento90/go-health) **star:84** 健康包简化了向服务中添加健康检查的方式。   [![最近一年没有更新][Yellow]](https://github.com/Talento90/go-health)   [![godoc][GoDoc]](https://godoc.org/github.com/Talento90/go-health)
* [cmd](https://github.com/SimonBaeumer/cmd) **star:81** 用于在osx、windows和linux上执行shell命令的库。   [![godoc][GoDoc]](https://godoc.org/github.com/SimonBaeumer/cmd)
* [pm](https://github.com/VividCortex/pm) **star:77** 进程(即goroutine)管理器与HTTP API。   [![最近一年没有更新][Yellow]](https://github.com/VividCortex/pm)   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/pm)
* [repeat](https://github.com/ssgreg/repeat) **star:76** 执行不同的后 backoff 策略，这对重新尝试操作和心跳非常有用。   [![最近一年没有更新][Yellow]](https://github.com/ssgreg/repeat)   [![godoc][GoDoc]](https://godoc.org/github.com/ssgreg/repeat)
* [limiters](https://github.com/mennanov/limiters) **star:71** Golang中的分布式应用程序速率限制器，具有可配置的后端和分布式锁。   [![godoc][GoDoc]](https://godoc.org/github.com/mennanov/limiters)
* [mimemagic](https://github.com/zRedShift/mimemagic) **star:69** 纯粹 Go 超性能MIME嗅探库/实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/zRedShift/mimemagic)
* [netbug](https://github.com/e-dard/netbug) **star:69** 远程对你的服务进行性能分析   [![最近一年没有更新][Yellow]](https://github.com/e-dard/netbug)   [![godoc][GoDoc]](https://godoc.org/github.com/e-dard/netbug)
* [UNIS](https://github.com/esemplastic/unis) **star:67** Go 语言字符串处理函数的通用架构 。   [![最近一年没有更新][Yellow]](https://github.com/esemplastic/unis)   [![godoc][GoDoc]](https://godoc.org/github.com/esemplastic/unis)
* [handy](https://github.com/miguelpragier/handy) **star:66** 许多实用程序和帮助程序，如字符串处理程序/格式化程序和验证器。   [![最近一年没有更新][Yellow]](https://github.com/miguelpragier/handy)   [![godoc][GoDoc]](https://godoc.org/github.com/miguelpragier/handy)
* [multitick](https://github.com/VividCortex/multitick) **star:65** 用于 aligned tickers 的多路复用   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/multitick)
* [goval](https://github.com/maja42/goval) **star:63** 在Go中计算任意表达式。   [![godoc][GoDoc]](https://godoc.org/github.com/maja42/goval)
* [goreadability](https://github.com/philipjkim/goreadability) **star:62** 网页摘要提取器使用Facebook开放图形和arc90的可读性。   [![最近一年没有更新][Yellow]](https://github.com/philipjkim/goreadability)   [![godoc][GoDoc]](https://godoc.org/github.com/philipjkim/goreadability)
* [pgo](https://github.com/arthurkushman/pgo) **star:60** 用于PHP社区的 Convenient 函数。   [![godoc][GoDoc]](https://godoc.org/github.com/arthurkushman/pgo)
* [minquery](https://github.com/icza/minquery) **star:59** MongoDB / mgo.v2, 支持高效分页查询(用于继续列出我们停止的文档的游标)。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/minquery)
* [go-astitodo](https://github.com/asticode/go-astitodo) **star:57** 解析你 Go 语言代码中的 TODOs（待办事项）。   [![最近一年没有更新][Yellow]](https://github.com/asticode/go-astitodo)   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astitodo)
* [golog](https://github.com/mlimaloureiro/golog) **star:55** 简单、轻量级的命令后工具，用于对你的计划任务进行跟踪。   [![最近一年没有更新][Yellow]](https://github.com/mlimaloureiro/golog)   [![godoc][GoDoc]](https://godoc.org/github.com/mlimaloureiro/golog)
* [go-lock](https://github.com/viney-shih/go-lock) **star:54** go-lock是一个锁库，它实现了读写互斥锁和读写尝试锁，而不需要等待。   [![godoc][GoDoc]](https://godoc.org/github.com/viney-shih/go-lock)
* [filter](https://github.com/gookit/filter) **star:52** 提供Go数据的过滤、清理和转换。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/filter)
* [retry](https://github.com/thedevsaddam/retry) **star:52** 简单易用的重试机制包，为 Go 。   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/retry)
* [copy-pasta](https://github.com/jutkko/copy-pasta) **star:49** 通用多工作站剪切板，使用类似 S3 的后端作为存储。   [![最近一年没有更新][Yellow]](https://github.com/jutkko/copy-pasta)   [![godoc][GoDoc]](https://godoc.org/github.com/jutkko/copy-pasta)
* [beyond](https://github.com/wesovilabs/beyond) **star:47** Go工具将带你进入AOP的世界!   [![godoc][GoDoc]](https://godoc.org/github.com/wesovilabs/beyond)
* [slice](https://github.com/psampaz/slice) **star:47** 用于普通Go切片操作的类型安全函数。   [![最近一年没有更新][Yellow]](https://github.com/psampaz/slice)   [![godoc][GoDoc]](https://godoc.org/github.com/psampaz/slice)
* [golarm](https://github.com/msempere/golarm) **star:45** 告警（支持系统事件）。   [![最近一年没有更新][Yellow]](https://github.com/msempere/golarm)   [![godoc][GoDoc]](https://godoc.org/github.com/msempere/golarm)
* [goback](https://github.com/carlescere/goback) **star:44**  一个 Go 语言的简单的指数补偿包。   [![godoc][GoDoc]](https://godoc.org/github.com/carlescere/goback)
* [dbt](https://github.com/nikogura/dbt) **star:43** 用于从中心可信存储库运行自更新签名二进制文件的框架。   [![godoc][GoDoc]](https://godoc.org/github.com/nikogura/dbt)
* [intrinsic](https://github.com/mengzhuo/intrinsic) **star:43** 不需要编写任何汇编代码就能使用 x86 SIMD。   [![最近一年没有更新][Yellow]](https://github.com/mengzhuo/intrinsic)   [![godoc][GoDoc]](https://godoc.org/github.com/mengzhuo/intrinsic)   [![归档项目][Archived]](https://github.com/mengzhuo/intrinsic)
* [retry-go](https://github.com/rafaeljesus/retry-go) **star:43** 对 Go 来说，重试变得简单而容易。   [![最近一年没有更新][Yellow]](https://github.com/rafaeljesus/retry-go)   [![godoc][GoDoc]](https://godoc.org/github.com/rafaeljesus/retry-go)
* [gpath](https://github.com/tenntenn/gpath) **star:40**  用于简化结构体域访问的库。   [![最近一年没有更新][Yellow]](https://github.com/tenntenn/gpath)   [![godoc][GoDoc]](https://godoc.org/github.com/tenntenn/gpath)
* [go-httpheader](https://github.com/mozillazg/go-httpheader) **star:37**  用于将结构体编码进 http 头的 Go 语言库   [![godoc][GoDoc]](https://godoc.org/github.com/mozillazg/go-httpheader)
* [myhttp](https://github.com/inancgumus/myhttp) **star:35** 简单的API，使HTTP GET请求与超时支持。   [![最近一年没有更新][Yellow]](https://github.com/inancgumus/myhttp)   [![godoc][GoDoc]](https://godoc.org/github.com/inancgumus/myhttp)   [![归档项目][Archived]](https://github.com/inancgumus/myhttp)
* [backscanner](https://github.com/icza/backscanner) **star:34** 类似 bufio 的扫描器，但它以相反的顺序读取和返回行，从给定的位置开始，然后返回。   [![godoc][GoDoc]](https://godoc.org/github.com/icza/backscanner)
* [equalizer](https://github.com/reugn/equalizer) **star:34** 用Go实现的限流工具   [![godoc][GoDoc]](https://godoc.org/github.com/reugn/equalizer)
* [evaluator](https://github.com/nullne/evaluator) **star:33** 基于 s-expression。它很简单，很容易扩展。   [![godoc][GoDoc]](https://godoc.org/github.com/nullne/evaluator)
* [gostrutils](https://github.com/ik5/gostrutils) **star:32** 字符串操作和转换函数的集合。   [![godoc][GoDoc]](https://godoc.org/github.com/ik5/gostrutils)
* [rclient](https://github.com/zpatrick/rclient) **star:32** 可读、灵活、易于使用的REST api客户端。   [![最近一年没有更新][Yellow]](https://github.com/zpatrick/rclient)   [![godoc][GoDoc]](https://godoc.org/github.com/zpatrick/rclient)
* [slicer](https://github.com/leaanthony/slicer) **star:29** 使处理切片更容易。   [![godoc][GoDoc]](https://godoc.org/github.com/leaanthony/slicer)
* [tome](https://github.com/cyruzin/tome) **star:29** Tome设计用于对简单的RESTful api进行分页。   [![最近一年没有更新][Yellow]](https://github.com/cyruzin/tome)   [![godoc][GoDoc]](https://godoc.org/github.com/cyruzin/tome)
* [set](https://github.com/nofeaturesonlybugs/set) **star:28** 性能和灵活的结构映射和松散的类型转换。   [![最近一周有更新][Green]](https://github.com/nofeaturesonlybugs/set)   [![godoc][GoDoc]](https://godoc.org/github.com/nofeaturesonlybugs/set)
* [throttle](https://github.com/yudppp/throttle) **star:28** Throttle是一个在每个持续时间内只执行一个动作的对象。   [![godoc][GoDoc]](https://godoc.org/github.com/yudppp/throttle)
* [sshman](https://github.com/shoobyban/sshman) **star:27** 用于多个远程服务器上的authorized_keys文件的SSH管理器。   [![最近一周有更新][Green]](https://github.com/shoobyban/sshman)   [![godoc][GoDoc]](https://godoc.org/github.com/shoobyban/sshman)
* [shutdown](https://github.com/ztrue/shutdown) **star:26** ' os的应用程序关闭挂钩。信号的处理。   [![最近一周有更新][Green]](https://github.com/ztrue/shutdown)   [![godoc][GoDoc]](https://godoc.org/github.com/ztrue/shutdown)
* [ugo](https://github.com/alxrm/ugo) **star:26** uGo 是一个切片工具箱，有着和 Go 语言一致的语法法。   [![最近一年没有更新][Yellow]](https://github.com/alxrm/ugo)   [![godoc][GoDoc]](https://godoc.org/github.com/alxrm/ugo)
* [generate](https://github.com/go-playground/generate) **star:24** 针对一个路径或环境变量，递归的执行 Go generate，可以通过正则表达式来进行过滤。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/generate)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/generate)
* [goplaceholder](https://github.com/michiwend/goplaceholder) **star:22** 一个小巧的 Go 语言库用于生成占位图片。   [![最近一年没有更新][Yellow]](https://github.com/michiwend/goplaceholder)   [![godoc][GoDoc]](https://godoc.org/github.com/michiwend/goplaceholder)
* [rerate](https://github.com/abo/rerate) **star:21** 基于 Redis 的速率计数器和限速器   [![最近一年没有更新][Yellow]](https://github.com/abo/rerate)   [![godoc][GoDoc]](https://godoc.org/github.com/abo/rerate)
* [ghokin](https://github.com/antham/ghokin) **star:20** 没有外部依赖的gherkin (cucumber, behat…)并行格式化程序。   [![godoc][GoDoc]](https://godoc.org/github.com/antham/ghokin)
* [mimesniffer](https://github.com/aofei/mimesniffer) **star:18** 一个用于Go的MIME类型嗅探器。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/mimesniffer)
* [structs](https://github.com/PumpkinSeed/structs) **star:18** 简单来讲就是 "Make" 的替代品。   [![最近一年没有更新][Yellow]](https://github.com/PumpkinSeed/structs)   [![godoc][GoDoc]](https://godoc.org/github.com/PumpkinSeed/structs)
* [ctxutil](https://github.com/posener/ctxutil) **star:17** 上下文工具。   [![最近一年没有更新][Yellow]](https://github.com/posener/ctxutil)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/ctxutil)
* [filler](https://github.com/yaronsumel/filler) **star:16** 使用“fill”标签填充结构的小工具。   [![最近一年没有更新][Yellow]](https://github.com/yaronsumel/filler)   [![godoc][GoDoc]](https://godoc.org/github.com/yaronsumel/filler)
* [rest-go](https://github.com/edermanoel94/rest-go) **star:16** 一个包，它为使用rest api提供了许多有用的方法。   [![最近一年没有更新][Yellow]](https://github.com/edermanoel94/rest-go)   [![godoc][GoDoc]](https://godoc.org/github.com/edermanoel94/rest-go)
* [dlog](https://github.com/kirillDanshin/dlog) **star:15** 编译时控制的日志，让你的 release 包变得更小而不需移除 debug 调用。   [![最近一年没有更新][Yellow]](https://github.com/kirillDanshin/dlog)   [![godoc][GoDoc]](https://godoc.org/github.com/kirillDanshin/dlog)
* [go-convert](https://github.com/Eun/go-convert) **star:15** 包go-convert使您能够将一个值转换为另一种类型。   [![godoc][GoDoc]](https://godoc.org/github.com/Eun/go-convert)
* [okrun](https://github.com/xta/okrun) **star:15**  Go 运行错误 steamroller。   [![最近一年没有更新][Yellow]](https://github.com/xta/okrun)   [![godoc][GoDoc]](https://godoc.org/github.com/xta/okrun)
* [copy](https://github.com/gotidy/copy) **star:14** 包快速复制不同类型的struct。   [![最近一年没有更新][Yellow]](https://github.com/gotidy/copy)   [![godoc][GoDoc]](https://godoc.org/github.com/gotidy/copy)
* [jsend](https://github.com/clevergo/jsend) **star:14** 在Go中编写JSend的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/clevergo/jsend)
* [command](https://github.com/txgruppi/command) **star:13** 命令模式，支持线程安全的串行、并行调度。   [![最近一年没有更新][Yellow]](https://github.com/txgruppi/command)   [![godoc][GoDoc]](https://godoc.org/github.com/txgruppi/command)
* [cvt](https://github.com/shockerli/cvt) **star:12** 简单而安全的将任何值转换为另一种类型。   [![godoc][GoDoc]](https://godoc.org/github.com/shockerli/cvt)   [![包含中文文档][CN]](https://github.com/shockerli/cvt)
* [go-problemdetails](https://github.com/mvmaasakkers/go-problemdetails) **star:12** 打包处理问题细节。   [![最近一年没有更新][Yellow]](https://github.com/mvmaasakkers/go-problemdetails)   [![godoc][GoDoc]](https://godoc.org/github.com/mvmaasakkers/go-problemdetails)
* [go-type](https://github.com/mikekonan/go-types) **star:12** 为ISO-4217、ISO-3166和其他类型的存储/验证和传输提供Go类型的库。   [![godoc][GoDoc]](https://godoc.org/github.com/mikekonan/go-types)
* [ptr](https://github.com/gotidy/ptr) **star:11** 提供函数的包，用于从基本类型的常量简化指针的创建。   [![godoc][GoDoc]](https://godoc.org/github.com/gotidy/ptr)
* [silk](https://github.com/chrispassas/silk) **star:11** 阅读silk netflow文件。   [![最近一年没有更新][Yellow]](https://github.com/chrispassas/silk)   [![godoc][GoDoc]](https://godoc.org/github.com/chrispassas/silk)
* [retry](https://github.com/shafreeck/retry) **star:10** 一个相当简单的库，以确保您的工作可以完成。   [![最近一年没有更新][Yellow]](https://github.com/shafreeck/retry)   [![godoc][GoDoc]](https://godoc.org/github.com/shafreeck/retry)
* [go-countries](https://github.com/mikekonan/go-countries) **star:9** 对ISO-3166代码的轻量级查找。   [![最近一年没有更新][Yellow]](https://github.com/mikekonan/go-countries)   [![godoc][GoDoc]](https://godoc.org/github.com/mikekonan/go-countries)
* [statiks](https://github.com/janiltonmaciel/statiks) **star:9** 快速，零配置，静态HTTP文件服务器。   [![最近一年没有更新][Yellow]](https://github.com/janiltonmaciel/statiks)   [![godoc][GoDoc]](https://godoc.org/github.com/janiltonmaciel/statiks)
* [blank](https://github.com/Henry-Sarabia/blank) **star:7** 验证或删除字符串中的空白。   [![最近一年没有更新][Yellow]](https://github.com/Henry-Sarabia/blank)   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/blank)
* [go-clip](https://github.com/prashantgupta24/go-clip) **star:7** Mac的一个极简的剪贴板管理器。   [![godoc][GoDoc]](https://godoc.org/github.com/prashantgupta24/go-clip)
* [retry](https://github.com/percolate/retry) **star:7** 一个简单但高度可配置的Go重试包。   [![最近一年没有更新][Yellow]](https://github.com/percolate/retry)
* [sliceconv](https://github.com/Henry-Sarabia/sliceconv) **star:7** 基本类型之间的片转换。   [![最近一年没有更新][Yellow]](https://github.com/Henry-Sarabia/sliceconv)   [![godoc][GoDoc]](https://godoc.org/github.com/Henry-Sarabia/sliceconv)
* [nfdump](https://github.com/chrispassas/nfdump) **star:6** 读取nfdump netflow文件。   [![godoc][GoDoc]](https://godoc.org/github.com/chrispassas/nfdump)
* [go-safe](https://github.com/kenkyu392/go-safe) **star:5** Panic-safe沙箱。   [![godoc][GoDoc]](https://godoc.org/github.com/kenkyu392/go-safe)
* [go-actuator](https://github.com/sinhashubham95/go-actuator) **star:4** 基于Go的web框架的生产就绪特性。   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/go-actuator)
* [lets-go](https://github.com/aplescia-chwy/lets-go) **star:3** Go模块，为云本地REST API开发提供公共工具。还包含AWS特定的实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/aplescia-chwy/lets-go)
* [olaf](https://github.com/btnguyen2k/olaf) **star:3** Twitter Snowflake 在Go中实现。   [![最近一年没有更新][Yellow]](https://github.com/btnguyen2k/olaf)   [![godoc][GoDoc]](https://godoc.org/github.com/btnguyen2k/olaf)
* [tik](https://github.com/andy2046/tik) **star:3** 简单和容易的时间轮包去。   [![最近一年没有更新][Yellow]](https://github.com/andy2046/tik)   [![godoc][GoDoc]](https://godoc.org/github.com/andy2046/tik)
* [bleep](https://github.com/sinhashubham95/bleep) **star:2** 在Go中对任意一组OS信号执行任意数量的操作。   [![最近一年没有更新][Yellow]](https://github.com/sinhashubham95/bleep)   [![godoc][GoDoc]](https://godoc.org/github.com/sinhashubham95/bleep)
* [goctx](https://github.com/zerosnake0/goctx) **star:2** 获得高性能的上下文值。   [![最近一年没有更新][Yellow]](https://github.com/zerosnake0/goctx)   [![godoc][GoDoc]](https://godoc.org/github.com/zerosnake0/goctx)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#utilities) 吧~)*

## UUID

*用于处理uuid的库。 (翻译出错了? 试试 [英文版](README_EN.md#uuid) 吧~)*

* [uuid](https://github.com/google/uuid) **star:3295** 基于RFC 4122和DCE 1.1的uuid包:身份验证和安全服务。   [![star > 2000][Awesome]](https://github.com/google/uuid)   [![godoc][GoDoc]](https://godoc.org/github.com/google/uuid)
* [ulid](https://github.com/oklog/ulid) **star:2516** 实现了ULID(普遍唯一的词典分类标识符)。   [![star > 2000][Awesome]](https://github.com/oklog/ulid)   [![godoc][GoDoc]](https://godoc.org/github.com/oklog/ulid)
* [uniq](https://gitlab.com/skilstak/code/go/uniq)  没有麻烦，安全，快速的唯一标识符与命令。
* [xid](https://github.com/rs/xid) **star:2383** Xid是一个全局唯一id生成器库，可以直接在服务器代码中安全地使用。   [![star > 2000][Awesome]](https://github.com/rs/xid)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/xid)
* [uuid](https://github.com/gofrs/uuid) **star:1058** 通用唯一标识符(UUID)的实现。支持uuid的创建和解析。积极维护satori uuid的fork。   [![godoc][GoDoc]](https://godoc.org/github.com/gofrs/uuid)
* [wuid](https://github.com/edwingeng/wuid) **star:444** 一个非常快的唯一数字生成器，比UUID快10-135倍。   [![godoc][GoDoc]](https://godoc.org/github.com/edwingeng/wuid)
* [sno](https://github.com/muyo/sno) **star:55** 使用嵌入元数据的紧凑、可排序和快速的惟一id。   [![godoc][GoDoc]](https://godoc.org/github.com/muyo/sno)
* [nanoid](https://github.com/aidarkhanov/nanoid) **star:41** 一个小而有效的Go唯一字符串ID生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/aidarkhanov/nanoid)
* [goid](https://github.com/jakehl/goid) **star:29** 生成和解析RFC4122兼容的V4 uuid。   [![最近一年没有更新][Yellow]](https://github.com/jakehl/goid)   [![godoc][GoDoc]](https://godoc.org/github.com/jakehl/goid)
* [uuid](https://github.com/agext/uuid) **star:13** 使用快速或加密质量的随机节点标识符生成、编码和解码UUIDs v1。   [![最近一年没有更新][Yellow]](https://github.com/agext/uuid)   [![godoc][GoDoc]](https://godoc.org/github.com/agext/uuid)
* [gouid](https://github.com/twharmon/gouid) **star:11** 生成加密安全的随机字符串id，只有一个分配。   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/gouid)
* [goflake](https://github.com/hart87/GoFlake) **star:8** 一种在分布式系统中使用的小型、可扩展的、无服务器的唯一ID生成器。受到推特雪花的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/hart87/GoFlake)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#uuid) 吧~)*

## 验证

*库进行验证。 (翻译出错了? 试试 [英文版](README_EN.md#validation) 吧~)*

* [validator](https://github.com/go-playground/validator) **star:9470**  Go 结构体及域验证，包括：跨域、跨结构体, Map, 切片和数组。   [![star > 2000][Awesome]](https://github.com/go-playground/validator)   [![最近一周有更新][Green]](https://github.com/go-playground/validator)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/validator)
* [govalidator](https://github.com/asaskevich/govalidator) **star:5202** 用于字符串，数字，切片和结构的验证器和sanitizers。   [![star > 2000][Awesome]](https://github.com/asaskevich/govalidator)   [![godoc][GoDoc]](https://godoc.org/github.com/asaskevich/govalidator)
* [ozzo-validation](https://github.com/go-ozzo/ozzo-validation) **star:2513** 支持各种数据类型(结构、字符串、映射、片等)的验证，使用可配置和可扩展的验证规则，这些规则在通常的代码构造中指定，而不是在结构标签中指定。   [![star > 2000][Awesome]](https://github.com/go-ozzo/ozzo-validation)   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-validation)
* [govalidator](https://github.com/thedevsaddam/govalidator) **star:1047** 用简单的规则验证Golang请求数据。深受Laravel请求验证的启发。   [![最近一年没有更新][Yellow]](https://github.com/thedevsaddam/govalidator)   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/govalidator)
* [validate](https://github.com/gookit/validate) **star:509**  Go 封装数据验证和过滤。支持验证映射、结构、请求(表单、JSON、url)。值，上载文件)数据和更多特性。   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/validate)   [![包含中文文档][CN]](https://github.com/gookit/validate)
* [checkdigit](https://github.com/osamingo/checkdigit) **star:86** 提供校验数字算法(Luhn, Verhoeff, Damm)和计算器(ISBN, EAN, JAN, UPC等)。   [![最近一年没有更新][Yellow]](https://github.com/osamingo/checkdigit)   [![godoc][GoDoc]](https://godoc.org/github.com/osamingo/checkdigit)
* [terraform-validator](https://github.com/thazelart/terraform-validator) **star:75** 一种规范和约定验证器。   [![最近一年没有更新][Yellow]](https://github.com/thazelart/terraform-validator)   [![godoc][GoDoc]](https://godoc.org/github.com/thazelart/terraform-validator)
* [validate](https://github.com/gobuffalo/validate) **star:66** 这个包提供了一个框架，用于为Go应用程序编写验证。   [![godoc][GoDoc]](https://godoc.org/github.com/gobuffalo/validate)
* [jio](https://github.com/faceair/jio) **star:63** jio是一个json模式验证器，类似于[joi](https://github.com/hapijs/joi)。   [![最近一年没有更新][Yellow]](https://github.com/faceair/jio)   [![godoc][GoDoc]](https://godoc.org/github.com/faceair/jio)   [![包含中文文档][CN]](https://github.com/faceair/jio)
* [gody](https://github.com/guiferpa/gody) **star:52** :一个轻量级的结构验证器。   [![godoc][GoDoc]](https://godoc.org/github.com/guiferpa/gody)
* [govalid](https://github.com/twharmon/govalid) **star:23** 快速、基于标签的结构验证。   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/govalid)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#validation) 吧~)*

## 版本控制

*用于版本控制的库。 (翻译出错了? 试试 [英文版](README_EN.md#version-control) 吧~)*

* [go-git](https://github.com/go-git/go-git) **star:2987** 纯Go中高度可扩展的Git实现。   [![star > 2000][Awesome]](https://github.com/go-git/go-git)   [![最近一周有更新][Green]](https://github.com/go-git/go-git)   [![godoc][GoDoc]](https://godoc.org/github.com/go-git/go-git)
* [git2go](https://github.com/libgit2/git2go) **star:1686**  libgit2 的 Go 语言接口。   [![godoc][GoDoc]](https://godoc.org/github.com/libgit2/git2go)
* [glab](https://github.com/profclems/glab) **star:1666** 一个开源的GitLab命令行工具，将GitLab的酷特性带到您的命令行。   [![最近一周有更新][Green]](https://github.com/profclems/glab)   [![godoc][GoDoc]](https://godoc.org/github.com/profclems/glab)
* [hercules](https://github.com/src-d/hercules) **star:1650** 从Git存储库历史中获得高级见解。   [![godoc][GoDoc]](https://godoc.org/github.com/src-d/hercules)
* [gh](https://github.com/rjeczalik/gh) **star:76** 用于GitHub webhook的可编写脚本的服务器和net/http中间件。   [![最近一年没有更新][Yellow]](https://github.com/rjeczalik/gh)   [![godoc][GoDoc]](https://godoc.org/github.com/rjeczalik/gh)
* [go-vcs](https://github.com/sourcegraph/go-vcs) **star:74** 在Go中操作和检查VCS存储库。   [![godoc][GoDoc]](https://godoc.org/github.com/sourcegraph/go-vcs)
* [githooks](https://github.com/gabyx/githooks) **star:31** 每回购和共享Git挂钩版本控制和自动更新。   [![最近一周有更新][Green]](https://github.com/gabyx/githooks)   [![godoc][GoDoc]](https://godoc.org/github.com/gabyx/githooks)
* [hgo](https://github.com/beyang/hgo) **star:13** Hgo是一组Go包的集合，提供对本地Mercurial存储库的读取访问。   [![最近一年没有更新][Yellow]](https://github.com/beyang/hgo)   [![godoc][GoDoc]](https://godoc.org/github.com/beyang/hgo)
* [froggit-go](https://github.com/jfrog/froggit-go) **star:11** Froggit-Go是一个Go库，允许在VCS提供商上执行操作。   [![最近一周有更新][Green]](https://github.com/jfrog/froggit-go)   [![godoc][GoDoc]](https://godoc.org/github.com/jfrog/froggit-go)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#version-control) 吧~)*

## 视频

*用于操作视频的库。 (翻译出错了? 试试 [英文版](README_EN.md#video) 吧~)*

* [goav](https://github.com/giorgisio/goav) **star:1793** FFmpeg的全面Go绑定。   [![godoc][GoDoc]](https://godoc.org/github.com/giorgisio/goav)
* [m3u8](https://github.com/grafov/m3u8) **star:892** 苹果HLS的M3U8播放列表解析器和生成器库。   [![godoc][GoDoc]](https://godoc.org/github.com/grafov/m3u8)
* [gmf](https://github.com/3d0c/gmf) **star:733**  FFmpeg av\* 库的 Go 语言接口。   [![godoc][GoDoc]](https://godoc.org/github.com/3d0c/gmf)
* [go-astits](https://github.com/asticode/go-astits) **star:385** 在GO中解析和演示MPEG传输流(.ts)。   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astits)
* [go-astisub](https://github.com/asticode/go-astisub) **star:364** 使用 Go 语言操作字幕(.srt, .stl, .ttml, .webvtt, .ssa/.ass, teletext, .smi, etc.)。   [![最近一周有更新][Green]](https://github.com/asticode/go-astisub)   [![godoc][GoDoc]](https://godoc.org/github.com/asticode/go-astisub)
* [libvlc-go](https://github.com/adrg/libvlc-go) **star:271** Go绑定libvlc 2.X/3.X/4。X(由VLC媒体播放器使用)。   [![godoc][GoDoc]](https://godoc.org/github.com/adrg/libvlc-go)
* [gortsplib](https://github.com/aler9/gortsplib) **star:175** 纯Go RTSP服务器和客户端库。   [![godoc][GoDoc]](https://godoc.org/github.com/aler9/gortsplib)
* [gst](https://github.com/ziutek/gst) **star:164**  GStreamer的Go工具。   [![最近一年没有更新][Yellow]](https://github.com/ziutek/gst)   [![godoc][GoDoc]](https://godoc.org/github.com/ziutek/gst)
* [go-m3u8](https://github.com/quangngotan95/go-m3u8) **star:84** 苹果m3u8播放列表的解析器和生成器库。   [![最近一年没有更新][Yellow]](https://github.com/quangngotan95/go-m3u8)   [![godoc][GoDoc]](https://godoc.org/github.com/quangngotan95/go-m3u8)
* [v4l](https://github.com/korandiz/v4l) **star:64** 用于Linux的视频捕捉库，用Go编写。   [![godoc][GoDoc]](https://godoc.org/github.com/korandiz/v4l)
* [libgosubs](https://github.com/wargarblgarbl/libgosubs) **star:16** 字幕格式支持 .srt、.ttml和.ass。   [![最近一年没有更新][Yellow]](https://github.com/wargarblgarbl/libgosubs)   [![godoc][GoDoc]](https://godoc.org/github.com/wargarblgarbl/libgosubs)
* [go-mpd](https://github.com/unki2aut/go-mpd) **star:10** MPEG-DASH清单文件的解析器和生成器库。   [![最近一年没有更新][Yellow]](https://github.com/unki2aut/go-mpd)   [![godoc][GoDoc]](https://godoc.org/github.com/unki2aut/go-mpd)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#video) 吧~)*

## Web框架

*全栈 web 框架。 (翻译出错了? 试试 [英文版](README_EN.md#web-frameworks) 吧~)*

* [Gin](https://github.com/gin-gonic/gin) **star:54778** Gin是一个用Go编写的web框架!它具有一个类似于martini的API，性能更好，速度快40倍。   [![star > 2000][Awesome]](https://github.com/gin-gonic/gin)   [![最近一周有更新][Green]](https://github.com/gin-gonic/gin)   [![godoc][GoDoc]](https://godoc.org/github.com/gin-gonic/gin)
* [Beego](https://github.com/beego/beego) **star:27574** beego是一种用于 Go 编程语言的开源高性能web框架。   [![star > 2000][Awesome]](https://github.com/beego/beego)   [![最近一周有更新][Green]](https://github.com/beego/beego)   [![godoc][GoDoc]](https://godoc.org/github.com/beego/beego)
* [Buffalo](https://gobuffalo.io)  为 Go 语言带来堪比 Rails 的高生产效率!
* [Confetti Framework](https://www.confetti-framework.com)  Confetti is a Go web application framework with an expressive, elegant syntax. Confetti combines the elegance of Laravel and the simplicity of Go.
* [Echo](https://github.com/labstack/echo) **star:21462** 高性能、极简的Go web框架。   [![star > 2000][Awesome]](https://github.com/labstack/echo)   [![最近一周有更新][Green]](https://github.com/labstack/echo)   [![godoc][GoDoc]](https://godoc.org/github.com/labstack/echo)
* [Fiber](https://github.com/gofiber/fiber) **star:17727** 一个灵感来自Express.js的web框架构建在Fasthttp上。   [![star > 2000][Awesome]](https://github.com/gofiber/fiber)   [![最近一周有更新][Green]](https://github.com/gofiber/fiber)   [![godoc][GoDoc]](https://godoc.org/github.com/gofiber/fiber)
* [Revel](https://github.com/revel/revel) **star:12480** 用于Go语言的高效web框架。   [![star > 2000][Awesome]](https://github.com/revel/revel)   [![godoc][GoDoc]](https://godoc.org/github.com/revel/revel)
* [Goa](https://github.com/goadesign/goa) **star:4545** Goa为在Go中开发远程api和微服务提供了一种全面的方法。   [![star > 2000][Awesome]](https://github.com/goadesign/goa)   [![最近一周有更新][Green]](https://github.com/goadesign/goa)   [![godoc][GoDoc]](https://godoc.org/github.com/goadesign/goa)
* [Gizmo](https://github.com/NYTimes/gizmo) **star:3579** 《纽约时报》使用的微服务工具包。   [![star > 2000][Awesome]](https://github.com/NYTimes/gizmo)   [![godoc][GoDoc]](https://godoc.org/github.com/NYTimes/gizmo)
* [go-json-rest](https://github.com/ant0ine/go-json-rest) **star:3491** 设置RESTful JSON API的快速简便方法。   [![star > 2000][Awesome]](https://github.com/ant0ine/go-json-rest)   [![godoc][GoDoc]](https://godoc.org/github.com/ant0ine/go-json-rest)
* [Macaron](https://github.com/go-macaron/macaron) **star:3243** Macaron 是一个高效的模块化设计的web框架   [![star > 2000][Awesome]](https://github.com/go-macaron/macaron)   [![godoc][GoDoc]](https://godoc.org/github.com/go-macaron/macaron)
* [utron](https://github.com/gernest/utron) **star:2208** Go(Golang)的轻量级MVC框架。   [![star > 2000][Awesome]](https://github.com/gernest/utron)   [![最近一年没有更新][Yellow]](https://github.com/gernest/utron)   [![godoc][GoDoc]](https://godoc.org/github.com/gernest/utron)
* [tigertonic](https://github.com/rcrowley/go-tigertonic) **star:997** 用于构建 JSON web 服务的 Go 语言框架，受到 Dropwizard 的启发。   [![最近一年没有更新][Yellow]](https://github.com/rcrowley/go-tigertonic)   [![godoc][GoDoc]](https://godoc.org/github.com/rcrowley/go-tigertonic)
* [Goyave](https://github.com/go-goyave/goyave) **star:937** 功能完备的REST API框架，旨在干净的代码和快速的开发，具有强大的内置功能。   [![最近一周有更新][Green]](https://github.com/go-goyave/goyave)   [![godoc][GoDoc]](https://godoc.org/github.com/go-goyave/goyave)
* [tango](https://github.com/lunny/tango) **star:833** 微型的、支持插件的 web 框架。   [![最近一年没有更新][Yellow]](https://github.com/lunny/tango)   [![godoc][GoDoc]](https://godoc.org/github.com/lunny/tango)   [![包含中文文档][CN]](https://github.com/lunny/tango)   [![归档项目][Archived]](https://github.com/lunny/tango)
* [Gearbox](https://github.com/abahmed/gearbox) **star:589** 一个用Go编写的web框架，专注于高性能和内存优化。   [![最近一周有更新][Green]](https://github.com/abahmed/gearbox)   [![godoc][GoDoc]](https://godoc.org/github.com/abahmed/gearbox)
* [gongular](https://github.com/mustafaakin/gongular) **star:446**  快速 Go web 框架，支持输入映射／验证以及依赖注入。   [![最近一年没有更新][Yellow]](https://github.com/mustafaakin/gongular)   [![godoc][GoDoc]](https://godoc.org/github.com/mustafaakin/gongular)
* [Aero](https://github.com/aerogo/aero) **star:426** 高性能的Go web框架，在Lighthouse中达到最高分。   [![godoc][GoDoc]](https://godoc.org/github.com/aerogo/aero)
* [neo](https://github.com/ivpusic/neo) **star:414** Neo是一个非常简单且快速的Web框架API。   [![最近一年没有更新][Yellow]](https://github.com/ivpusic/neo)   [![godoc][GoDoc]](https://godoc.org/github.com/ivpusic/neo)
* [Air](https://github.com/aofei/air) **star:407** 一个理想的精细化的Go web框架。   [![godoc][GoDoc]](https://godoc.org/github.com/aofei/air)
* [mango](https://github.com/paulbellamy/mango) **star:359** ManGo 是一个模块化 web 应用框架，受到 Rack 和 PEP333 的启发。   [![最近一年没有更新][Yellow]](https://github.com/paulbellamy/mango)   [![godoc][GoDoc]](https://godoc.org/github.com/paulbellamy/mango)
* [Gondola](https://github.com/rainycape/gondola) **star:308** web框架写的网站越快越好。   [![最近一年没有更新][Yellow]](https://github.com/rainycape/gondola)   [![godoc][GoDoc]](https://godoc.org/github.com/rainycape/gondola)
* [Flamingo](https://github.com/i-love-flamingo/flamingo) **star:273** 可插拔web项目的框架。包括模块的概念和提供DI、Configareas、i18n、模板引擎、graphql、可观察性、安全性、事件、路由和反向路由等功能。   [![最近一周有更新][Green]](https://github.com/i-love-flamingo/flamingo)   [![godoc][GoDoc]](https://godoc.org/github.com/i-love-flamingo/flamingo)
* [Golf](https://github.com/dinever/golf) **star:251** Golf 是一个快速、简单、轻量级的 Go 语言微型 web 框架。具有强大的功能且没有标准库以外的依赖。   [![godoc][GoDoc]](https://godoc.org/github.com/dinever/golf)
* [Flamingo Commerce](https://github.com/i-love-flamingo/flamingo-commerce) **star:249** 提供使用干净的体系结构(如DDD和端口和适配器)的电子商务功能，您可以使用这些功能来构建灵活的电子商务应用程序。   [![最近一周有更新][Green]](https://github.com/i-love-flamingo/flamingo-commerce)   [![godoc][GoDoc]](https://godoc.org/github.com/i-love-flamingo/flamingo-commerce)
* [WebGo](https://github.com/bnkamalesh/webgo) **star:213** 构建web应用程序的微框架;处理程序链接、中间件和上下文注入。与标准库兼容的HTTP处理程序(即http.HandlerFunc)。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/webgo)
* [Ginrpc](https://github.com/xxjwxc/ginrpc) **star:201** Gin参数自动绑定工具，Gin rpc工具。   [![godoc][GoDoc]](https://godoc.org/github.com/xxjwxc/ginrpc)   [![包含中文文档][CN]](https://github.com/xxjwxc/ginrpc)
* [uAdmin](https://github.com/uadmin/uadmin) **star:169** 受到 Sinatra 启发的 Go 语言 web 框架。   [![godoc][GoDoc]](https://godoc.org/github.com/uadmin/uadmin)
* [hiboot](https://github.com/hidevopsio/hiboot) **star:162** hiboot是一个高性能的web应用程序框架，支持自动配置和依赖注入。   [![godoc][GoDoc]](https://godoc.org/github.com/hidevopsio/hiboot)   [![包含中文文档][CN]](https://github.com/hidevopsio/hiboot)
* [rk-boot](https://github.com/rookie-ninja/rk-boot) **star:128** 一个引导程序库，用于快速方便地使用Gin和gRPC构建企业微服务。   [![godoc][GoDoc]](https://godoc.org/github.com/rookie-ninja/rk-boot)
* [go-rest](https://github.com/ungerik/go-rest) **star:124** 小型的 REST 框架。   [![最近一年没有更新][Yellow]](https://github.com/ungerik/go-rest)   [![godoc][GoDoc]](https://godoc.org/github.com/ungerik/go-rest)
* [appy](https://github.com/appist/appy) **star:114** 一个固执己见的高效web框架，有助于更容易地扩展业务。   [![godoc][GoDoc]](https://godoc.org/github.com/appist/appy)
* [patron](https://github.com/beatlabs/patron) **star:90** Patron是一个遵循最佳云实践的微服务框架，专注于提升开发效率。   [![最近一周有更新][Green]](https://github.com/beatlabs/patron)   [![godoc][GoDoc]](https://godoc.org/github.com/beatlabs/patron)
* [Microservice](https://github.com/claygod/microservice) **star:77** 创建微服务的框架，用Golang编写。   [![最近一周有更新][Green]](https://github.com/claygod/microservice)   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/microservice)
* [vox](https://github.com/aisk/vox) **star:74** 一个面向人类的golang web框架，深受Koa的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/aisk/vox)
* [Golax](https://github.com/fulldump/golax) **star:72** 一个非Sinatra快速HTTP框架，支持谷歌自定义方法、深度拦截器、递归等。   [![最近一年没有更新][Yellow]](https://github.com/fulldump/golax)   [![godoc][GoDoc]](https://godoc.org/github.com/fulldump/golax)
* [rux](https://github.com/gookit/rux) **star:69** 简单而快速的web框架，可用于构建golang HTTP应用程序   [![godoc][GoDoc]](https://godoc.org/github.com/gookit/rux)   [![包含中文文档][CN]](https://github.com/gookit/rux)
* [aah](https://aahframework.org)  可伸缩、高性能、快速开发的Go Web框架。
* [YARF](https://github.com/yarf-framework/yarf) **star:64** 快速微框架，旨在以快速和简单的方式构建REST api和web服务。   [![最近一年没有更新][Yellow]](https://github.com/yarf-framework/yarf)   [![godoc][GoDoc]](https://godoc.org/github.com/yarf-framework/yarf)
* [Fireball](https://github.com/zpatrick/fireball) **star:55** 感觉更加自然的 web 框架。   [![最近一年没有更新][Yellow]](https://github.com/zpatrick/fireball)   [![godoc][GoDoc]](https://godoc.org/github.com/zpatrick/fireball)
* [goa](https://github.com/goa-go/goa) **star:47** goa就像golang中的koajs一样，是一个灵活、轻量级、高性能和可扩展的基于中间件的web框架。   [![最近一年没有更新][Yellow]](https://github.com/goa-go/goa)   [![godoc][GoDoc]](https://godoc.org/github.com/goa-go/goa)
* [GoTuna](https://github.com/gotuna/gotuna) **star:38** 具有mux路由器、中间件、会话、模板、嵌入式视图和静态文件的Go的极简web框架。   [![godoc][GoDoc]](https://godoc.org/github.com/gotuna/gotuna)
* [Resoursea](https://github.com/resoursea/api) **star:31** 用于快速编写基于资源的服务的REST框架。   [![最近一年没有更新][Yellow]](https://github.com/resoursea/api)   [![godoc][GoDoc]](https://godoc.org/github.com/resoursea/api)
* [REST Layer](https://rest-layer.io)  框架，用于在数据库之上构建REST/GraphQL API，主要是通过代码进行配置。
* [rex](https://github.com/goanywhere/rex) **star:31**  Rex 是一个用于进行模块化开发的库，基于Gorilla/mux 完全兼容大多数的 net/HTTP.   [![最近一年没有更新][Yellow]](https://github.com/goanywhere/rex)   [![godoc][GoDoc]](https://godoc.org/github.com/goanywhere/rex)
* [goweb](https://github.com/twharmon/goweb) **star:24** 具有路由、websockets、日志、中间件、静态文件服务器(可选gzip)和自动TLS的Web框架。   [![godoc][GoDoc]](https://godoc.org/github.com/twharmon/goweb)
* [Banjo](https://github.com/nsheremet/banjo) **star:18** 非常简单和快速的网络框架 Go 。   [![最近一年没有更新][Yellow]](https://github.com/nsheremet/banjo)   [![godoc][GoDoc]](https://godoc.org/github.com/nsheremet/banjo)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#web-frameworks) 吧~)*

### 中间件

#### 仿真中间件

* [Tollbooth](https://github.com/didip/tollbooth) **star:2092** 限制速率的 HTTP 请求处理程序。   [![star > 2000][Awesome]](https://github.com/didip/tollbooth)   [![godoc][GoDoc]](https://godoc.org/github.com/didip/tollbooth)
* [CORS](https://github.com/rs/cors) **star:2000** 轻松地向API添加CORS功能。   [![star > 2000][Awesome]](https://github.com/rs/cors)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/cors)
* [Limiter](https://github.com/ulule/limiter) **star:1479** 简单的速度限制中间件。   [![最近一周有更新][Green]](https://github.com/ulule/limiter)   [![godoc][GoDoc]](https://godoc.org/github.com/ulule/limiter)
* [go-server-timing](https://github.com/mitchellh/go-server-timing) **star:823** 添加/解析Server-Timing头。   [![最近一年没有更新][Yellow]](https://github.com/mitchellh/go-server-timing)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/go-server-timing)
* [go-fault](https://github.com/github/go-fault) **star:420** Go的故障注入中间件。   [![godoc][GoDoc]](https://godoc.org/github.com/github/go-fault)
* [ln-paywall](https://github.com/philippgille/ln-paywall) **star:119** 使用Lightning Network(比特币)实现基于每个请求的api货币化中间件。   [![最近一年没有更新][Yellow]](https://github.com/philippgille/ln-paywall)   [![godoc][GoDoc]](https://godoc.org/github.com/philippgille/ln-paywall)
* [XFF](https://github.com/sebest/xff) **star:86** 处理 X-Forwarded-For 头的中间件。   [![最近一年没有更新][Yellow]](https://github.com/sebest/xff)   [![godoc][GoDoc]](https://godoc.org/github.com/sebest/xff)
* [formjson](https://github.com/rs/formjson) **star:35** 透明地将JSON输入作为标准表单POST处理。   [![最近一年没有更新][Yellow]](https://github.com/rs/formjson)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/formjson)
* [rk-gin](https://github.com/rookie-ninja/rk-gin) **star:21** 用于Gin框架的中间件，具有日志记录、度量、认证、跟踪等功能。   [![最近一周有更新][Green]](https://github.com/rookie-ninja/rk-gin)   [![godoc][GoDoc]](https://godoc.org/github.com/rookie-ninja/rk-gin)
* [rk-grpc](https://github.com/rookie-ninja/rk-grpc) **star:21** 中间件为gRPC与日志，指标，认证，跟踪等。   [![最近一周有更新][Green]](https://github.com/rookie-ninja/rk-grpc)   [![godoc][GoDoc]](https://godoc.org/github.com/rookie-ninja/rk-grpc)
* [client-timing](https://github.com/posener/client-timing) **star:19** 用于服务器定时报头的HTTP客户机。   [![最近一年没有更新][Yellow]](https://github.com/posener/client-timing)   [![godoc][GoDoc]](https://godoc.org/github.com/posener/client-timing)
* [mid](https://github.com/bobg/mid) **star:3** 其他HTTP中间件特性:从处理程序返回惯用错误;接收/响应JSON数据;请求跟踪;和更多。   [![godoc][GoDoc]](https://godoc.org/github.com/bobg/mid)

#### 用于创建HTTP中间件的库

* [negroni](https://github.com/urfave/negroni) **star:7135** 符合语言习惯的 HTTP 中间件库。   [![star > 2000][Awesome]](https://github.com/urfave/negroni)   [![godoc][GoDoc]](https://godoc.org/github.com/urfave/negroni)   [![包含中文文档][CN]](https://github.com/urfave/negroni)
* [alice](https://github.com/justinas/alice) **star:2444** 用于连接中间件的库，简单无痛苦。   [![star > 2000][Awesome]](https://github.com/justinas/alice)   [![godoc][GoDoc]](https://godoc.org/github.com/justinas/alice)
* [render](https://github.com/unrolled/render) **star:1568** Go package用于方便地呈现JSON、XML和HTML模板响应。   [![godoc][GoDoc]](https://godoc.org/github.com/unrolled/render)
* [stats](https://github.com/thoas/stats) **star:581** 使用中间件来存储关于web应用程序的各种信息。   [![最近一年没有更新][Yellow]](https://github.com/thoas/stats)   [![godoc][GoDoc]](https://godoc.org/github.com/thoas/stats)
* [interpose](https://github.com/carbocation/interpose) **star:295** golang的极简网络/http中间件。   [![最近一年没有更新][Yellow]](https://github.com/carbocation/interpose)   [![godoc][GoDoc]](https://godoc.org/github.com/carbocation/interpose)
* [renderer](https://github.com/thedevsaddam/renderer) **star:231** 简单、轻量级和更快的响应(JSON、JSONP、XML、YAML、HTML、文件)。   [![最近一年没有更新][Yellow]](https://github.com/thedevsaddam/renderer)   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsaddam/renderer)
* [muxchain](https://github.com/stephens2424/muxchain) **star:209** 用于net/http的轻量级中间件。   [![最近一年没有更新][Yellow]](https://github.com/stephens2424/muxchain)   [![godoc][GoDoc]](https://godoc.org/github.com/stephens2424/muxchain)
* [gores](https://github.com/alioygur/gores) **star:96** 处理HTML、JSON、XML等响应的Go包。对于RESTful api非常有用。   [![最近一年没有更新][Yellow]](https://github.com/alioygur/gores)   [![godoc][GoDoc]](https://godoc.org/github.com/alioygur/gores)
* [rye](https://github.com/InVisionApp/rye) **star:95** 支持JWT、CORS、Statsd和Go 1.7上下文的小型Go中间件库(带有罐装中间件)。   [![最近一年没有更新][Yellow]](https://github.com/InVisionApp/rye)   [![godoc][GoDoc]](https://godoc.org/github.com/InVisionApp/rye)
* [mediary](https://github.com/HereMobilityDevelopers/mediary) **star:78** 在http中添加拦截器。客户端允许转储/成型/跟踪/…的请求/响应。   [![最近一年没有更新][Yellow]](https://github.com/HereMobilityDevelopers/mediary)   [![godoc][GoDoc]](https://godoc.org/github.com/HereMobilityDevelopers/mediary)
* [chain](https://github.com/codemodus/chain) **star:63** 带有范围数据的处理程序包装器链接(基于网络/上下文的“中间件”)。   [![最近一年没有更新][Yellow]](https://github.com/codemodus/chain)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/chain)
* [go-wrap](https://github.com/go-on/wrap) **star:59** net/http的小型中间件包。   [![最近一年没有更新][Yellow]](https://github.com/go-on/wrap)   [![godoc][GoDoc]](https://godoc.org/github.com/go-on/wrap)   [![归档项目][Archived]](https://github.com/go-on/wrap)
* [catena](https://github.com/codemodus/catena) **star:7** HTTP.Handler wrapper catenation (和chain具有相同的 API ).。   [![最近一年没有更新][Yellow]](https://github.com/codemodus/catena)   [![godoc][GoDoc]](https://godoc.org/github.com/codemodus/catena)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#libraries-for-creating-http-middlewares) 吧~)*

### 路由器

* [mux](https://github.com/gorilla/mux) **star:15854** 强大的URL路由器和调度器为golang。   [![star > 2000][Awesome]](https://github.com/gorilla/mux)   [![最近一周有更新][Green]](https://github.com/gorilla/mux)   [![godoc][GoDoc]](https://godoc.org/github.com/gorilla/mux)
* [httprouter](https://github.com/julienschmidt/httprouter) **star:13604** 高性能路由。使用这个库和标准http处理工具可以构建一个非常高性能大web框架。   [![star > 2000][Awesome]](https://github.com/julienschmidt/httprouter)   [![最近一周有更新][Green]](https://github.com/julienschmidt/httprouter)   [![godoc][GoDoc]](https://godoc.org/github.com/julienschmidt/httprouter)
* [chi](https://github.com/go-chi/chi) **star:10755** 小巧、快速、具有丰富表达力的 HTTP 路由，基于net/context.。   [![star > 2000][Awesome]](https://github.com/go-chi/chi)   [![godoc][GoDoc]](https://godoc.org/github.com/go-chi/chi)
* [gocraft/web](https://github.com/gocraft/web) **star:1455** Mux和中间件包在Go中。   [![最近一年没有更新][Yellow]](https://github.com/gocraft/web)   [![godoc][GoDoc]](https://godoc.org/github.com/gocraft/web)
* [Bone](https://github.com/go-zoo/bone) **star:1278** 闪电快速HTTP多路复用器。   [![最近一年没有更新][Yellow]](https://github.com/go-zoo/bone)   [![godoc][GoDoc]](https://godoc.org/github.com/go-zoo/bone)
* [Goji](https://github.com/goji/goji) **star:894** 枸杞是一种简约的和灵活的与支持'net/context` HTTP请求多路复用器。   [![最近一年没有更新][Yellow]](https://github.com/goji/goji)   [![godoc][GoDoc]](https://godoc.org/github.com/goji/goji)
* [fasthttprouter](https://github.com/buaazp/fasthttprouter) **star:869** 高性能路由器分叉从`httprouter`。第一个路由器适合`fasthttp`。   [![最近一年没有更新][Yellow]](https://github.com/buaazp/fasthttprouter)   [![godoc][GoDoc]](https://godoc.org/github.com/buaazp/fasthttprouter)
* [httptreemux](https://github.com/dimfeld/httptreemux) **star:521** 高速，灵活，基于树的 HTTP 路由。受到了 httprouter 的启发。   [![godoc][GoDoc]](https://godoc.org/github.com/dimfeld/httptreemux)
* [xujiajun/gorouter](https://github.com/xujiajun/gorouter) **star:511** 一个简单和快速的HTTP路由器 Go 。   [![最近一年没有更新][Yellow]](https://github.com/xujiajun/gorouter)   [![godoc][GoDoc]](https://godoc.org/github.com/xujiajun/gorouter)
* [ozzo-routing](https://github.com/go-ozzo/ozzo-routing) **star:425** 一个非常快的Go (golang) HTTP路由器，支持正则表达式路由匹配。完全支持构建RESTful api。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ozzo/ozzo-routing)
* [lars](https://github.com/go-playground/lars) **star:384** 是一个轻量级、快速、可扩展、零分配的HTTP路由，用于创建定制化的框架。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/lars)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/lars)
* [Siesta](https://github.com/VividCortex/siesta) **star:351** 编写中间件和处理程序的可组合框架。   [![godoc][GoDoc]](https://godoc.org/github.com/VividCortex/siesta)
* [vestigo](https://github.com/husobee/vestigo) **star:265** 高性能，独立，HTTP兼容的URL路由器的go web应用程序。   [![最近一年没有更新][Yellow]](https://github.com/husobee/vestigo)   [![godoc][GoDoc]](https://godoc.org/github.com/husobee/vestigo)
* [gowww/router](https://github.com/gowww/router) **star:159** 超快的HTTP 路由，完全兼容 net/HTTP.Handler 接口.。   [![最近一年没有更新][Yellow]](https://github.com/gowww/router)   [![godoc][GoDoc]](https://godoc.org/github.com/gowww/router)
* [pure](https://github.com/go-playground/pure) **star:122** 是一个轻量级HTTP路由器，它坚持net/ HTTP“实现”的std。   [![最近一年没有更新][Yellow]](https://github.com/go-playground/pure)   [![godoc][GoDoc]](https://godoc.org/github.com/go-playground/pure)
* [alien](https://github.com/gernest/alien) **star:120** 轻量级和快速http路由器从外层空间。   [![最近一年没有更新][Yellow]](https://github.com/gernest/alien)   [![godoc][GoDoc]](https://godoc.org/github.com/gernest/alien)
* [GoRouter](https://github.com/vardius/gorouter) **star:104** GoRouter是一个服务器/API微框架，HTTP请求路由器，多路复用器，mux，它为请求路由器提供了支持“net/context”的中间件。   [![最近一周有更新][Green]](https://github.com/vardius/gorouter)   [![godoc][GoDoc]](https://godoc.org/github.com/vardius/gorouter)
* [violetear](https://github.com/nbari/violetear) **star:103** HTTP路由器。   [![godoc][GoDoc]](https://godoc.org/github.com/nbari/violetear)
* [Bxog](https://github.com/claygod/Bxog) **star:101** 简单和快速的HTTP路由器 Go 。它可以处理不同难度、长度和嵌套的路径。他还知道如何根据接收到的参数创建URL。   [![最近一年没有更新][Yellow]](https://github.com/claygod/Bxog)   [![godoc][GoDoc]](https://godoc.org/github.com/claygod/Bxog)
* [xmux](https://github.com/rs/xmux) **star:93** 高性能mux基于httprouter 'net/context`支持。   [![最近一年没有更新][Yellow]](https://github.com/rs/xmux)   [![godoc][GoDoc]](https://godoc.org/github.com/rs/xmux)
* [bellt](https://github.com/GuilhermeCaruso/bellt) **star:52** 一个简单的Go HTTP路由器。   [![最近一年没有更新][Yellow]](https://github.com/GuilhermeCaruso/bellt)   [![godoc][GoDoc]](https://godoc.org/github.com/GuilhermeCaruso/bellt)
* [ngamux](https://github.com/ngamux/ngamux) **star:45** 简单的HTTP路由器为Go。   [![godoc][GoDoc]](https://godoc.org/github.com/ngamux/ngamux)
* [FastRouter](https://github.com/razonyang/fastrouter) **star:19** 一个快速，灵活的HTTP路由器写在Go。   [![最近一年没有更新][Yellow]](https://github.com/razonyang/fastrouter)   [![godoc][GoDoc]](https://godoc.org/github.com/razonyang/fastrouter)
* [goroute](https://github.com/goroute/route) **star:6** 简单但功能强大的HTTP请求多路复用器。   [![最近一年没有更新][Yellow]](https://github.com/goroute/route)   [![godoc][GoDoc]](https://godoc.org/github.com/goroute/route)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#routers) 吧~)*

## WebAssembly

* [tinygo](https://github.com/tinygo-org/tinygo) **star:9208** 去编译小地方。微控制器、网络组装和命令行工具。基于LLVM。   [![star > 2000][Awesome]](https://github.com/tinygo-org/tinygo)   [![最近一周有更新][Green]](https://github.com/tinygo-org/tinygo)   [![godoc][GoDoc]](https://godoc.org/github.com/tinygo-org/tinygo)
* [dom](https://github.com/dennwc/dom) **star:438** DOM库。   [![最近一年没有更新][Yellow]](https://github.com/dennwc/dom)   [![godoc][GoDoc]](https://godoc.org/github.com/dennwc/dom)
* [go-canvas](https://github.com/markfarnan/go-canvas) **star:149** 库使用HTML5画布，与所有绘画内的go代码。   [![最近一年没有更新][Yellow]](https://github.com/markfarnan/go-canvas)   [![godoc][GoDoc]](https://godoc.org/github.com/markfarnan/go-canvas)
* [wasmbrowsertest](https://github.com/agnivade/wasmbrowsertest) **star:111** 在浏览器中运行Go WASM测试。   [![godoc][GoDoc]](https://godoc.org/github.com/agnivade/wasmbrowsertest)
* [webapi](https://github.com/gowebapi/webapi) **star:93** 从WebIDL生成的DOM和HTML的绑定。   [![最近一周有更新][Green]](https://github.com/gowebapi/webapi)   [![godoc][GoDoc]](https://godoc.org/github.com/gowebapi/webapi)
* [vert](https://github.com/norunners/vert) **star:57** Go和JS值之间的互操作。   [![godoc][GoDoc]](https://godoc.org/github.com/norunners/vert)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#webassembly) 吧~)*

## Windows

* [go-ole](https://github.com/go-ole/go-ole) **star:833** 为 Go 语言实现的 Win32 OLE。   [![godoc][GoDoc]](https://godoc.org/github.com/go-ole/go-ole)
* [d3d9](https://github.com/gonutz/d3d9) **star:129**  Direct3D9 的 Go 语言接口。   [![godoc][GoDoc]](https://godoc.org/github.com/gonutz/d3d9)
* [gosddl](https://github.com/MonaxGT/gosddl) **star:8** 从SDDL-string到用户友好的JSON的转换器。SDDL由四个部分组成:所有者、主群、DACL、SACL。   [![最近一年没有更新][Yellow]](https://github.com/MonaxGT/gosddl)   [![godoc][GoDoc]](https://godoc.org/github.com/MonaxGT/gosddl)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#windows) 吧~)*

## XML

*用于操作XML的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#xml) 吧~)*

* [zek](https://github.com/miku/zek) **star:525** 从XML生成Go结构。   [![godoc][GoDoc]](https://godoc.org/github.com/miku/zek)
* [xpath](https://github.com/antchfx/xpath) **star:446** Go的XPath包。   [![最近一周有更新][Green]](https://github.com/antchfx/xpath)   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/xpath)
* [xquery](https://github.com/antchfx/xquery) **star:154** XQuery允许您使用XPath表达式从HTML/XML文档中提取数据。   [![最近一年没有更新][Yellow]](https://github.com/antchfx/xquery)   [![godoc][GoDoc]](https://godoc.org/github.com/antchfx/xquery)   [![归档项目][Archived]](https://github.com/antchfx/xquery)
* [xml2map](https://github.com/sbabiv/xml2map) **star:37** XML来映射转换器编写的Golang。   [![godoc][GoDoc]](https://godoc.org/github.com/sbabiv/xml2map)
* [xmlwriter](https://github.com/shabbyrobe/xmlwriter) **star:20** 基于libxml2的xmlwriter模块的过程性XML生成API。   [![godoc][GoDoc]](https://godoc.org/github.com/shabbyrobe/xmlwriter)
* [XML-Comp](https://github.com/xml-comp/xml-comp) **star:15** 简单的命令行XML比较器，生成文件夹、文件和标记的差异。   [![最近一年没有更新][Yellow]](https://github.com/xml-comp/xml-comp)   [![godoc][GoDoc]](https://godoc.org/github.com/xml-comp/xml-comp)

## 零信任

*实现零信任架构的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#zero-trust) 吧~)*

* [Cosign](https://github.com/sigstore/cosign) **star:1465** 在OCI注册中心中的容器签名、验证和存储。   [![最近一周有更新][Green]](https://github.com/sigstore/cosign)   [![godoc][GoDoc]](https://godoc.org/github.com/sigstore/cosign)
* [Spire](https://github.com/spiffe/spire) **star:1032** SPIRE (SPIFFE Runtime Environment)是一个api工具链，用于跨各种托管平台在软件系统之间建立信任。   [![最近一周有更新][Green]](https://github.com/spiffe/spire)   [![godoc][GoDoc]](https://godoc.org/github.com/spiffe/spire)
* [in-toto](https://github.com/in-toto/in-toto-golang) **star:48** 实现in-toto(提供一个框架来保护软件供应链的完整性)python参考实现。   [![godoc][GoDoc]](https://godoc.org/github.com/in-toto/in-toto-golang)
* [Spiffe-Vault](https://github.com/philips-labs/spiffe-vault) **star:8** 利用Spiffe JWT认证和Hashicorp Vault实现无秘密认证。   [![最近一周有更新][Green]](https://github.com/philips-labs/spiffe-vault)   [![godoc][GoDoc]](https://godoc.org/github.com/philips-labs/spiffe-vault)

# 工具

* Go 软件和插件。 (翻译出错了? 试试 [英文版](README_EN.md#tools) 吧~)*

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#tools) 吧~)*

## 代码分析

* [GoLint](https://github.com/golang/lint) **star:3929** Go 源码的 linter。   [![star > 2000][Awesome]](https://github.com/golang/lint)   [![godoc][GoDoc]](https://godoc.org/github.com/golang/lint)   [![归档项目][Archived]](https://github.com/golang/lint)
* [Golint online](http://go-lint.appspot.com/)  Lints online Go source files on GitHub, Bitbucket and Google Project Hosting using the golint package.
* [errcheck](https://github.com/kisielk/errcheck) **star:1780** Errcheck是一个用于检查Go程序中未检查错误的程序。   [![godoc][GoDoc]](https://godoc.org/github.com/kisielk/errcheck)
* [go-critic](https://github.com/go-critic/go-critic) **star:1209** 源代码检查工具。   [![最近一周有更新][Green]](https://github.com/go-critic/go-critic)   [![godoc][GoDoc]](https://godoc.org/github.com/go-critic/go-critic)
* [gcvis](https://github.com/davecheney/gcvis) **star:1051** 实时可视化跟踪 GC 数据。   [![最近一年没有更新][Yellow]](https://github.com/davecheney/gcvis)   [![godoc][GoDoc]](https://godoc.org/github.com/davecheney/gcvis)
* [php-parser](https://github.com/z7zmey/php-parser) **star:849** 用 Go 编写的 PHP 解析器。   [![godoc][GoDoc]](https://godoc.org/github.com/z7zmey/php-parser)
* [staticcheck](https://github.com/dominikh/go-tools/tree/master/cmd/staticcheck)  用于大量静态分析检查，您可能已经从 c# 的 ReSharper 等工具中习惯了这些检查。
* [GoPlantUML](https://github.com/jfeliu007/goplantuml) **star:629** 生成文本plantump类图的库和CLI，其中包含关于结构和接口的信息，以及它们之间的关系。   [![godoc][GoDoc]](https://godoc.org/github.com/jfeliu007/goplantuml)
* [goreturns](https://sourcegraph.com/github.com/sqs/goreturns)  添加 zero 返回声明，以匹配 func 返回类型。
* [gosimple](https://github.com/dominikh/go-tools/tree/master/cmd/gosimple)  gosimple 是 Go 源代码的linter，专门用于简化代码。
* [goast-viewer](https://github.com/yuroyoro/goast-viewer) **star:572** 基于 Web 的 Golang AST 可视化工具。   [![最近一年没有更新][Yellow]](https://github.com/yuroyoro/goast-viewer)
* [GoCover.io](https://gocover.io/)  GoCover.io 提供了任意 golang 包的代码覆盖率服务。
* [goimports](https://godoc.org/golang.org/x/tools/cmd/goimports)  来修复(添加，删除) Go 中自动导入的工具。
* [go-cleanarch](https://github.com/roblaszczak/go-cleanarch) **star:554** go-cleanarch 的创建是为了验证 Clean 体系结构规则，比如 Go 项目中的依赖关系。   [![godoc][GoDoc]](https://godoc.org/github.com/roblaszczak/go-cleanarch)
* [go-mod-outdated](https://github.com/psampaz/go-mod-outdated) **star:553** 找出项目中过期的依赖项。   [![最近一周有更新][Green]](https://github.com/psampaz/go-mod-outdated)   [![godoc][GoDoc]](https://godoc.org/github.com/psampaz/go-mod-outdated)
* [todocheck](https://github.com/preslavmihaylov/todocheck) **star:363** 静态代码分析器连接TODO注释代码有问题在你的问题跟踪器。   [![godoc][GoDoc]](https://godoc.org/github.com/preslavmihaylov/todocheck)
* [unconvert](https://github.com/mdempsky/unconvert) **star:314** 在源码中删除不必要的类型转换。   [![最近一年没有更新][Yellow]](https://github.com/mdempsky/unconvert)   [![godoc][GoDoc]](https://godoc.org/github.com/mdempsky/unconvert)
* [unused](https://github.com/dominikh/go-tools/tree/master/cmd/unused)  对未使用的常量、变量、函数和类型的代码进行检查。
* [golines](https://github.com/segmentio/golines) **star:297** 格式化程序，它自动缩短Go代码中的长行。   [![最近一周有更新][Green]](https://github.com/segmentio/golines)   [![godoc][GoDoc]](https://godoc.org/github.com/segmentio/golines)
* [tickgit](https://github.com/augmentable-dev/tickgit) **star:273** CLI和go包用于显示代码注释TODOs(以任何语言)并应用“git blame”来识别作者。   [![最近一周有更新][Green]](https://github.com/augmentable-dev/tickgit)   [![godoc][GoDoc]](https://godoc.org/github.com/augmentable-dev/tickgit)
* [dupl](https://github.com/mibk/dupl) **star:267** 用于代码克隆检测的工具。   [![最近一年没有更新][Yellow]](https://github.com/mibk/dupl)   [![godoc][GoDoc]](https://godoc.org/github.com/mibk/dupl)
* [gostatus](https://github.com/shurcooL/gostatus) **star:245** 用于显示包含 Go 包的存储库的状态的命令行工具，。   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/gostatus)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/gostatus)
* [apicompat](https://github.com/bradleyfalzon/apicompat) **star:175** 检查 Go 项目最近的向下不兼容修改。   [![最近一年没有更新][Yellow]](https://github.com/bradleyfalzon/apicompat)   [![godoc][GoDoc]](https://godoc.org/github.com/bradleyfalzon/apicompat)
* [go-checkstyle](https://github.com/qiniu/checkstyle) **star:118** checkstyle是一个类似于java checkstyle的检查工具。   [![godoc][GoDoc]](https://godoc.org/github.com/qiniu/checkstyle)
* [lint](https://github.com/surullabs/lint) **star:66** 将 linters 作为测试的一部分。   [![最近一年没有更新][Yellow]](https://github.com/surullabs/lint)   [![godoc][GoDoc]](https://godoc.org/github.com/surullabs/lint)
* [validate](https://github.com/mccoyst/validate) **star:60** 使用 tags 自动验证结构体字段。   [![最近一年没有更新][Yellow]](https://github.com/mccoyst/validate)   [![godoc][GoDoc]](https://godoc.org/github.com/mccoyst/validate)
* [go-outdated](https://github.com/firstrow/go-outdated) **star:44** 显示过期包的终端应用。   [![最近一年没有更新][Yellow]](https://github.com/firstrow/go-outdated)   [![godoc][GoDoc]](https://godoc.org/github.com/firstrow/go-outdated)   [![归档项目][Archived]](https://github.com/firstrow/go-outdated)
* [tarp](https://github.com/verygoodsoftwarenotvirus/tarp) **star:14** 在源码中寻找没有直接单元测试的函数和方法。   [![最近一年没有更新][Yellow]](https://github.com/verygoodsoftwarenotvirus/tarp)   [![godoc][GoDoc]](https://godoc.org/github.com/verygoodsoftwarenotvirus/tarp)   [![归档项目][Archived]](https://github.com/verygoodsoftwarenotvirus/tarp)
* [golang-ifood-sdk](https://github.com/arxdsilva/golang-ifood-sdk) **star:8** 好   [![godoc][GoDoc]](https://godoc.org/github.com/arxdsilva/golang-ifood-sdk)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#code-analysis) 吧~)*

## 编辑器插件

* [vim-go](https://github.com/fatih/vim-go) **star:14181** Go 开发会用到的 Vim 插件。   [![star > 2000][Awesome]](https://github.com/fatih/vim-go)
* [gocode](https://github.com/nsf/gocode) **star:4942** Autocompletion daemon for the Go programming language.   [![star > 2000][Awesome]](https://github.com/nsf/gocode)   [![godoc][GoDoc]](https://godoc.org/github.com/nsf/gocode)
* [GoSublime](https://github.com/DisposaBoy/GoSublime) **star:3417** 包含了可为文本编辑器 SublimeText 3 提供代码自动填充和其他类似IDE的功能的 Golang IDE 插件集合。   [![star > 2000][Awesome]](https://github.com/DisposaBoy/GoSublime)   [![最近一年没有更新][Yellow]](https://github.com/DisposaBoy/GoSublime)   [![godoc][GoDoc]](https://godoc.org/github.com/DisposaBoy/GoSublime)
* [vscode-go](https://github.com/golang/vscode-go) **star:2331** Visual Studio代码的扩展(VS代码)，它提供了对Go语言的支持。   [![star > 2000][Awesome]](https://github.com/golang/vscode-go)   [![最近一周有更新][Green]](https://github.com/golang/vscode-go)
* [go-plus](https://github.com/joefitzgerald/go-plus) **star:1518** 在 Atom 中添加自动完成，格式化，语法检查，高亮和审查。   [![归档项目][Archived]](https://github.com/joefitzgerald/go-plus)
* [go-mode](https://github.com/dominikh/go-mode.el) **star:1216** 在 GNU/Emacs 支持 GO。   [![最近一周有更新][Green]](https://github.com/dominikh/go-mode.el)
* [coc-go language server extension for Vim/Neovim](https://github.com/josa42/coc-go) **star:417** 这个插件添加[gopls](https://github.com/golang/tools/blob/master/gopls/README.md)功能到Vim/Neovim。
* [Watch](https://github.com/eaburns/Watch) **star:188** Runs a command in an acme win on file changes.   [![最近一年没有更新][Yellow]](https://github.com/eaburns/Watch)   [![godoc][GoDoc]](https://godoc.org/github.com/eaburns/Watch)
* [goimports-reviser](https://github.com/incu6us/goimports-reviser) **star:103** 用于导入的格式化工具。   [![godoc][GoDoc]](https://godoc.org/github.com/incu6us/goimports-reviser)
* [goprofiling](https://marketplace.visualstudio.com/items?itemName=MaxMedia.go-prof)  在 VS Code 中支持 Go 的基准分析。
* [vim-compiler-go](https://github.com/rjohnsondev/vim-compiler-go) **star:88** 在保存时突出显示语法错误的 Vim 插件。   [![最近一年没有更新][Yellow]](https://github.com/rjohnsondev/vim-compiler-go)
* [go-language-server](https://github.com/theia-ide/go-language-server) **star:31** A wrapper to turn the VSCode go extension into a language server supporting the language-server-protocol.   [![最近一年没有更新][Yellow]](https://github.com/theia-ide/go-language-server)   [![归档项目][Archived]](https://github.com/theia-ide/go-language-server)
* [gounit-vim](https://github.com/hexdigest/gounit-vim) **star:22** 基于函数或方法的签名生成Go测试的Vim插件。   [![最近一年没有更新][Yellow]](https://github.com/hexdigest/gounit-vim)
* [theia-go-extension](https://github.com/theia-ide/theia-go-extension) **star:16** 在 Theia IDE中支持 Go。   [![最近一年没有更新][Yellow]](https://github.com/theia-ide/theia-go-extension)   [![归档项目][Archived]](https://github.com/theia-ide/theia-go-extension)
* [Go Doc](https://github.com/msyrus/vscode-go-doc) **star:5** 一个Visual Studio Code扩展，用于在输出中显示定义和生成go doc。
* [Go plugin for JetBrains IDEs](https://plugins.jetbrains.com/plugin/9568-go)  JetBrains IDEs 的 Go 插件。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#editor-plugins) 吧~)*

## Go 生成工具

* [gotests](https://github.com/cweill/gotests) **star:3625** 从源代码生成测试用例。   [![star > 2000][Awesome]](https://github.com/cweill/gotests)   [![godoc][GoDoc]](https://godoc.org/github.com/cweill/gotests)
* [genny](https://github.com/cheekybits/genny) **star:1622** 优雅的 Go 泛型。   [![godoc][GoDoc]](https://godoc.org/github.com/cheekybits/genny)
* [re2dfa](https://github.com/opennota/re2dfa) **star:190** 将正则表达式转换为有限状态机，并输出 Go 源代码。   [![最近一年没有更新][Yellow]](https://github.com/opennota/re2dfa)   [![godoc][GoDoc]](https://godoc.org/github.com/opennota/re2dfa)   [![归档项目][Archived]](https://github.com/opennota/re2dfa)
* [TOML-to-Go](https://xuri.me/toml-to-go)  在浏览器中将 TOML 转换为 Go 类型。
* [xgen](https://github.com/xuri/xgen) **star:131** XSD (XML模式定义)解析器和Go/C/Java/Rust/TypeScript代码生成器。   [![godoc][GoDoc]](https://godoc.org/github.com/xuri/xgen)
* [gonerics](https://github.com/bouk/gonerics) **star:113** Go中的易用的泛型。   [![最近一年没有更新][Yellow]](https://github.com/bouk/gonerics)   [![godoc][GoDoc]](https://godoc.org/github.com/bouk/gonerics)
* [hasgo](https://github.com/DylanMeeus/hasgo) **star:108** 可生成用于切片的 Haskell。   [![godoc][GoDoc]](https://godoc.org/github.com/DylanMeeus/hasgo)
* [gocontracts](https://github.com/Parquery/gocontracts) **star:79** 通过同步代码和文档来实现 design-by-contract 设计。   [![最近一年没有更新][Yellow]](https://github.com/Parquery/gocontracts)   [![godoc][GoDoc]](https://godoc.org/github.com/Parquery/gocontracts)
* [gounit](https://github.com/hexdigest/gounit) **star:61** 使用您自己的模板生成Go测试用例。   [![最近一年没有更新][Yellow]](https://github.com/hexdigest/gounit)   [![godoc][GoDoc]](https://godoc.org/github.com/hexdigest/gounit)
* [generic](https://github.com/usk81/generic) **star:41** 灵活的 Go 数据类型。   [![最近一年没有更新][Yellow]](https://github.com/usk81/generic)   [![godoc][GoDoc]](https://godoc.org/github.com/usk81/generic)
* [godal](https://github.com/mafulong/godal) **star:11** 通过指定可被gorm使用的sql ddl文件，生成golang对应的orm模型。   [![godoc][GoDoc]](https://godoc.org/github.com/mafulong/godal)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#go-generate-tools) 吧~)*

## Go 工具

* [go-swagger](https://github.com/go-swagger/go-swagger) **star:7128** 基于 Go 的Swagger 2.0实现。   [![star > 2000][Awesome]](https://github.com/go-swagger/go-swagger)   [![最近一周有更新][Green]](https://github.com/go-swagger/go-swagger)   [![godoc][GoDoc]](https://godoc.org/github.com/go-swagger/go-swagger)
* [OctoLinker](https://github.com/OctoLinker/browser-extension) **star:4865** 借助的 OctoLinker 浏览器扩展，可以高效的地浏览  GitHub go文件。   [![star > 2000][Awesome]](https://github.com/OctoLinker/browser-extension)   [![最近一周有更新][Green]](https://github.com/OctoLinker/browser-extension)
* [go-callvis](https://github.com/TrueFurby/go-callvis) **star:3746** 使用 dot format 可视化 Go 程序的调用图。   [![star > 2000][Awesome]](https://github.com/TrueFurby/go-callvis)   [![godoc][GoDoc]](https://godoc.org/github.com/TrueFurby/go-callvis)
* [depth](https://github.com/KyleBanks/depth) **star:669** 通过分析导入，将包依赖关系树可视化输出。   [![godoc][GoDoc]](https://godoc.org/github.com/KyleBanks/depth)
* [richgo](https://github.com/kyoh86/richgo) **star:641** 用文本装饰丰富 go test 的输出。   [![最近一周有更新][Green]](https://github.com/kyoh86/richgo)   [![godoc][GoDoc]](https://godoc.org/github.com/kyoh86/richgo)
* [rts](https://github.com/galeone/rts) **star:227** 从服务器响应生成Go结构。   [![godoc][GoDoc]](https://godoc.org/github.com/galeone/rts)
* [godbg](https://github.com/tylerwince/godbg) **star:182** 实现了 Rusts 的 dbg! 宏，可以方便的在开发过程中快速、容易地调试。   [![最近一年没有更新][Yellow]](https://github.com/tylerwince/godbg)   [![godoc][GoDoc]](https://godoc.org/github.com/tylerwince/godbg)
* [gomodrun](https://github.com/dustinblackman/gomodrun/)  执行并缓存Go中包含的二进制文件的Go工具。国防部文件。
* [typex](https://github.com/dtgorski/typex) **star:136** 检查Go类型及其传递依赖关系，或者将结果导出为TypeScript值对象(或类型)声明。   [![最近一年没有更新][Yellow]](https://github.com/dtgorski/typex)   [![godoc][GoDoc]](https://godoc.org/github.com/dtgorski/typex)
* [colorgo](https://github.com/songgao/colorgo) **star:107** 将 go 命令包装成彩色的 go build 输出。   [![最近一年没有更新][Yellow]](https://github.com/songgao/colorgo)   [![godoc][GoDoc]](https://godoc.org/github.com/songgao/colorgo)
* [gothanks](https://github.com/psampaz/gothanks) **star:106** GoThanks自动帮你开始。mod github依赖，以这种方式发送一些爱给他们的维护者。   [![godoc][GoDoc]](https://godoc.org/github.com/psampaz/gothanks)
* [roumon](https://github.com/becheran/roumon) **star:72** 通过命令行接口监控所有激活goroutines的当前状态。   [![godoc][GoDoc]](https://godoc.org/github.com/becheran/roumon)
* [igo](https://github.com/rocketlaunchr/igo) **star:51** 一个igo to go transpiler (go语言的新语言功能!)   [![最近一年没有更新][Yellow]](https://github.com/rocketlaunchr/igo)   [![godoc][GoDoc]](https://godoc.org/github.com/rocketlaunchr/igo)
* [modver](https://github.com/bobg/modver)  根据[semver](https://semver.org/)规则，比较Go模块的两个版本，以检查所需的版本号更改(主要、次要或patchlevel)。
* [go-james](https://github.com/pieterclaerhout/go-james) **star:50** 去项目骨架创造者，建立和测试您的项目没有手动设置。   [![godoc][GoDoc]](https://godoc.org/github.com/pieterclaerhout/go-james)
* [go-pkg-complete](https://github.com/skelterjohn/go-pkg-complete) **star:39** Bash completion for go and wgo。   [![最近一年没有更新][Yellow]](https://github.com/skelterjohn/go-pkg-complete)
* [generator-go-lang](https://github.com/axelspringer/generator-go-lang) **star:24** 一个[Yeoman](https://yeoman.io)发电机，以启动新的Go项目。   [![最近一年没有更新][Yellow]](https://github.com/axelspringer/generator-go-lang)   [![归档项目][Archived]](https://github.com/axelspringer/generator-go-lang)
* [docs](https://github.com/go-oas/docs) **star:9** 自动为GO项目生成RESTful API文档-与开放API规范标准一致。   [![godoc][GoDoc]](https://godoc.org/github.com/go-oas/docs)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#go-tools) 吧~)*

## 软件包

*用Go编写的软件。 (翻译出错了? 试试 [英文版](README_EN.md#software-packages) 吧~)*

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#software-packages) 吧~)*

### DevOps 工具

* [kubernetes](https://github.com/kubernetes/kubernetes) **star:84505** 来自谷歌的容器集群管理器。   [![star > 2000][Awesome]](https://github.com/kubernetes/kubernetes)   [![最近一周有更新][Green]](https://github.com/kubernetes/kubernetes)   [![godoc][GoDoc]](https://godoc.org/github.com/kubernetes/kubernetes)
* [Moby](https://github.com/moby/moby) **star:61987** Collaborative project for the container ecosystem to assemble container-based systems.   [![star > 2000][Awesome]](https://github.com/moby/moby)   [![最近一周有更新][Green]](https://github.com/moby/moby)   [![godoc][GoDoc]](https://godoc.org/github.com/moby/moby)
* [traefik](https://github.com/containous/traefik) **star:36455** 反向代理和负载均衡器，支持多个后端。   [![star > 2000][Awesome]](https://github.com/containous/traefik)   [![最近一周有更新][Green]](https://github.com/containous/traefik)   [![godoc][GoDoc]](https://godoc.org/github.com/containous/traefik)
* [Gitea](https://github.com/go-gitea/gitea) **star:27852** 从 Gogs fork，完全由社区驱动。   [![star > 2000][Awesome]](https://github.com/go-gitea/gitea)   [![最近一周有更新][Green]](https://github.com/go-gitea/gitea)   [![godoc][GoDoc]](https://godoc.org/github.com/go-gitea/gitea)   [![包含中文文档][CN]](https://github.com/go-gitea/gitea)
* [gitea-github-migrator](https://git.jonasfranz.software/JonasFranzDEV/gitea-github-migrator)  将所有GitHub repositories、issues、milestones 和 labels 都迁移到 Gitea。
* [Vegeta](https://github.com/tsenart/vegeta) **star:18880** HTTP负载测试工具和库。超过9000 !   [![star > 2000][Awesome]](https://github.com/tsenart/vegeta)   [![godoc][GoDoc]](https://godoc.org/github.com/tsenart/vegeta)
* [Packer](https://github.com/mitchellh/packer) **star:13436** 用于从一个源配置为多个平台创建相同的机器图像。   [![star > 2000][Awesome]](https://github.com/mitchellh/packer)   [![最近一周有更新][Green]](https://github.com/mitchellh/packer)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/packer)
* [Hey](https://github.com/rakyll/hey) **star:12694** 压力测试工具，可用来代替 ApacheBench (ab)。   [![star > 2000][Awesome]](https://github.com/rakyll/hey)   [![最近一周有更新][Green]](https://github.com/rakyll/hey)   [![godoc][GoDoc]](https://godoc.org/github.com/rakyll/hey)
* [webhook](https://github.com/adnanh/webhook) **star:7333** 允许用户创建在服务器上执行命令的 HTTP hooks。   [![star > 2000][Awesome]](https://github.com/adnanh/webhook)   [![godoc][GoDoc]](https://godoc.org/github.com/adnanh/webhook)
* [Wide](https://wide.b3log.org/login)  为使用 Golang 的团队提供基于 web 的 IDE。
* [GVM](https://github.com/moovweb/gvm) **star:6935** GVM 提供了一个接口来管理 Go 版本。   [![star > 2000][Awesome]](https://github.com/moovweb/gvm)
* [gaia](https://github.com/gaia-pipeline/gaia) **star:4553** 可用于任何编程语言来构建强大的管道。   [![star > 2000][Awesome]](https://github.com/gaia-pipeline/gaia)   [![最近一周有更新][Green]](https://github.com/gaia-pipeline/gaia)   [![godoc][GoDoc]](https://godoc.org/github.com/gaia-pipeline/gaia)
* [gox](https://github.com/mitchellh/gox) **star:4169** 非常简单，没有多余的跨平台编译工具。   [![star > 2000][Awesome]](https://github.com/mitchellh/gox)   [![godoc][GoDoc]](https://godoc.org/github.com/mitchellh/gox)
* [bosun](https://github.com/bosun-monitor/bosun) **star:3232** 按照时间轴发出告警的框架。   [![star > 2000][Awesome]](https://github.com/bosun-monitor/bosun)   [![godoc][GoDoc]](https://godoc.org/github.com/bosun-monitor/bosun)
* [Ddosify](https://github.com/ddosify/ddosify) **star:3232** 高性能负载测试工具，用Golang编写。   [![star > 2000][Awesome]](https://github.com/ddosify/ddosify)   [![最近一周有更新][Green]](https://github.com/ddosify/ddosify)   [![godoc][GoDoc]](https://godoc.org/github.com/ddosify/ddosify)
* [bombardier](https://github.com/codesenberg/bombardier) **star:2996** 快速跨平台 HTTP 基准测试工具。   [![star > 2000][Awesome]](https://github.com/codesenberg/bombardier)   [![godoc][GoDoc]](https://godoc.org/github.com/codesenberg/bombardier)
* [Pomerium](https://github.com/pomerium/pomerium) **star:2893** Pomerium是一个可识别身份的访问代理。   [![star > 2000][Awesome]](https://github.com/pomerium/pomerium)   [![最近一周有更新][Green]](https://github.com/pomerium/pomerium)   [![godoc][GoDoc]](https://godoc.org/github.com/pomerium/pomerium)
* [script](https://github.com/bitfield/script) **star:1983** 让DevOps编写类shell和系统管理任务变得更加容易。   [![godoc][GoDoc]](https://godoc.org/github.com/bitfield/script)
* [kala](https://github.com/ajvb/kala) **star:1745** 简单、现代和高性能的作业调度程序。   [![最近一周有更新][Green]](https://github.com/ajvb/kala)   [![godoc][GoDoc]](https://godoc.org/github.com/ajvb/kala)
* [fac](https://github.com/mkchoi212/fac) **star:1742** 修复 git 合并冲突。   [![最近一年没有更新][Yellow]](https://github.com/mkchoi212/fac)   [![godoc][GoDoc]](https://godoc.org/github.com/mkchoi212/fac)
* [goxc](https://github.com/laher/goxc) **star:1673** 专注于跨平台编译和打包的 Go 构建工具。   [![最近一年没有更新][Yellow]](https://github.com/laher/goxc)   [![godoc][GoDoc]](https://godoc.org/github.com/laher/goxc)
* [StatusOK](https://github.com/sanathp/statusok) **star:1524** 监视您的网站和REST api。当服务器宕机或响应时间超过预期时，通过Slack、电子邮件获得通知。   [![godoc][GoDoc]](https://godoc.org/github.com/sanathp/statusok)
* [s3gof3r](https://github.com/rlmcpherson/s3gof3r) **star:1115** 小型实用程序/库，针对大型对象在Amazon S3中的高速传输进行了优化。   [![godoc][GoDoc]](https://godoc.org/github.com/rlmcpherson/s3gof3r)
* [go-selfupdate](https://github.com/sanbornm/go-selfupdate) **star:908** 允许你的 Go应用程序 进行自我更新。   [![godoc][GoDoc]](https://godoc.org/github.com/sanbornm/go-selfupdate)
* [s5cmd](https://github.com/peak/s5cmd) **star:898** 非常快的S3和本地文件系统执行工具。   [![godoc][GoDoc]](https://godoc.org/github.com/peak/s5cmd)
* [skm](https://github.com/TimothyYe/skm) **star:746** SKM是一个简单而强大的SSH密钥管理器，它可以帮助您轻松地管理多个SSH密钥!   [![godoc][GoDoc]](https://godoc.org/github.com/TimothyYe/skm)
* [Scaleway-cli](https://github.com/scaleway/scaleway-cli) **star:723** 从命令行管理 BareMetal 服务器(与使用Docker一样容易)。   [![godoc][GoDoc]](https://godoc.org/github.com/scaleway/scaleway-cli)
* [ghorg](https://github.com/gabrie30/ghorg) **star:661** 支持GitHub, GitLab, Gitea和Bitbucket。   [![最近一周有更新][Green]](https://github.com/gabrie30/ghorg)   [![godoc][GoDoc]](https://godoc.org/github.com/gabrie30/ghorg)
* [uTask](https://github.com/ovh/utask) **star:590** 对yaml中声明的业务流程进行建模和执行的自动化引擎。   [![godoc][GoDoc]](https://godoc.org/github.com/ovh/utask)
* [kool](https://github.com/kool-dev/kool) **star:573** 命令行工具管理Docker环境作为一种简单的方式。   [![godoc][GoDoc]](https://godoc.org/github.com/kool-dev/kool)
* [cassowary](https://github.com/rogerwelin/cassowary) **star:553** 用Go编写的跨平台HTTP负载测试工具。   [![godoc][GoDoc]](https://godoc.org/github.com/rogerwelin/cassowary)   [![包含中文文档][CN]](https://github.com/rogerwelin/cassowary)
* [aurora](https://github.com/xuri/aurora) **star:545** 基于web的跨平台 Beanstalkd 队列服务器控制台。
* [govvv](https://github.com/ahmetalpbalkan/govvv) **star:512** 可轻松地添加版本信息到 Go 二进制文件。   [![最近一年没有更新][Yellow]](https://github.com/ahmetalpbalkan/govvv)   [![godoc][GoDoc]](https://godoc.org/github.com/ahmetalpbalkan/govvv)
* [gonative](https://github.com/inconshreveable/gonative) **star:326** 用原生 Go 创建一个跨平台的 Go 工具链。   [![最近一年没有更新][Yellow]](https://github.com/inconshreveable/gonative)   [![godoc][GoDoc]](https://godoc.org/github.com/inconshreveable/gonative)
* [Pewpew](https://github.com/bengadbois/pewpew) **star:310** 灵活的 HTTP 命令行压测工具。   [![godoc][GoDoc]](https://godoc.org/github.com/bengadbois/pewpew)
* [trubka](https://github.com/xitonix/trubka) **star:310** 一个CLI工具，用于管理和故障排除Apache Kafka集群，具有通用发布/使用协议缓冲区和与Kafka之间的纯文本事件的能力。   [![最近一周有更新][Green]](https://github.com/xitonix/trubka)   [![godoc][GoDoc]](https://godoc.org/github.com/xitonix/trubka)
* [jcli](https://github.com/jenkins-zh/jenkins-cli) **star:303** 詹金斯CLI允许你管理你的詹金斯作为一个简单的方法。   [![godoc][GoDoc]](https://godoc.org/github.com/jenkins-zh/jenkins-cli)   [![包含中文文档][CN]](https://github.com/jenkins-zh/jenkins-cli)
* [Mora](https://github.com/emicklei/mora) **star:297** 用于访问 MongoDB 文档和元数据的 REST 服务器。   [![godoc][GoDoc]](https://godoc.org/github.com/emicklei/mora)
* [lstags](https://github.com/ivanilves/lstags) **star:285** 提供了工具和API，可用来同步不同注册中心的Docker图像。   [![godoc][GoDoc]](https://godoc.org/github.com/ivanilves/lstags)
* [Balerter](https://github.com/balerter/balerter) **star:242** 一个自托管的基于脚本的警报管理器。   [![godoc][GoDoc]](https://godoc.org/github.com/balerter/balerter)
* [dogo](https://github.com/liudng/dogo) **star:238** 监视源文件中的更改并自动编译和运行(restart)。   [![最近一年没有更新][Yellow]](https://github.com/liudng/dogo)   [![godoc][GoDoc]](https://godoc.org/github.com/liudng/dogo)   [![包含中文文档][CN]](https://github.com/liudng/dogo)
* [manssh](https://github.com/xwjdsh/manssh) **star:238** manssh是一个命令行工具，可以方便地管理ssh别名配置。   [![最近一周有更新][Green]](https://github.com/xwjdsh/manssh)   [![godoc][GoDoc]](https://godoc.org/github.com/xwjdsh/manssh)
* [godbg](https://github.com/sirnewton01/godbg) **star:224** 基于 web 的 gdb 前端应用程序。   [![最近一年没有更新][Yellow]](https://github.com/sirnewton01/godbg)
* [Gogs](https://gogs.io/)  自托管的Git服务。
* [easyssh-proxy](https://github.com/appleboy/easyssh-proxy) **star:218** Golang package for easy remote execution through SSH and SCP downloading via `ProxyCommand`.   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/easyssh-proxy)
* [Blast](https://github.com/dave/blast) **star:202** 一个用于API负载测试和批处理作业的简单工具。   [![最近一年没有更新][Yellow]](https://github.com/dave/blast)   [![godoc][GoDoc]](https://godoc.org/github.com/dave/blast)
* [kwatch](https://github.com/abahmed/kwatch) **star:202** 立即监视和检测Kubernetes(k8)集群中的崩溃。   [![最近一周有更新][Green]](https://github.com/abahmed/kwatch)   [![godoc][GoDoc]](https://godoc.org/github.com/abahmed/kwatch)
* [gobrew](https://github.com/cryptojuice/gobrew) **star:186** gobrew 允许您轻松地在 go 的多个版本之间切换。   [![最近一年没有更新][Yellow]](https://github.com/cryptojuice/gobrew)
* [terraform-provider-openapi](https://github.com/dikhan/terraform-provider-openapi) **star:179** Terraform provider plugin，它根据OpenAPI文档(以前称为swagger文件)在运行时动态配置自身，该文档包含了公开的api的定义。   [![最近一周有更新][Green]](https://github.com/dikhan/terraform-provider-openapi)   [![godoc][GoDoc]](https://godoc.org/github.com/dikhan/terraform-provider-openapi)
* [abbreviate](https://github.com/dnnrly/abbreviate) **star:174** 缩写是一种工具，可以将长字符串转换为具有可配置分隔符的短字符串，例如将分支名称嵌入到部署堆栈id中。   [![godoc][GoDoc]](https://godoc.org/github.com/dnnrly/abbreviate)
* [ostent](https://github.com/ostrost/ostent) **star:171** 收集和显示系统指标，并可选 Graphite and/or fluxdb作为依赖。   [![最近一年没有更新][Yellow]](https://github.com/ostrost/ostent)   [![godoc][GoDoc]](https://godoc.org/github.com/ostrost/ostent)
* [kcli](https://github.com/cswank/kcli) **star:165** 用于检查kafka主题/分区/消息的命令行工具。   [![最近一年没有更新][Yellow]](https://github.com/cswank/kcli)   [![godoc][GoDoc]](https://godoc.org/github.com/cswank/kcli)
* [grapes](https://github.com/yaronsumel/grapes) **star:152** 旨在轻松地通过ssh分发命令的轻量级工具。   [![最近一年没有更新][Yellow]](https://github.com/yaronsumel/grapes)   [![godoc][GoDoc]](https://godoc.org/github.com/yaronsumel/grapes)
* [winrm-cli](https://github.com/masterzen/winrm-cli) **star:136** 在Windows机器上远程执行命令的Cli工具。   [![godoc][GoDoc]](https://godoc.org/github.com/masterzen/winrm-cli)
* [Dockerfile-Generator](https://github.com/ozankasikci/dockerfile-generator) **star:119** 一个go库和一个可执行文件，它使用各种输入通道生成有效的Dockerfiles。   [![最近一年没有更新][Yellow]](https://github.com/ozankasikci/dockerfile-generator)   [![godoc][GoDoc]](https://godoc.org/github.com/ozankasikci/dockerfile-generator)
* [drone-scp](https://github.com/appleboy/drone-scp) **star:93** 通过 SSH 进行文件拷贝。其中 SSH 通过二进制文件、docker 或 Drone CI触发。   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/drone-scp)
* [go-furnace](https://github.com/go-furnace/go-furnace) **star:85** 用Go编写的托管解决方案，可轻松地在AWS、GCP或DigitalOcean上部署应用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/go-furnace/go-furnace)
* [s3-proxy](https://github.com/oxyno-zeta/s3-proxy) **star:76** 具有GET、PUT和DELETE方法和身份验证(OpenID连接和基本身份验证)的S3代理。   [![最近一周有更新][Green]](https://github.com/oxyno-zeta/s3-proxy)   [![godoc][GoDoc]](https://godoc.org/github.com/oxyno-zeta/s3-proxy)
* [Dropship](https://github.com/chrismckenzie/dropship) **star:56** 通过 cdn 部署代码的工具。   [![最近一年没有更新][Yellow]](https://github.com/chrismckenzie/dropship)   [![godoc][GoDoc]](https://godoc.org/github.com/chrismckenzie/dropship)
* [drone-jenkins](https://github.com/appleboy/drone-jenkins) **star:32** 使用二进制文件、docker或 Drone CI 来触发下游Jenkins作业。   [![godoc][GoDoc]](https://godoc.org/github.com/appleboy/drone-jenkins)
* [Rodent](https://github.com/alouche/rodent) **star:31** 管理Go版本、项目和跟踪依赖项。   [![最近一年没有更新][Yellow]](https://github.com/alouche/rodent)
* [awsenv](https://github.com/soniah/awsenv) **star:27** 可以为 profile 加载Amazon (AWS)环境变量的轻量二进制文件。   [![最近一年没有更新][Yellow]](https://github.com/soniah/awsenv)   [![godoc][GoDoc]](https://godoc.org/github.com/soniah/awsenv)
* [lwc](https://github.com/timdp/lwc) **star:25** UNIX wc命令的实时更新版本。   [![最近一年没有更新][Yellow]](https://github.com/timdp/lwc)   [![godoc][GoDoc]](https://godoc.org/github.com/timdp/lwc)
* [docker-go-mingw](https://github.com/x1unix/docker-go-mingw) **star:24** 使用MinGW工具链在Windows上构建Go二进制文件的Docker图像。   [![最近一周有更新][Green]](https://github.com/x1unix/docker-go-mingw)
* [DepCharge](https://github.com/centerorbit/depcharge) **star:18** Helps orchestrating the execution of commands across the many dependencies in larger projects.   [![godoc][GoDoc]](https://godoc.org/github.com/centerorbit/depcharge)
* [httpref](https://github.com/dnnrly/httpref) **star:18** httpref是一个方便的CLI参考，用于HTTP方法、状态码、头以及TCP和UDP端口。   [![godoc][GoDoc]](https://godoc.org/github.com/dnnrly/httpref)
* [sg](https://github.com/ChristopherRabotin/sg) **star:5** 可测试一组HTTP极限(如ab)，可以在每个调用之间使用响应代码和数据，根据之前的响应来确定特定的服务器压力。   [![最近一年没有更新][Yellow]](https://github.com/ChristopherRabotin/sg)   [![godoc][GoDoc]](https://godoc.org/github.com/ChristopherRabotin/sg)
* [aptly](https://github.com/smira/aptly) **star:3** Debian存储库管理工具。   [![最近一年没有更新][Yellow]](https://github.com/smira/aptly)   [![godoc][GoDoc]](https://godoc.org/github.com/smira/aptly)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#devops-tools) 吧~)*

### 其他软件

* [croc](https://github.com/schollz/croc) **star:18192** 轻松、安全地将文件或文件夹从一台计算机发送到另一台计算机。   [![star > 2000][Awesome]](https://github.com/schollz/croc)   [![godoc][GoDoc]](https://godoc.org/github.com/schollz/croc)
* [Docker](https://www.docker.com/)  面向开发人员和系统管理员的分布式应用程序的开放平台。
* [restic](https://github.com/restic/restic) **star:15427** 消除重复项备份程序。   [![star > 2000][Awesome]](https://github.com/restic/restic)   [![最近一周有更新][Green]](https://github.com/restic/restic)   [![godoc][GoDoc]](https://godoc.org/github.com/restic/restic)
* [Gor](https://github.com/buger/gor) **star:15050** Http 流量复制工具，用于实时回放从生产环境到阶段/开发环境的流量。   [![star > 2000][Awesome]](https://github.com/buger/gor)   [![最近一周有更新][Green]](https://github.com/buger/gor)   [![godoc][GoDoc]](https://godoc.org/github.com/buger/gor)
* [Seaweed File System](https://github.com/chrislusf/seaweedfs) **star:13664** 快速、简单、可伸缩的分布式文件系统，采用了O(1)磁盘查找。   [![star > 2000][Awesome]](https://github.com/chrislusf/seaweedfs)   [![最近一周有更新][Green]](https://github.com/chrislusf/seaweedfs)   [![godoc][GoDoc]](https://godoc.org/github.com/chrislusf/seaweedfs)
* [Comcast](https://github.com/tylertreat/Comcast) **star:7735** 模拟坏的网络连接。   [![star > 2000][Awesome]](https://github.com/tylertreat/Comcast)   [![godoc][GoDoc]](https://godoc.org/github.com/tylertreat/Comcast)
* [toxiproxy](https://github.com/shopify/toxiproxy) **star:7700** 为自动化测试模拟网络和系统条件的代理。   [![star > 2000][Awesome]](https://github.com/shopify/toxiproxy)   [![最近一周有更新][Green]](https://github.com/shopify/toxiproxy)   [![godoc][GoDoc]](https://godoc.org/github.com/shopify/toxiproxy)
* [tsuru](https://tsuru.io/)  Extensible and open source Platform as a Service software.
* [confd](https://github.com/kelseyhightower/confd) **star:7691** 使用 etcd 或 consul 的模板和数据管理本地应用程序配置文件。   [![star > 2000][Awesome]](https://github.com/kelseyhightower/confd)   [![godoc][GoDoc]](https://godoc.org/github.com/kelseyhightower/confd)
* [LiteIDE](https://github.com/visualfc/liteide) **star:6695** 简单的、开源的、跨平台的Go IDE。   [![star > 2000][Awesome]](https://github.com/visualfc/liteide)   [![最近一周有更新][Green]](https://github.com/visualfc/liteide)   [![包含中文文档][CN]](https://github.com/visualfc/liteide)
* [drive](https://github.com/odeke-em/drive) **star:6283** 基于命令行的谷歌驱动器客户端。   [![star > 2000][Awesome]](https://github.com/odeke-em/drive)   [![godoc][GoDoc]](https://godoc.org/github.com/odeke-em/drive)
* [nes](https://github.com/fogleman/nes) **star:4967** 任天堂娱乐系统(NES)模拟器。   [![star > 2000][Awesome]](https://github.com/fogleman/nes)   [![godoc][GoDoc]](https://godoc.org/github.com/fogleman/nes)
* [Duplicacy](https://github.com/gilbertchen/duplicacy) **star:4007** 跨平台网络和云备份工具。   [![star > 2000][Awesome]](https://github.com/gilbertchen/duplicacy)   [![godoc][GoDoc]](https://godoc.org/github.com/gilbertchen/duplicacy)
* [scc](https://github.com/boyter/scc) **star:3025** 一个非常快速准确的代码计数器，采用了复杂的计算和 COCOMO 预估。   [![star > 2000][Awesome]](https://github.com/boyter/scc)   [![最近一周有更新][Green]](https://github.com/boyter/scc)   [![godoc][GoDoc]](https://godoc.org/github.com/boyter/scc)
* [myLG](https://github.com/mehrdadrad/mylg) **star:2542** 命令行网络诊断工具。   [![star > 2000][Awesome]](https://github.com/mehrdadrad/mylg)   [![最近一年没有更新][Yellow]](https://github.com/mehrdadrad/mylg)   [![godoc][GoDoc]](https://godoc.org/github.com/mehrdadrad/mylg)
* [GoBoy](https://github.com/Humpheh/goboy) **star:2413** 用 Go 编写的任天堂Game Boy彩色模拟器。   [![star > 2000][Awesome]](https://github.com/Humpheh/goboy)   [![最近一年没有更新][Yellow]](https://github.com/Humpheh/goboy)   [![godoc][GoDoc]](https://godoc.org/github.com/Humpheh/goboy)
* [Stack Up](https://github.com/pressly/sup) **star:2312** Stack Up 是一个超级简单的部署工具 — 只面向Unix。   [![star > 2000][Awesome]](https://github.com/pressly/sup)   [![godoc][GoDoc]](https://godoc.org/github.com/pressly/sup)
* [syncthing](https://syncthing.net/)  开放，分散的文件同步工具和协议。
* [lgo](https://github.com/yunabe/lgo) **star:2228** 与 Jupyter 可进行交互 Go 程序。它支持代码完成、代码检查以及与Go 100% 兼容性。   [![star > 2000][Awesome]](https://github.com/yunabe/lgo)   [![最近一年没有更新][Yellow]](https://github.com/yunabe/lgo)   [![godoc][GoDoc]](https://godoc.org/github.com/yunabe/lgo)
* [limetext](https://limetext.github.io)  一个强大而优雅的文本编辑器。
* [Circuit](https://github.com/gocircuit/circuit) **star:1928** Circuit 是一个可编程平台即服务(PaaS)和/或基础设施即服务(IaaS)，用于管理、发现、同步和编排包含云应用程序的服务和主机。   [![最近一年没有更新][Yellow]](https://github.com/gocircuit/circuit)   [![godoc][GoDoc]](https://godoc.org/github.com/gocircuit/circuit)
* [snap](https://github.com/intelsdi-x/snap) **star:1797** 强大的遥测框架。   [![最近一年没有更新][Yellow]](https://github.com/intelsdi-x/snap)   [![godoc][GoDoc]](https://godoc.org/github.com/intelsdi-x/snap)
* [borg](https://github.com/crufter/borg) **star:1530** 基于终端的bash代码段搜索引擎。   [![最近一年没有更新][Yellow]](https://github.com/crufter/borg)   [![godoc][GoDoc]](https://godoc.org/github.com/crufter/borg)
* [Documize](https://github.com/documize/community) **star:1463** 集成了SaaS工具数据的现代wiki软件。   [![最近一周有更新][Green]](https://github.com/documize/community)
* [blocky](https://github.com/0xERR0R/blocky) **star:1257** 快速和轻量级的DNS代理作为广告拦截器，为本地网络具有许多功能。   [![最近一周有更新][Green]](https://github.com/0xERR0R/blocky)   [![godoc][GoDoc]](https://godoc.org/github.com/0xERR0R/blocky)
* [Go Package Store](https://github.com/shurcooL/Go-Package-Store) **star:886** App that displays updates for the Go packages in your GOPATH.   [![最近一年没有更新][Yellow]](https://github.com/shurcooL/Go-Package-Store)   [![godoc][GoDoc]](https://godoc.org/github.com/shurcooL/Go-Package-Store)
* [shell2http](https://github.com/msoap/shell2http) **star:877** 通过http服务器执行shell命令(用于原型或远程控制)。   [![godoc][GoDoc]](https://godoc.org/github.com/msoap/shell2http)
* [vFlow](https://github.com/VerizonDigital/vflow) **star:860** 高性能、可伸缩和可靠的 IPFIX、sFlow和 Netflow 收集器。   [![godoc][GoDoc]](https://godoc.org/github.com/VerizonDigital/vflow)
* [peg](https://github.com/pointlander/peg) **star:834** 解析表达式语法，是Packrat解析器生成器的实现。   [![godoc][GoDoc]](https://godoc.org/github.com/pointlander/peg)
* [Leaps](https://github.com/jeffail/leaps) **star:711** 使用操作转换的成对编程服务。   [![godoc][GoDoc]](https://godoc.org/github.com/jeffail/leaps)
* [gfile](https://github.com/Antonito/gfile) **star:643** 通过WebRTC在两台计算机之间安全地传输文件，不需要任何第三方依赖。   [![godoc][GoDoc]](https://godoc.org/github.com/Antonito/gfile)
* [Guora](https://github.com/meloalright/guora) **star:573** 一个用Go编写的类似Quora的自托管web应用程序。   [![最近一年没有更新][Yellow]](https://github.com/meloalright/guora)   [![godoc][GoDoc]](https://godoc.org/github.com/meloalright/guora)   [![包含中文文档][CN]](https://github.com/meloalright/guora)
* [Gebug](https://github.com/moshebe/gebug) **star:558** 一个工具，通过启用调试器和热重新加载特性，使docker化的Go应用程序的调试非常容易，无缝。   [![最近一周有更新][Green]](https://github.com/moshebe/gebug)   [![godoc][GoDoc]](https://godoc.org/github.com/moshebe/gebug)
* [gocc](https://github.com/goccmack/gocc) **star:509** Gocc是一个用Go编写的编译器工具包。   [![godoc][GoDoc]](https://godoc.org/github.com/goccmack/gocc)
* [mockingjay](https://github.com/quii/mockingjay-server) **star:503** 一份配置文件中便可伪造HTTP服务器与用户之间的行为。您还可以使服务器随机宕机，以帮助进行更实际的性能测试。   [![最近一年没有更新][Yellow]](https://github.com/quii/mockingjay-server)   [![godoc][GoDoc]](https://godoc.org/github.com/quii/mockingjay-server)
* [go-peerflix](https://github.com/Sioro-Neoku/go-peerflix) **star:439** 视频流 torrent 客户端。   [![godoc][GoDoc]](https://godoc.org/github.com/Sioro-Neoku/go-peerflix)
* [ipe](https://github.com/dimiro1/ipe) **star:344** Open source Pusher server implementation compatible with Pusher client libraries written in GO.   [![godoc][GoDoc]](https://godoc.org/github.com/dimiro1/ipe)
* [ide](https://github.com/thestrukture/ide) **star:324** 基于浏览器的IDE   [![godoc][GoDoc]](https://godoc.org/github.com/thestrukture/ide)
* [tcpprobe](https://github.com/mehrdadrad/tcpprobe) **star:317** 用于网络性能和路径监控的TCP工具，包括套接字统计信息。   [![godoc][GoDoc]](https://godoc.org/github.com/mehrdadrad/tcpprobe)
* [wellington](https://github.com/wellington/wellington) **star:300** Sass 项目管理工具，使用sprite函数(如Compass)扩展语言。   [![最近一年没有更新][Yellow]](https://github.com/wellington/wellington)   [![godoc][GoDoc]](https://godoc.org/github.com/wellington/wellington)
* [woke](https://github.com/get-woke/woke) **star:298** 检测源代码中不包含的语言。   [![godoc][GoDoc]](https://godoc.org/github.com/get-woke/woke)
* [Cherry](https://github.com/rafael-santiago/cherry) **star:268** 微型网络聊天服务器。   [![最近一年没有更新][Yellow]](https://github.com/rafael-santiago/cherry)   [![godoc][GoDoc]](https://godoc.org/github.com/rafael-santiago/cherry)
* [joincap](https://github.com/assafmo/joincap) **star:171** 用于合并多个pcap文件的命令行实用程序。   [![godoc][GoDoc]](https://godoc.org/github.com/assafmo/joincap)
* [Juju](https://jujucharms.com/)  Cloud-agnostic的服务部署和编制 —— 支持EC2、Azure、Openstack、MAAS等。
* [Neo-cowsay](https://github.com/Code-Hex/Neo-cowsay) **star:171** 🐮cowsay重生。一个新时代。   [![godoc][GoDoc]](https://godoc.org/github.com/Code-Hex/Neo-cowsay)
* [tcpdog](https://github.com/mehrdadrad/tcpdog) **star:171** 基于eBPF的TCP可观测性。   [![godoc][GoDoc]](https://godoc.org/github.com/mehrdadrad/tcpdog)
* [Orbit](https://github.com/gulien/orbit) **star:162** 一个根据模板来运行命令和生成文件的简单小工具。   [![最近一年没有更新][Yellow]](https://github.com/gulien/orbit)   [![godoc][GoDoc]](https://godoc.org/github.com/gulien/orbit)
* [Better Go Playground](https://goplay.tools)  使用语法高亮显示、代码完成和其他功能。
* [vaku](https://github.com/lingrino/vaku) **star:128** 用于库中基于文件夹的函数(如复制、移动和搜索)的CLI和API。   [![最近一周有更新][Green]](https://github.com/lingrino/vaku)   [![godoc][GoDoc]](https://godoc.org/github.com/lingrino/vaku)
* [dp](https://github.com/scryinfo/dp) **star:83** 通过SDK与区块链进行数据交换，开发人员可以轻松访问DAPP开发。   [![最近一周有更新][Green]](https://github.com/scryinfo/dp)   [![godoc][GoDoc]](https://godoc.org/github.com/scryinfo/dp)
* [boxed](https://github.com/tejo/boxed) **star:75** 基于Dropbox的博客引擎。   [![最近一年没有更新][Yellow]](https://github.com/tejo/boxed)   [![godoc][GoDoc]](https://godoc.org/github.com/tejo/boxed)
* [crawley](https://github.com/s0rg/crawley) **star:46** 网刮板/爬虫为cli。   [![godoc][GoDoc]](https://godoc.org/github.com/s0rg/crawley)
* [naclpipe](https://github.com/unix4fun/naclpipe) **star:22** 基于加密管的简单的NaCL EC25519工具。   [![最近一年没有更新][Yellow]](https://github.com/unix4fun/naclpipe)   [![godoc][GoDoc]](https://godoc.org/github.com/unix4fun/naclpipe)
* [term-quiz](https://github.com/crazcalm/term-quiz) **star:21** 测试你的终端。   [![最近一年没有更新][Yellow]](https://github.com/crazcalm/term-quiz)   [![godoc][GoDoc]](https://godoc.org/github.com/crazcalm/term-quiz)
* [Snitch](https://github.com/lucasgomide/snitch) **star:15** 当有人通过 Tsuru 部署任何应用程序时，会通知您的团队以及其他工具。   [![最近一年没有更新][Yellow]](https://github.com/lucasgomide/snitch)   [![godoc][GoDoc]](https://godoc.org/github.com/lucasgomide/snitch)
* [GoDocTooltip](https://github.com/diankong/GoDocTooltip) **star:12** 包含了 Go 使用手册文档的 Chrome 扩展。
* [GoLand](https://jetbrains.com/go)  功能齐全的跨平台 Go IDE。
* [protoncheck](https://github.com/servusdei2018/protoncheck) **star:3** ProtonMail模块的waybar/polybar/yabar/i3blocks。   [![godoc][GoDoc]](https://godoc.org/github.com/servusdei2018/protoncheck)
* [hoofli](https://github.com/dnnrly/hoofli) **star:1** 从Chrome或Firefox网络检查生成PlantUML图表。   [![godoc][GoDoc]](https://godoc.org/github.com/dnnrly/hoofli)
* [hugo](https://gohugo.io/)  快速、现代的静态网站引擎。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#other-software) 吧~)*

# 资源

*在哪里可以找到新的Go库。 (翻译出错了? 试试 [英文版](README_EN.md#resources) 吧~)*

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#resources) 吧~)*

## 基准

* [go-web-framework-benchmark](https://github.com/smallnest/go-web-framework-benchmark) **star:1617** web框架基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/smallnest/go-web-framework-benchmark)
* [go-http-routing-benchmark](https://github.com/julienschmidt/go-http-routing-benchmark) **star:1543** HTTP请求路由器基准测试和比较。   [![godoc][GoDoc]](https://godoc.org/github.com/julienschmidt/go-http-routing-benchmark)
* [go_serialization_benchmarks](https://github.com/alecthomas/go_serialization_benchmarks) **star:1242** Go序列化方法的基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/alecthomas/go_serialization_benchmarks)
* [skynet](https://github.com/atemerev/skynet) **star:1003** 天网 1M 线程微基准测试。
* [speedtest-resize](https://github.com/fawick/speedtest-resize) **star:214** 对比各种图像大小调整算法性能。   [![最近一年没有更新][Yellow]](https://github.com/fawick/speedtest-resize)   [![godoc][GoDoc]](https://godoc.org/github.com/fawick/speedtest-resize)
* [go-benchmarks](https://github.com/tylertreat/go-benchmarks) **star:142** Few miscellaneous Go microbenchmarks. Compare some language features to alternative approaches   [![最近一年没有更新][Yellow]](https://github.com/tylertreat/go-benchmarks)   [![godoc][GoDoc]](https://godoc.org/github.com/tylertreat/go-benchmarks)
* [gospeed](https://github.com/feyeleanor/GoSpeed) **star:108** 计算语言结构的速度的微观基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/feyeleanor/GoSpeed)
* [autobench](https://github.com/davecheney/autobench) **star:92** 用来来比较不同Go版本之间的性能的框架。   [![最近一年没有更新][Yellow]](https://github.com/davecheney/autobench)   [![godoc][GoDoc]](https://godoc.org/github.com/davecheney/autobench)
* [golang-sql-benchmark](https://github.com/tyler-smith/golang-sql-benchmark) **star:60** 为流行的 Go 数据库/SQL实用程序收集基准测试。   [![最近一年没有更新][Yellow]](https://github.com/tyler-smith/golang-sql-benchmark)   [![godoc][GoDoc]](https://godoc.org/github.com/tyler-smith/golang-sql-benchmark)
* [gocostmodel](https://github.com/PuerkitoBio/gocostmodel) **star:57** Go语言常用基本操作的基准测试。   [![godoc][GoDoc]](https://godoc.org/github.com/PuerkitoBio/gocostmodel)
* [kvbench](https://github.com/jimrobinson/kvbench) **star:24** K / V 类型数据库基准测试。   [![最近一年没有更新][Yellow]](https://github.com/jimrobinson/kvbench)   [![godoc][GoDoc]](https://godoc.org/github.com/jimrobinson/kvbench)
* [go-benchmark-app](https://github.com/mrLSD/go-benchmark-app) **star:22** 强大的HTTP基准测试工具，包含了Аb，Wrk，Siege工具。收集统计和各种参数指标，并比较相关结果。   [![最近一年没有更新][Yellow]](https://github.com/mrLSD/go-benchmark-app)   [![godoc][GoDoc]](https://godoc.org/github.com/mrLSD/go-benchmark-app)
* [go-ml-benchmarks](https://github.com/nikolaydubina/go-ml-benchmarks) **star:19** 机器学习推理基准。   [![godoc][GoDoc]](https://godoc.org/github.com/nikolaydubina/go-ml-benchmarks)
* [go-json-benchmark](https://github.com/zerosnake0/go-json-benchmark) **star:6** JSON的基准。   [![最近一年没有更新][Yellow]](https://github.com/zerosnake0/go-json-benchmark)   [![godoc][GoDoc]](https://godoc.org/github.com/zerosnake0/go-json-benchmark)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#benchmarks) 吧~)*

## 会议

* [Capital Go](http://www.capitalgolang.com)  华盛顿特区。,美国。
* [dotGo](https://www.dotgo.eu)  巴黎,法国。
* [GoCon](https://gocon.connpass.com/)  东京,日本。
* [GoDays](https://www.godays.io/)  德国柏林。
* [GoLab](https://golab.io/)  佛罗伦萨,意大利。
* [GopherChina](https://gopherchina.org)  上海,中国。
* [GopherCon](https://www.gophercon.com/)  美国丹佛。
* [GopherCon Australia](https://gophercon.com.au/)  澳大利亚悉尼。
* [GopherCon Brazil](https://gopherconbr.org)  弗洛,巴西。
* [GopherCon Europe](https://gophercon.is/)  德国柏林。
* [GopherCon India](https://www.gophercon.in/)  印度浦那。
* [GopherCon Israel](https://www.gophercon.org.il/)  特拉维夫,以色列。
* [GopherCon Russia](https://www.gophercon-russia.ru)  莫斯科,俄罗斯。
* [GopherCon Singapore](https://gophercon.sg)  新加坡枫树商贸城。
* [GopherCon UK](https://www.gophercon.co.uk/)  伦敦,英国。
* [GopherCon Vietnam](https://gophercon.vn/)  越南胡志明市。
* [GoWayFest](https://goway.io/)  白俄罗斯明斯克。
* [GoWest Conference](https://www.gowestconf.com/)  利希、美国。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#conferences) 吧~)*

## E-Books

* [100 Go Mistakes: How to Avoid Them](https://www.manning.com/books/100-go-mistakes-how-to-avoid-them)
* [A Go Developer's Notebook](https://leanpub.com/GoNotebook/read)
* [An Introduction to Programming in Go](http://www.golang-book.com/)
* [Build an Orchestrator in Go](https://www.manning.com/books/build-an-orchestrator-in-go)
* [Build Web Application with Golang](https://astaxie.gitbooks.io/build-web-application-with-golang/content/en/)
* [Building Web Apps With Go](https://codegangsta.gitbooks.io/building-web-apps-with-go/content/)
* [Continuous Delivery in Go](https://www.manning.com/books/continuous-delivery-in-go)  这篇关于持续交付的实用指南向您展示了如何快速建立一个自动化管道，以改进您的测试、代码质量和最终产品。
* [For the Love of Go](https://bitfieldconsulting.com/books/love)  为围棋初学者准备的入门书。
* [Go 101](https://go101.org)  一本关注 Go 语法/语义和各种细节的书。
* [Go Bootcamp](http://golangbootcamp.com)
* [GoBooks](https://github.com/dariubs/GoBooks) **star:11551** 一份精选的 Go 书籍清单。   [![star > 2000][Awesome]](https://github.com/dariubs/GoBooks)
* [How To Code in Go eBook](https://www.digitalocean.com/community/books/how-to-code-in-go-ebook)  600页的Go介绍针对的是第一次开发人员。
* [Go Succinctly](https://github.com/thedevsir/gosuccinctly) **star:21** in Persian.   [![最近一年没有更新][Yellow]](https://github.com/thedevsir/gosuccinctly)   [![godoc][GoDoc]](https://godoc.org/github.com/thedevsir/gosuccinctly)
* [Learning Go](https://www.miek.nl/downloads/Go/Learning-Go-latest.pdf)
* [Network Programming With Go](https://jan.newmarch.name/go/)
* [Practical Go Lessons](https://www.practical-go-lessons.com/)
* [Spaceship Go A Journey to the Standard Library](https://blasrodri.github.io/spaceship-go-gh-pages/)
* [The Go Programming Language](https://www.gopl.io/)
* [The Golang Standard Library by Example (Chinese)](https://github.com/polaris1119/The-Golang-Standard-Library-by-Example)
* [Web Application with Go the Anti-Textbook](https://github.com/thewhitetulip/web-dev-golang-anti-textbook/)
* [Writing A Compiler In Go](https://compilerbook.com)
* [Writing An Interpreter In Go](https://interpreterbook.com)  这本书介绍了编写习惯的，表达的，高效的Go代码的技巧，避免了常见的陷阱。


**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#e-books) 吧~)*

## Gophers

* [Free Gophers Pack](https://github.com/MariaLetta/free-gophers-pack) **star:2386** 由 Maria Letta 提供的与 Gopher 有关的图片包，其中包含了插图,表情文字。   [![star > 2000][Awesome]](https://github.com/MariaLetta/free-gophers-pack)   [![最近一年没有更新][Yellow]](https://github.com/MariaLetta/free-gophers-pack)   [![godoc][GoDoc]](https://godoc.org/github.com/MariaLetta/free-gophers-pack)
* [gopher-logos](https://github.com/GolangUA/gopher-logos) **star:96** 可爱的 gopher 标识。
* [Go-gopher-Vector](https://github.com/keygx/Go-gopher-Vector) **star:42** 与 Go gopher 相关的媒介数据[。ai . svg)。   [![最近一年没有更新][Yellow]](https://github.com/keygx/Go-gopher-Vector)
* [gopher-stickers](https://github.com/tenntenn/gopher-stickers)
* [gophericons](https://github.com/shalakhin/gophericons)
* [gophers](https://github.com/egonelbre/gophers) **star:2586** Free gophers.   [![star > 2000][Awesome]](https://github.com/egonelbre/gophers)   [![最近一年没有更新][Yellow]](https://github.com/egonelbre/gophers)   [![godoc][GoDoc]](https://godoc.org/github.com/egonelbre/gophers)
* [gophers](https://github.com/ashleymcnamara/gophers) **star:2548** 阿什莉·麦克纳马拉的歌斐艺术品。   [![star > 2000][Awesome]](https://github.com/ashleymcnamara/gophers)   [![最近一年没有更新][Yellow]](https://github.com/ashleymcnamara/gophers)   [![godoc][GoDoc]](https://godoc.org/github.com/ashleymcnamara/gophers)
* [gopherize.me](https://github.com/matryer/gopherize.me) **star:545** Gopherize自己。
* [gophers](https://github.com/sillecelik/go-gopher) **star:98** Gopher amigurumi玩具图案。
* [gophers](https://github.com/rogeralsing/gophers) **star:54** 随机gopher图形。   [![最近一年没有更新][Yellow]](https://github.com/rogeralsing/gophers)
* [gophers](https://github.com/scraly/gophers) **star:12** Gophers by Aurélie Vache.

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#gophers) 吧~)*

## 聚会

* [Basel Go Meetup](https://www.meetup.com/Basel-Go-Meetup/)
* [Belfast Gophers](https://www.meetup.com/Belfast-Gophers/)
* [Belgrade Golang Meetup](https://www.meetup.com/golang-serbia/)
* [Berlin Golang](https://www.meetup.com/golang-users-berlin/)
* [Brisbane Gophers](https://www.meetup.com/Brisbane-Golang-Meetup/)
* [Canberra Gophers](https://www.meetup.com/Canberra-Gophers/)
* [Go Language NYC](https://www.meetup.com/golanguagenewyork/)
* [Go London User Group](https://www.meetup.com/Go-London-User-Group/)
* [Go Remote Meetup](https://www.meetup.com/Go-Remote-Meetup/)
* [Go Toronto](https://www.meetup.com/go-toronto/)
* [Go User Group Atlanta](https://www.meetup.com/Go-Users-Group-Atlanta/)
* [GoBandung](https://www.meetup.com/GoBandung/)
* [GoBridge, San Francisco, CA](https://www.meetup.com/gobridge/)
* [GoCracow - Krakow, Poland](https://www.meetup.com/GoCracow/)
* [GoJakarta](https://www.meetup.com/GoJakarta/)
* [Golang Amsterdam](https://www.meetup.com/golang-amsterdam/)
* [Golang Argentina](https://www.meetup.com/Golang-Argentina/)
* [Golang Athens](https://www.meetup.com/Athens-Gophers/)
* [Golang Baltimore, MD](https://www.meetup.com/BaltimoreGolang/)
* [Golang Bangalore](https://www.meetup.com/Golang-Bangalore/)
* [Golang Belo Horizonte - Brazil](https://www.meetup.com/go-belo-horizonte/)
* [Golang Boston](https://www.meetup.com/bostongo/)
* [Golang Bulgaria](https://www.meetup.com/Golang-Bulgaria/)
* [Golang Cardiff, UK](https://www.meetup.com/Cardiff-Go-Meetup/)
* [Golang Copenhagen](https://www.meetup.com/Go-Cph/)
* [Golang Curitiba - Brazil](https://www.meetup.com/GolangCWB/)
* [Golang DC, Arlington, VA](https://www.meetup.com/Golang-DC/)
* [Golang Dorset, UK](https://www.meetup.com/golang-dorset/)
* [Golang Estonia](https://www.meetup.com/Golang-Estonia/)
* [Golang Gurgaon, India](https://www.meetup.com/Gurgaon-Go-Meetup/)
* [Golang Hamburg - Germany](https://www.meetup.com/Go-User-Group-Hamburg/)
* [Golang Israel](https://www.meetup.com/Go-Israel/)
* [Golang Joinville - Brazil](https://www.meetup.com/Joinville-Go-Meetup/)
* [Golang Kathmandu](https://www.meetup.com/Golang-Kathmandu/)
* [Golang Korea](https://www.meetup.com/GDG-Golang-Korea/)
* [Golang Lima - Peru](https://www.meetup.com/Golang-Peru/)
* [Golang Lyon](https://www.meetup.com/Golang-Lyon/)
* [Golang Marseille](https://www.meetup.com/fr-FR/Golang-Marseille/)
* [Golang Melbourne](https://www.meetup.com/golang-mel/)
* [Golang Mountain View](https://www.meetup.com/Golang-Mountain-View/)
* [Golang New York](https://www.meetup.com/nycgolang/)
* [Golang North East](https://www.meetup.com/en-AU/Golang-North-East/)
* [Golang Paris](https://www.meetup.com/Golang-Paris/)
* [Golang Poland](https://www.meetup.com/Golang-Poland/)
* [Golang Pune](https://www.meetup.com/Golang-Pune/)
* [Golang Singapore](https://www.meetup.com/golangsg/)
* [Golang Stockholm](https://www.meetup.com/Go-Stockholm/)
* [Golang Sydney, AU](https://www.meetup.com/golang-syd/)
* [Golang São Paulo - Brazil](https://www.meetup.com/golangbr/)
* [Golang Taipei](https://www.meetup.com/golang-taipei-meetup/)
* [Golang Thessaloniki](https://www.meetup.com/thessaloniki-golang-meetup/)
* [Golang Turkey](https://kommunity.com/goturkiye)
* [Golang Vancouver, BC](https://www.meetup.com/golangvan/)
* [Golang Vienna, Austria](https://www.meetup.com/viennago/)
* [Golang Казань](https://www.meetup.com/GolangKazan/)
* [Golang Москва](https://www.meetup.com/Golang-Moscow/)
* [Golang Питер](https://www.meetup.com/Golang-Peter/)
* [GoSF - San Francisco, CA](https://www.meetup.com/golangsf)
* [Istanbul Golang](https://www.meetup.com/Istanbul-Golang/)
* [Seattle Go Programmers](https://www.meetup.com/golang/)
* [Ukrainian Golang User Groups](https://www.meetup.com/uagolang/)
* [Utah Go User Group](https://www.meetup.com/utahgophers/)
* [Women Who Go - San Francisco, CA](https://www.meetup.com/Women-Who-Go/)

*在这里添加您所在城市/国家的群组(发送**PR**) (翻译出错了? 试试 [英文版](README_EN.md#meetups) 吧~)*

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#meetups) 吧~)*

## 风格指南

* [bahlo/go-styleguide](https://github.com/bahlo/go-styleguide)
* [CockroachDB](https://github.com/cockroachdb/cockroach/blob/master/docs/style.md)
* [GitLab](https://docs.gitlab.com/ee/development/go_guide/)
* [Hyperledger](https://github.com/hyperledger/fabric/blob/release-1.4/docs/source/style-guides/go-style.rst)
* [Magnetico](https://github.com/boramalper/magnetico/wiki/magnetico-Design-Specification)
* [Sourcegraph](https://about.sourcegraph.com/handbook/engineering/go_style_guide)
* [Thanos](https://thanos.io/tip/contributing/coding-style-guide.md/)
* [Uber](https://github.com/uber-go/guide/blob/master/style.md)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#style-guides) 吧~)*

## 社交媒体
### Twitter

* [@golang](https://twitter.com/golang)
* [@golang_news](https://twitter.com/golang_news)
* [@golangch](https://twitter.com/golangch)
* [@golangflow](https://twitter.com/golangflow)
* [@golangweekly](https://twitter.com/golangweekly)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#twitter) 吧~)*

### Reddit
 * [r/golang](https://www.reddit.com/r/golang/)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#reddit) 吧~)*

## 网站

* [awesome-awesomeness](https://github.com/bayandin/awesome-awesomeness) **star:28426** 其他 awesome 系列的列表。   [![star > 2000][Awesome]](https://github.com/bayandin/awesome-awesomeness)
* [Awesome Remote Job](https://github.com/lukasz-madon/awesome-remote-job) **star:21584** Curated list of awesome remote jobs. A lot of them are looking for Go hackers.   [![star > 2000][Awesome]](https://github.com/lukasz-madon/awesome-remote-job)   [![最近一周有更新][Green]](https://github.com/lukasz-madon/awesome-remote-job)
* [Awesome Golang Workshops](https://github.com/amit-davidson/awesome-golang-workshops) **star:453** 一个令人敬畏的戈朗工作室的策划列表。
* [golang-graphics](https://github.com/mholt/golang-graphics) **star:139** 收藏的 Go 图像，图形和艺术作品。   [![最近一年没有更新][Yellow]](https://github.com/mholt/golang-graphics)   [![归档项目][Archived]](https://github.com/mholt/golang-graphics)
* [golang-nuts](https://groups.google.com/forum/#!forum/golang-nuts)  Go 邮件列表。
* [Google Plus Community](https://plus.google.com/communities/114112804251407510571)  Google+社区 golang爱好者聚集地。
* [Gopher Community Chat](https://invite.slack.golangbridge.org)  加入我们为Gophers设立的全新Slack社区([了解它是如何产生的](https://blog.gopheracademy.com/gophers-slack-community/))。
* [Gophercises](https://gophercises.com/)  为 Go 初学者提供免费的代码训练。
* [gowalker.org](https://gowalker.org)   Go API 文档。
* [json2go](https://m-zajac.github.io/json2go)  高级JSON去结构转换-在线工具。
* [justforfunc](https://www.youtube.com/c/justforfunc)  致力于传授 Go 编程语言技巧和技巧的Youtube 频道，由Francesc Campoy [@francesc](https://twitter.com/francesc)主办。
* [Learn Go Programming](https://blog.learngoprogramming.com)  学习Go概念与插图。
* [Lille Gophers](https://lille-gophers.loscrackitos.codes/)  Golang在法国里尔谈论社区([@LilleGophers](https://twitter.com/LilleGophers))。
* [gocryforhelp](https://github.com/ninedraft/gocryforhelp) **star:40** 专门收集需要帮助的Go项目，这是你开启开源之路的好去处。   [![最近一年没有更新][Yellow]](https://github.com/ninedraft/gocryforhelp)
* [godoc.org](https://godoc.org/)  开源 Go 包的文档。
* [Golang Developer Jobs](https://golangjob.xyz)  开发人员的工作专为Golang相关的角色。
* [Golang Flow](https://golangflow.io)  发布更新、新闻、包等等。
* [Golang News](https://golangnews.com)  关于 Go 编程的链接和新闻。
* [Golang Resources](https://golangresources.com)  一个最佳示范，包含文章，练习，讨论和视频学习。
* [awesome-go-extra](https://github.com/xwjdsh/awesome-go-extra) **star:20** 解析awesome-go README文件并生成一个新的README文件与repo信息。   [![最近一周有更新][Green]](https://github.com/xwjdsh/awesome-go-extra)   [![godoc][GoDoc]](https://godoc.org/github.com/xwjdsh/awesome-go-extra)   [![包含中文文档][CN]](https://github.com/xwjdsh/awesome-go-extra)
* [CodinGame](https://www.codingame.com/)  以小游戏互动完成任务的形式来学习 Go。
* [Go Blog](https://blog.golang.org)  官方 Go 博客。
* [Go Code Club](https://www.youtube.com/watch?v=nvoIPQYdx9g&list=PLEcwzBXTPUE_YQR7R0BRtHBYJ0LN3Y0i3)  一群地鼠每周阅读和讨论一个不同的Go项目。
* [Go Community on Hashnode](https://hashnode.com/n/go)  Hashnode上的Go社区。
* [Go Forum](https://forum.golangbridge.org)  讨论 Go 的论坛。
* [Go In 5 Minutes](https://www.goin5minutes.com/)  5 minute screencasts focused on getting one thing done.
* [Go Projects](https://github.com/golang/go/wiki/Projects)  wiki上的 Go 社区项目列表。
* [Go Proverbs](https://go-proverbs.github.io/)  罗伯·派克的箴言。
* [Go Report Card](https://goreportcard.com)  为你的 Go 包生成一份报告单。
* [go.dev](https://go.dev/)  一个 go 开发者的中心。
* [Awesome Go @LibHunt](https://go.libhunt.com)  属于你的 Go 工具箱。
* [Made with Golang](https://madewithgolang.com/?ref=awesome-go)
* [r/Golang](https://www.reddit.com/r/golang)  与 Go 有关的新闻。
* [studygolang](https://studygolang.com)  Go语言中文网
* [Trending Go repositories on GitHub today](https://github.com/trending?l=go)  寻找最新的 Go库 的好地方。
* [TutorialEdge - Golang](https://tutorialedge.net/course/golang/)

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#websites) 吧~)*

### 教程

* [Build web application with Golang](https://github.com/astaxie/build-web-application-with-golang) **star:39475** Golang电子书，主要讲述如何用 Golang 建立一个web应用程序。   [![star > 2000][Awesome]](https://github.com/astaxie/build-web-application-with-golang)   [![godoc][GoDoc]](https://godoc.org/github.com/astaxie/build-web-application-with-golang)   [![包含中文文档][CN]](https://github.com/astaxie/build-web-application-with-golang)
* [Building and Testing a REST API in Go with Gorilla Mux and PostgreSQL](https://semaphoreci.com/community/tutorials/building-and-testing-a-rest-api-in-go-with-gorilla-mux-and-postgresql)  我们会写一个API的帮助下强大的大猩猩Mux。
* [Building Go Web Applications and Microservices Using Gin](https://semaphoreci.com/community/tutorials/building-go-web-applications-and-microservices-using-gin)  Get familiar with Gin and find out how it can help you reduce boilerplate code and build a request handling pipeline.
* [Caching Slow Database Queries](https://medium.com/@rocketlaunchr.cloud/caching-slow-database-queries-1085d308a0c9)  如何缓存数据库的慢查询。
* [Canceling MySQL](https://medium.com/@rocketlaunchr.cloud/canceling-mysql-in-go-827ed8f83b30)  如何取消MySQL查询。
* [Go Cheat Sheet](https://github.com/a8m/go-lang-cheat-sheet) **star:6167**  Go's reference card。   [![star > 2000][Awesome]](https://github.com/a8m/go-lang-cheat-sheet)
* [Go database/sql tutorial](http://go-database-sql.org/)  数据库概论/ sql。
* [Go Language Tutorial](https://www.javatpoint.com/go-tutorial)  学习Go语言教程。
* [Go Playground for iOS](https://codeplayground.app)  在你的移动设备上编辑你编辑和运行你的 Go 代码。
* [Go Tutorial](https://www.tutorialspoint.com/go/index.htm)  学习编程。
* [Ethereum Development with Go](https://github.com/miguelmota/ethereum-development-with-go-book) **star:1146** 一本讲述如何用 Go 进行以太开发的小册。   [![godoc][GoDoc]](https://godoc.org/github.com/miguelmota/ethereum-development-with-go-book)   [![包含中文文档][CN]](https://github.com/miguelmota/ethereum-development-with-go-book)
* [Games With Go](https://gameswithgo.org/)  关于编程和游戏开发系列教学视频。
* [Go By Example](https://gobyexample.com/)  手把手教你 如何在 Go 应用程序中使用注释。
* [50 Shades of Go](https://devs.cloudimmunity.com/gotchas-and-common-mistakes-in-go-golang/)  Go 初学者经常遇到的陷阱、误区、错误
* [A Guide to Golang E-Commerce](https://snipcart.com/blog/golang-ecommerce-ponzu-cms-demo?utm_term=golang-ecommerce-ponzu-cms-demo)  教你如何用 Go 搭建一个电商平台 (包括demo)。
* [A Tour of Go](https://tour.golang.org/)  互动的 Go 之旅。
* [Design Patterns in Go](https://github.com/shubhamzanwar/design-patterns) **star:63** 在Go中实现的编程设计模式的集合。   [![最近一年没有更新][Yellow]](https://github.com/shubhamzanwar/design-patterns)   [![godoc][GoDoc]](https://godoc.org/github.com/shubhamzanwar/design-patterns)
* [Debugged.it Go patterns](https://github.com/haveyoudebuggedit/go-patterns) **star:1** 高级的Go模式和准备运行的示例。   [![godoc][GoDoc]](https://godoc.org/github.com/haveyoudebuggedit/go-patterns)
* [Go WebAssembly Tutorial - Building a Simple Calculator](https://tutorialedge.net/golang/go-webassembly-tutorial/)
* [go-patterns](https://github.com/tmrts/go-patterns) **star:18153** 策划的清单去设计模式，食谱和习惯用法。   [![star > 2000][Awesome]](https://github.com/tmrts/go-patterns)   [![godoc][GoDoc]](https://godoc.org/github.com/tmrts/go-patterns)
* [Learn Go with TDD](https://github.com/quii/learn-go-with-tests) **star:16370** 学习使用测试驱动开发。   [![star > 2000][Awesome]](https://github.com/quii/learn-go-with-tests)   [![最近一周有更新][Green]](https://github.com/quii/learn-go-with-tests)   [![godoc][GoDoc]](https://godoc.org/github.com/quii/learn-go-with-tests)   [![包含中文文档][CN]](https://github.com/quii/learn-go-with-tests)
* [Learning Go by examples](https://dev.to/aurelievache/learning-go-by-examples-introduction-448n)  本文以学习高朗语的具体应用为例。
* [Learning Golang - From zero to hero](https://milapneupane.com.np/2019/07/06/learning-golang-from-zero-to-hero/)  面向 Golang 初学者教程。
* [package main](https://www.youtube.com/packagemain)  关于 Go 编程的YouTube频道。
* [Programming with Google Go](https://www.coursera.org/specializations/google-golang)  Coursera的专业学习可以从零开始。
* [Saving a Third of Our Memory by Re-ordering Go Struct Fields](https://qvault.io/golang/struct-field-ordering-memory/)  Go结构中的字段排序是多么低效。
* [Learn Go with 1000+ Exercises](https://github.com/inancgumus/learngo) **star:12607** 通过成千上万的例子、练习和测验来学习Go。   [![star > 2000][Awesome]](https://github.com/inancgumus/learngo)   [![godoc][GoDoc]](https://godoc.org/github.com/inancgumus/learngo)
* [Golang for Node.js Developers](https://github.com/miguelmota/golang-for-nodejs-developers) **star:2756** 引入示例讲述 Golang 与Node.js在学习上的差异。   [![star > 2000][Awesome]](https://github.com/miguelmota/golang-for-nodejs-developers)   [![godoc][GoDoc]](https://godoc.org/github.com/miguelmota/golang-for-nodejs-developers)
* [Golang Tutorial Guide](https://www.freecodecamp.org/news/golang-tutorial-list-free-courses-learn-go-programming-language/)  学习Go编程语言的免费课程列表。
* [Golangbot](https://golangbot.com/learn-golang-series/)  Go 编程教程。
* [GolangCode](https://golangcode.com/)  收集代码片段和教程，以帮助处理日常问题。
* [GopherSnippets](https://gophersnippets.com/)  带有测试和可测试示例的代码片段，用于Go编程语言。
* [Gosamples](https://gosamples.dev/)  让您解决日常代码问题的代码片段集合。
* [Hackr.io](https://hackr.io/tutorials/learn-golang)  Go社区投票选举出来的最好的在线 Go 教程。
* [How to Benchmark: dbq vs sqlx vs GORM](https://medium.com/@rocketlaunchr.cloud/how-to-benchmark-dbq-vs-sqlx-vs-gorm-e814caacecb5)  学习如何在Golang中进行基准测试。作为案例研究，我们将对dbq、sqlx和GORM进行基准测试。
* [How To Deploy a Go Web Application with Docker](https://semaphoreci.com/community/tutorials/how-to-deploy-a-go-web-application-with-docker)  学习如何使用Docker进行Go开发，以及如何构建Docker生产镜像。
* [How to Use Godog for Behavior-driven Development in Go](https://semaphoreci.com/community/tutorials/how-to-use-godog-for-behavior-driven-development-in-go)  快速使用Godog —— 一个行为驱动开发的构建和测试应用程序框架。
* [go-clean-template](https://github.com/evrone/go-clean-template) **star:519** Golang服务的Clean Architecture模板。   [![最近一周有更新][Green]](https://github.com/evrone/go-clean-template)   [![godoc][GoDoc]](https://godoc.org/github.com/evrone/go-clean-template)
* [goapp](https://github.com/bnkamalesh/goapp) **star:332** 关于构建和开发Go web应用/服务的指南。   [![godoc][GoDoc]](https://godoc.org/github.com/bnkamalesh/goapp)
* [The world’s easiest introduction to WebAssembly with Golang](https://medium.com/@martinolsansky/webassembly-with-golang-is-fun-b243c0e34f02)
* [Working with Go](https://github.com/mkaz/working-with-go) **star:1157** 由一个经验丰富的Go程序员群体编写的一系列Go学习范例。   [![最近一年没有更新][Yellow]](https://github.com/mkaz/working-with-go)   [![归档项目][Archived]](https://github.com/mkaz/working-with-go)
* [Your basic Go](https://yourbasic.org/golang)  如何收集大量的教程。

**(⬆回到顶部)(#内容)* (翻译出错了? 试试 [英文版](README_EN.md#tutorials) 吧~)*

